/* **************************************************************************
*  filename  : Ad.cpp
*  author    : Alessandro Maraschini <alessandro.maraschini@datamat.it>
*  copyright : (C) 2002 by DATAMAT
***************************************************************************/
//
// $Id: Ad.cpp,v 1.38 2004/04/01 14:08:48 dhsmith Exp $
//

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#ifdef HAVE_STRINGSTREAM
#include <sstream>
#else
#include <strstream>
#endif
#include <ctype.h>

#include "edg/workload/common/utilities/classad_utils.h"
#include "edg/workload/common/requestad/Ad.h"
#include "edg/workload/common/requestad/exception_codes.h"
#include "edg/workload/common/requestad/JobAdExceptions.h"
COMMON_NAMESPACE_BEGIN{ //Defining UserInterFace NameSpace
namespace requestad{
using namespace classad;
using namespace std ;
using namespace edg::workload::common::utilities ;

   Ad::Ad(){};
   Ad::~Ad()throw(){
        // cout << "\nAd destructor\n" << flush ;
   };
   Ad::Ad(const string& jdl){
   };
   Ad::Ad(const classad::ClassAd& classAd ):classad::ClassAd(classAd){};
   //Methods

   void Ad::fromFile(const string& jdl_file){
        EDG_STACK_TRY("fromFile(const string& jdl_file)");
#ifdef HAVE_STRINGSTREAM
        stringstream buffer ;
#else
        strstream buffer;
#endif
        ifstream jdl_in( jdl_file.c_str()  );
        string result = "", tmpStr ;
        int blank ;
        while ( getline(jdl_in, tmpStr, '\n') ){
          //find the first no-blank character
          blank = 0 ;
          while (tmpStr[blank]==' ')
               blank++;
          //Check For Commented lines:
          if ( tmpStr[blank] =='#' ){
              //header += "\n" + tmpStr;
              //Python Comment: do nothing
          }else if (tmpStr[blank] =='/' && tmpStr[blank+1] =='/'){
              //header += "\n" + tmpStr;
              //C/C++ Comment: do nothing
          }else
              result += " " + tmpStr;
        }
        // fb.close() ;
	while ( result.length() !=0  ){
	  if (  result.substr(0,1)==" " )
	     result = result.substr(1);
	else
	    break;
	}
	while ( result.find("\t") < result.size() ){
		result = result.substr(0 ,  result.find("\t")) + result.substr( result.find("\t")+1);
	}
	fromString( result );
	EDG_STACK_CATCH() ;   //Exiting from method: remove line from stack trace
   };
   // void Ad::checkSyntax( const string attr_name , ExprTree* attr_value  ){   /**DEPRECATED TBD*/   }   ;
   string Ad::toString(){
      string       buffer="";
      PrettyPrint  unp;
      //flat the classAd into one single line
      unp.SetClassAdIndentation(0);
      unp.SetListIndentation(0);
      //Unparse the ClassAd instance
      unp.Unparse(buffer, this );
      return buffer;
   };
   

string Ad::toString( const string& attr_name ){
   string       buffer="";
   PrettyPrint  unp;
   ExprTree *tree = Lookup(attr_name) ;
   if (tree==NULL)
         throw AdEmptyException (__FILE__ , __LINE__ ,   "toString( const string& attr_name )",   WL_JDLEMPTY ,attr_name);
   //flat the classAd into one single line
   unp.SetClassAdIndentation(0);
   unp.SetListIndentation(0);
   //Unparse the ClassAd instance
   unp.Unparse(buffer, tree);
   return buffer;
}

   string Ad::toLines(){
     string       buffer="";
     PrettyPrint  unp;
     //Unparse the ClassAd instance
     unp.SetClassAdIndentation(1);
     unp.SetListIndentation(0);
     // create the JobAd string representation
     unp.Unparse(buffer, this );
     return buffer;
   };

/******************************************************************
 method :  isSet
Check whether the JobAd has been initialised (true) or not (false)
*******************************************************************/
bool  Ad::isSet(){
 vector < pair < string, ExprTree* > >  vect ;
 GetComponents( vect ) ;
 if (vect.size() >0)
    return true ;
 return false ;
};


/******************************************************************
 method :  clear
*******************************************************************/
void Ad::clear(){   Clear();  };

   void Ad::insertAttribute(const std::string& attr_name , ExprTree* val){
      if (!  Insert (attr_name  , val) )
         throw AdSyntaxException (__FILE__ , __LINE__ ,  "insertAttribute(const std::string& attr_name , ExprTree* val)" ,   WL_JDLSYN ,attr_name);
   };
   void Ad::insertAttribute(const std::string& attr_name , Value val){
    EDG_STACK_TRY("Ad::insertAttribute(const std::string& attr_name , Value val)") ;
    insertAttribute (attr_name , (ExprTree*)Literal::MakeLiteral (val) ) ;
    EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
   };

/**
* Converts a string into its lower value
**/
string Ad::toLower ( const string &src ){
	string result = "" ;
	const char* tmp = src.c_str() ;
	// generate an array of char (one char overdimensioned for security)
	char res [src.length()+1] ;
	for  (unsigned int i = 0 ; i< src.length() ; i++ )
	    res[i] = tolower(  tmp[i]  ) ;
	// Add the string terminator char
	res[ src.length() ] = '\0' ;
	return string (res) ;
} ;

/******************************************************************
 method :   delAttribute
*******************************************************************/
classad::ExprTree* Ad::delAttribute(const string& attr_name) {
   // EDG_STACK_TRY("JobAd::delAttribute(const string& attr_name)");
   //Call superclass method
   ExprTree* attr_value = Lookup(attr_name)->Copy() ;
   if (! Delete(attr_name))
      //The attribute has NOT been removed successfully
      throw AdEmptyException (__FILE__ , __LINE__ ,   "Ad::delAttribute(const string& attr_name)",   WL_JDLEMPTY ,attr_name);
   return attr_value;
   // EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};


/******************************************************************
method :  hasAttribute
 check if the attribute name is present
*******************************************************************/
bool Ad::hasAttribute( ExprTree* tree ,  const std::string& attr_value){
      Value val ;
      string str;
      if ( !EvaluateExpr( tree, val ) )
          // unable to parse the attribute
          return false ;
      if           ( val.GetType() == Value::CLASSAD_VALUE){
             // The attribute has to be a string or a list of strings
            return false ;
      }else if   ( val.GetType() == Value::LIST_VALUE){
                 const ExprList    *el;
                 vector<ExprTree*> vectList ;
                 val.IsListValue(el) ;
                 el->GetComponents(vectList) ;
                 for ( int i = 0; i< (int)vectList.size() ; i++){
                       if (hasAttribute ( vectList[i] , attr_value) )
                          return true ;
                 };
                 return false ;
         }else if   ( val.IsStringValue( str ) ){
	    if (toLower(str)==toLower(attr_value))
	        return true ;
            else
	       return false ;
         }else if   ( val.GetType() == Value::BOOLEAN_VALUE ||
                        val.GetType() == Value::INTEGER_VALUE  ||
                        val.GetType() == Value::REAL_VALUE  )
			     return false ;
         else
	    return false ;
}
bool Ad::hasAttribute( const std::string& attr_name, const std::string& attr_value){
   ExprTree            *tree ;
   tree = Lookup (attr_name);
   if (tree == NULL)
        // attribute not present
        return false;
   else
      return hasAttribute (tree , attr_value);
}
bool Ad::hasAttribute(const string& attr_name){
   // EDG_STACK_TRY("hasAttribute(const string& attr_name)") ;
   ExprTree            *tree ;
   tree = Lookup (attr_name);
   if (tree == NULL)
        return false;
   else
        return true;
   // EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

std::vector<std::string> Ad::attributes(){
	vector< pair< string, ExprTree *> >  vect ;
	GetComponents(  vect  ) ;
	std::vector<std::string> attributes ;
	for (unsigned int i = 0 ; i< vect.size() ; i++ ) attributes.push_back(  vect[i].first  ) ;
	return attributes ;
} ;

classad::ExprList* Ad::fromList(const std::string& father , std::string& jdl , std::string& fxm){
	// cout << "**    Ad::fromList \n" << father << ">jdl: " << jdl << "\n" << father << ">fxm:" << fxm << endl << flush ;
	// ExprList* toAdd ;
	vector<ExprTree*>    vect;
	int lookFor = 0;
	string currentChar ;
	while ( jdl.length()>0 ){
		currentChar = jdl.substr(   0,  1   );
		jdl = jdl.substr (1, jdl.length()-1 );
		switch (lookFor) {
			case 0:
			// still empty value
			if (currentChar==","){
				if (vect.size()==0)  { /* if it's empty-->error */ fxm+=father+": List value begins with \",\" char\n"; lookFor=3 ; break;}
				else /* next item to be found  */ lookFor = 1;
			}
			else if (currentChar=="}") /* List Terminated, return ExprList */   return classad::ExprList::MakeExprList(vect);
			else if (   (currentChar==" ")||(currentChar=="\t") )/* Skip char */   break;
			else { /* One char has been found don't break but follow to case 1, appending previous char */ jdl = currentChar +jdl ; lookFor =1 ; }
			case 1:{
			/* Looking for an attribute */
			// cout << lookFor << ") ListRead calling readValue for " << father << "\n queda "<< jdl << endl << flush ;
			ExprTree* tree = readValue ( father , jdl, fxm );
			if (tree == NULL) /* Some Errors occurred but logged while readValue (or empty list) */  lookFor = 3 ;
			else { vect.push_back(  tree->Copy() ) ;  lookFor = 0; }
			// cout << lookFor << ") ListRead value for " << father << "\n queda "<< jdl << endl << flush ;
			break;}
			case 3: /* Error case*/
			if (currentChar=="}") return ExprList::MakeExprList(vect);
			break;
			default:
			throw AdSyntaxException ( __FILE__ , __LINE__ ,  "FATAL ERROR:  Reached Unexpected point, please contact the developers" ,   WL_JDLSYN , father );
			break;
		}
	} // end while
	// Reached end of string
	// Ending Session error Managing:
	switch (lookFor) {
		case 0: /*  empty list: ok*/ break;
		case 1:
		case 3: /* comma and then no-value:error*/ fxm+=father+": List values is not closed, check the \"}\" char\n"; break;
		default:
		throw AdSyntaxException ( __FILE__ , __LINE__ ,  "FATAL ERROR:  Reached Unexpected point, please contact the developers" ,   WL_JDLSYN , father );
		break;
	}
	return classad::ExprList::MakeExprList(vect);
   }

   classad::ClassAd* Ad::fromString(const std::string& fat , std::string& jdl, std::string& fxm){
	// cout << "**    Ad::fromString \n" << fat << ">jdl: " << jdl << "\n" << fat << ">fxm:" << fxm << endl << flush ;
	// Read a ClassAd Value from the parsed string
	// ExprTree* toAdd ;
	ClassAd* classAd = new ClassAd ();
	string father = (fat=="")? "- " : fat+"::" ;
	vector< pair< string, ExprTree* > > vect ;
	// if (father =="" ) toAdd =this;
	ClassAdParser cp ;
	int lookFor = 0;
	string currentChar , attrName = "" ;
	while ( jdl.length()>0 ){
		currentChar = jdl.substr(   0,  1   );
		jdl = jdl.substr (1, jdl.length()-1 );
		switch (lookFor) {
			case 0: /* Look for attrName */
			if (   (currentChar==" ")||(currentChar=="\t")   ) break;
			else if (currentChar=="]") return classAd ;
			else{
			   attrName += currentChar ;
			   lookFor = 6;
			   break;
			}
			case 6: /* filling attribute name*/
			if (   (currentChar==" ")||(currentChar=="\t")   ) lookFor=1 ;
			else if (currentChar=="=") lookFor=2 ;
			else attrName += currentChar ; /* Special forbidden chars'?*/
			break;
			case 1: /* Look for equals */
			if (  (currentChar==" ")||(currentChar=="\t")   ) break;
			else if (currentChar=="=") /* equals found, attrName terminated lookfor*/lookFor = 2;
			else{  /* Some error occurred*/ lookFor = 3 ; fxm +=father + attrName +  ":  Unable to find \"=\" char\n"; }
			break;
			case 2:{ /* Look for value */
			  // cout << "FromString Calling ReadValue for " <<   attrName << "\nQueda:"  << jdl << endl << flush;
			  jdl = currentChar + jdl ;
			  ExprTree* tree = readValue ( father + attrName , jdl, fxm );
			  if (tree == NULL) { /* Some Errors occurred but logged while readValue*/  lookFor = 3 ; attrName = "" ; break;
			  }else if (Lookup(attrName) != NULL ) {     fxm +=father + attrName + ": already set attribute" +"\n";  lookFor = 3 ;  attrName = ""; break;
			  } else{
			     	classAd->Insert (  attrName , tree );
			     	// vect.push_back(  pair <string , ExprTree*> (attrName , tree ) ) ;
			     	lookFor = 4;
			     	// cout << "FromString inserted for " << attrName << "\nqueda " << jdl << endl << flush;
			     	attrName = "" ;
			     	break;
			  }
			}
			attrName = "" ;
			break;
			case 4: /* Look for terminator char*/
			if  (     (currentChar==" ") ||(currentChar=="\t")   )/* Do nothing just break*/ break;
			else if (currentChar==";"){  /* EOL: look for another char*/ lookFor = 0; break; }
			else if (currentChar !="]") { /* Some  Error Occurred*/  lookFor = 3 ; fxm +=father + attrName +  ": found ("+ currentChar +")Unable to find EOL char terminator \";\"\n";  break;}
			else return classAd ;
			case 3: /* Error occurred */
			if (currentChar=="]") return classAd ;
			else break;
			case 5: /* ClassAd finished return*/
			// if (toAdd!=NULL ) return (ClassAd*) toAdd;
			// else  return NULL ;//
			// cout << "... Ad::fromStirng Exiting from " <<  father <<endl << flush;
			return classAd ; //classAd->ClassAd::MakeClassAd( vect ) ;
			default:
			throw AdSyntaxException ( __FILE__ , __LINE__ ,  "FATAL ERROR:  Reached Unexpected point, please contact the developers" ,   WL_JDLSYN , father );
			break;
		} // end Switch
	} // end while
	// Ending Session error Managing:
	switch (lookFor) {
		case 6:
		case 1: /**/ fxm +=father + attrName +": Looking for \"=\" and caught EOF\n" ; break;
		case 2: fxm +=father + attrName +": Looking for attribute value and caught EOF\n" ; break;
		case 3: /* Error*/  break ;
		case 4:
		case 0: /* EOT missing*/  fxm +=father + ": Unable to find EOL classad terminator \"]\"\n" ; break;
		default:
		throw AdSyntaxException ( __FILE__ , __LINE__ ,  "FATAL ERROR:  Reached Unexpected point, please contact the developers" ,   WL_JDLSYN , father );
		break;
	}
	return classAd;  //->ClassAd::MakeClassAd( vect ) ;
};

classad::ExprTree* Ad::readValue(const std::string& father , std::string& jdl , std::string& fxm){
	// cout << "**    Ad::readValue \n" << father << ">jdl: " << jdl << "\n" << father << ">fxm:" << fxm << endl << flush ;
	ExprTree* toAdd ;
	ClassAdParser cp ;
	int lookFor = 0 , numpar= 0;
	string currentChar , attrValue = "" ;
	while ( jdl.length()>0 ){
		currentChar = jdl.substr(   0,  1   );
		jdl = jdl.substr (1, jdl.length()-1 );
		switch (lookFor) {
			case 0:
			// still empty value
			if (   (currentChar==" ") ||(currentChar=="\t")   )break;
			else if (currentChar=="[") return fromString ( father , jdl, fxm );
			else if (currentChar=="{") return fromList ( father , jdl, fxm );
			else if (currentChar=="\"") /*A String value begun, look for string closing*/  lookFor = 2 ;
			else if (    (currentChar=="]")  ||  (currentChar=="}")     )   { /* Repristinate eaten value*/jdl = currentChar + jdl ;  return (ClassAd*) NULL ;  }
			else /* all other chars: value initialising*/ lookFor =1 ;
			attrValue+=currentChar ;
			break;
			case 1:
			// The attrValue has begun but is not inside parenthesys, check wheter is finished
			if (currentChar=="\""){ /*A String value begun, look for string closing*/  lookFor = 2 ;  attrValue+=currentChar ;}
			else if (currentChar=="("){ /*A String value begun, look for string closing*/  numpar= 1 ; lookFor = 3 ;  attrValue+=currentChar ;}
			else if(   (currentChar==",") ||  (currentChar==";")  ||  (currentChar=="]")   ||  (currentChar=="}")   ){
				/* Repristinate last char*/jdl = currentChar + jdl ;
				// cout << "\nReadValue  finished for : " << father << "="<< attrValue << "\nstill : "<< jdl << endl << flush ;
				toAdd= cp.ParseExpression(  attrValue, true )  ;
				if (toAdd==NULL) {  fxm+= father +": Syntax error. Unable to parse the value '"+attrValue + "'\n" ; }
				return toAdd ;
			} else  attrValue+=currentChar ;
			break;
			case 3:
			// A parentesys has begun, wait for closing par(TBD special forbidden chars?)
			attrValue+=currentChar ;
			if (currentChar=="(") numpar++ ;
			else if (currentChar==")") /*A par value ended, look for string closing (TBD count parenthesys)*/ numpar--  ;
			if (numpar==0)lookFor = 1 ;
			break;
			case 2:
			// A string has begun, wait for ending char (TBD special forbidden chars?)
			attrValue+=currentChar ;
			if (currentChar=="\"") /*A String value ended, look for string closing*/  lookFor = 1 ;
			break;
			default:
			throw AdSyntaxException ( __FILE__ , __LINE__ ,  "FATAL ERROR:  Reached Unexpected point, please contact the developers" ,   WL_JDLSYN , father );
			break;
		}
	}
	// Reached end of string
	// Ending Session error Managing:
	switch (lookFor) {
		case 0:
		case 1:
		case 2:
		case 3:
		break;
		default:
		throw AdSyntaxException ( __FILE__ , __LINE__ ,  "FATAL ERROR:  Reached Unexpected point, please contact the developers" ,   WL_JDLSYN , father );
		break;
	}
	toAdd= cp.ParseExpression(  attrValue, true )  ;
	if (toAdd==NULL) {  fxm+= father + ": Unable to parse (syntax Error)\n" ; }
	return toAdd ;
   }

   // void Ad::fromString(const string& jdl ){}
   // This Is the main method: it parses a string char by char and is able to recognise each attribute
   void Ad::fromString(const string& jdl_toParse ){
	EDG_STACK_TRY("fromString(const string& jdl )");
	// Appending parenthesis, if necessary
	string jdl = jdl_toParse ;
	while ( jdl.find(" ") ==0 ) jdl =jdl.substr(1, jdl.length()-1 ) ;
	while ( jdl.find("\t") ==0 ) jdl =jdl.substr(1, jdl.length()-1 ) ;
	if (!jdl.find("[") == 0 )
		jdl = "[" +jdl +"]" ;
	string fxm ="" ;
	// jdl = jdl.substr (1, jdl.length()-1 );
	/*  OLD IMPLEMENTTION: */
	// ClassAd* ad = fromString ("" , jdl , fxm );
	/*  NEW IMPLEMENTTION utils */
	ClassAd* ad ( parse_classad(   jdl   )  );

	vector< pair< string, ExprTree* > > vect ;
	ad->GetComponents(  vect  ) ;
	// cout << "Iterating over classad: " << endl << flush ;
	if (vect.size() == 0 )  throw AdSyntaxException (__FILE__ , __LINE__ , "fromString(const string& jdl )"  ,   WL_JDLPARSE , "Not a valid ClassAd"  );
	for (unsigned int i = 0; i< vect.size() ; i++)  try{  /*cout << vect[i].first << endl << flush ;*/ insertAttribute ( vect[i].first , vect[i].second ) ; }catch (Exception &exc) { fxm += (string) exc.what() +"\n"; }
	// cout << "\n\nOUTPUT final Error: " << fxm << endl << flush ;
	if (fxm!= "")
	       throw AdSyntaxException (__FILE__ , __LINE__ , "fromString(const string& jdl )"  ,   WL_JDLPARSE , fxm  );
	EDG_STACK_CATCH() ;   //Exiting from method: remove line from stack trace
   };


/******************************
*  Add /append attribute Methods
********************************/
void Ad::addAttribute(string attr_name , Value val){  //TBD somebody calls???
   EDG_STACK_TRY("Ad::addAttribute(string attr_name , Value val)");
   //allowed values:
   string             strVal;
   int                 intVal;
   bool              bolVal;
   double           douVal;
   const ExprList    *el;
   if   (val.IsIntegerValue(intVal))
            addAttribute(attr_name , intVal);   //  Integer TYPE
   else if (val.IsStringValue(strVal))
            addAttribute(attr_name , strVal);   //  String  TYPE
   else if (val.IsBooleanValue(bolVal))
            addAttribute(attr_name , bolVal);   //  Boolean TYPE
   else if (val.IsRealValue(douVal))
            addAttribute(attr_name , douVal);   //  Real    TYPE
   else if (val.IsListValue(el)){
            ExprListIterator elIter(el);            //  LIST    TYPE: Iteration
            elIter.ToFirst();
            elIter.CurrentValue(val);
            while (!elIter.IsAfterLast()){
               //Recursive Function  call:
               addAttribute(attr_name,val);
               elIter. NextValue(val);
            }
   }  else  throw AdMismatchException ( __FILE__ , __LINE__ ,METHOD, WL_JDLSYN, attr_name);
  EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};
void Ad::appendValue(ExprTree* trees , const Value& val , const string& attr_name){
     string METHOD ="Ad::appendValue(ExprTree* trees , const Value& val , const string& attr_name)" ;
   // cout << "Ad::AppendValue for: " <<attr_name << endl<<flush;
     Value      valSource;
     const ExprList    *el;
     vector<ExprTree*>    vect;
     //ExprTree trees has to be copied in order to avoid memory-conflicts
     ExprTree *tree =  trees->Copy();
     if (tree== NULL)
        throw  AdClassAdException (__FILE__ , __LINE__ ,METHOD, WL_JDLSYN , "ExprTree::Copy();");
     //Converts the Source tree Expression to a Value valueSource
     // cout << "Ad::AppendValue 01 for: " <<attr_name << endl<<flush;
     if(  !EvaluateExpr( tree, valSource )    )
               throw  AdClassAdException (__FILE__ , __LINE__ ,METHOD, EPERM , "ClassAd::EvaluateExpr",attr_name);
     // Check The Source Value and retrieve/create the Vector
     // cout << "Ad::AppendValue 02 for: " <<attr_name << endl<<flush;
     if (  valSource.IsListValue(el)     )
          el-> GetComponents(vect);  //It's a list ->retrieve vector components
     else
          vect.push_back(tree);           //It's a single value -> append it to an empty vector
     // cout << "Ad::AppendValue 03 for: " <<attr_name << endl<<flush;
     /* val is the new value that needs to be inserted in the list:
     Set the new Value to a Literal (ExpTree son) and appends it*/
     Literal   *lit = Literal::MakeLiteral (val);
     // cout << "Ad::AppendValue 04 for: " <<attr_name << endl<<flush;
     if (lit!= NULL)
        vect.push_back(   (ExprTree*) lit  );
     else
        throw  AdClassAdException (__FILE__ , __LINE__ ,METHOD, WL_JDLSYN , "Literal::MakeLiteral");
     //Re-Generate the new ExprTreelist from the vector
     ExprList* newEl;
     // cout << "Ad::AppendValue 05 for: " <<attr_name << endl<<flush;
     newEl= ExprList::MakeExprList(vect);
     newEl -> SetParentScope(  (const ClassAd *) this ) ;    // TBD needed????
     // cout << "Ad::AppendValue 06 for: " <<attr_name << endl<<flush;
     insertAttribute(attr_name , newEl ) ;
   // cout << "Ad::AppendValue DONE for: " <<attr_name << endl<<flush;
};


void Ad::addAttribute(const string& attr_name, Ad* attr_value){
  EDG_STACK_TRY("Ad::addAttribute(const string& attr_name, Ad attr_value)");
    ExprTree*     tree= Lookup(attr_name) ;
    if (tree== NULL){
        //The attribute doesn't exist, it should be set
        setAttribute(attr_name , attr_value);
    }else {
	//  NEW IMPLEMENTATION:
	// Implementing appendValue without passing through Value:
	const ExprList    *el;
	Value val ;
	vector<ExprTree*>    vect;
	ExprTree*     trees =  tree->Copy();
	//Converts the Source tree Expression to a Value valueSource
	if(  !EvaluateExpr( trees, val )    )
		throw  AdClassAdException (__FILE__ , __LINE__ ,METHOD, EPERM, "ClassAd::EvaluateExpr" , attr_name);
	// Create a Vector with the previous value, wheter is a list or a simple classad
	if (  val.IsListValue(el)     )
		el-> GetComponents(vect);  //It's a list ->retrieve vector components
	else
		vect.push_back(trees);           //It's a single value -> append it to an empty vector
	// Now Add the new value:
	vect.push_back(  attr_value->Copy()  );
	//Re-Generate the new ExprTreelist from the vector
	ExprList* newEl;
	// cout << "Ad::AddAttribute 01 for: " <<attr_name << endl<<flush;
	newEl= ExprList::MakeExprList(vect);
	newEl -> SetParentScope(  (const ClassAd *) this ) ;    // TBD needed????
	// cout << "Ad::AddAttribute 02 for: " <<attr_name << endl<<flush;
	// cout << "Ad::AddAttribute 03 for: " <<attr_name << endl<<flush;
	insertAttribute(attr_name , newEl ) ;
	// cout << "Ad::AddAttribute DONE for: " <<attr_name << endl<<flush;
    }
    // cout << "Ad::addAttribute (Ad) Done." << attr_name << endl << flush ;
  EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
}
void Ad::addAttribute(const string& attr_name, int attr_value){
   EDG_STACK_TRY("Ad::addAttribute(const string& attr_name, int attr_value)");
    //Check the couple attr_name/attr_value
    ExprTree*     tree=Lookup(attr_name);
    if (tree==NULL) /** then */ setAttribute(attr_name , attr_value);
    else {
         //The attribute already exist. a list should be made
         Value      val;
         val.SetIntegerValue(attr_value);
         appendValue(tree , val , attr_name ) ;
    }
    EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

void Ad::addAttribute(const string& attr_name, double attr_value){
   EDG_STACK_TRY("Ad::addAttribute(const string& attr_name, double attr_value)") ;
    //Check the couple attr_name/attr_value

    ExprTree*     tree=Lookup(attr_name);
    if (tree==NULL)
        //The attribute doesn't exist, it should be set
        setAttribute(attr_name , attr_value);
    else {
         //The attribute already exist. a list should be made
         Value      val;
         val.SetRealValue(attr_value);
         appendValue(tree , val , attr_name );
    }
    EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

void Ad::addAttribute(const string& attr_name, bool attr_value){
   EDG_STACK_TRY("Ad::addAttribute(const string& attr_name, bool attr_value)") ;
    //Check the couple attr_name/attr_value
    ExprTree*     tree=Lookup(attr_name);
    if (tree==NULL)
        //The attribute doesn't exist, it should be set
        setAttribute(attr_name , attr_value);
    else {
         //The attribute already exist. A list should be made, aclling append Value method
         Value      val;
         val.SetBooleanValue(attr_value);
         //Append the value to the already existing Expression
         appendValue(tree , val , attr_name );
         }
    EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};
void Ad::addAttribute(const string& attr_name, const string& attr_value){
    EDG_STACK_TRY("Ad::addAttribute(const string& attr_name, const string& attr_value)") ;
    //Check the couple attr_name/attr_value
    ExprTree*     tree=Lookup(attr_name);
    if (tree==NULL)
        //The attribute doesn't exist, it should be set
        setAttribute(attr_name , attr_value);
    else {
         //The attribute already exist. a list should be made
         Value      val;
         val.SetStringValue(attr_value);
         //Append the value to the already existing Expression
         appendValue(tree , val , attr_name );
         }
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};


/***************************
* SetAttribute Methods
****************************/

void Ad::setAttributeExpr (const string& attr_name, const string& attr_value) {
   // EDG_STACK_TRY("Ad::setAttributeExpr (const string& attr_name, const string& attr_value)") ;
    if (  hasAttribute(attr_name)   )
        throw AdEmptyException (__FILE__ , __LINE__ , "Ad::setAttributeExpr (const string& attr_name, const string& attr_value)",   WL_JDLFULL ,attr_name);
   // JdlAttributeList jdlist ;
   ClassAdParser par ;
   ExprTree *expr =par.ParseExpression(attr_value, true) ;
   if (expr != NULL)
      insertAttribute (attr_name , expr);
   else
       throw  AdClassAdException (__FILE__ , __LINE__ , "Ad::setAttributeExpr (const string& attr_name, const string& attr_value)", WL_JDLSYN , "ClassAdParser::ParseExpression");
   // EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};



void Ad::setAttribute (const string& attr_name, int attr_value){
EDG_STACK_TRY("Ad::setAttribute (const string& attr_name, int attr_value)");
   if (  hasAttribute(attr_name)   )
        throw AdEmptyException (__FILE__ , __LINE__ ,METHOD,   WL_JDLFULL ,attr_name);
   // jdlist.checkInt (attr_name , attr_value) ;
   Value val ;
   val.SetIntegerValue(attr_value) ;
   insertAttribute( attr_name , val) ;
  EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

void Ad::setAttribute (const string& attr_name, double attr_value){
   EDG_STACK_TRY("Ad::setAttribute (const string& attr_name, double attr_value)");
   if (  hasAttribute(attr_name)   )
        throw AdEmptyException (__FILE__ , __LINE__ ,METHOD,   WL_JDLFULL ,attr_name);
   // jdlist.checkDouble(attr_name , attr_value);
   Value val ;
   val.SetRealValue(attr_value) ;
   insertAttribute( attr_name , val) ;
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

void Ad::setAttribute (const string& attr_name, bool attr_value){
   EDG_STACK_TRY("Ad::setAttribute (const string& attr_name, bool attr_value)");
   if (  hasAttribute(attr_name)   )
        throw AdEmptyException (__FILE__ , __LINE__ ,METHOD,   WL_JDLFULL ,attr_name);
   // jdlist.checkBool(attr_name , attr_value);
   Value val ;
   val.SetBooleanValue(attr_value) ;
   insertAttribute( attr_name , val) ;
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

void Ad::setAttribute (const string& attr_name, const string& attr_value){
   EDG_STACK_TRY("Ad::setAttribute (const string& attr_name, const string& attr_value)");
   if (  hasAttribute(attr_name)   )
        throw AdEmptyException (__FILE__ , __LINE__ ,METHOD,   WL_JDLFULL ,attr_name);
   Value val ;
   val.SetStringValue(attr_value) ;
   insertAttribute( attr_name , val) ;
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};
void Ad::setAttribute (const string& attr_name, Ad* attr_value){
   EDG_STACK_TRY("Ad::setAttribute (const string& attr_name, bool attr_value)");
 // cout <<"Ad::setAttribute (const string& attr_name, Ad* attr_value)" << attr_value->toString() << endl << flush ;
   if (  hasAttribute(attr_name)   )
        throw AdEmptyException (__FILE__ , __LINE__ ,METHOD,   WL_JDLFULL ,attr_name);
   insertAttribute( attr_name , attr_value->Copy()) ;
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

/*************************************
* get Methods :
*************************************/


string Ad::getAttributeExpr (const string& attr_name){
   //  EDG_STACK_TRY("JobAd::getAttributeExpr (const string& attr_name)throw (exception)") ;
   ExprTree* tree = Lookup (attr_name);
   ClassAdUnParser unp;
   if (tree == NULL )
        throw AdEmptyException (__FILE__ , __LINE__ ,  "Ad::getAttributeExpr (const string& attr_name)throw (exception)" ,   WL_JDLEMPTY ,attr_name);
   string buffer;
   unp.Unparse( buffer , tree);
   return buffer ;
   //  EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};


int Ad::getType (const string &attr_name ){
  EDG_STACK_TRY( "getType (const string &attr_name )") ;
  Value val =getTypeValue(attr_name);
  if (val.GetType() ==Value::LIST_VALUE){
       const ExprList    *el;
       vector<ExprTree*> vectList ;
       val.IsListValue(el) ;
       el->GetComponents(vectList) ;
       EvaluateExpr(  vectList[0] , val ) ;
  }
  switch ( (int) val.GetType()  ){
    case  (int) Value::ERROR_VALUE:
    case  (int) Value::INTEGER_VALUE:
    case  (int) Value::BOOLEAN_VALUE:
    case  (int) Value::STRING_VALUE:
    case  (int) Value::REAL_VALUE:
    case  (int) Value::UNDEFINED_VALUE:
        return (int) val.GetType() ;
    default:
        return TYPE_UNKNOWN ;
  }
  EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
} ;
/*
*Retreive a Value instance of the selected type
* This Method is used by all  get<type>value methods */
Value Ad::getTypeValue(const string& attr_name){
  ExprTree            *tree ;
  Value                val;
  tree = Lookup(attr_name.c_str()) ;
  if (tree==NULL)
       throw AdEmptyException (__FILE__ , __LINE__ ,   "getTypeValue(const string& attr_name)",   WL_JDLEMPTY ,attr_name);
  else
      EvaluateAttr(attr_name , val);
  return val;
};
vector<double> Ad::getDoubleValue(const string& attr_name)   {
   EDG_STACK_TRY("getDoubleValue(const string& attr_name)");
   double d;
   int    i;
   vector<double> vect;
   const ExprList *el;
   //Retrieve the Value type and Check
   Value val =  getTypeValue(attr_name);
   if (  val.IsRealValue(d)  ){             //It's a Real --->OK
        vect.push_back(d);
   }else if (  val.IsIntegerValue(i)  ){    //It's an Int --->OK (casting)
        vect.push_back(   (double) i);
   }else if (val.IsListValue(el)){          //It's a List, Iterate over values
    EvalState *es = NULL;
    for ( ExprList::const_iterator elIter = el->begin();
	  elIter != el->end(); elIter++ ) {
	  (*elIter)->Evaluate(*es, val);
         if (val.IsRealValue(d)){
             vect.push_back(d);
         } else if  ( val.IsIntegerValue(i)  ){
             vect.push_back ( (double) i);
         }else
             throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
         // elIter. NextValue(val);
      }
   }else  throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
   return vect;
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};

/* *****************************************************************
 methods :   get<type>[Value]
 Retreive the value of an attribute (if Value is specified return the value of the specified attribute as a vector)
 where <type> could be:
 -int
 -double
 -bool
 -string

*******************************************************************/
vector<bool> Ad::getBoolValue(const string& attr_name){
   EDG_STACK_TRY("getBoolValue(const string& attr_name)");
   bool            b;
   vector<bool>    vect ;
   const ExprList *el;
   //Retrieve the Value type and Check
   Value val =  getTypeValue(attr_name);
   if (  val.IsBooleanValue(b)  ){          //It's a Boolean --->OK
        vect.push_back(b);
   }else if (val.IsListValue(el)){          //It's a List, Iterate over values
/* OLD approach -> deprecated
      ExprListIterator elIter(el);
      elIter.ToFirst();
      elIter.CurrentValue(val);
      while (!elIter.IsAfterLast()){
*/
    EvalState *es = NULL;
    for ( ExprList::const_iterator elIter = el->begin();
	  elIter != el->end(); elIter++ ) {
	  (*elIter)->Evaluate(*es, val);
         if (val.IsBooleanValue(b)){
             vect.push_back(b);
         }else
             throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
         //elIter. NextValue(val);
      }
   } else  throw  AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
   return vect;
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};



/**  This is a static method that transforms a Value into a vector of string*/
vector<string> vectorString ( Value &val , const string& attr_name , const string& METHOD) {
	string s;
	vector<string> vect;
	const ExprList *el;
	if (val.IsStringValue(s)){           //It's astring --->OK
		vect.push_back(s);
	}else if (val.IsListValue( el)){          //It's a List, Iterate over values
		EvalState *es = NULL;
		for ( ExprList::const_iterator elIter = el->begin(); elIter != el->end(); elIter++ ) {
			(*elIter)->Evaluate(*es, val);
			if (val.IsStringValue(s))  vect.push_back(s);
			else throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
		}
	}else  throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
	return vect;
}


vector<vector<string> > Ad::getStringList(const string& attr_name){
	EDG_STACK_TRY("getStringValue(const string& attr_name)");
	Value val =  getTypeValue(attr_name);
	string s ;
	const ExprList *el;
	vector<vector<string> > vect;
	if (val.IsStringValue(s)){           //It's astring --->OK
		vector< string> one ;
		one.push_back(s);
		vect.push_back(one) ;
		// single value, just return
		return vect;
	}else if (val.IsListValue( el)){          //It's a List, Iterate over values
		EvalState *es = NULL;
		vector< string> one ;
		for ( ExprList::const_iterator elIter = el->begin(); elIter != el->end(); elIter++ ) {
			/*  Iterate over the list values, could be list of strings, lists, mixed:
				attr = {  "value1" , "value2" ...   }
				attr = {  "value1",  {"valueB1" , "valueB2"} ...   }
			*/
			(*elIter)->Evaluate(*es, val);
			if (val.IsStringValue(s)){
				// it's a string, all values must be string
				if ( vect.size() >0)
					throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
				one.push_back(s);
			}else if (val.IsListValue( )){
				// it's a list of string: all values must be string
				if ( one.size() >0)
					throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
				vect.push_back (   vectorString ( val , attr_name , METHOD ) ) ;
			}
		}
		if ( one.size() >0 )
			vect.push_back(one) ;
	}else  throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
	return vect ;
	EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
} ;


vector<string> Ad::getStringValue(const string& attr_name) {
	Value val =  getTypeValue(attr_name);
	return vectorString ( val , attr_name , "getStringValue(const string& attr_name)"  ) ;
};

vector<int> Ad::getIntValue(const string& attr_name){
   EDG_STACK_TRY("getIntValue(const string& attr_name)");
   int i ;
   vector<int> vect ;
   const ExprList *el;
   //Retrieve the Value type and Check
   Value val =  getTypeValue(attr_name);
   if (val.IsListValue(el)){             //It's a List, Iterate over values
    EvalState *es = NULL;
    for ( ExprList::const_iterator elIter = el->begin();
	  elIter != el->end(); elIter++ ) {
	  (*elIter)->Evaluate(*es, val);
         if (  val.IsIntegerValue(i)  )
            vect.push_back (i);
         else
            throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
         // elIter. NextValue(val);
      }
   }else  if (  val.IsIntegerValue(i)  ){  //It's an Int --->OK (casting)
      vect.push_back (i);
   }else throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name);
   return vect;
   EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
};


} // requestad namespace
COMMON_NAMESPACE_END } //Closing  UserInterFace NameSpace
