/* **************************************************************************
*  filename  : JdlAttributeList.cpp
*  author    : Alessandro Maraschini <alessandro.maraschini@datamat.it>
*  copyright : (C) 2002 by DATAMAT
***************************************************************************/

// Exception handling:
#include "edg/workload/common/requestad/JobAdExceptions.h"
#include "edg/workload/common/requestad/exception_codes.h"
// Default attribute values
#include "edg/workload/common/requestad/jdl_attributes.h"
// sp & split methods:
#include "edg/workload/common/utilities/utils.h"
// Header
#include "edg/workload/common/requestad/JdlAttributeList.h"
// Attribute names
#include "edg/workload/common/requestad/JDLAttributes.h"
// #include "edg/workload/common/requestad/JDLAttributes.h.G"
COMMON_NAMESPACE_BEGIN{ //Defining UserInterFace NameSpace
namespace requestad{
using namespace std ;
using namespace classad;
using namespace edg::workload::common::utilities ;
JdlAttributeList::JdlAttributeList(){
checking = true ;
// Stirng Attributes:
stringAttrs.push_back(JDL::EXECUTABLE) ;
stringAttrs.push_back(JDL::ARGUMENTS) ;
stringAttrs.push_back(JDL::STDINPUT) ;
stringAttrs.push_back(JDL::INPUTSB);
stringAttrs.push_back(JDL::STDOUTPUT);
stringAttrs.push_back(JDL::STDERROR);
stringAttrs.push_back(JDL::OUTPUTSB);
stringAttrs.push_back(JDL::ENVIRONMENT);
stringAttrs.push_back(JDL::MYPROXY);
stringAttrs.push_back(JDL::JOBTYPE);
stringAttrs.push_back(JDL::INPUTDATA);
stringAttrs.push_back(JDL::DATA_ACCESS);
stringAttrs.push_back(JDL::REPLICA_CATALOG);
stringAttrs.push_back(JDL::OUTPUT_SE);
stringAttrs.push_back(JDL::USER_CONTACT);
stringAttrs.push_back(JDL::JOBID);
stringAttrs.push_back(JDL::CE_MATCH);
stringAttrs.push_back(JDL::CHKPT_STEPS);
stringAttrs.push_back(JDL::CERT_SUBJ);
stringAttrs.push_back(JDL::CEID);
stringAttrs.push_back(JDL::SUBMIT_TO);
stringAttrs.push_back(JDL::HLR_LOCATION);
stringAttrs.push_back(JDL::LRMS_TYPE);
stringAttrs.push_back(JDL::MWVERSION);
stringAttrs.push_back(JDL::VIRTUAL_ORGANISATION);
// Integer Attributes:
// JDL::NODENUMB ,  JDL::CHKPT_STEPS , JDL::SHPORT, JDL::RETRYCOUNT
intAttrs.push_back(JDL::NODENUMB);
intAttrs.push_back(JDL::CHKPT_STEPS);
intAttrs.push_back(JDL::SHPORT);
intAttrs.push_back(JDL::RETRYCOUNT);
// DoubleAttributes: RANK , JDL::CE_RANK
doubleAttrs.push_back(JDL::RANK);
doubleAttrs.push_back(JDL::CE_RANK);
// BooleanAttributes: JDL::REQUIREMENTS , JDL::FUZZY_RANK
boolAttrs.push_back(JDL::REQUIREMENTS);
boolAttrs.push_back(JDL::RANK);
// Ad Attributes: OUTPUTDATA
adAttrs.push_back(JDL::OUTPUTDATA ) ;
// ListAttributes: DL::USER_CONTACT, JDL::INPUTSB,  JDL::OUTPUTSB, JDL::ENVIRONMENT ,JDL::JOBTYPE,
// JDL::INPUTDATA ,  JDL::DATA_ACCESS , JDL::CE_MATCH, JDL::CE_RANK , JDL::CHKPT_STEPS
listAttrs.push_back(JDL::USER_CONTACT) ;
listAttrs.push_back(JDL::INPUTSB) ;
listAttrs.push_back(JDL::OUTPUTSB) ;
listAttrs.push_back(JDL::ENVIRONMENT) ;
listAttrs.push_back(JDL::JOBTYPE) ;
listAttrs.push_back(JDL::INPUTDATA) ;
listAttrs.push_back(JDL::DATA_ACCESS) ;
listAttrs.push_back(JDL::CE_MATCH) ;
listAttrs.push_back(JDL::CE_RANK) ;
listAttrs.push_back(JDL::CHKPT_STEPS) ;
listAttrs.push_back(JDL::OUTPUTDATA) ;
// Expr Attributes:  JDL::RANK, JDL::REQUIREMENTS
exprAttrs.push_back(JDL::RANK) ;
exprAttrs.push_back(JDL::REQUIREMENTS) ;
// To be Checked Attributes: JDL::RANK, JDL::REQUIREMENTS, JDL::INPUTSB, JDL::ENVIRONMENT , JDL::SHPORT};
checkAttrs.push_back(JDL::RANK) ;
checkAttrs.push_back(JDL::REQUIREMENTS) ;
checkAttrs.push_back(JDL::INPUTSB) ;
checkAttrs.push_back(JDL::ENVIRONMENT) ;
checkAttrs.push_back(JDL::SHPORT) ;

// Default attribute
defaultAttrs.resize ( MAX_ATTR ) ;
setDefault ( JOBTYPE_MPICH_REQ_RTE , JDL_JOBTYPE_MPICH_REQ_RTE ) ;
setDefault ( JOBTYPE_MPICH_REQ_CPU ,JDL_JOBTYPE_MPICH_REQ_CPU ) ;
setDefault ( JOBTYPE_MPICH_RANK_FREE , JDL_JOBTYPE_MPICH_RANK_FREE ) ;
setDefault ( REQ_DEFAULT , JDL_REQ_DEFAULT ) ;
setDefault ( RANK_DEFAULT , JDL_RANK_DEFAULT ) ;
}; //End cTor
void JdlAttributeList::setDefault ( Attr attr_name , const string& attr_value){ //TBD REMOVE THIS METHOD
    defaultAttrs[attr_name] = attr_value ;
}  ;
bool  JdlAttributeList::findAttribute(const string& attr_name) {
   return   findAttr (attr_name , boolAttrs  )   ||
               findAttr (attr_name , intAttrs   )     ||
               findAttr (attr_name , stringAttrs)   ||
               findAttr (attr_name , doubleAttrs) ||
               findAttr (attr_name , adAttrs) ||
               findAttr (attr_name , exprAttrs  ) ;
};
//This Method verifies if the specified attribute belongs to the specified list
string JdlAttributeList::toLower ( const string & src) {
	string result = "" ;
	const char* tmp = src.c_str() ;
	// generate an array of char (one char overdimensioned for security)
	char res [src.length()+1] ;
	for  (unsigned int i = 0 ; i< src.length() ; i++ )
	    res[i] = tolower(  tmp[i]  ) ;
	// Add the string terminator char
	res[ src.length() ] = '\0' ;
	return string (res) ;
};
bool compare (const string& src , const string& dst ) {
	if (  JdlAttributeList::toLower(src) == JdlAttributeList::toLower(dst)   )
		return true ;
	return false ;

}
bool  JdlAttributeList::findAttr (const string& attr_name , vector<string> lis) const {
    vector<string>::iterator it;
    for (it = lis.begin() ; it!=lis.end() ; ++it)
        if ( toLower(*it) == toLower(attr_name) )
            return true;
    return false;
}
/******************************************************************
 PRIVATE methods :  check<type> (string attr_name , <type> attr_value )
 verify if the couple attr_name /attr_value is valid
 where <type> could be:
 -int
 -double
 -bool
 -string
 -Ad
 -Expression
*******************************************************************/
void JdlAttributeList::checkExpr(const string& attr_name,const string&  attr_value)   {
JDLATTR_SET_METHOD("checkExpr(const string& attr_name,const string&  attr_value)");
//Check if the couple is ok... i.e. rank and requirements
if (   findAttribute(attr_name)  || !checking )
   if (  ! findExpr(attr_name)  )
       throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name) ;
//   EDG_STACK_CATCH() ;   //Exiting from method: remove line from stack trace
};
void JdlAttributeList::checkInt(const string& attr_name, int attr_value)   {
JDLATTR_SET_METHOD("checkInt(const string& attr_name, int attr_value)");
if (   findAttribute(attr_name)  || !checking )
   if (   ( ! findInt(attr_name)  )  && ( ! findDouble(attr_name)  )   )
        throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name) ;
   else if(  compare (attr_name ,   JDL::NODENUMB) && ( attr_value < 1)  )
        throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLSYN  , attr_name , "value must be greater than 0") ;
   else if(  attr_value < 0 && !compare(attr_name ,   JDL::RETRYCOUNT) )
        throw AdMismatchException (__FILE__ , __LINE__ ,METHOD,  WL_JDLSYN , attr_name , "value cannot be less than 0") ;
//   EDG_STACK_CATCH() ;   //Exiting from method: remove line from stack trace
};
void JdlAttributeList::checkDouble(const string& attr_name, const double& attr_value)   {
JDLATTR_SET_METHOD("checkDouble(const string& attr_name, const double& attr_value)");
if (   findAttribute(attr_name)  || !checking )
   if    ( ! findDouble(attr_name) )
            throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name) ;
};
void JdlAttributeList::checkBool(const string& attr_name, const bool& attr_value)   {
JDLATTR_SET_METHOD("checkBool(const string& attr_name, const bool& attr_value)");
if (   findAttribute(attr_name)  || !checking )
   if    ( ! findBool(attr_name)   )
            throw  AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name) ;
};
void JdlAttributeList::checkAd(const string& attr_name, ClassAd* attr_value)   {
JDLATTR_SET_METHOD("checkAd(const string& attr_name, ClassAd* attr_value)");
	const string sepStr =  "$STR$"  ;
	if (   findAttribute(attr_name)  || !checking )
	if    ( ! findAd(attr_name)   )
		throw  AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name) ;
	ExprTree* tree ;
	Value val ;
	if (   compare (attr_name ,   JDL::OUTPUTDATA )   ){
		//     checked  Value = OD_OUTPUT_FILE
		tree = attr_value->Lookup ( JDL::OD_OUTPUT_FILE );
		if ( tree == NULL)
			throw AdSemanticMandatoryException ( __FILE__ , __LINE__ ,METHOD,   WL_JDLSYN ,JDL::OUTPUTDATA+"." +JDL::OD_OUTPUT_FILE ) ;
		// if (  !attr_value->EvaluateAttr(JDL::OD_OUTPUT_FILE , val )  )
		if (  !attr_value->EvaluateExpr(tree , val )  )
			throw AdClassAdException (__FILE__ , __LINE__ ,METHOD, WL_JDLSYN , "ClassAd::EvaluateExpr");
		if (  val.IsListValue() )
			throw AdListException( __FILE__ , __LINE__ ,METHOD,WL_JDLSYN , JDL::OUTPUTDATA + "."  + JDL::OD_OUTPUT_FILE) ;
		else if ( ! val.IsStringValue()  )
			throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , JDL::OUTPUTDATA+"." +JDL::OD_OUTPUT_FILE);
		//  checked Value = OD_LOGICAL_FILENAME
		tree = attr_value->Lookup ( JDL::OD_LOGICAL_FILENAME );
		if ( tree != NULL){
			// if (!attr_value->EvaluateAttr(JDL::OD_LOGICAL_FILENAME , val ))
			if (  !attr_value->EvaluateExpr(tree , val )  )
			throw AdClassAdException (__FILE__ , __LINE__ ,METHOD, WL_JDLSYN , "ClassAd::EvaluateExpr");
			string lfn ;
			if (  val.GetType() == Value::LIST_VALUE  )
				throw AdListException( __FILE__ , __LINE__ ,METHOD,WL_JDLSYN , JDL::OUTPUTDATA + "."  + JDL::OD_LOGICAL_FILENAME) ;
			else if (  !val.IsStringValue( lfn  )  )
				throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , JDL::OUTPUTDATA + "."  + JDL::OD_LOGICAL_FILENAME );
				vector<string> vec = split (lfn , ":") ;
				if  (vec[0] != "lfn")
					throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "lfn:<value>") ;
				if (checkFormat(  sepStr+sp(":")+ sepStr , lfn) )
					throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "lfn:<value>") ;
		}
	}
};


void JdlAttributeList::checkString(const string& attr_name, const string& attr_value)   {
JDLATTR_SET_METHOD("checkString(const string& attr_name, const string& attr_value)");
      if (   findAttribute(attr_name)  || !checking ){     //The attribute name exists:
            if  (    ( ! findString(attr_name) ) &&  ( ! findExpr(attr_name) )   ) //TBD..uhm.. findExpr... if it's a string... uihmmm TBD
                  throw AdMismatchException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name) ;
      string format;
      vector<string> vec ;
      const string sepStr =  "$STR$"  ;
      const string sepInt =  "$INT$"  ;
      //Ce_id Check
      if    (  compare (attr_name , JDL::CEID )   || compare (attr_name  , JDL::SUBMIT_TO ) ){
           format=sepStr+sp(":")+ sepInt+ sp("/") +sepStr +sp("-") +sepStr +sp("-") +sepStr ;
           if (checkFormat(format , attr_value) )
               throw  AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "<full-hostname>:<port-number>/jobmanager-<service>-<queuename>") ;
      }
      //ReplicaCatalog Check
      if ( compare (attr_name ,  JDL::REPLICA_CATALOG  )){
           format=sepStr+sp("://")+ sepStr+ sp(":") +sepInt +sp("/") +sepStr;
           if (checkFormat(format , attr_value) )
               throw  AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "<protocol>://<address>:<port>/<DN>") ;
      }
      //Environment Check
      else if (compare (attr_name ,   JDL::ENVIRONMENT)){
           format=sepStr+sp("=")+ sepStr ;
           if (checkFormat(format , attr_value) )
               throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "<variable>=<value>") ;
      }
      //InputData Check
      else if (compare (attr_name ,   JDL::INPUTDATA) ){
           vec = split (attr_value , ":") ;
           if (  (vec[0] != "lfn")&&(vec[0] != "guid")&&(vec[0] != "lds")
		 && (vec[0] != "query") )
                 throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "lfn | guid:<value> | lds | query") ;
           format=sepStr+sp(":")+ sepStr ;
           if (checkFormat(format , attr_value) )
                  throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "lfn | guid:<value> | lds | query") ;
      }
      //UserContact Check
      else if ( compare (attr_name ,   JDL::USER_CONTACT) ){
	  if ( count (attr_value , "@" )  != 1 )
                  throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "<user>@<host name>") ;
      }
      //StdOutput Check
      else if ( compare (attr_name ,   JDL::STDOUTPUT) ){
           if (  attr_value.find("..") ==0  )
                  throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "<absolute path>|<directory relative path>") ;
      }
      // WildCards check
	else if   (       compare( attr_name , JDL::STDOUTPUT) || 
		compare( attr_name , JDL::STDINPUT) || 
		compare (attr_name , JDL::EXECUTABLE ) ||
		compare (attr_name  , JDL::STDERROR  )  ){
              string wildcards  [JDL_ARRAY] = {"*" , "{" , "}" , "[", "]", "?" };
	      for (int i = 0  ;  i < JDL_ARRAY ; i++ )
	          if (   attr_value.find(  wildcards [i]) > 0 && attr_value.find(  wildcards [i]) < attr_value.length() )
                         throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "wildcards not allowed") ; //TBD change exc???

      }
      //OputputSandbox Check DEPRECATED
      /*
      else if compare (attr_name ,   JDL::OUTPUTSB){
          vec = split (attr_value , "/") ;
          if (    (vec.size()>1)  )
                  throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "<simple file name>") ;
      }*/
      //JobType Format
      /*
      else if compare (attr_name ,  JDL::JOBTYPE ){
         if (   (attr_value !=JDL_JOBTYPE_MPICH)
           &&  (attr_value !=JDL_JOBTYPE_NORMAL)
           &&  (attr_value !=JDL_JOBTYPE_PARTITIONABLE)
           &&  (attr_value !=JDL_JOBTYPE_MULTIPLE)
           &&  (attr_value !=JDL_JOBTYPE_CHECKPOINTABLE)
           &&  (attr_value !=JDL_JOBTYPE_INTERACTIVE)    )
                  throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JDLMISMATCH , attr_name , "MpiCh | Normal | Partitionable | Multiple | Checkpointable") ;
      }
      */
} // end if findAttribute
//   EDG_STACK_CATCH() ;   //Exiting from method: remove line from stack trace
};

} // namespace requestad
COMMON_NAMESPACE_END } //Closing  UserInterFace NameSpace
