/* **************************************************************************
*  filename  : JobAdSchema.cpp
*  author    : Alessandro Maraschini <alessandro.maraschini@datamat.it>
*  copyright : (C) 2003 by DATAMAT
***************************************************************************/

#include "edg/workload/common/requestad/JobAdSchema.h"
// Exception handling:
#include "edg/workload/common/requestad/JobAdExceptions.h"
#include "edg/workload/common/requestad/exception_codes.h"
#include <iostream>


COMMON_NAMESPACE_BEGIN{ //Defining UserInterFace NameSpace
namespace requestad{
using namespace std ;
using namespace edg::workload::common::utilities ;


	/** GLUE schema static constructor  (JobAd default utilised schema)*/
	JobAdSchema* JobAdSchema::glueSchema( ) {
		// EDG_STACK_TRY("glueSchema( )");
		JobAdSchema *schema = new JobAdSchema() ;
		schema->values.push_back("other.DataAccessCost") ;
		schema->values.push_back("other.GlueHostApplicationSoftwareRunTimeEnvironment") ;
		schema->values.push_back("other.GlueCEInfoTotalCPUs") ;
		schema->values.push_back("other.GlueCEStateFreeCPUs") ;
		schema->values.push_back("other.GlueHostNetworkAdapterOutboundIP") ;
		return schema ;
		// EDG_STACK_CATCH() ; //Exiting from method: remove line from stack trace
	}
	JobAdSchema* JobAdSchema::Copy( ){ return new JobAdSchema ( values) ; } ;

/*
	/ EDG schema static constructor /
	static public *JobAdSchema JobAdSchema::edgSchema( ) {
		string values [] =  {  } ;
		return new JobAdSchema ( values) ;
	}
*/

	/** CUSTOM schema constructor
	* @param values an array of string of #SCHEMA_ARRAY dimension  */
	JobAdSchema::JobAdSchema (vector <string > vals) {
		string METHOD = "JobAdSchema" ;
		values.resize(0) ;
		// chek the dimension:
		if ( vals.size() != SCHEMA_ARRAY  )
			throw AdFormatException (__FILE__ , __LINE__ ,METHOD, WL_JOBADSCHEMA, "") ;
		for (unsigned int i = 0 ; i< SCHEMA_ARRAY; i++ ){
			// cout << i << ") JobSchema constructor Setting Attribute...  " << vals[i] << "#" << endl ;
			values.push_back(  vals[i]   );
		}
	}

	string JobAdSchema::get ( attribute attrName ) {
		if ( attrName >= SCHEMA_ARRAY )
			// attribute is wfongly casted by an integer
			throw std::bad_cast() ;
		// cout << "JobADSchecma getting found: "<< values[attrName]   << endl ;
		return values[attrName] ;
	} ;


	JobAdSchema::JobAdSchema(){
		/** Do nothing, this megtod is private */
	} ;



} // namespace requestad
COMMON_NAMESPACE_END } //Closing  UserInterFace NameSpace
