#include "ManipulationExceptions.h"

using namespace std;

namespace edg { namespace workload { namespace common { namespace requestad {

ManipulationException::ManipulationException( const string &parameter ) : exception(), me_parameter( parameter ), me_reason()
{}

ManipulationException::~ManipulationException( void ) throw()
{}

const char *ManipulationException::what( void ) const throw()
{
  this->me_reason.assign( "RequestAd module: " );
  this->me_reason.append( this->reason() );

  return this->me_reason.c_str();
}

string ManipulationException::reason( void ) const
{
  string     error( "Error while manipulating ClassAd parameter: " );

  error.append( this->me_parameter );

  return error;
}

CannotGetAttribute::CannotGetAttribute( const string &parameter ) : ManipulationException( parameter )
{}

CannotGetAttribute::~CannotGetAttribute( void ) throw()
{}

string CannotGetAttribute::reason( void ) const
{
  string    error( "Error while extracting ClassAd parameter: " );

  error.append( this->me_parameter );

  return error;
}

CannotSetAttribute::CannotSetAttribute( const string &parameter ) : ManipulationException( parameter )
{}

CannotSetAttribute::~CannotSetAttribute( void ) throw()
{}

string CannotSetAttribute::reason( void ) const
{
  string     error( "Error while setting ClassAd parameter: " );

  error.append( this->me_parameter );

  return error;
}

CannotRemoveAttribute::CannotRemoveAttribute( const string &parameter ) : ManipulationException( parameter )
{}

CannotRemoveAttribute::~CannotRemoveAttribute( void ) throw()
{}

string CannotRemoveAttribute::reason( void ) const
{
  string     error( "Error while removing ClassAd parameter: " );

  error.append( this->me_parameter );

  return error;
}

}}}}; // Namespaces closure
