// $Id: dgas_config.cpp,v 1.2 2003/04/11 08:44:19 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/

#include <iostream>
#include <fstream>
#include <string>
#include <dgas_config.h>

inline string stripBeginBlanks (string textLine)
{
	string::size_type pos = 0;
	if ( textLine.length() != 0 )
	{
	while ( textLine[pos] == ' ' || textLine[pos] == '\t' || textLine[pos] == '\n')
	{
		textLine.erase( pos, 1);
	}
	}
	return textLine;
}

int
dgas_conf_read( string confFileName, map<string,string> *confMap)
{
	ifstream inFile(confFileName.c_str());
	if ( ! inFile )
	{
		#ifdef DEBUG
		 cerr << "Error opening config file: "<< confFileName << endl;
		#endif
		 return 1;
	}
	string textLine;
	while ( getline (inFile, textLine, '\n'))
	{
		textLine = stripBeginBlanks(textLine);
		if (textLine[0] == '#')
		{
			continue;
		}
		if (textLine.find("=") != string::npos )
		{
			string::size_type pos = 0;
			pos = textLine.find_first_of("=");
			string param = textLine.substr(0,pos);
			string value = textLine.substr(pos);
			pos =0;
			while ((pos = param.find_first_of( " \t", pos)) 
					!= string::npos)
			{
				param.erase ( pos, 1);
			}
			string::size_type endpos = 0;
			pos = value.find_first_of("\"");
			endpos = value.find_first_of("\"", pos+1);
			if ( pos == string::npos || endpos == string::npos)
				return 2;
			value = value.substr(pos+1, endpos-pos-1);
			confMap->insert(
					map<string,string>::
					value_type( param, value)
					);
			
		}
			
	}
	inFile.close();
	return 0;
}//dgas_conf_read()


