// $Id: libdgas_log.cpp,v 1.4 2003/12/02 10:21:15 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/




#ifndef LIB_HLR_CT_H
#define LIB_HLR_CT_H


#include "libdgas_log.h"
#include <iostream>
#include <fstream>
#include <sstream>

#ifndef SYSTEM_LOG_LEVEL
#define SYSTEM_LOG_LEVEL 6
#endif

/* Function definitions*/

	

/* Error and Log printing functions 
 *
 */
  

int hlr_error ( string error_string )
{
	cerr << "ERROR: "<< error_string << endl;
	return 0;
}


int hlr_log ( string log_string , int log_level )
{
	if ( log_level <= SYSTEM_LOG_LEVEL )
	{
		cerr << "LOG (" << log_level << "): " << log_string << endl;
	}
	return 0;
}

int hlr_log ( string log_string, ofstream *logFile , int log_level )
{
	time_t curtime;
	struct tm *timeLog;
	curtime = time(NULL);
	timeLog = localtime(&curtime);
	char timeBuff[22];
	strftime(timeBuff,sizeof(timeBuff),"%Y %b %d %T",timeLog); 
	//strip end of line from log_string;
	if ( log_level <= SYSTEM_LOG_LEVEL )
	{
		*logFile << "LOG (" << log_level << ") " << timeBuff  <<" : " << log_string << endl;
	}
	return 0;
}


/* Function definitions*/

int bootstrapLog(string logFileName, ofstream *logfile)
{
	time_t curtime;
	struct tm *timeLog;
	curtime = time(NULL);
	timeLog = localtime(&curtime);
	
	logfile->open( logFileName.c_str() , ios::app);
	if ( !(*logfile) )
	{
		return 1;
	}
	else
	{
		*logfile << "Log start up on:" << asctime(timeLog) << endl;
		return 0;
	}
	

}

/* Error and Log printing functions 
 *
 */
  


#endif
