#include "xmlUtil.h"

inline string stripWhite ( string &input )
{
	size_t startPos = input.find_first_not_of(" \n\0");
	if ( startPos == string::npos )
		return "";
	size_t endPos = input.find_last_not_of(" \n\0");
	if ( endPos == string::npos )
		return "";
	return input.substr( startPos, endPos - startPos +1 );
}


node parse(string *xmlInput, string _tag)
{
	string * _mainDoc = xmlInput;
	size_t pos;
	pos = xmlInput->find("<" + _tag);
	if ( pos == string::npos )
	{
		node nodeBuff(_mainDoc, atoi(E_PARSE_ERROR));
		return nodeBuff;
	}
	string starttag = xmlInput->substr(pos, 
			xmlInput->find_first_of(">",pos)-pos+1);
	string endtag = "</" + _tag + ">";
	string buffer;
	pos = xmlInput->find( starttag );
	if ( pos == string::npos )
	{
		node nodeBuff(_mainDoc, atoi(E_PARSE_ERROR));
		return nodeBuff;	
	}
	else
	{
		size_t _startPos = pos;
		size_t textStart = pos + starttag.size();
		pos = xmlInput->find( endtag );
		if ( pos == string::npos )
		{
			node nodeBuff(_mainDoc, atoi(E_PARSE_ERROR));
			return nodeBuff;
		}
		else
		{
			size_t _endPos = pos + endtag.size();
			size_t textEnd = pos;
			string _text = xmlInput->substr(
					textStart,
					textEnd-textStart);
			_text = stripWhite(_text);
			node nodeBuff(_mainDoc, 
					0,
					_tag,
					_text,
					_startPos,
					_endPos,
					true );
			return nodeBuff;
				       	
			
		}
		
	}
	
}

attrType node::getAttributes()
{
	attrType attributes;
	if (valid)
	{
		size_t pos = startPos + tag.size() +1;	
		string buffer;
		buffer = mainDoc->substr(pos,
				mainDoc->find_first_of(">",pos) - pos);
		bool goOn = true;
		while ( goOn )
		{
			pos = buffer.find_first_not_of(" ,");
			if ( pos == string::npos )
			{
				goOn = false;
				break;
			}
			size_t pos1 = buffer.find_first_of("=");
			string param = buffer.substr(pos,
					pos1 - pos);
			param = stripWhite(param);
			buffer.erase(0, pos1 +1);
			pos = buffer.find_first_of('\"');
			pos1 = buffer.find_first_of('\"',pos+1);
			string value = buffer.substr(pos+1, 
					pos1 - pos -1);
			value = stripWhite(value);
			buffer.erase(0, pos1 +1);
			attributes.insert(
					attrType::
					value_type(param,value)
					);
		}
		if ( attributes.size() == 0 )
		{
			status = atoi(E_NO_ATTRIBUTES);
			return attributes;
		}
		return attributes;
		
	}
	else
	{
		status = atoi(E_PARSE_ERROR);
		
	}
	return attributes;
}

int node::release()
{
	if (valid)
	{
		mainDoc->erase(startPos, endPos-startPos);
		valid = false;
		return 0;
	}
	else
	{
		return atoi(E_PARSE_ERROR);
	}
}
