// $Id: hlrAcctdesc.cpp,v 1.3 2003/09/02 14:13:05 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<hlrAcctdesc.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;

hlrAcctdesc::hlrAcctdesc( string _id,
		string _type,
		string _email,
		string _descr,
		string _certSubject)
{
	id = _id;
	email = _email;
	descr = _descr;
	certSubject = _certSubject;
	type = _type;
	#ifdef DEBUG
	 cerr << "hlrAcctdesc::hlrAcctdesc:" << *this << endl;
	#endif
}


int hlrAcctdesc::get()
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _id = id;
		string _type = type;
		string _email = email;
		string _descr = descr;
		string _certSubject = certSubject;
		//connection to the DB Ok, go on
		if (id == "" ) _id = "%";
		if (type == "" ) _type = "%";
		if (email == "" ) _email = "%";
		if (descr == "" ) _descr = "%";
		if (certSubject == "" ) _certSubject = "%";
		string queryStr =  "SELECT * FROM acctdesc WHERE ";
		queryStr += "id LIKE '" + _id + "' AND ";
		queryStr += "a_type LIKE '" + _type + "' AND ";
		queryStr += "email LIKE '" + _email + "' AND ";
		queryStr += "descr LIKE '" + _descr + "' AND ";
		queryStr += "cert_subject LIKE '" + _certSubject + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrAcctdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				id = result.getItem(0,0);
				type = result.getItem(0,1);
				email = result.getItem(0,2);
				descr = result.getItem(0,3);
				certSubject = result.getItem(0,4);
				#ifdef DEBUG
				 cerr << "DEBUG: hlrAcctdesc::get()," << *this <<endl;
				#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << hlrDb.errNo << ":" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrAcctdesc::get(vector<hlrAcctdesc>& uv)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _id = id;
		string _type = type;
		string _email = email;
		string _descr = descr;
		string _certSubject = certSubject;
		//connection to the DB Ok, go on
		if (id == "" ) _id = "%";
		if (type == "" ) _type = "%";
		if (email == "" ) _email = "%";
		if (descr == "" ) _descr = "%";
		if (certSubject == "" ) _certSubject = "%";
		string queryStr =  "SELECT * FROM acctdesc WHERE ";
		queryStr += "id LIKE '" + _id + "' AND ";
		queryStr += "a_type LIKE '" + _type + "' AND ";
		queryStr += "email LIKE '" + _email + "' AND ";
		queryStr += "descr LIKE '" + _descr + "' AND ";
		queryStr += "cert_subject LIKE '" + _certSubject + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrAcctdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else 
			{
				hlrAcctdesc u;
				for (int i =0; i < numRows; i++ )
				{
					u.id = result.getItem(i,0);
					u.type = result.getItem(i,1);
					u.email = result.getItem(i,2);
					u.descr = result.getItem(i,3);
					u.certSubject = result.getItem(i,4);
					#ifdef DEBUG
				 	cerr << "DEBUG: hlrAcctdesc::get(vector<hlrAcctdesc> *)," << *this << endl;
					#endif
					uv.push_back(u);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

int hlrAcctdesc::put()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO acctdesc VALUES ('";
		queryStr += id + "','";
		queryStr += type + "','";
		queryStr += email + "','";
		queryStr += descr + "','";
		queryStr += certSubject + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "hlrAcctdesc::put(),inserted:id=" << *this << endl;
		#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

int hlrAcctdesc::del()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr;
		queryStr = "DELETE FROM acctdesc WHERE id='";
		queryStr += id + "'";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		else
		{
			#ifdef DEBUG
			 cerr << "hlrAcctdesc::del(),deleted:id=" <<id << endl;;
			#endif
			return 0;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

bool hlrAcctdesc::exists()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		//connection to the DB Ok, go on
		string _id = id;
		string _type = type;
		string _email = email;
		string _descr = descr;
		string _certSubject = certSubject;
		if (id == "" ) _id = "%";
		if (type == "" ) _type = "%";
		if (email == "" ) _email = "%";
		if (descr == "" ) _descr = "%";
		if (certSubject == "" ) _certSubject = "%";
		string queryStr =  "SELECT id FROM acctdesc WHERE ";
		queryStr += "id LIKE '" + _id + "' AND ";
		queryStr += "a_type LIKE '" + _type + "' AND ";
		queryStr += "email LIKE '" + _email + "' AND ";
		queryStr += "descr LIKE '" + _descr + "' AND ";
		queryStr += "cert_subject LIKE '" + _certSubject + "'";
		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return false; 
	}
}

int hlrAcctdesc::getKeys(vector<string>& keys)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _id = id;
		string _type = type;
		string _email = email;
		string _descr = descr;
		string _certSubject = certSubject;
		//connection to the DB Ok, go on
		if (id == "" ) _id = "%";
		if (type == "" ) _type = "%";
		if (email == "" ) _email = "%";
		if (descr == "" ) _descr = "%";
		if (certSubject == "" ) _certSubject = "%";
		string queryStr =  "SELECT id FROM acctdesc WHERE ";
		queryStr += "id LIKE '" + _id + "' AND ";
		queryStr += "a_type LIKE '" + _type + "' AND ";
		queryStr += "email LIKE '" + _email + "' AND ";
		queryStr += "descr LIKE '" + _descr + "' AND ";
		queryStr += "cert_subject LIKE '" + _certSubject + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrAcctdesc::getKeys(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else 
			{
				//vector<hlrAcctdesc> uvBuff;
				string k;
				for (int i =0; i < numRows; i++ )
				{
					k = result.getItem(i,0);
					#ifdef DEBUG
				 	cerr << "DEBUG: hlrAcctdesc::get(vector<string> *),";
				 	cerr << "id=" << k << endl;
					#endif
					keys.push_back(k);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

ostream& operator << ( ostream& os, const hlrAcctdesc& a )
{
	os << "id=" << a.id;
	os << ",type=" << a.type;
	os << ",email=" << a.email;
	os << ",descr=" << a.descr;
	os << ",certSubject=" << a.certSubject;
	return os;

}
