// $Id: hlrFdesc.cpp,v 1.2 2003/04/28 14:44:49 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<hlrFdesc.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;


hlrFdesc::hlrFdesc( string _fid,
		string _descr,
		int _total,
		int _spent)
{
	fid = _fid;
	descr = _descr;
	total = _total;
	spent = _spent;
	#ifdef DEBUG
	 cerr << "hlrFdesc::hlrFdesc:fid=" << fid;
	 cerr << "descr=" << descr;
	 cerr << "total=" << total;
	 cerr << "spent=" << spent << endl;
	#endif
}

int hlrFdesc::get()
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _fid = fid;
		string _descr = descr;
		//connection to the DB Ok, go on
		if (fid == "" ) _fid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT * FROM fdesc WHERE ";
		queryStr += "fid LIKE '" + _fid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrFdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				fid = result.getData()[0][0];
				descr = result.getData()[0][1];
				total = atoi((result.getData()[0][2]).c_str());
				spent = atoi((result.getData()[0][3]).c_str());
				#ifdef DEBUG
				 cerr << "DEBUG: hlrFdesc::get(),";
				 cerr << "fid=" << fid << ",";
				 cerr << "descr=" << descr << ",";
				 cerr << "total=" << total << ",";
				 cerr << "spent=" << spent << endl;
				#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrFdesc::get(vector<hlrFdesc>& fv)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _fid = fid;
		string _descr = descr;
		//connection to the DB Ok, go on
		if (fid == "" ) _fid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT * FROM fdesc WHERE ";
		queryStr += "fid LIKE '" + _fid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrFdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				hlrFdesc f;
				for (int i = 0; i < numRows; i++)
				{
					f.fid = result.getItem(i,0);
					f.descr = result.getItem(i,1);
					f.total = atoi(result.getItem(i,2).c_str());
					f.spent = atoi(result.getItem(i,3).c_str());
					#ifdef DEBUG
					 cerr << "DEBUG: hlrFdesc::get(),";
					 cerr << "fid=" << f.fid << ",";
					 cerr << "descr=" << f.descr << ",";
					 cerr << "total=" << f.total << ",";
					 cerr << "spent=" << f.spent << endl;
					#endif
					 fv.push_back(f);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

int hlrFdesc::put()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO fdesc VALUES ('";
		queryStr += fid + "','";
		queryStr += descr + "','";
		queryStr += int2string(total) + "','";
		queryStr += int2string(spent) + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "hlrFdesc::put(),inserted:fid=" <<fid;
		 cerr << ",descr="<<descr;
		 cerr << ",total="<<total;
		 cerr << ",spent="<<spent<<endl;
		#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


int hlrFdesc::del()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr;
		queryStr = "DELETE FROM fdesc WHERE fid='";
		queryStr += fid + "'";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		else
		{
			#ifdef DEBUG
			 cerr << "hlrFdesc::del(),deleted:fid=" <<fid << endl;;
			#endif
			return 0;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


bool hlrFdesc::exists()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		//connection to the DB Ok, go on	
		string _fid = fid;
		string _descr = descr;
		if (fid == "" ) _fid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT fid FROM fdesc WHERE ";
		queryStr += "fid LIKE '" + _fid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrFdesc::exists(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif

		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return false; 
	}
}

int hlrFdesc::getKeys(vector<string>& keys)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _fid = fid;
		string _descr = descr;
		//connection to the DB Ok, go on
		if (fid == "" ) _fid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT fid FROM fdesc WHERE ";
		queryStr += "fid LIKE '" + _fid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrFdesc::getKeys(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				string k;
				for (int i = 0; i < numRows; i++)
				{
					k = result.getItem(i,0);
					#ifdef DEBUG
					 cerr << "DEBUG: hlrFdesc::getKeys(),";
					 cerr << "fid=" << k << ",";
					#endif
					 keys.push_back(k);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

int hlrFdesc::credit(int& v)
{
        #ifdef DEBUG
        cerr << endl <<"DEBUG: ENTERING "<< __BASE_FILE__ << "::credit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
                        hlr_sql_user,
                        hlr_sql_password,
                        hlr_sql_dbname
                );		
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE fdesc ";
		queryStr += "SET total=total+" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "fid='" + fid +"'";
		#ifdef DEBUG
		cerr << "DEBUG:hlrFdesc::credit(),";
		cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
			cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
			cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
			cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
		        cerr <<"DEBUG: EXITING "<< __BASE_FILE__ << "::credit()..." << endl;
			#endif	
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
	        cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
                cerr << "Error connecting to the DataBase, got error:" << endl;
                cerr << hlrDb.errMsg << endl;
                #endif
                #ifdef DEBUG
		cerr <<"DEBUG: EXITING "<< __BASE_FILE__ << "::credit()..." << endl;
                #endif
                return hlrDb.errNo;
	}
        #ifdef DEBUG
	cerr <<"DEBUG: EXITING "<< __BASE_FILE__ << "::credit()..." << endl;
        #endif
	return 0;
	
}

int hlrFdesc::debit(int& v)
{
        #ifdef DEBUG
        cerr << endl <<"DEBUG: ENTERING "<< __BASE_FILE__ << "::debit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
                        hlr_sql_user,
                        hlr_sql_password,
                        hlr_sql_dbname
                );		
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE fdesc ";
		queryStr += "SET spent=spent+" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "fid='" + fid +"'";
		#ifdef DEBUG
		cerr << "DEBUG:hlrFdesc::debit(),";
		cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
			cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
			cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
			cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
		        cerr <<"DEBUG: EXITING "<< __BASE_FILE__ << "::debit()..." << endl;
			#endif	
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
	        cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
                cerr << "Error connecting to the DataBase, got error:" << endl;
                cerr << hlrDb.errMsg << endl;
                #endif
                #ifdef DEBUG
		cerr <<"DEBUG: EXITING "<< __BASE_FILE__ << "::debit()..." << endl;
                #endif
                return hlrDb.errNo;
	}
        #ifdef DEBUG
	cerr <<"DEBUG: EXITING "<< __BASE_FILE__ << "::debit()..." << endl;
        #endif
	return 0;
	
}
