// $Id: hlrGf.cpp,v 1.2 2003/04/28 14:44:49 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<hlrGf.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;


hlrGf::hlrGf( string _gid,
		string _fid,
		int _total,
		int _booked,
		int _spent)
{
	gid = _gid;
	fid = _fid;
	total = _total;
	booked = _booked;
	spent = _spent;
	#ifdef DEBUG
	 cerr << "hlrUdesc::hlrUdesc:gid=" << gid;
	 cerr << "fid=" << fid;
	 cerr << "total=" << total;
	 cerr << "booked=" << booked;
	 cerr << "spent=" << spent << endl;
	#endif
}

int hlrGf::get()
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM gf WHERE ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGf::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				gid = result.getData()[0][1];//It is right :
				fid = result.getData()[0][0];// fid:0 gid:1 !
				total = atoi((result.getData()[0][2]).c_str());
				booked = atoi((result.getData()[0][3]).c_str());
				spent = atoi((result.getData()[0][4]).c_str());
				#ifdef DEBUG
				 cerr << "DEBUG: hlrGf::get(),";
				 cerr << "gid=" << gid << ",";
				 cerr << "fid=" << fid << ",";
				 cerr << "total=" << total << ",";
				 cerr << "booked=" << booked << ",";
				 cerr << "spent=" << spent << endl;
				#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrGf::get(vector<hlrGf>& gv)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM gf WHERE ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGf::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				hlrGf g;
				for ( int i =0; i < numRows; i++ )
				{
					g.gid = result.getItem(i,1);//It is right :
					g.fid = result.getItem(i,0);// fid:0 gid:1 !
					g.total = atoi(result.getItem(i,2).c_str());
					g.booked = atoi(result.getItem(i,3).c_str());
					g.spent = atoi(result.getItem(i,4).c_str());
					#ifdef DEBUG
					 cerr << "DEBUG: hlrGf::get(),";
					 cerr << "gid=" << g.gid << ",";
					 cerr << "fid=" << g.fid << ",";
					 cerr << "total=" << g.total << ",";
					 cerr << "booked=" << g.booked << ",";
					 cerr << "spent=" << g.spent << endl;
					#endif
					gv.push_back(g);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

int hlrGf::put()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO gf VALUES ('";
		queryStr += fid + "','";//it is right! fid before gid
		queryStr += gid + "','";
		queryStr += int2string(total) + "','";
		queryStr += int2string(booked) + "','";
		queryStr += int2string(spent) + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "hlrGf::put(),inserted:gid=" <<gid;
		 cerr << ",fid="<<fid;
		 cerr << ",total="<<total;
		 cerr << ",booked="<<booked;
		 cerr << ",spent="<<spent<<endl;
		#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


int hlrGf::del()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr;
		//FIXME modify to use wildcards
		queryStr = "DELETE FROM gf WHERE gid='";
		queryStr += gid + "' AND fid='";
		queryStr += fid + "'";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		else
		{
			#ifdef DEBUG
			 cerr << "hlrGf::del(),deleted:gid=" <<gid;
			 cerr << ",fid=" << fid << endl;
			#endif
			return 0;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


bool hlrGf::exists()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		//connection to the DB Ok, go on
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM gf WHERE ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGf::exists(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif

		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			cerr << queryStr << endl;
			#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return false; 
	}
}

int hlrGf::credit(int& v)
{

	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrGf::credit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE gf ";
		queryStr += "SET total=total+" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "gid='" + gid +"' AND ";
		queryStr += "fid='" + fid +"' ";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGf::credit(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrGf::credit()" << endl;
       		 	#endif
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrGf::credit()" << endl;
       	 	#endif
		return false; 
	}
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrGf::credit()" << endl;
        	#endif
		return 0;
}

int hlrGf::debit(int& v)
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrGf::debit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE gf ";
		queryStr += "SET spent=spent+" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "gid='" + gid +"' AND ";
		queryStr += "fid='" + fid +"' ";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGf::credit(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrGf::debit()" << endl;
       		 	#endif
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrGf::debit()" << endl;
       	 	#endif
		return false; 
	}
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrGf::debit()" << endl;
        	#endif
	return 0;
}
