// $Id: hlrGrdesc.cpp,v 1.2 2003/04/28 14:44:49 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<hlrGrdesc.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;

hlrGrdesc::hlrGrdesc( string _gid,
		string _descr)
{
	gid = _gid;
	descr = _descr;
	#ifdef DEBUG
	 cerr << "hlrGrdesc::hlrGrdesc:gid=" << gid;
	 cerr << "descr=" << descr << endl;
	#endif
}

int hlrGrdesc::get()
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _gid = gid;
		string _descr = descr;
		//connection to the DB Ok, go on
		if (gid == "" ) _gid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT * FROM grdesc WHERE ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGrdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				gid = result.getData()[0][0];
				descr = result.getData()[0][1];
				#ifdef DEBUG
				 cerr << "DEBUG: hlrGrdesc::get(),";
				 cerr << "gid=" << gid << ",";
				 cerr << "descr=" << descr << endl;
				#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrGrdesc::get(vector<hlrGrdesc>& gv)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _gid = gid;
		string _descr = descr;
		//connection to the DB Ok, go on
		if (gid == "" ) _gid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT * FROM grdesc WHERE ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGrdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				hlrGrdesc g;
				for ( int i = 0; i < numRows; i++ )
				{
					g.gid = result.getItem(i,0);
					g.descr = result.getItem(i,0);
					#ifdef DEBUG
				 	cerr << "DEBUG: hlrGrdesc::get(),";
				 	cerr << "gid=" << g.gid << ",";
				 	cerr << "descr=" << g.descr << endl;
					#endif
					gv.push_back(g);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


int hlrGrdesc::put()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO grdesc VALUES ('";
		queryStr += gid + "','";
		queryStr += descr + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "hlrGrdesc::put(),inserted:gid=" <<gid;
		 cerr << ",descr="<<descr << endl;
		#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


int hlrGrdesc::del()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr;
		queryStr = "DELETE FROM grdesc WHERE gid='";
		queryStr += gid + "'";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		else
		{
			#ifdef DEBUG
			 cerr << "hlrGrdesc::del(),deleted:gid=" <<gid << endl;;
			#endif
			return 0;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}



bool hlrGrdesc::exists()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string _gid = gid;
		string _descr = descr;
		//connection to the DB Ok, go on
		if (gid == "" ) _gid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT gid FROM grdesc WHERE ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGrdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return false; 
	}
}

int hlrGrdesc::getKeys(vector<string>& keys)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _gid = gid;
		string _descr = descr;
		//connection to the DB Ok, go on
		if (gid == "" ) _gid = "%";
		if (descr == "" ) _descr = "%";
		string queryStr =  "SELECT gid FROM grdesc WHERE ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "descr LIKE '" + _descr + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrGrdesc::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				string k;
				for ( int i = 0; i < numRows; i++ )
				{
					k = result.getItem(i,0);
					#ifdef DEBUG
				 	cerr << "DEBUG: hlrGrdesc::getKeys(vector<string> &),";
				 	cerr << "gid=" << k << ",";
					#endif
					keys.push_back(k);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}
