// $Id: hlrRgf.cpp,v 1.3 2003/12/02 12:00:57 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<hlrRgf.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;


hlrRgf::hlrRgf( string _rid,
		string _gid,
		string _fid,
		int _total)
{
	rid = _rid;
	gid = _gid;
	fid = _fid;
	total = _total;
	#ifdef DEBUG
	 cerr << "DEBUG:hlrRgf::hlrRgf():rid=" << rid;
	 cerr << ",gid=" << gid;
	 cerr << ",fid=" << fid;
	 cerr << ",total=" << total << endl;
	#endif
}

int hlrRgf::get()
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _rid = rid;
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (rid == "" ) _rid = "%";
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM rgf WHERE ";
		queryStr += "rid LIKE '" + _rid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrRgf::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				rid = result.getData()[0][0];
				gid = result.getData()[0][1];
				fid = result.getData()[0][2];
				total = atoi((result.getData()[0][3]).c_str());
				#ifdef DEBUG
				 cerr << "DEBUG: hlrUdesc::get(),";
				 cerr << "rid=" << rid << ",";
				 cerr << "gid=" << gid << ",";
				 cerr << "fid=" << fid << ",";
				 cerr << "total=" << total << endl;
				#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			cerr << queryStr << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrRgf::get(vector<hlrRgf>& rv)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _rid = rid;
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (rid == "" ) _rid = "%";
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM rgf WHERE ";
		queryStr += "rid LIKE '" + _rid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrRgf::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				hlrRgf r;
				for ( int i = 0; i < numRows; i++ )
				{
					r.rid = result.getItem(i,0);
					r.gid = result.getItem(i,1);
					r.fid = result.getItem(i,2);
					r.total = atoi(result.getItem(i,3).c_str());
					#ifdef DEBUG
					 cerr << "DEBUG: hlrRgf::get(),";
					 cerr << "rid=" << r.rid << ",";
					 cerr << "gid=" << r.gid << ",";
					 cerr << "fid=" << r.fid << ",";
					 cerr << "total=" << r.total << endl;
					#endif
					 rv.push_back(r);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			cerr << queryStr << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


int hlrRgf::put()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO rgf VALUES ('";
		queryStr += rid + "','";
		queryStr += gid + "','";
		queryStr += fid + "','";
		queryStr += int2string(total) + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "DEBUG:hlrRgf::put():inserted:rid=" <<rid;
		 cerr << ",gid="<<gid;
		 cerr << ",fid="<<fid;
		 cerr << ",total="<<total<<endl;
		#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}



int hlrRgf::del()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr;
		//FIXME modify to use wildcards
		queryStr = "DELETE FROM rgf WHERE rid='";
		queryStr += rid + "' AND gid='";
		queryStr += gid + "' AND fid='";
		queryStr += fid + "'";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		else
		{
			#ifdef DEBUG
			 cerr << "DEBUG:hlrRgf::del():deleted:rid=" <<rid;
			 cerr << ",gid=" << gid;
			 cerr << ",fid=" << fid << endl;
			#endif
			return 0;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}

bool hlrRgf::exists()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string _rid = rid;
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (rid == "" ) _rid = "%";
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM rgf WHERE ";
		queryStr += "rid LIKE '" + _rid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrRgf::exists(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif

		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return false; 
	}
}

int hlrRgf::credit(int& v)
{

	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrRgf::credit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE rgf ";
		queryStr += "SET total=total+" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "rid='" + rid +"' AND ";
		queryStr += "gid='" + gid +"' AND ";
		queryStr += "fid='" + fid +"' ";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrRgf::credit(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrRgf::credit()" << endl;
       		 	#endif
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrRgf::credit()" << endl;
       	 	#endif
		return 1; 
	}
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrRgf::credit()" << endl;
        	#endif
		return 0;
}

int hlrRgf::debit(int& v)
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrRgf::debit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE rgf ";
		queryStr += "SET total=total-" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "rid='" + rid +"' AND ";
		queryStr += "gid='" + gid +"' AND ";
		queryStr += "fid='" + fid +"' ";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrRgf::credit(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrRgf::debit()" << endl;
       		 	#endif
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrRgf::debit()" << endl;
       	 	#endif
		return 1; 
	}
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrRgf::debit()" << endl;
        	#endif
	return 0;
}
