// $Id: hlrTransIn.cpp,v 1.2 2003/04/28 14:44:49 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


// This class doesn't manage directly the timestamp field,
// it should be set up manually at higher levels!!

#include<hlrTransIn.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;


hlrTransIn::hlrTransIn( int _tid,
		string _rid,
		string _gid,
		string _fromDn,
		string _fromUrl,
		int _amount,
		string _timeStamp,
		string _dgJobId)
{
	tid = _tid;
	rid = _rid;
	gid = _gid;
	fromDn = _fromDn;
	fromUrl = _fromUrl;
	amount = _amount;
	timeStamp = _timeStamp;
	dgJobId = _dgJobId;
	#ifdef DEBUG
	 cerr << "hlrTransIn::hlrTransIn:tid=" << tid;
	 cerr << "rid=" << rid;
	 cerr << "gid=" << gid;
	 cerr << "fromDn=" << fromDn;
	 cerr << "fromUrl=" << fromUrl;
	 cerr << "amount=" << amount;
	 cerr << "timeStamp=" << timeStamp;
	 cerr << "dgJobId=" << dgJobId << endl;
	#endif
}



int hlrTransIn::get()
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _tid = int2string(tid);
		string _rid = rid;
		string _gid = gid;
		string _fromDn = fromDn;
		string _fromUrl = fromUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (rid == "" ) _rid = "%";
		if (gid == "" ) _gid = "%";
		if (fromDn == "" ) _fromDn = "%";
		if (fromUrl == "" ) _fromUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT * FROM trans_in WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "rid LIKE '" + _rid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "from_dn LIKE '" + _fromDn + "' AND ";
		queryStr += "from_url LIKE '" + _fromUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransIn::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				tid = atoi(result.getItem(0,0).c_str());
				rid = result.getItem(0,1);
				gid = result.getItem(0,2);
				fromDn = result.getItem(0,3);
				fromUrl = result.getItem(0,4);
				amount = atoi(result.getItem(0,5).c_str());
				timeStamp = result.getItem(0,6);
				dgJobId = result.getItem(0,7);
				#ifdef DEBUG
				 cerr << "DEBUG: hlrTransIn::get(),";
				 cerr << "tid=" << tid << ",";
				 cerr << "rid=" << rid << ",";
				 cerr << "gid=" << gid << ",";
				 cerr << "fromDn=" << fromDn << ",";
				 cerr << "fromUrl=" << fromUrl << ",";
				 cerr << "amount=" << amount << ",";
				 cerr << "timeStamp=" << timeStamp << ",";
				 cerr << "dgJobId=" << dgJobId << endl;
				#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrTransIn::get(vector<hlrTransIn>& tv)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _tid = int2string(tid);
		string _rid = rid;
		string _gid = gid;
		string _fromDn = fromDn;
		string _fromUrl = fromUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (rid == "" ) _rid = "%";
		if (gid == "" ) _gid = "%";
		if (fromDn == "" ) _fromDn = "%";
		if (fromUrl == "" ) _fromUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT * FROM trans_in WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "rid LIKE '" + _rid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "from_dn LIKE '" + _fromDn + "' AND ";
		queryStr += "from_url LIKE '" + _fromUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransIn::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				hlrTransIn t;
				for ( int i=0; i < numRows; i++ )
				{
					t.tid = atoi(result.getItem(i,0).c_str());
					t.rid = result.getItem(i,1);
					t.gid = result.getItem(i,2);
					t.fromDn = result.getItem(i,3);
					t.fromUrl = result.getItem(i,4);
					t.amount = atoi(result.getItem(i,5).c_str());
					t.timeStamp = result.getItem(i,6);
					t.dgJobId = result.getItem(i,7);
					#ifdef DEBUG
					 cerr << "DEBUG: hlrTransIn::get(),";
					 cerr << "tid=" << t.tid << ",";
					 cerr << "rid=" << t.rid << ",";
					 cerr << "gid=" << t.gid << ",";
					 cerr << "fromDn=" << t.fromDn << ",";
					 cerr << "fromUrl=" << t.fromUrl << ",";
					 cerr << "amount=" << t.amount << ",";
					 cerr << "timeStamp=" << t.timeStamp << ",";
					 cerr << "dgJobId=" << t.dgJobId << endl;
					#endif
					 tv.push_back(t);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


int hlrTransIn::put()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO trans_in VALUES (";
		queryStr += "0,'";
		queryStr += rid + "','";
		queryStr += gid + "','";
		queryStr += fromDn + "','";
		queryStr += fromUrl + "',";
		queryStr += int2string(amount) + ",'";
		queryStr += timeStamp + "','";
		queryStr += dgJobId + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "hlrTransIn::put(),inserted:tid=" <<tid;
				 cerr << "rid=" << rid << ",";
				 cerr << "gid=" << gid << ",";
				 cerr << "fromDn=" << fromDn << ",";
				 cerr << "fromUrl=" << fromUrl << ",";
				 cerr << "amount=" << amount << ",";
				 cerr << "timeStamp=" << timeStamp << ",";
				 cerr << "dgJobId=" << dgJobId << endl;
		#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}



int hlrTransIn::del()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr;
		//FIXME modify to use wildcards
		queryStr = "DELETE FROM trans_in WHERE tid=";
		queryStr += int2string(tid);
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		else
		{
			#ifdef DEBUG
			 cerr << "hlrTransIn::del(),deleted:tid=" << tid << endl;
			#endif
			return 0;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}



bool hlrTransIn::exists()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{	
		string _tid = int2string(tid);
		string _rid = rid;
		string _gid = gid;
		string _fromDn = fromDn;
		string _fromUrl = fromUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (rid == "" ) _rid = "%";
		if (gid == "" ) _gid = "%";
		if (fromDn == "" ) _fromDn = "%";
		if (fromUrl == "" ) _fromUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT tid FROM trans_in WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "rid LIKE '" + _rid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "from_dn LIKE '" + _fromDn + "' AND ";
		queryStr += "from_url LIKE '" + _fromUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransIn::exists(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			cerr << queryStr << endl;
			#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return false; 
	}
}

int hlrTransIn::getKeys(vector<int>& keys)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _tid = int2string(tid);
		string _rid = rid;
		string _gid = gid;
		string _fromDn = fromDn;
		string _fromUrl = fromUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (rid == "" ) _rid = "%";
		if (gid == "" ) _gid = "%";
		if (fromDn == "" ) _fromDn = "%";
		if (fromUrl == "" ) _fromUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT * FROM trans_in WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "rid LIKE '" + _rid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "from_dn LIKE '" + _fromDn + "' AND ";
		queryStr += "from_url LIKE '" + _fromUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransIn::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				int k;
				for ( int i=0; i < numRows; i++ )
				{
					k = atoi(result.getItem(i,0).c_str());
					#ifdef DEBUG
					 cerr << "DEBUG: hlrTransIn::getKeys(),";
					 cerr << "tid=" << k << endl;
					#endif
					 keys.push_back(k);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}
