// $Id: hlrTransOut.cpp,v 1.2 2003/04/28 14:44:49 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


// This class doesn't manage directly the timestamp field,
// it should be set up manually at higher levels!!

#include<hlrTransOut.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;


hlrTransOut::hlrTransOut( int _tid,
		string _uid,
		string _gid,
		string _toDn,
		string _toUrl,
		int _amount,
		string _timeStamp,
		string _dgJobId)
{
	tid = _tid;
	uid = _uid;
	gid = _gid;
	toDn = _toDn;
	toUrl = _toUrl;
	amount = _amount;
	timeStamp = _timeStamp;
	dgJobId = _dgJobId;
	#ifdef DEBUG
	 cerr << "hlrTransOut::hlrTransOut:tid=" << tid;
	 cerr << "uid=" << uid;
	 cerr << "gid=" << gid;
	 cerr << "toDn=" << toDn;
	 cerr << "toUrl=" << toUrl;
	 cerr << "amount=" << amount;
	 cerr << "timeStamp=" << timeStamp;
	 cerr << "dgJobId=" << dgJobId << endl;
	#endif
}



int hlrTransOut::get()
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _tid = int2string(tid);
		string _uid = uid;
		string _gid = gid;
		string _toDn = toDn;
		string _toUrl = toUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (toDn == "" ) _toDn = "%";
		if (toUrl == "" ) _toUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT * FROM trans_out WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "uid LIKE '" + _uid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "to_dn LIKE '" + _toDn + "' AND ";
		queryStr += "to_url LIKE '" + _toUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransOut::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				tid = atoi(result.getItem(0,0).c_str());
				uid = result.getItem(0,1);
				gid = result.getItem(0,2);
				toDn = result.getItem(0,3);
				toUrl = result.getItem(0,4);
				amount = atoi(result.getItem(0,5).c_str());
				timeStamp = result.getItem(0,6);
				dgJobId = result.getItem(0,7);
				#ifdef DEBUG
				 cerr << "DEBUG: hlrTransOut::get(),";
				 cerr << "tid=" << tid << ",";
				 cerr << "uid=" << uid << ",";
				 cerr << "gid=" << gid << ",";
				 cerr << "toDn=" << toDn << ",";
				 cerr << "toUrl=" << toUrl << ",";
				 cerr << "amount=" << amount << ",";
				 cerr << "timeStamp=" << timeStamp << ",";
				 cerr << "dgJobId=" << dgJobId << endl;
				#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrTransOut::get(vector<hlrTransOut>& tv)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _tid = int2string(tid);
		string _uid = uid;
		string _gid = gid;
		string _toDn = toDn;
		string _toUrl = toUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (toDn == "" ) _toDn = "%";
		if (toUrl == "" ) _toUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT * FROM trans_out WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "uid LIKE '" + _uid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "to_dn LIKE '" + _toDn + "' AND ";
		queryStr += "to_url LIKE '" + _toUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransOut::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				hlrTransOut t;
				for ( int i = 0; i < numRows; i++ )
				{
					t.tid = atoi(result.getItem(i,0).c_str());
					t.uid = result.getItem(i,1);
					t.gid = result.getItem(i,2);
					t.toDn = result.getItem(i,3);
					t.toUrl = result.getItem(i,4);
					t.amount = atoi(result.getItem(i,5).c_str());
					t.timeStamp = result.getItem(i,6);
					t.dgJobId = result.getItem(i,7);
					#ifdef DEBUG
					 cerr << "DEBUG: hlrTransOut::get(),";
					 cerr << "tid=" << t.tid << ",";
					 cerr << "uid=" << t.uid << ",";
					 cerr << "gid=" << t.gid << ",";
					 cerr << "toDn=" << t.toDn << ",";
					 cerr << "toUrl=" << t.toUrl << ",";
					 cerr << "amount=" << t.amount << ",";
					 cerr << "timeStamp=" << t.timeStamp << ",";
					 cerr << "dgJobId=" << t.dgJobId << endl;
					#endif
					 tv.push_back(t);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}


int hlrTransOut::put()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO trans_out VALUES (";
		queryStr += "0,'";
		queryStr += uid + "','";
		queryStr += gid + "','";
		queryStr += toDn + "','";
		queryStr += toUrl + "',";
		queryStr += int2string(amount) + ",'";
		queryStr += timeStamp + "','";
		queryStr += dgJobId + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "hlrTransOut::put(),inserted:tid=" << tid << ",";
				 cerr << "uid=" << uid << ",";
				 cerr << "gid=" << gid << ",";
				 cerr << "toDn=" << toDn << ",";
				 cerr << "toUrl=" << toUrl << ",";
				 cerr << "amount=" << amount << ",";
				 cerr << "timeStamp=" << timeStamp << ",";
				 cerr << "dgJobId=" << dgJobId << endl;
		#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}



int hlrTransOut::del()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr;
		//FIXME modify to use wildcards
		queryStr = "DELETE FROM trans_out WHERE tid='";
		queryStr += int2string(tid) + "'";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		}
		else
		{
			#ifdef DEBUG
			 cerr << "hlrTransOut::del(),deleted:tid=" << tid << endl;
			#endif
			return 0;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}



bool hlrTransOut::exists()
{
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{	
		string _tid = int2string(tid);
		string _uid = uid;
		string _gid = gid;
		string _toDn = toDn;
		string _toUrl = toUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (toDn == "" ) _toDn = "%";
		if (toUrl == "" ) _toUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT tid FROM trans_out WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "uid LIKE '" + _uid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "to_dn LIKE '" + _toDn + "' AND ";
		queryStr += "to_url LIKE '" + _toUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransOut::exists(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			cerr << queryStr << endl;
			#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return false; 
	}
}

int hlrTransOut::getKeys(vector<int>& keys)
{
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _tid = int2string(tid);
		string _uid = uid;
		string _gid = gid;
		string _toDn = toDn;
		string _toUrl = toUrl;
		string _timeStamp = timeStamp;
		string _dgJobId = dgJobId;
		//connection to the DB Ok, go on
		if (tid == 0 ) _tid = "%";
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (toDn == "" ) _toDn = "%";
		if (toUrl == "" ) _toUrl = "%";
		if (timeStamp == "" ) _timeStamp = "%";
		if (dgJobId == "" ) _dgJobId = "%";
		string queryStr =  "SELECT tid FROM trans_out WHERE ";
		queryStr += "tid LIKE '" + _tid + "' AND ";
		queryStr += "uid LIKE '" + _uid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "to_dn LIKE '" + _toDn + "' AND ";
		queryStr += "to_url LIKE '" + _toUrl + "' AND ";
		queryStr += "tr_stamp LIKE '" + _timeStamp + "' AND ";
		queryStr += "dg_jobid LIKE '" + _dgJobId + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrTransOut::getKeys(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
				return NO_RECORD;
			}
			else
			{
				int k;
				for ( int i = 0; i < numRows; i++ )
				{
					k = atoi(result.getItem(i,0).c_str());
					#ifdef DEBUG
					 cerr << "DEBUG: hlrTransOut::getKeys(),";
					 cerr << "tid=" << k << endl;
					#endif
					 keys.push_back(k);
				}
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		return hlrDb.errNo; 
	}
}
