// $Id: hlrUgf.cpp,v 1.2 2003/04/28 14:44:49 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<hlrUgf.h>

#define TOO_MANY_ROWS 1
#define NO_RECORD 2
#define E_DEL 3

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_sql_dbname;


hlrUgf::hlrUgf( string _uid,
		string _gid,
		string _fid,
		int _assigned,
		int _booked,
		int _spent)
{
	uid = _uid;
	gid = _gid;
	fid = _fid;
	assigned = _assigned;
	booked = _booked;
	spent = _spent;
	#ifdef DEBUG
	 cerr << "hlrUgf::hlrUgf:uid=" << uid;
	 cerr << ",gid=" << gid;
	 cerr << ",fid=" << fid;
	 cerr << ",assigned=" << assigned;
	 cerr << ",booked=" << booked;
	 cerr << ",spent=" << spent << endl;
	#endif
}

int hlrUgf::get()
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrUgf::get()..." << endl;
        #endif
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _uid = uid;
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM ugf WHERE ";
		queryStr += "uid LIKE '" + _uid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrUgf::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows > 1 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, found n." << numRows << "entries." << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 		#endif
				return TOO_MANY_ROWS;
			}
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 		#endif
				return NO_RECORD;
			}
			if ( numRows == 1 )
			{
				uid = result.getItem(0,0);
				gid = result.getItem(0,1);
				fid = result.getItem(0,2);
				assigned = atoi((result.getItem(0,3)).c_str());
				booked = atoi((result.getItem(0,4)).c_str());
				spent = atoi((result.getItem(0,5)).c_str());
				#ifdef DEBUG
				 cerr << "DEBUG: hlrUgf::get(),";
				 cerr << "uid=" << uid << ",";
				 cerr << "gid=" << gid << ",";
				 cerr << "fid=" << fid << ",";
				 cerr << "assigned=" << assigned << ",";
				 cerr << "booked=" << booked << ",";
				 cerr << "spent=" << spent << endl;
				#endif
				#ifdef DEBUG
				cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 			#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 		#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
        	#endif
		return hlrDb.errNo; 
	}
	return 0;
}

int hlrUgf::get(vector<hlrUgf>& uv)
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrUgf::get()..." << endl;
        #endif
	db hlrDb ( hlr_sql_server, 
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		 );
	if ( hlrDb.errNo == 0 )
	{
		string _uid = uid;
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM ugf WHERE ";
		queryStr += "uid LIKE '" + _uid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrUgf::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		 dbResult result = hlrDb.query(queryStr);
		 if ( hlrDb.errNo == 0)
		 {
			int numRows = result.numRows();
			if ( numRows == 0 )
			{
			 #ifdef DEBUG
				cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "DB mismatch, Record not found." << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 		#endif
				return NO_RECORD;
			}
			else
			{
				hlrUgf u;
				for ( int i =0; i < numRows; i++ )
				{
					u.uid = result.getItem(i,0);
					u.gid = result.getItem(i,1);
					u.fid = result.getItem(i,2);
					u.assigned = atoi(result.getItem(i,3).c_str());
					u.booked = atoi(result.getItem(i,4).c_str());
					u.spent = atoi(result.getItem(i,5).c_str());
					#ifdef DEBUG
					 cerr << "DEBUG: hlrUgf::get(),";
					 cerr << "uid=" << u.uid << ",";
					 cerr << "gid=" << u.gid << ",";
					 cerr << "fid=" << u.fid << ",";
					 cerr << "assigned=" << u.assigned << ",";
					 cerr << "booked=" << u.booked << ",";
					 cerr << "spent=" << u.spent << endl;
					#endif
					 uv.push_back(u);
				}
				#ifdef DEBUG
				cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 			#endif
				 return 0;
			}
		 }
		 else
		 {
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 		#endif
			return hlrDb.errNo;
		 }
	}
	else
	{
		//connection to the DB failed, return error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::get()" << endl;
       	 	#endif
		return hlrDb.errNo; 
	}
}

int hlrUgf::put()
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrUgf::put()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
	       );
	if ( hlrDb.errNo == 0)
	{
		//connection ok, go on
		string queryStr;
		queryStr = "REPLACE INTO ugf VALUES ('";
		queryStr += uid + "','";
		queryStr += gid + "','";
		queryStr += fid + "','";
		queryStr += int2string(assigned) + "','";
		queryStr += int2string(booked) + "','";
		queryStr += int2string(spent) + "')";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::put()." << endl;
       	 		#endif
			return hlrDb.errNo;
		}
		#ifdef DEBUG
		 cerr << "hlrUgf::put(),inserted:uid=" <<uid;
		 cerr << ",gid="<<gid;
		 cerr << ",fid="<<fid;
		 cerr << ",assigned="<<assigned;
		 cerr << ",booked="<<booked;
		 cerr << ",spent="<<spent<<endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::put()" << endl;
        	#endif
		return 0;
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::put()" << endl;
       		 #endif
		return hlrDb.errNo; 
	}
}



int hlrUgf::del()
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrUgf::del()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string _uid = uid;
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr;
		//FIXME modify to use wildcards
		queryStr = "DELETE FROM ugf WHERE uid LIKE '";
		queryStr += _uid + "' AND gid LIKE '";
		queryStr += _gid + "' AND fid LIKE '";
		queryStr += _fid + "'";
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::del()" << endl;
       		 	#endif
			return hlrDb.errNo;
		}
		else
		{
			if ( !(*this).exists() )
			{
				#ifdef DEBUG
				 cerr << "hlrUgf::del(),deleted:uid=" <<uid;
				 cerr << ",gid=" << gid;
				 cerr << ",fid=" << fid << endl;
				#endif
				#ifdef DEBUG
				cerr << endl <<"DEBUG: EXITING hlrUgf::del()" << endl;
       		 		#endif
				return 0;
			}
			else
			{
				#ifdef DEBUG
		 		cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
				cerr << "Error deleting the record" << endl;
				#endif

				#ifdef DEBUG
				cerr << endl <<"DEBUG: EXITING hlrUgf::del()" << endl;
       		 		#endif
				return E_DEL;
			}
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::del()" << endl;
       	 	#endif
		return hlrDb.errNo; 
	}
}

bool hlrUgf::exists()
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrUgf::exists()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		//connection to the DB Ok, go on
		string _uid = uid;
		string _gid = gid;
		string _fid = fid;
		//connection to the DB Ok, go on
		if (uid == "" ) _uid = "%";
		if (gid == "" ) _gid = "%";
		if (fid == "" ) _fid = "%";
		string queryStr =  "SELECT * FROM ugf WHERE ";
		queryStr += "uid LIKE '" + _uid + "' AND ";
		queryStr += "gid LIKE '" + _gid + "' AND ";
		queryStr += "fid LIKE '" + _fid + "'";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrUgf::get(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif

		dbResult result = hlrDb.query(queryStr);
		if ( hlrDb.errNo == 0)
		{
			if ( result.numRows() == 1 )
			{
				#ifdef DEBUG
				cerr << endl <<"DEBUG: EXITING hlrUgf::exists()" << endl;
       			 	#endif
				return true;
			}
			else
			{
				#ifdef DEBUG
				cerr << endl <<"DEBUG: EXITING hlrUgf::exists()" << endl;
       			 	#endif
				return false;
			}
		}
		else
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::exists()" << endl;
       		 	#endif
			return false;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::exists()" << endl;
       	 	#endif
		return false; 
	}
}


int hlrUgf::credit(int& v)
{

	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrUgf::credit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE ugf ";
		queryStr += "SET assigned=assigned+" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "uid='" + uid +"' AND ";
		queryStr += "gid='" + gid +"' AND ";
		queryStr += "fid='" + fid +"' ";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrUgf::credit(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::credit()" << endl;
       		 	#endif
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::credit()" << endl;
       	 	#endif
		return hlrDb.errNo; 
	}
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::credit()" << endl;
        	#endif
		return 0;
}

int hlrUgf::debit(int& v)
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING hlrUgf::debit()..." << endl;
        #endif
	db hlrDb(hlr_sql_server,
			hlr_sql_user,
			hlr_sql_password,
			hlr_sql_dbname
		);
	if (hlrDb.errNo == 0)
	{
		string queryStr =  "UPDATE ugf ";
		queryStr += "SET spent=spent+" + int2string(v);
		queryStr += " WHERE ";
		queryStr += "uid='" + uid +"' AND ";
		queryStr += "gid='" + gid +"' AND ";
		queryStr += "fid='" + fid +"' ";
		#ifdef DEBUG
		 cerr << "DEBUG:hlrUgf::credit(),";
		 cerr << "DB Query:" << queryStr << endl;
		#endif
		hlrDb.query(queryStr);
		if ( hlrDb.errNo != 0 )
		{
			#ifdef DEBUG
		 	cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 	cerr << "Error in query:" << endl;
			cerr << queryStr << endl;
		 	cerr << hlrDb.errMsg << endl;
			#endif
			#ifdef DEBUG
			cerr << endl <<"DEBUG: EXITING hlrUgf::debit()" << endl;
       		 	#endif
			return hlrDb.errNo;
		}
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << ":";
		 cerr << "Error connecting to the DataBase, got error:" << endl;
		 cerr << hlrDb.errMsg << endl;
		#endif
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::debit()" << endl;
       	 	#endif
		return hlrDb.errNo; 
	}
		#ifdef DEBUG
		cerr << endl <<"DEBUG: EXITING hlrUgf::debit()" << endl;
        	#endif
	return 0;
}
