#include <qTransaction.h>

extern const char * hlr_sql_server;
extern const char * hlr_sql_user;
extern const char * hlr_sql_password;
extern const char * hlr_tmp_sql_dbname;


qTransaction::qTransaction (
		string _transactionId,
		string _fromCertSubject,
		string _toCertSubject,
		string _fromHlrId,
		string _toHlrId,
		int _amount,
		string _timestamp,
		string _logData,
		int _priority,
		int _statusTime,
		string _tType
		)
{
	transactionId = _transactionId;
	fromCertSubject = _fromCertSubject;
	toCertSubject = _toCertSubject;
	fromHlrId = _fromHlrId;
	toHlrId= _toHlrId;
	amount= _amount;
	timestamp = _timestamp;
	logData = _logData;
	priority = _priority;
	statusTime = _statusTime;
	tType = _tType;
	#ifdef DEBUG
	 cerr << "qTransaction Constructor: " << endl;
	 cerr << "tranasctionId = "<< transactionId << endl;
	#endif
}

int qTransaction::put()
{
	 db hlrTmp(hlr_sql_server,
			 hlr_sql_user,
			 hlr_sql_password,
			 hlr_tmp_sql_dbname);
	 if (hlrTmp.errNo == 0)
	 {
		 string queryStr = "INSERT INTO trans_queue VALUES ('";
		 queryStr += transactionId;
		 queryStr += "','";
		 queryStr += fromCertSubject;
		 queryStr += "','";
		 queryStr += toCertSubject;
		 queryStr += "','";
		 queryStr += fromHlrId;
		 queryStr += "','";
		 queryStr += toHlrId;
		 queryStr += "',";
		 queryStr += int2string(amount);
		 queryStr += ",'";
		 queryStr += timestamp;
		 queryStr += "','";
		 queryStr += logData;
		 queryStr += "',";
		 queryStr += int2string(priority);
		 queryStr += ",";
		 queryStr += int2string(statusTime);
		 queryStr += ",'";
		 queryStr += tType;
		 queryStr += "')";
		 hlrTmp.query(queryStr);
		#ifdef DEBUG
		 cerr << "qTransaction::put() query = " << queryStr << endl;
		#endif
		 return hlrTmp.errNo;
	 }
	 else
	 {
		  return hlrTmp.errNo;
	 }
}

int qTransaction::get(int _priority)
{
	 db hlrTmp(hlr_sql_server,
			 hlr_sql_user,
			 hlr_sql_password,
			 hlr_tmp_sql_dbname);
	 if (hlrTmp.errNo == 0)
	 {
		 string queryStr = "SELECT * FROM trans_queue WHERE priority =";
		 queryStr += int2string(_priority);
		#ifdef DEBUG
		 cerr << "qTransaction::get(int _priority) query = " << queryStr << endl;
		#endif
		 dbResult result = hlrTmp.query(queryStr);
		 if ( hlrTmp.errNo == 0 )
		 {
			 //query fine
			 if (result.numRows() == 0)
			 {
				 //no records with this priority found;
				 return 1;
			 }
			 else
			 {
				 //found some records, return th first;
				 transactionId=result.getItem(0,0);
				 fromCertSubject=result.getItem(0,1);
				 toCertSubject=result.getItem(0,2);
				 fromHlrId=result.getItem(0,3);
				 toHlrId=result.getItem(0,4);
				 amount = atoi(result.getItem(0,5).c_str());
				 timestamp = result.getItem(0,6);
				 logData = result.getItem(0,7);
				 priority = atoi(result.getItem(0,8).c_str());
				 statusTime = atoi(result.getItem(0,9).c_str());
				 tType = result.getItem(0,10);
				 return 0;
				 
			 }
		 }
		 else
		 {
			 return hlrTmp.errNo;
		 }
		 
	 }
	 else
	 {
		 return hlrTmp.errNo;
	 }
	
}

int qTransaction::remove()
{
	 db hlrTmp(hlr_sql_server,
			 hlr_sql_user,
			 hlr_sql_password,
			 hlr_tmp_sql_dbname);
	 if (hlrTmp.errNo == 0)
	 {
		 
		 string queryStr = "DELETE FROM trans_queue WHERE transaction_id = '";	 
		 queryStr += transactionId;
		 queryStr += "'";
		#ifdef DEBUG
		 cerr << "qTransaction::remove() query = " << queryStr << endl;
		#endif
		 hlrTmp.query(queryStr);
		 return hlrTmp.errNo;
		 
	 }
	 else
	 {
		 return hlrTmp.errNo;
	 }
	
}

int qTransaction::update()
{
	 db hlrTmp(hlr_sql_server,
			 hlr_sql_user,
			 hlr_sql_password,
			 hlr_tmp_sql_dbname);
	 if (hlrTmp.errNo == 0)
	 {
		 string queryStr = "SELECT * FROM trans_queue WHERE transaction_id ='";  
		 queryStr += transactionId;
		 queryStr += "'";
		#ifdef DEBUG
		 cerr << "qTransaction::update() query = " << queryStr << endl;
		#endif
		 dbResult buffer = hlrTmp.query(queryStr);
		 if ( buffer.numRows() == 1 )
		 { 
		 	queryStr = "REPLACE INTO trans_queue VALUES ('";
			 queryStr += transactionId;
			 queryStr += "','";
			 queryStr += fromCertSubject;
			 queryStr += "','";
			 queryStr += toCertSubject;
			 queryStr += "','";
			 queryStr += fromHlrId;
			 queryStr += "','";
			 queryStr += toHlrId;
			 queryStr += "',";
			 queryStr += int2string(amount);
			 queryStr += ",'";
			 queryStr += timestamp;
			 queryStr += "','";
			 queryStr += logData;
			 queryStr += "',";
			 queryStr += int2string(priority);
			 queryStr += ",";
			 queryStr += int2string(statusTime);
	 	 	 queryStr += ",'";
			 queryStr += tType;
			 queryStr += "')";
			#ifdef DEBUG
			 cerr << "qTransaction::update() query = " << queryStr << endl;
			#endif
			 hlrTmp.query(queryStr);
			 return hlrTmp.errNo;
		 }
		 else
		 {
			 return 1;
		 }
	 }
	 else
	 {
		 return hlrTmp.errNo;
	 }
	
}
