/***************************************************************************
 *  filename  : LDAPQuery.cpp
 *  authors   : Salvatore Monforte <salvatore.monforte@ct.infn.it>
 *  copyright : (C) 2001 by INFN
 ***************************************************************************/

// $Id:

/**
 * @file LDAPQuery.cpp
 * @brief This files implemtns an LDAP Query Object.
 * @author Salvatore Monforte salvatore.monforte@ct.infn.it
 * @author commetns by Marco Pappalardo marco.pappalardo@ct.infn.it and Salvatore Monforte
 */


/** This class header file. */
#include "LDAPQuery.h"
/** The LDAP Connection header file. */
#include "LDAPConnection.h"

/**
 * Constructor.
 * This object queries a database through an LDAP Connection 
 * for record satisfing a filter, having a specified scope.
 */ 
LDAPQuery::LDAPQuery(LDAPConnection* c, const string& f,const vector<string>& v, int s) :
  connection(c), filter(f), scope(s)
{
  vector<string>::const_iterator it;

  int i = 0;
  
  topic = new char*[v.size()+1];
  
  for(it = v.begin(); it != v.end(); it++) {
    
    topic[i++]=const_cast<char*>((*it).c_str());
  }

  topic[i]=NULL;
}

/**
 * Destructor.
 */
LDAPQuery::~LDAPQuery()
{
  delete topic;
}




 


