// $Id: dgas_paResPrice.cpp,v 1.1 2003/04/04 10:29:54 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<dgas_paResPrice.h>

#define E_NO_ITEM 1
#define E_PRICE_INSERT 2
#define E_NO_PRICE 3


extern const char * pa_sql_server;
extern const char * pa_sql_user;
extern const char * pa_sql_password;
extern const char * pa_sql_dbname;


paResPrice::paResPrice ( string _resID, int _time, int _price)
{
	#ifdef DEBUG
	 cerr << "DEBUG: paResPrice::paResPrice(), Constructor:";
	#endif
	resID = _resID;
	time = _time;
	price = _price;
	#ifdef DEBUG
	 cerr << "resID=" << resID << ",";
	 cerr << "time=" << time << ",";
	 cerr << "price=" << price << endl;
	#endif
}

int paResPrice::get()
{
	paResItem itemBuff;
	if ( itemBuff.get(resID) != 0 )
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 cerr << "Item not found." << endl;
		 return E_NO_ITEM;
		#endif
	}
	#ifdef DEBUG
	 cerr << "DEBUG: paResPrice::get(),";
	 cerr << "resID=" << resID << ",";
	 cerr << "time=" << time << ",";
	#endif
	 db paDb(pa_sql_server,
			 pa_sql_user,
			 pa_sql_password,
			 pa_sql_dbname
			 );
	 if ( paDb.errNo == 0 )
	 {
		 //connection to the DB is OK, we can do the query
		string queryStr = "";
		queryStr = "SELECT * FROM ";
		queryStr += itemBuff.histTable;
	       	queryStr += " WHERE time <= ";
		queryStr += int2string(time);
		queryStr += " ORDER BY time DESC LIMIT 1 ";
		#ifdef DEBUG
	 	 cerr << "DEBUG: paResPrice::get(),";
		 cerr << "DB query:" << queryStr << endl;
		#endif
		 dbResult result= paDb.query(queryStr);
		 if ( paDb.errNo == 0)
		 {
			 if (result.numRows() != 0 )
			 {
			 	time = atoi((result.getData()[0][0]).c_str());
			 	price = atoi((result.getData()[0][1]).c_str());
			 
				#ifdef DEBUG
			 	cerr << "DEBUG: paResPrice::get(),";
	 			cerr << "time=" << time << ",";
	 			cerr << "price=" << price << endl;;
				#endif
				return 0;
			 }
			 else
			 {
				 return E_NO_PRICE;
			 }
		 }
		 else
		 {
			 //query failed, report the error
			#ifdef DEBUG
		 	 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 	 cerr << "Error querying the database, got error: " << endl;
		 	 cerr << paDb.errMsg << endl;
			#endif
			 return paDb.errNo;
		 }
	 }
	 else
	 {
		 //Error conecting to the database, reporting the error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 cerr << "Error connecting to the database, got error: " << endl;
		 cerr << paDb.errMsg << endl;
		#endif
		 return paDb.errNo;
	 }
}

int paResPrice::put()
{
	paResItem itemBuff;
	if ( itemBuff.get(resID) != 0 )
	{
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 cerr << "Item not found." << endl;
		 return E_NO_ITEM;
		#endif
	}
	#ifdef DEBUG
	 cerr << "DEBUG: paResPrice::put(),";
	 cerr << "resID=" << resID << ",";
	 cerr << "time=" << time << ",";
	#endif
	 db paDb(pa_sql_server,
			 pa_sql_user,
			 pa_sql_password,
			 pa_sql_dbname
			 );
	 if ( paDb.errNo == 0 )
	 {
		string queryStr = "";
		queryStr = "INSERT INTO ";
		queryStr += itemBuff.histTable;
		queryStr += " VALUES (";
		queryStr += int2string(time);
		queryStr += ",";
		queryStr += int2string(price);
		queryStr += ")";
		paDb.query(queryStr);
		if ( paDb.errNo == 0 )
		{
			#ifdef DEBUG
                        cerr << "DEBUG: paResPrice::put(),";
                        cerr << "time=" << time << ",";
                        cerr << "price=" << price << endl;;
                        #endif
                        return 0;
		}
		else
		{
			//query failed, report the error
			#ifdef DEBUG
		 	 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 	 cerr << "Error inserting the price, got error: " << endl;
		 	 cerr << paDb.errMsg << endl;
			#endif
			 return E_PRICE_INSERT;
		}
	 }
	 else
	 {
		 //Error conecting to the database, reporting the error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 cerr << "Error connecting to the database, got error: " << endl;
		 cerr << paDb.errMsg << endl;
		#endif
		 return paDb.errNo;
	 }
}
