// $Id: dgas_paResource.cpp,v 1.1 2003/04/04 10:29:54 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/


#include<dgas_paResource.h>

#define E_GET_RES 1

paResource::paResource (string _resID, int _defMinTTL, int _suggPrice )
{
	resID = _resID;
	defMinTTL = _defMinTTL;
	suggestedPrice = _suggPrice;
	#ifdef DEBUG
	 cerr << "DEBUG: paREesource::paResource, ";
	 cerr << "resID:" << resID << ",";
	 cerr << "defMinTTL:" << defMinTTL << ",";
	 cerr << "suggestedPrice:" << suggestedPrice << endl;
	#endif
}

int paResource::put()
{
	paResItem itemBuff(resID, defMinTTL, suggestedPrice);
	if ( !itemBuff.exists() )
	{
		#ifdef DEBUG
		 cerr << "DEBUG: Inserting resource in PA: ";
	 	 cerr << "resID:" << resID << ",";
	 	 cerr << "defMinTTL:" << defMinTTL << ",";
		 cerr << "suggestedPrice:" << suggestedPrice << endl;
		#endif
		return itemBuff.put();
	}
	else
	{
		#ifdef DEBUG
		 cerr << "DEBUG: Replacing resource in PA: ";
	 	 cerr << "resID:" << resID << ",";
	 	 cerr << "defMinTTL:" << defMinTTL << ",";
		 cerr << "suggestedPrice:" << suggestedPrice << endl;
		#endif
		return itemBuff.replace();
	}
}

bool paResource::exists()
{
	paResItem itemBuff(resID);
	return itemBuff.exists();
}

int paResource::del()
{
	paResItem itemBuff(resID);
	return itemBuff.del();
}

int paResource::get(string _resID)
{
	paResItem itemBuff;
	if ( itemBuff.get(_resID) != 0 )
	{
		return E_GET_RES;
	}
	else
	{
		resID = itemBuff.resID;
		defMinTTL = itemBuff.defMinTTL;
		suggestedPrice = itemBuff.suggestedPrice;
		#ifdef DEBUG
		 cerr << "DEBUG: Found Resource,";
	 	 cerr << "resID:" << resID << ",";
	 	 cerr << "defMinTTL:" << defMinTTL << ",";
		 cerr << "suggestedPrice:" << suggestedPrice << endl;
		#endif
		return 0;
	}
	
}
