// DGAS (DataGrid Accounting System) 
// Client APIs.
// 
// $Id: edg-wl-dgas-ATMClient.h,v 1.5 2004/01/12 15:32:09 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
//
//    

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
#include <unistd.h>
#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <stringSplit.h>
#ifndef GSI
#include "SocketClient.h"
#include "SocketAgent.h"
#else
#include "GSISocketClient.h"
#include "GSISocketAgent.h"
#endif
#include "comm_struct.h"
#include "int2string.h"
#include "hlr_prot_errcode.h"

#define EDG_WL_DGAS_DEF_CONF "/opt/edg/etc/edg-wl-dgas-ATMClient.conf"

using namespace std;
#ifndef EDG_SOCKETPP
using namespace edg::workload::common::socket_pp;
#endif

struct ATM_job_data
{
	string dgJobId;
	int time;
	string res_acct_PA_id;
	string res_acct_bank_id;
	string user_CertSubject;
	string res_grid_id;
};

struct ATM_usage_info
{
	int cpu_time;
	int wall_time;
	int mem;
	int vmem;
};


//The main code of the client that is the public method too.
int ATM_client(
		string user_acct_bank_id, 
		ATM_job_data &job_data, 
		ATM_usage_info &usage_info, 
		string *server_answer,
		string confFileName = EDG_WL_DGAS_DEF_CONF);


//Parse the XML input, returns 0 if success >1 otherwise, differerntly from
//the other client code, here we will not use Xerces since we want the code
//to be very light and easily portable.
int ATMc_parse_xml(string input_message);

//Compose the XML ATM_request message used to send the job info to the user
//DGAS server.
void ATMc_xml_compose(
		ATM_job_data &job_data, 
		ATM_usage_info &usage_info, 
		string *xml);


