// DGAS (DataGrid Accounting System) 
// Client APIs.
// 
// $Id: edg-wl-dgas-paClient.cpp,v 1.4 2003/12/02 13:50:06 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
//
//    

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <sstream>
#include <libPA_comm.h>
#include "edg-wl-dgas-paClient.h"
#include "hlr_prot_errcode.h"

#ifndef LOCAL_PA
#define LOCAL_PA "localhost:56567"
#endif
#define GRIS_PORT "2135"
#define ACCT_PA_ID  "ACCT_PA_ID"

/* FIXME
 * This function is not currently available. It will bu uncommented as soon
 * as the needed info will be available in the CE GRIS
string gris_get_acct_pa_id( string resID )
{
	#ifdef DEBUG
	 cerr << "Trying to find the PA id in the CE GRIS" << endl;
	#endif
	string gris_hostname;
	string gris_port = GRIS_PORT;
	int retCode = 0;
	int pos_start = resID.find("/CN=");
	int pos_end;
	if ( pos_start == string::npos )
	{
		#ifdef DEBUG
		cerr << "Can't parse the certificate subject to retrieve Hostname" << endl;
		#endif
		retCode = 1;
	}
	else
	{
		pos_end = resID.find_first_of("/",pos_start+1);
		if ( pos_end == string::npos )
		{
			#ifdef DEBUG
			cerr << "Can't parse the certificate subject to retrieve Hostname" << endl;
			#endif
			retCode = 1;
		}
		else
		{
			gris_hostname = resID.substr(pos_start+4,pos_end-pos_start-4);
		}
	}
	if ( retCode == 1 )
	{
		#ifdef DEBUG 
		 cerr << "May be it's CEid" << endl;
		#endif
		pos_start = 0;
	        pos_end = resID.find_first_of(":",pos_start+1);	
		if ( pos_end == string::npos )
		{
			#ifdef DEBUG
			 cerr << "Can't parse the ID to retrieve Hostname" << endl;
			#endif
			 retCode = 2;
		}
		else
		{
			gris_hostname = resID.substr(0, pos_end-pos_start );
		}
		
		 
	}
	#ifdef DEBUG
	cerr << "host_name: " << gris_hostname << endl;
        cerr << "GRIS port: " << gris_port << endl;	
	#endif
	LDAPSynchConnection connection( "o=Grid", 
			gris_hostname, 
			atoi(gris_port.c_str()), 
			30);
	vector<string> attributes;
	attributes.push_back(ACCT_PA_ID);
	string _acct_pa_id = "";
	string filter = "ObjectClass=computingelement";
	LDAPQuery query(&connection, filter, attributes);
	LDAPForwardIterator ldap_it( &query );
	if ( connection.Open() )
	{
		if ( ldap_it.rewind())
		{
			do
			{
				for (vector<string>::const_iterator
						it = attributes.begin();
						it != attributes.end();
						it++)
				{
					string value;
					(*ldap_it).EvaluateAttribute( (*it), value);
					#ifdef DEBUG
					  cerr << (*it) << " = " << value << endl;
					#endif
					  if ( (*it) == ACCT_PA_ID )
					  {
						  _acct_pa_id = value;
						  continue;
					  }
				}
			} while ( ++ldap_it );
		}
		else
		{
			return "";
		}
	}
	else
	{
		return "";
	}
	return _acct_pa_id;
	

	//resID -> res_url -> res GRIS address -> ldapsearch 
	// -> _acct_pa_id
	//
	// 
	// failure = ""
}
*/

int pac_parse_xml ( string &xmlInput, price *priceRes)
{
	string buffer;
	node Node;
	string tag = "PRICE_INFO";
	Node = parse (&xmlInput, tag); //isolate PRICE_INFO node
	if ( Node.status == 0 )
	{
		node tagBuff;
		tagBuff = parse ( &Node.text, "ERROR");
		if ( tagBuff.status == 0 )
		{
			return atoi((tagBuff.text).c_str());//report the error
		}
		tagBuff = parse ( &Node.text, "RES_ID");
		if ( tagBuff.status == 0 )
		{
			priceRes->resID = tagBuff.text;
			#ifdef DEBUG
			cerr << "got:" << tag << "=" << tagBuff.text << endl;
			#endif
		}
		else
		{
			return atoi(E_PARSE_ERROR);
		}
		tagBuff = parse ( &Node.text, "TIME");
		if ( tagBuff.status == 0 )
		{
			priceRes->time = atoi((tagBuff.text).c_str());
			#ifdef DEBUG
			cerr << "got:" << tag << "=" << tagBuff.text << endl;
			#endif
		}
		else
		{
			return atoi(E_PARSE_ERROR);
		}
		tagBuff = parse ( &Node.text, "MIN_TTL");
		if ( tagBuff.status == 0 )
		{
			priceRes->minTTL = atoi((tagBuff.text).c_str());
			#ifdef DEBUG
			cerr << "got:" << tag << "=" << tagBuff.text << endl;
			#endif
		}
		else
		{
			return atoi(E_PARSE_ERROR);
		}
		tagBuff = parse ( &Node.text, "PRICE");
		if ( tagBuff.status == 0 )
		{
			priceRes->priceValue = atoi((tagBuff.text).c_str());
			#ifdef DEBUG
			cerr << "got:" << tag << "=" << tagBuff.text << endl;
			#endif
		}
		else
		{
			return atoi(E_PARSE_ERROR);
		}
	}
	return 0;
}

//TBI
int cert2hostname( string cert_subject , string *hostname)
{
	//cert_subject -> hostname
	// 0 on success
	// 1 on failure
	
	return 0;
}

int get_defaultPA(string *pa_url_string)
{
	*pa_url_string=LOCAL_PA; 
	return 0;
}


//cert_subject : certificate subject of the resource that has to be priced
//pa_url_string : url of the PA that we want to query, if pa_url_string is NULL
//the system will try to contact the PA of the resource or the default PA of the//caller system.
//time :  GMT timestamp of the price that we want.
//res_price : pointer to the structure that will contain the result.
int dgas_pa_client(string _acct_pa_id , price *res_price)
{
	string output_message; 
	string input_message;
	int returnCode = 0;
	if (_acct_pa_id == "") //user didn't give the _acct_pa_id directly
	{
		/*
		 *
 		* This function is not currently available. It will bu uncommented as soon
		 * as the needed info will be available in the CE GRIS
		// request the _acct_pa_id to the gris of the resource
		_acct_pa_id = gris_get_acct_pa_id( res_price->resID );
		*/
		if ( _acct_pa_id == "" ) //_acct_pa_id not found in the GRIS
		{
			// the GRIS doesn't contain th PA URL
			// use the default
			return atoi(E_NO_PA);
		}
	}
	char delim = ':';
	//decompose remote PA url into server_name and port.
	vector<string> urlBuff;
	Split(delim, _acct_pa_id, &urlBuff);
	if ( urlBuff.size() != 3 )
		return atoi(E_PA_PARSE_ID);
	string paHostname = urlBuff[0];
	int paPort = atoi((urlBuff[1]).c_str());
	string paContact = urlBuff[2];
	#ifdef DEBUG
	cerr << "PA url: Hostname: #" << paHostname 
		<< "# , Port : #" << paPort << "#" << endl;
	#endif
	//compose the xml message.
	price pa_query = {res_price->resID, res_price->time};
	pa_xml_compose(pa_query, &output_message);
	//contact the PA server
	try{ //try1
	#ifdef GSI
	GSISocketClient *theClient = new GSISocketClient(paHostname,paPort);
	theClient-> ServerContact(paContact);
	#else
	SocketClient *theClient = new SocketClient(paHostname,paPort);
	#endif
	if (!(theClient -> Open()))
	{
		#ifdef DEBUG
		cerr << "ERROR: can't open connection\n" << endl; 
		#endif
		returnCode =  atoi(E_NO_CONNECTION);
        }
	else
	{	
		#ifdef DEBUG
		cerr << "Connection opened, sending message..." << endl;
		#endif
		if ( !(theClient->Send(output_message)) )
		{
			#ifdef DEBUG
			cerr << "ERROR: can't send message\n" << endl; 
			#endif
			returnCode = atoi(E_SEND_MESSAGE);
		}
		#ifdef DEBUG
		cerr << "Message sent. Waiting for answer..." << endl;
		#endif
		if ( !(theClient->Receive(input_message)) )
		{
			#ifdef DEBUG
			cerr << "ERROR: can't receive message\n" << endl; 
			#endif
			returnCode = atoi(E_RECEIVE_MESSAGE);
		}
		#ifdef DEBUG
		cerr << input_message << endl;
		#endif
		theClient->Close();
		returnCode = pac_parse_xml(input_message, res_price);
	}
	delete theClient;
	}//try1
	catch( std::exception& e)
	{
		         std::cerr << e.what() << std::endl;
			 returnCode = atoi(E_NO_CONNECTION);
	}
	return returnCode;
}//pa_client

void pa_xml_compose(price &price_query, string *xml)
{
	//initialize the message
	//the message will be of type PA_query
	*xml = "<HLR type=\"PA_query\">\n<HEAD>\n<VER>1.0</VER>\n</HEAD>\n<BODY>\n";
	*xml += "<PRICE_INFO>\n";
	*xml += "<RES_ID>\n";
	*xml += price_query.resID;
	*xml += "\n</RES_ID>\n";
	*xml += "<TIME>\n";
	*xml += int2string(price_query.time);
	*xml += "\n</TIME>\n";
	*xml += "</PRICE_INFO>\n";
	*xml += "</BODY>\n</HLR>\n";
	return;
}//pa_xml_compose

