// DGAS (DataGrid Accounting System) 
// Client APIs.
// 
// $Id: edg-wl-dgas-userAuthClient.h,v 1.2 2003/12/02 13:50:06 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
//
//    

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <sstream>
#include <fstream>
#ifndef GSI
#include "edg/workload/common/socket++/SocketClient.h"
#include "edg/workload/common/socket++/SocketAgent.h"
#else
#include "edg/workload/common/socket++/GSISocketClient.h"
#include "edg/workload/common/socket++/GSISocketAgent.h"
#endif
#include "edg/workload/dgas/common/xmlUtil.h"
#include "edg/workload/dgas/common/stringSplit.h"
#include "edg/workload/dgas/common/int2string.h"
#include "edg/workload/dgas/common/hlr_prot_errcode.h"


using namespace std;
#ifndef EDG_SOCKETPP
using namespace edg::workload::common::socket_pp;
#endif

//structure that contains the info about the job to auhorize on the user HLR
//dgJobId must be specified by the caller, while submTime can always be 
//retrieved by the dgas_jobAuth_client function. usrCert is retrieved by the 
//server if GSI communication is enabled at configure time.
struct userAuth_data
{
	bool userHasValidAccount;
	bool jobIsRegistered;
	string dgJobId;
	string userCertSubject;
	int jobRegTime;
	int availableCredits;
};


//0 on success > 0 on failure
int dgas_userAuth_client(string &user_acct_bank_id , 
		userAuth_data &auth_data,
		string *server_answer);


