#include <string>
#include <iostream>
#include <getopt.h>
#include <vector>
#include "edg-wl-dgas-userAuthClient.h"

#define OPTION_STRING "hs:j:"

using namespace std;

bool needs_help = 0;

string acct_id_buff = ""; 
string edgJobId_buff = "";
vector<string> info_v;

void help()
{
	cerr << "DGAS ping client" << endl;
	cerr << "Author: Andrea Guarise <andrea.guarise@to.infn.it>" << endl << endl;
	cerr << "Usage:" << endl;
	cerr << "jobAuth_client <OPTIONS>" << endl;
	cerr << "Where options are:" << endl;
	cerr << "-h  --help         :this help" << endl;
	cerr << "-s  --server       :remote server HLRLocation" << endl;
	cerr << "-j  --edgJobId     :Edg job Id for the job" << endl;
	cerr << endl;
	
		
}

int options ( int argc, char **argv )
{
	int option_char;
	int option_index = 0;
	static struct option long_options[] =
	{
		{"server",1,0,'s'},
		{"edgJobId",1,0,'j'},
		{"help",0,0,'h'},
		{0,0,0,0}
	};
	while (( option_char = getopt_long( argc, argv, OPTION_STRING,
					long_options, &option_index)) != EOF)
		switch (option_char)
		{
			case 's': acct_id_buff = optarg; break;
			case 'j': edgJobId_buff = optarg; break;
			case 'h': needs_help =1; break;		  
			default : break;
		}
		if (optind < argc) 
		{
                      while (optind < argc)
                         info_v.push_back(argv[optind++]);
                }
	return 0;
}
int main (int argc, char *argv[])
{
	options(argc, argv);
	if (needs_help)
	{
		help();
		return 0;
	}
	userAuth_data d;
	d.userHasValidAccount = false;
	d.jobIsRegistered = false;
	d.dgJobId = edgJobId_buff;
	d.userCertSubject="DISABLED FEATURE"; //this won't be set by the API for security
			      //reason.
	d.jobRegTime=-1;
	d.availableCredits=-1;
	
	int res;
	string output;
	res = dgas_userAuth_client( 
			acct_id_buff,
		        d,	
			&output);
	if ( res != 0 )
	{
		cout << "Server: " << acct_id_buff << "Unreachable." << endl;
	}
	else
	{
		cout << "User Authorization status:" << endl << endl;
		cout << "AvailableInformation: " <<endl;
		cout << "userHasValidAccount: " << d.userHasValidAccount << endl;
		cout << "jobIsRegistered: " << d.jobIsRegistered << endl;
		cout << "edgJobId: " << d.dgJobId << endl;
		cout << "userCertSubject: " << d.userCertSubject << endl;
		cout << "jobRegTime: " << d.jobRegTime << endl;
		cout << "availableCredits: " << d.availableCredits << endl;
	}
	#ifdef DEBUG
	cout << output << endl;
	#endif
	return res;
}

