// DGAS (DataGrid Accounting System) 
// Client APIs.
// 
// $Id: ATM_bank_client.cpp,v 1.4 2003/12/02 13:50:07 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
//
//   
//   This is different from other clients: it is meant to be used only
//   from within an HLR server to communicate the credit ticket to another
//   HLR, therefore it is not inserted in the clients API but in the server 
//   ones. 

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
#include "ATM_bank_client.h"

#define GRIS_PORT "2135"
#define ACCT_BANK_ID  "ACCT_BANK_ID"

extern ofstream logStream;

int bc_parse_xml(string &xmlInput)
{
	//get the status from the XML
	string buffer;
	node Node;
	int status = atoi(E_PARSE_ERROR);
	string tag = "TR_INFO";
	Node = parse (&xmlInput, tag); //isolate TR_INFO node
	if ( Node.status == 0)
	{
		tag = "STATUS";
		Node = parse (&Node.text, tag);
		if ( Node.status == 0 )
		{
			status = atoi((Node.text).c_str()); //report the status
		}
	}
	return status;
}

void tr_xml_compose(hlrTransaction &t, string *xml)
{
	//initialize the message
	//the message will be of type bank_do_credit.
	*xml = "<HLR type=\"bank_do_credit\">\n<HEAD>\n<VER>";
	*xml +=	"0.1";
	*xml += "</VER>\n</HEAD>\n<BODY>\n";
	*xml += "<TR_INFO>\n";
	*xml += "<TO_GRID_ID>\n";
	*xml += t.toId; //resource certificate subject
	*xml += "\n</TO_GRID_ID>\n";
	*xml += "<ID>\n";
	*xml += t.id;  
	*xml += "\n</ID>\n";
	*xml += "<FROM_GRID_ID>\n";
	*xml += t.fromId; //user certificate subject
	*xml += "\n</FROM_GRID_ID>\n";
	*xml += "<AMOUNT>\n";
	*xml += int2string(t.amount);
	*xml += "\n</AMOUNT>\n";
	if ( t.logData != "" )
	{
		*xml += "<LOGDATA>\n";
		*xml += t.logData;
		*xml += "\n</LOGDATA>\n";
	}
	if ( t.fromHlrUrl != "" )
	{
		*xml += "<FROM_HLR_URL>\n";
		*xml += t.fromHlrUrl;
		*xml += "\n</FROM_HLR_URL>\n";
	}
	*xml += "</TR_INFO>\n";
	*xml += "</BODY>\n</HLR>\n";
	return;
}//tr_xml_compose

/*
 * FIXME this function is not currently available
 * it will be uncommented when the needed info
 * will be available in the CE IS
string gris_get_acct_bank_id( string resID )
{
	#ifdef DEBUG
	 cerr << "Trying to find the bank id in the CE GRIS" << endl;
	#endif
	string gris_hostname;
	string gris_port = GRIS_PORT;
	int retCode = 0;
	unsigned int pos_start = resID.find("/CN=");
	unsigned int pos_end;
	if ( pos_start == string::npos )
	{
		#ifdef DEBUG
		cerr << "Can't parse the certificate subject to retrieve Hostname" << endl;
		#endif
		retCode = 1;
	}
	else
	{
		pos_end = resID.find_first_of("/",pos_start+1);
		if ( pos_end == string::npos )
		{
			#ifdef DEBUG
			cerr << "Can't parse the certificate subject to retrieve Hostname" << endl;
			#endif
			retCode = 1;
		}
		else
		{
			gris_hostname = resID.substr(pos_start+4,pos_end-pos_start-4);
		}
	}
	if ( retCode == 1 )
	{
		#ifdef DEBUG 
		 cerr << "May be it's CEid" << endl;
		#endif
		pos_start = 0;
	        pos_end = resID.find_first_of(":",pos_start+1);	
		if ( pos_end == string::npos )
		{
			#ifdef DEBUG
			 cerr << "Can't parse the ID to retrieve Hostname" << endl;
			#endif
			 retCode = 2;
		}
		else
		{
			gris_hostname = resID.substr(0, pos_end-pos_start );
		}
		
		 
	}
	#ifdef DEBUG
	cerr << "host_name: " << gris_hostname << endl;
        cerr << "GRIS port: " << gris_port << endl;	
	#endif
	LDAPSynchConnection connection( "o=Grid", 
			gris_hostname, 
			atoi(gris_port.c_str()), 
			30);
	vector<string> attributes;
	attributes.push_back(ACCT_BANK_ID);
	string _acct_bank_id = "";
	string filter = "ObjectClass=computingelement";
	LDAPQuery query(&connection, filter, attributes);
	LDAPForwardIterator ldap_it( &query );
	if ( connection.Open() )
	{
		if ( ldap_it.rewind())
		{
			do
			{
				for (vector<string>::const_iterator
						it = attributes.begin();
						it != attributes.end();
						it++)
				{
					string value;
					(*ldap_it).EvaluateAttribute( (*it), value);
					#ifdef DEBUG
					  cerr << (*it) << " = " << value << endl;
					#endif
					  if ( (*it) == ACCT_BANK_ID )
					  {
						  _acct_bank_id = value;
						  continue;
					  }
				}
			} while ( ++ldap_it );
		}
		else
		{
			return "";
		}
	}
	else
	{
		return "";
	}
	return _acct_bank_id;
}
*/

bool acctExists(string &a)
{
	#ifdef DEBUG
	cerr << endl <<"DEBUG: ENTERING acctExists()..." << endl;
	#endif
	bool result = false;
	// if there is a user corresponding to the one
	// in fromId the transaction is directed outside this HLR
	hlrUser uBuff;
	uBuff.certSubject=a;
	if ( uBuff.exists() )
	{
	     result = true;
	}
	else
	{
		hlrResource rBuff;
                rBuff.certSubject=a;
                if ( rBuff.exists() )
                {
                       result = true;
                }
		else
		{
		      hlrFund fBuff;
                      fBuff.fid = a;
                      if ( fBuff.exists() )
                      {
                      }
                      else
                      {
                       //FIXME insert group check here
		       //and delete next line
		       result = false;
		      }
		}
	}
	 #ifdef DEBUG
        cerr << "DEBUG: acctExists(), result=" << result;
        cerr << "DEBUG: EXITING acctExists()." << endl << endl;
        #endif
        return result;
}

int dgas_bankClient(hlrTransaction &t)
{
	#ifdef DEBUG
	cerr << "DEBUG: ENTERING dgas_bankClient()..." << endl;
	#endif
	int returnCode = 0;
	string output_message; 
	string input_message;
	if ( t.toHlrUrl == "" )
	{
		/*
		 * FIXME this function is not currently available
		 * it will be uncommented when the needed info
		 * will be available in the CE IS
		t.toHlrUrl = gris_get_acct_bank_id( t.toId );
		*/
		if ( t.toHlrUrl == "" )
		{
			#ifdef DEBUG
			cerr << "DEBUG: EXITING dgas_bankClient()." << endl;
			#endif
			return atoi(E_NO_RES_BANK_ID);
		}
	}
	//decompose remote HLR url into server_name and port.
	vector<string> urlBuff;
	Split (':', t.toHlrUrl, &urlBuff);
	if (urlBuff.size() != 3)
	{
		#ifdef DEBUG
		cerr << "DEBUG: EXITING dgas_bankClient()." << endl;
		#endif
		return atoi(E_BANK_PARSE_ID);
	}
	string toHlrHostname = urlBuff[0];
	int toHlrPort = atoi((urlBuff[1]).c_str());
	string toHlrContact = urlBuff[2];
	#ifdef DEBUG
	cerr << "DEBUG:Remote HLR url: Hostname:" << toHlrHostname 
		<< ",Port:" << toHlrPort << ",Contact:" << toHlrContact  << endl;
	#endif
	//check if the transaction alraedy exists
	t.tType = out; // set the tType in order to avoid confusion;
	if ( t.exists() )
	{
		#ifdef DEBUG
		cerr << "DEBUG: EXITING dgas_bankClient()." << endl;
		#endif
		return atoi(CREDIT_DUPL);
	}
	else
	{
	//check if the account exists
		if ( !acctExists(t.fromId) ) //this function does exactly what we need
		{
			#ifdef DEBUG
			cerr << "DEBUG: EXITING dgas_bankClient()." << endl;
			#endif
			return atoi(E_NO_USER);
		}
	}
	//compose the xml message.
	tr_xml_compose(t, &output_message);
	//contact the remote HLR server and give the resource credit
	//ticket to the remote (resource) HLR
	try{//try1
	#ifdef GSI
	GSISocketClient *theClient = new GSISocketClient(toHlrHostname, toHlrPort);
	theClient-> ServerContact(toHlrContact);
	#else
	
	SocketClient *theClient = new SocketClient(toHlrHostname,toHlrPort);
	#endif
	if (!(theClient -> Open()))
	{
		#ifdef DEBUG
		cerr << "ERROR: can't open connection\n" << endl; 
		#endif
		returnCode = atoi(E_NO_CONNECTION);
        }
	else
	{	
		#ifdef DEBUG
		cerr << "Connection opened, sending message..." << endl;
		#endif
		if ( !(theClient->Send(output_message)) )
		{
			#ifdef DEBUG
			cerr << "ERROR: can't send message\n" << endl; 
			#endif
			returnCode =atoi(E_SEND_MESSAGE);
		}
		#ifdef DEBUG
		cerr << "Message sent. Waiting for answer..." << endl;
		#endif
		if ( !(theClient->Receive(input_message)) )
		{
			#ifdef DEBUG
			cerr << "ERROR: can't receive message\n" << endl; 
			#endif
			returnCode = atoi(E_RECEIVE_MESSAGE);
		}
		#ifdef DEBUG
		cerr << "dgas_bankClient: Message received from server:" << endl;
		cerr << input_message << endl;
		#endif
		theClient->Close();
		returnCode = bc_parse_xml(input_message);
		//debit the  account processing the transaction
		if ( returnCode == 0 )
		{
			if ( t.process() != 0 )
			{
				returnCode = atoi(E_DEBIT_ERROR);
			}
			else
			{
				//log transaction data
				transOutLog Log(t.id,
						t.logData);
				Log.put();
				//clean up 
				//remove the jobAuth record from the database
				string stringLogBuff;
				jobAuth jobAuthBuff;
				jobAuthBuff.dgJobId = t.id;
				if ( jobAuthBuff.remove() )
				{
					string stringLogBuff =
						"Bank Client: jobAuth info for job: " +
						t.id + "correctly removed from the DB";
				}
				else
				{
					string stringLogBuff =
						"Bank Client: Warning, jobAuth info for job: " +
						t.id + "hasn't been expunged from the DB";
				}
				hlr_log(stringLogBuff, &logStream, 1);
			}
		}	
	}
	delete theClient;
	}//try1
	catch( std::exception& e)
        {
		std::cerr << e.what() << std::endl;
		returnCode = atoi(E_NO_CONNECTION);
	}
	#ifdef DEBUG
	cerr << "DEBUG: EXITING dgas_bankClient()." << endl;
	#endif
	return returnCode;
}//bank_client


