// DGAS (DataGrid Accounting System) 
// Server Daeomn and protocol engines.
// 
// $Id: jobAuth_engine.cpp,v 1.3 2003/12/02 13:50:09 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
//
//    

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
#include <jobAuth_engine.hpp>



int jobAuth_engine( string &doc, connInfo &connectionInfo, string *output )
{
	#ifdef DEBUG
	 cerr << "Entering jobAuth engine" << endl;
	#endif
	int res;
	int returnCode = 0;
	vector<jobAuth> jobs;
	node nodeBuff;
	while ( nodeBuff.status == 0 )
	{
		string tag = "JOB_AUTH_INFO";
		nodeBuff = parse( &doc, tag );
		if ( nodeBuff.status != 0)
			break;
		jobAuth job_buffer;
		node tagBuff;
		tagBuff = parse ( &doc, "DG_JOBID");
		if ( tagBuff.status == 0 )
		{
			#ifdef DEBUG
				cerr << "jobAuth_engine, got: " << tagBuff.text << endl;
			#endif
			job_buffer.dgJobId  = tagBuff.text;
		}
		tagBuff = parse ( &doc, "USER_CERT_SUBJECT");
		if ( tagBuff.status == 0 )
		{
			#ifdef DEBUG
				cerr << "jobAuth_engine, got: " << tagBuff.text << endl;
			#endif
			job_buffer.usrCert = tagBuff.text;
		}
		tagBuff = parse ( &doc, "SUBMISSION_TIME");
		if ( tagBuff.status == 0 )
		{
			#ifdef DEBUG
				cerr << "jobAuth_engine, got: " << tagBuff.text << endl;
			#endif
			job_buffer.submTime = atoi((tagBuff.text).c_str());
		}
		nodeBuff.release();
		jobs.push_back(job_buffer);
	}
	#ifdef DEBUG
	cerr << "stored n: " << jobs.size() << "job transactions" <<endl;
	#endif
	// now we have a vector<job_info> jobs that contains the elements
	// needed for the query. 
	// Once we have those information we can compose the XML answer and put
	// it into the string output.
	
	//initialize buffer string

		
	*output = "<HLR type=\"HLR_error\">\n<HEAD>\n<VER>1.0</VER>\n</HEAD>\n<BODY>\n";
		
	vector < jobAuth >::iterator job_it = jobs.begin();
	jobAuth jobAuth_buff;
	while ( job_it != jobs.end() )
	{
		//Check if the job dg_jobid has been already authorized, if so
		//return an error.
		if ( jobAuth_buff.get((*job_it).dgJobId) == 0 )
		{
			//dgJobId already present in the database
			*output += "<JOB_AUTH_INFO>\n";
			*output += "<DG_JOBID>";
			*output += (*job_it).dgJobId;
			*output += "</DG_JOBID>";
			*output += "<USER_CERT_SUBJECT>";
			*output += (*job_it).usrCert;
			*output += "</USER_CERT_SUBJECT>";
			*output += "<SUBMISSION_TIME>";
			*output += int2string((*job_it).submTime);
			*output += "</SUBMISSION_TIME>";
			*output += "</JOB_AUTH_INFO>\n";
			*output += "<ERROR>\n";
			*output += JOB_DUPL;
			*output += "\n</ERROR>\n";
			returnCode = atoi(JOB_DUPL);
		}
		else
		{
			// dg_jobid hasn't been authorized already.
			// authorize the job.
			if ( (*job_it).submTime <= 0 )
			{
				//set current timestamp
				(*job_it).submTime = time(NULL);
			}
			#ifdef GSI	
				(*job_it).usrCert = connectionInfo.contactString; 
			#endif
			res = (*job_it).put();
			*output = "<HLR type =\"JobAuth_answer\">\n<HEAD>\n<VER>1.0</VER>\n</HEAD>\n";
			*output += "<BODY>\n";
			*output += "<JOB_AUTH_INFO>\n";
			*output += "<DG_JOBID>\n";
			*output += (*job_it).dgJobId;
			*output += "\n</DG_JOBID>\n";
			*output += "<STATUS>\n";
			*output += int2string(res);
			*output += "</STATUS>\n";
			*output += "</JOB_AUTH_INFO>\n";
			returnCode = res;
				
		}


		//increment job_info vector iterator
		job_it++;
	
	}
	*output +="</BODY>\n</HLR>\n";
	// end of the job credit.
	
	//job reservation here  TBI
	
	#ifdef DEBUG
		cerr << "Formatted xml message:" << endl;
		cerr << *output << endl;
	#endif 
	return returnCode;
}


