// DGAS (DataGrid Accounting System) 
// Server Daeomn and protocol engines.
// 
// $Id: ping_engine.cpp,v 1.3 2003/12/02 13:50:09 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
//
//    

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
#include <ping_engine.hpp>

extern ofstream logStream;

void ping_engine( string &doc, connInfo &connectionInfo, statusInfo &status, errorInfo &errors, string *output )
{
	hlr_log( "Ping engine: Entering" , &logStream );
	string logBuff = "Ping engine: Serving: " + connectionInfo.hostName +
		"(" + connectionInfo.contactString + ")";
	hlr_log( logBuff, &logStream );
	int pingType = 0;
	node nodeBuff;
	while ( nodeBuff.status == 0 )
	{
		string tag = "PING";
		nodeBuff = parse( &doc, tag );
		if ( nodeBuff.status != 0)
			break;
		node tagBuff;
		tagBuff = parse ( &doc, "TYPE");
		if ( tagBuff.status == 0 )
		{
			#ifdef DEBUG
				cerr << "ping_engine, got: " << tagBuff.text << endl;
			#endif
			pingType  = atoi((tagBuff.text).c_str());
		}
		nodeBuff.release();
	}

	*output = "<HLR type =\"ping_reply\">\n<HEAD>\n<VER>1.0</VER>\n</HEAD>\n";
	*output += "<BODY>\n";
	if ( pingType == 0 )
	{
		*output += "<REPLY>\n0\n";
		*output += "</REPLY>\n";
	}
	else
	{
		*output += "<STATUS_INFO>\n";
		*output += "<ENGINES>\n";
		*output += status.engines;
		*output += "\n</ENGINES>\n";
		if (status.uiRequests != 0)
		{	
			*output += "<UI_REQUESTS>\n";
			*output += int2string(status.uiRequests);
			*output += "\n</UI_REQUESTS>\n";
		}
		if ( status.ATMRequests != 0 )
		{
			*output += "<ATM_REQUESTS>\n";
			*output += int2string(status.ATMRequests);
			*output += "\n</ATM_REQUESTS>\n";
		}
		if ( status.bankRequests != 0 )
		{
			*output += "<BANK_REQUESTS>\n";
			*output += int2string(status.bankRequests);
			*output += "\n</BANK_REQUESTS>\n";
		}
		if ( status.jobAuthRequests != 0 )
		{
			*output += "<JOBAUTH_REQUESTS>\n";
			*output += int2string(status.jobAuthRequests);
			*output += "\n</JOBAUTH_REQUESTS>\n";
		}
		if ( status.userAuthRequests != 0 )
		{
			*output += "<USERAUTH_REQUESTS>\n";
			*output += int2string(status.userAuthRequests);
			*output += "\n</USERAUTH_REQUESTS>\n";
		}
		if ( status.paRequests != 0 )
		{
			*output += "<PA_REQUESTS>\n";
			*output += int2string(status.paRequests);
			*output += "\n</PA_REQUESTS>\n";
		}
		if ( status.pingRequests != 0 )
		{
			*output += "<PING_REQUESTS>\n";
			*output += int2string(status.pingRequests);
			*output += "\n</PING_REQUESTS>\n";
		}
		if ( errors.ATMErrors != 0 )
		{
			*output += "<ATM_ERRORS>\n";
			*output += int2string(errors.ATMErrors);
			*output += "\n</ATM_ERRORS>\n";
		}
		if ( errors.bankErrors != 0 )
		{
			*output += "<BANK_ERRORS>\n";
			*output += int2string(errors.bankErrors);
			*output += "\n</BANK_ERRORS>\n";
		}
		if ( errors.jobAuthErrors != 0 )
		{
			*output += "<JOBAUTH_ERRORS>\n";
			*output += int2string(errors.jobAuthErrors);
			*output += "\n</JOBAUTH_ERRORS>\n";
		}
		if ( errors.jobAuthErrors != 0 )
		{
			*output += "<PA_ERRORS>\n";
			*output += int2string(errors.jobAuthErrors);
			*output += "\n</PA_ERRORS>\n";
		}

		*output += "</STATUS_INFO>\n";
	}
	*output +="</BODY>\n</HLR>\n";
	
	#ifdef DEBUG
		cerr << "Formatted xml message:" << endl;
		cerr << *output << endl;
	#endif 
	hlr_log( "Ping Engine: exit" , &logStream );
	return;
}


