// DGAS (DataGrid Accounting System) 
// Server Daeomn and protocol engines.
// 
// $Id: userAuth_engine.cpp,v 1.2 2003/12/02 13:50:09 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
//
//    

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
#include <userAuth_engine.h>

#define DEBUG

void userAuth_engine( string &doc, connInfo &connectionInfo, string *output )
{
	#ifdef DEBUG
	 cerr << "Entering userAuth engine" << endl;
	#endif
	int res;
	vector<string> jobIds;
	node nodeBuff;
	while ( nodeBuff.status == 0 )
	{
		string tag = "USER_AUTH_INFO";
		nodeBuff = parse( &doc, tag );
		if ( nodeBuff.status != 0)
			break;
		string jobIdBuffer;
		node tagBuff;
		tagBuff = parse ( &doc, "DG_JOBID");
		if ( tagBuff.status == 0 )
		{
			#ifdef DEBUG
				cerr << "userAuth_engine, got: " << tagBuff.text << endl;
			#endif
			jobIdBuffer  = tagBuff.text;
		}
		nodeBuff.release();
		jobIds.push_back(jobIdBuffer);
	}
	#ifdef DEBUG
	cerr << "stored n: " << jobIds.size() << "jobIds to authorize" <<endl;
	#endif
	// now we have a vector<strings> jobIds that contains the elements
	// needed for the query. 
	// Once we have those information we can compose the XML answer and put
	// it into the string output.
	
	//initialize buffer string

		
	*output = "<HLR type=\"HLR_error\">\n<HEAD>\n<VER>1.0</VER>\n</HEAD>\n<BODY>\n";
		
	vector < string >::iterator job_it = jobIds.begin();
	jobAuth jobAuth_buff;
	while ( job_it != jobIds.end() )
	{
		//Check if the job dg_jobid has been authorized,
		//if so get the submission time and the userCertSubject back.
		if ( jobAuth_buff.get(*job_it) != 0 )
		{
			//dgJobId isn't registered return an error.
			*output += "<USER_AUTH_INFO>\n";
			*output += "<DG_JOBID>\n";
			*output += *job_it;
			*output += "\n</DG_JOBID>\n";
			*output += "</USER_AUTH_INFO>\n";
			*output += "<ERROR>\n";
			*output += E_JOB_NOTREG;
			*output += "\n</ERROR>\n";
		}
		else
		{
			// dg_jobid has been authorized.
			// get the relevant User info from the db.
			hlrUser userBuff;
			userBuff.certSubject=jobAuth_buff.usrCert;
			#ifdef DEBUG 
			 cerr << "got request for user:" << userBuff.certSubject << endl;
			#endif
			if ( userBuff.get() == 0 )
			{
				//User account info found, the user has
				//a valid account on the system, 
				//use info to compose the XML Answer
				
				*output = "<HLR type =\"UserAuth_answer\">\n<HEAD>\n<VER>1.0</VER>\n</HEAD>\n";
				*output += "<BODY>\n";
				*output += "<USER_AUTH_INFO>\n";
				*output += "<jobIsRegistered>\n";
				*output += "true\n";
				*output += "</jobIsRegistered>\n";
				*output += "<jobRegTime>\n";
				*output += int2string(jobAuth_buff.submTime);
				*output += "\n</jobRegTime>\n";
				*output += "<userAccountIsValid>\n";
				*output += "true\n";
				*output += "</userAccountIsValid>\n";
				*output += "<userAvailableCredits>\n";
				*output += int2string(userBuff.assigned-userBuff.spent);
				*output += "\n</userAvailableCredits>\n";
				*output += "</USER_AUTH_INFO>\n";
			}
			else
			{
				//The user hasn't a valid account on the 
				//system compose appropriate msg.
				*output = "<HLR type =\"JobAuth_answer\">\n<HEAD>\n<VER>1.0</VER>\n</HEAD>\n";
				*output += "<BODY>\n";
				*output += "<USER_AUTH_INFO>\n";
				*output += "<jobIsRegistered>\n";
				*output += "true\n";
				*output += "</jobIsRegistered>\n";
				*output += "<jobRegTime>\n";
				*output += int2string(jobAuth_buff.submTime);
				*output += "\n</jobRegTime>\n";
				*output += "<userAccountIsValid>\n";
				*output += "false\n";
				*output += "<userAccountIsValid>\n";
				*output += "</USER_AUTH_INFO>\n";
			}
				
		}
		//increment job_info vector iterator
		job_it++;
	
	}
	*output +="</BODY>\n</HLR>\n";
	// end of the job credit.
	
	//job reservation here  TBI
	
	#ifdef DEBUG
		cerr << "Formatted xml message:" << endl;
		cerr << *output << endl;
	#endif 
	return;
}


