/* DGAS (DataGrid Accounting System) 
// Server Daeomn and protocol engines.
// 
// $Id: edg-wl-dgas-pa-pAlgDyn.cpp,v 1.1 2003/04/11 16:21:12 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Andrea Guarise <andrea.guarise@to.infn.it>
//         Rosario M. Piro <piro@to.infn.it>
*/
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
/*
      Note: If dynamically linked, this library will be searched for
            three symbols (num_keys, q_keys and getResPrice). The names
	    of these symbols MUST NOT BE CHANGED, otherwise the still running
	    program won't find them in a recompiled newer library version!

// -------------------------------------------------------------------------
//  Includes
// -------------------------------------------------------------------------*/
#include <iostream>
#include "edg-wl-dgas-pa-pAlgDyn.h"


/* the resulting price is returned as a string, in order to
   allow the change of pricing from int to double without necessarily
   changing the interface to this library; p_lib_helper in this case
   is a pointer to a vector<string> object and will be casted in getResPrice.
*/
/* DO NOT CHANGE THE NAME OF THIS FUNCTION (getResPrice), since
   it is a symbol that we have to search for (with dlsym()) when linking
   this library dynamically! */
#ifdef __cplusplus
extern "C" {
#endif

  int getResPrice (void *p_lib_helper, string &price_value)
  {
    vector<string> *price_info = (vector<string> *) p_lib_helper;
    struct pr_info info;
    price_t price;

    #ifdef DEBUG
    cerr << "getResPrice: calculated price is ";
    #endif

    /* the following assumes that results are passed in the same order they
       where defined in q_keys[] */
    info.tot_cpus =         strToInfo((*price_info)[0].c_str());
    info.free_cpus =        strToInfo((*price_info)[1].c_str());
    info.total_jobs =       strToInfo((*price_info)[2].c_str());
    info.running_jobs =     strToInfo((*price_info)[3].c_str());
    info.idle_jobs =        strToInfo((*price_info)[4].c_str()); 
    info.max_total_jobs =   strToInfo((*price_info)[5].c_str());
    info.max_running_jobs = strToInfo((*price_info)[6].c_str());
    info.worst_qtt =        strToInfo((*price_info)[7].c_str());
    info.estimated_qtt =    strToInfo((*price_info)[8].c_str());


    /* very simple price algorithm, for demonstrative purpose only
       the real one will be build up as a dynamic object. */
    price = (price_t) ((10*(double)info.tot_cpus)+(double)(2*(info.max_running_jobs-info.running_jobs))-info.idle_jobs);

    /* write price to price_value string */
    price_value = priceToString(price);

    #ifdef DEBUG
    cerr << price_value << endl << flush;
    #endif

    return 0; /* no error */
  }

#ifdef __cplusplus
} // extern "C"
#endif
