/* DGAS (DataGrid Accounting System) 
// Server Daeomn and protocol engines.
// 
// $Id: edg-wl-dgas-pa-pAlgMan.h,v 1.1 2003/04/11 16:21:12 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Rosario M. Piro <piro@to.infn.it>
*/
 /***************************************************************************
 * Code borrowed from:
 *  authors   :
 *  copyright : 
 ***************************************************************************/
/*
      Note: If dynamically linked, this library will be searched for
            three symbols (num_keys, q_keys and getResPrice). The names
	    of these symbols MUST NOT BE CHANGED, otherwise the still running
	    program won't find them in a recompiled newer library version!
//
//
//    

// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------
*/
#ifndef P_ALG_MAN
#define P_ALG_MAN

#include <vector>
#include <string>
#include <hlr_prot_errcode.h>
#include "edg-wl-dgas-paPriceType.h"

#define NUM_KEYS 0        /* we have no query keys! */

using namespace std;


/* definition of query keys */
/* There are no query keys required for a manual setting of the price */
/* We still have to define num_keys (which is set to 0), in order to  */
/* inform the linking pa_engine that no MDS query is necessary!       */
/* DO NOT CHANGE THE NAME OF THIS SYMBOL otherwise you will have to   */
/* change the dlsym() calls of the main program as well!              */
int num_keys = NUM_KEYS;

#ifdef __cplusplus
extern "C" { /* no name mangling, header usable for C and C++ */
#endif
/* the resulting price is returned as a string, in order to
   allow the change of pricing from int to double without necessarily
   changing the interface to this library; the p_lib_helper in this case
   is a pointer to a vector<string> object containing the necessary information
   needed to identify the database and the specific record in which to search
   for the suggested price. The pointer will be cast in getResPrice.
*/
int getResPrice (void *p_lib_helper, string &price_value);

/* DO NOT CHANGE THE NAME OF THIS FUNCTION (getResPrice), since
   it is a symbol that we have to search for (with dlsym()) when linking
   this library dynamically! */

#ifdef __cplusplus
}
#endif


#endif /* #ifndef P_ALG_MAN */
