// $Id: edg-wl-dgas-paSuggPrice.cpp,v 1.2 2003/04/28 14:44:49 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Author: Rosario Piro <piro@to.infn.it>
/***************************************************************************
 * Code borrowed from: dgas_paResPrice.cpp
 *  authors   : Andrea Guarise <andrea.guarise@to.infn.it>
 *             
 *  
 ***************************************************************************/


#include<edg-wl-dgas-paSuggPrice.h>
#include<db.h>
#include<dbResult.h>

#define TOO_MANY_ROWS  1
#define NO_RECORD      3

extern const char * _pa_sql_server;
extern const char * _pa_sql_user;
extern const char * _pa_sql_password;
extern const char * _pa_sql_dbname;


paSuggPrice::paSuggPrice ( string _resID, int _suggPrice)
{
	#ifdef DEBUG
	 cerr << "DEBUG: paSuggPrice::paSuggPrice(), Constructor:";
	#endif
	resID = _resID;
	suggestedPrice = _suggPrice;
	#ifdef DEBUG
	 cerr << "resID=" << resID << ",";
	 cerr << "suggestedPrice=" << suggestedPrice << endl;
	#endif
}

int paSuggPrice::get(string &_resID)
{
	#ifdef DEBUG
	 cerr << "DEBUG: paSuggPrice::get(),";
	 cerr << "resID=" << _resID << ",";
	#endif
	 db paDb(_pa_sql_server,
			 _pa_sql_user,
			 _pa_sql_password,
			 _pa_sql_dbname
			 );
	 if ( paDb.errNo == 0 )
	 {
	        //connection to the DB is OK, we can do the query
		string queryStr = "";
		queryStr = "SELECT * FROM res_index WHERE res_cert_subject='";
		queryStr += _resID;
		queryStr += "'";
		#ifdef DEBUG
	 	 cerr << "DEBUG: paSuggPrice::get(),";
		 cerr << "DB query for resource item:" << queryStr << endl;
		#endif
		 dbResult result= paDb.query(queryStr);
		 if ( paDb.errNo == 0)
		 {
			 int numRows = result.numRows();
			 //Query ok use the results
			 if (numRows > 1)
			 {
				#ifdef DEBUG
				 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
				 cerr << "DB mismatch, found n." << numRows << " entries." << endl;
				#endif
				 return TOO_MANY_ROWS;
			 }
			 if ( numRows == 0 )
			 {
				#ifdef DEBUG
				 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
				 cerr << "Record not found." << endl;
				#endif
				 return NO_RECORD;
			 }
			 if ( numRows == 1 )
			 {
				resID = result.getData()[0][1];
				suggestedPrice = atoi((result.getData()[0][3]).c_str());
				#ifdef DEBUG
	 			 cerr << "DEBUG: paSuggPrice::get(),";
	 			 cerr << "resID=" << resID << ",";
				 cerr << "suggestedPrice=" << suggestedPrice 
				      << endl;
				#endif
				return 0;
			 }
		 }
		 else
		 {
			 //query failed, report the error
			#ifdef DEBUG
		 	 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 	 cerr << "Error querying the database, got error: " << endl;
		 	 cerr << paDb.errMsg << endl;
			#endif
			 return paDb.errNo;
		 }

	 }
	 else
	 {
		 //Error conecting to the database, reporting the error
		#ifdef DEBUG
		 cerr << "DEBUG:" << __FILE__ << ":" << __LINE__ << " : ";
		 cerr << "Error connecting to the database, got error: " << endl;
		 cerr << paDb.errMsg << endl;
		#endif
		 return paDb.errNo;
	 }
	 return 0;
}
