// File: JobController.cpp
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2001 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: JobController.cpp,v 1.11 2005/08/25 13:42:26 dhsmith Exp $

#include "JobController.h"
#include "JobControllerImpl.h"
#include "JobControllerFactory.h"

JOBCONTROL_NAMESPACE_BEGIN {

namespace controller {

JobController::JobController( edg_wll_Context *cont ) : jc_impl( JobControllerFactory::instance()->create_server( cont ) )
{}

JobController::~JobController( void )
{ delete this->jc_impl; }

int JobController::submit( const classad::ClassAd *ad )
{ return this->jc_impl->submit( ad ); }

bool JobController::cancel( const common::jobid::JobId &id, const char *condorid, const char *logfile, bool force )
{ return this->jc_impl->cancel( id, condorid, logfile, force ); }

bool JobController::cancel( int condorid, bool force )
{ return this->jc_impl->cancel( condorid, force ); }

size_t JobController::queue_size( void )
{ return this->jc_impl->queue_size(); }

}; // namespace controller

} JOBCONTROL_NAMESPACE_END;

