#ifndef __JOBCONTROLLER_H_LOADED
#define __JOBCONTROLLER_H_LOADED

// File: JobController.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2001 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: JobController.h,v 1.10 2005/08/25 13:42:26 dhsmith Exp $

#include <cstdio>

#include "edg/workload/jobcontrol/jobcontrol_namespace.h"

typedef  struct _edg_wll_Context  *edg_wll_Context;

namespace classad { class ClassAd; }
COMMON_SUBNAMESPACE_CLASS( jobid, JobId );

JOBCONTROL_NAMESPACE_BEGIN {

namespace controller {

class JobControllerImpl;

class JobController
{
public:
  JobController( edg_wll_Context *cont = NULL );
  ~JobController( void );

  int submit( const classad::ClassAd *ad );
  bool cancel( const common::jobid::JobId &id, const char *condorid = NULL, const char *logfile = NULL, bool force = false );
  bool cancel( int condorid, bool force = true );
  size_t queue_size( void );

private:
  JobController( const JobController &rhs ); // Not implemented
  JobController &operator=( const JobController& rhs ); // Not implemented

  JobControllerImpl    *jc_impl;
};

}; // namespace controller

} JOBCONTROL_NAMESPACE_END;

#endif /* __JOBCONTROLLER_H_LOADED */

// Local Variables:
// mode: c++
// End:
