#ifndef EDG_WORKLOAD_JOBCONTROL_CONTROLLER_JOBCONTROLLERPROXY_H
#define EDG_WORKLOAD_JOBCONTROL_CONTROLLER_JOBCONTROLLERPROXY_H

// File: JobControllerProxy.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2001 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: JobControllerProxy.h,v 1.11 2005/08/25 13:42:26 dhsmith Exp $

#include <classad_distribution.h>

#include "edg/workload/common/utilities/FileList.h"
#include "edg/workload/common/utilities/FileListLock.h"

#include "edg/workload/jobcontrol/common/EventLogger.h"
#include "JobControllerImpl.h"

JOBCONTROL_NAMESPACE_BEGIN {

namespace controller {

class JobControllerProxy: public JobControllerImpl {
private:
  typedef common::utilities::FileList<classad::ClassAd>    queue_type;
  typedef common::utilities::FileListMutex                 mutex_type;

public:
  JobControllerProxy( queue_type &q, mutex_type &m, edg_wll_Context *cont );
  ~JobControllerProxy( void );

  virtual int submit( const classad::ClassAd *ad );
  virtual bool cancel( const common::jobid::JobId &id, const char *condorid, const char *logfile, bool force );
  virtual bool cancel( int condorid, bool force );
  virtual size_t queue_size( void );

private:
  JobControllerProxy( const JobControllerProxy &rhs ); // Not implemented
  JobControllerProxy &operator=( const JobControllerProxy &rhs ); // Not implemented

  int                      jcp_source;
  mutex_type              &jcp_mutex;
  queue_type              &jcp_queue;
  jccommon::EventLogger    jcp_logger;
};

}; // namespace controller

} JOBCONTROL_NAMESPACE_END;

#endif /* EDG_WORKLOAD_JOBCONTROL_CONTROLLER_JOBCONTROLLERPROXY_H */

// Local Variables:
// mode: c++
// End:
