/*

  !! Automatically generated file
  !! Do not edit, your changes will be discarded upon build
  !! Change the corresponding template file Event.cpp.T

*/

#include "edg/workload/logging/client/Event.h"
#include "edg/workload/common/jobid/JobIdExceptions.h"
#include "edg/workload/logging/client/LoggingExceptions.h"

#include <utility>
#include <vector>
#include <string>
#include <stdio.h>

#include <errno.h>


#include "edg/workload/logging/client/consumer.h"
#include "edg/workload/logging/client/events.h"
#include "edg/workload/common/jobid/jobid.h"

EWL_BEGIN_NAMESPACE;

#define CLASS_PREFIX "edg::workload::logging::Event::"


Event::Event(void)
{
  type = UNDEF;
  flesh = 0;
}


Event::Event(const Event &in)
{
  type = in.type;
  flesh = in.flesh;
  if (flesh) flesh->use();
}


Event::Event(edg_wll_Event *in)
{
  type = (Type)in->type;
  flesh = new CountRef<Event>((void*)in);
}


Event::~Event(void)
{
  if (flesh) flesh->release();
}


Event & 
Event::operator= (const Event &in)
{
  if (flesh) flesh->release();
  type = in.type;
  flesh = in.flesh;
  if (flesh) flesh->use();
  
  return *this;
}

int Event::getValInt(Attr attr)	const
{
	edg_wll_Event const	*cev = (edg_wll_Event *) flesh->ptr;

	switch (attr) {
		case Event::SOURCE: return(cev->any.source);
		case Event::PRIORITY: return(cev->any.priority);
		case Event::LEVEL: return(cev->any.level);
		default: break;
	}

	switch (cev->type) {
		case REGJOB:
		switch (attr) {
			case Event::NSUBJOBS: return(cev->regJob.nsubjobs);
			case Event::JOBTYPE: return(cev->regJob.jobtype);
			default: goto badattr;
		}
		case DEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case DONE:
		switch (attr) {
			case Event::EXIT_CODE: return(cev->done.exit_code);
			case Event::STATUS_CODE: return(cev->done.status_code);
			default: goto badattr;
		}
		case MATCH:
		switch (attr) {
			default: goto badattr;
		}
		case CHANGEACL:
		switch (attr) {
			case Event::PERMISSION_TYPE: return(cev->changeACL.permission_type);
			case Event::PERMISSION: return(cev->changeACL.permission);
			case Event::OPERATION: return(cev->changeACL.operation);
			case Event::USER_ID_TYPE: return(cev->changeACL.user_id_type);
			default: goto badattr;
		}
		case ABORT:
		switch (attr) {
			default: goto badattr;
		}
		case ENQUEUED:
		switch (attr) {
			case Event::RESULT: return(cev->enQueued.result);
			default: goto badattr;
		}
		case CLEAR:
		switch (attr) {
			case Event::REASON: return(cev->clear.reason);
			default: goto badattr;
		}
		case CHKPT:
		switch (attr) {
			default: goto badattr;
		}
		case USERTAG:
		switch (attr) {
			default: goto badattr;
		}
		case HELPERCALL:
		switch (attr) {
			case Event::SRC_ROLE: return(cev->helperCall.src_role);
			default: goto badattr;
		}
		case RUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case CANCEL:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->cancel.status_code);
			default: goto badattr;
		}
		case LISTENER:
		switch (attr) {
			case Event::SVC_PORT: return(cev->listener.svc_port);
			default: goto badattr;
		}
		case ACCEPTED:
		switch (attr) {
			case Event::FROM: return(cev->accepted.from);
			default: goto badattr;
		}
		case REFUSED:
		switch (attr) {
			case Event::FROM: return(cev->refused.from);
			default: goto badattr;
		}
		case RESUBMISSION:
		switch (attr) {
			case Event::RESULT: return(cev->resubmission.result);
			default: goto badattr;
		}
		case PENDING:
		switch (attr) {
			default: goto badattr;
		}
		case HELPERRETURN:
		switch (attr) {
			case Event::SRC_ROLE: return(cev->helperReturn.src_role);
			default: goto badattr;
		}
		case PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case CURDESCR:
		switch (attr) {
			default: goto badattr;
		}
		case TRANSFER:
		switch (attr) {
			case Event::DESTINATION: return(cev->transfer.destination);
			case Event::RESULT: return(cev->transfer.result);
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL,
				  "attribute is not of int type"));
        }
badattr:
        STACK_ADD;
        throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return -1; /* gcc, shut up! */
}

static char const *get_string_val(const edg_wll_Event *cev, Event::Attr attr)
{
	switch (attr) {
		case Event::LEVEL: return((const char *)edg_wll_LevelToString((edg_wll_Level)cev->any.level));
		case Event::USER: return(cev->any.user);
		case Event::SEQCODE: return(cev->any.seqcode);
		case Event::SRC_INSTANCE: return(cev->any.src_instance);
		case Event::HOST: return(cev->any.host);
		default: break;
	}

	switch (cev->type) {
		case Event::REGJOB:
		switch (attr) {
			case Event::NS: return(cev->regJob.ns);
			case Event::JOBTYPE: return((const char *)edg_wll_RegJobJobtypeToString(cev->regJob.jobtype));
			case Event::JDL: return(cev->regJob.jdl);
			case Event::SEED: return(cev->regJob.seed);
			default: goto badattr;
		}
		case Event::DEQUEUED:
		switch (attr) {
			case Event::QUEUE: return(cev->deQueued.queue);
			case Event::LOCAL_JOBID: return(cev->deQueued.local_jobid);
			default: goto badattr;
		}
		case Event::DONE:
		switch (attr) {
			case Event::STATUS_CODE: return((const char *)edg_wll_DoneStatus_codeToString(cev->done.status_code));
			case Event::REASON: return(cev->done.reason);
			default: goto badattr;
		}
		case Event::MATCH:
		switch (attr) {
			case Event::DEST_ID: return(cev->match.dest_id);
			default: goto badattr;
		}
		case Event::CHANGEACL:
		switch (attr) {
			case Event::USER_ID: return(cev->changeACL.user_id);
			default: goto badattr;
		}
		case Event::ABORT:
		switch (attr) {
			case Event::REASON: return(cev->abort.reason);
			default: goto badattr;
		}
		case Event::ENQUEUED:
		switch (attr) {
			case Event::REASON: return(cev->enQueued.reason);
			case Event::QUEUE: return(cev->enQueued.queue);
			case Event::RESULT: return((const char *)edg_wll_EnQueuedResultToString(cev->enQueued.result));
			case Event::JOB: return(cev->enQueued.job);
			default: goto badattr;
		}
		case Event::CLEAR:
		switch (attr) {
			case Event::REASON: return((const char *)edg_wll_ClearReasonToString(cev->clear.reason));
			default: goto badattr;
		}
		case Event::CHKPT:
		switch (attr) {
			case Event::CLASSAD: return(cev->chkpt.classad);
			case Event::TAG: return(cev->chkpt.tag);
			default: goto badattr;
		}
		case Event::USERTAG:
		switch (attr) {
			case Event::VALUE: return(cev->userTag.value);
			case Event::NAME: return(cev->userTag.name);
			default: goto badattr;
		}
		case Event::HELPERCALL:
		switch (attr) {
			case Event::SRC_ROLE: return((const char *)edg_wll_HelperCallSrc_roleToString(cev->helperCall.src_role));
			case Event::HELPER_PARAMS: return(cev->helperCall.helper_params);
			case Event::HELPER_NAME: return(cev->helperCall.helper_name);
			default: goto badattr;
		}
		case Event::RUNNING:
		switch (attr) {
			case Event::NODE: return(cev->running.node);
			default: goto badattr;
		}
		case Event::CANCEL:
		switch (attr) {
			case Event::STATUS_CODE: return((const char *)edg_wll_CancelStatus_codeToString(cev->cancel.status_code));
			case Event::REASON: return(cev->cancel.reason);
			default: goto badattr;
		}
		case Event::LISTENER:
		switch (attr) {
			case Event::SVC_HOST: return(cev->listener.svc_host);
			case Event::SVC_NAME: return(cev->listener.svc_name);
			default: goto badattr;
		}
		case Event::ACCEPTED:
		switch (attr) {
			case Event::FROM_HOST: return(cev->accepted.from_host);
			case Event::LOCAL_JOBID: return(cev->accepted.local_jobid);
			case Event::FROM_INSTANCE: return(cev->accepted.from_instance);
			default: goto badattr;
		}
		case Event::REFUSED:
		switch (attr) {
			case Event::REASON: return(cev->refused.reason);
			case Event::FROM_HOST: return(cev->refused.from_host);
			case Event::FROM_INSTANCE: return(cev->refused.from_instance);
			default: goto badattr;
		}
		case Event::RESUBMISSION:
		switch (attr) {
			case Event::REASON: return(cev->resubmission.reason);
			case Event::TAG: return(cev->resubmission.tag);
			case Event::RESULT: return((const char *)edg_wll_ResubmissionResultToString(cev->resubmission.result));
			default: goto badattr;
		}
		case Event::PENDING:
		switch (attr) {
			case Event::REASON: return(cev->pending.reason);
			default: goto badattr;
		}
		case Event::HELPERRETURN:
		switch (attr) {
			case Event::SRC_ROLE: return((const char *)edg_wll_HelperReturnSrc_roleToString(cev->helperReturn.src_role));
			case Event::RETVAL: return(cev->helperReturn.retval);
			case Event::HELPER_NAME: return(cev->helperReturn.helper_name);
			default: goto badattr;
		}
		case Event::PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CURDESCR:
		switch (attr) {
			case Event::DESCR: return(cev->curDescr.descr);
			default: goto badattr;
		}
		case Event::TRANSFER:
		switch (attr) {
			case Event::DEST_HOST: return(cev->transfer.dest_host);
			case Event::DEST_INSTANCE: return(cev->transfer.dest_instance);
			case Event::DEST_JOBID: return(cev->transfer.dest_jobid);
			case Event::REASON: return(cev->transfer.reason);
			case Event::RESULT: return((const char *)edg_wll_TransferResultToString(cev->transfer.result));
			case Event::JOB: return(cev->transfer.job);
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL, 
				  "attribute is not of string type and can not be converted"));
	}
badattr:
	STACK_ADD;
	throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return NULL; /* gcc, shut up! */
}


std::string 
Event::getValString(Attr attr) const
{
  edg_wll_Event const *cev = (edg_wll_Event *) flesh->ptr;
  std::string	ret;
  
  try {
    char const	*s = get_string_val(cev,attr);
    if (s) ret.assign(s);
    return ret;
  } catch (Exception &e) {
    STACK_ADD;
    throw;
  }
}


struct timeval 
Event::getValTime(Attr attr) const
{
  edg_wll_Event const *cev = (edg_wll_Event *) flesh->ptr;
	switch (attr) {
		case Event::TIMESTAMP: return(cev->any.timestamp);
		default: break;
	}
  
  /* XXX
   * to make things simpler we don't include this here as there are no
   * type specific timeval attributes currently
   *
   *	switch (cev->type) {
   */

  STACK_ADD; 
  throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
}

static
edg_wlc_JobId 
get_val_jobid(edg_wll_Event const *cev, Event::Attr attr) 
{
	switch (attr) {
		case Event::JOBID: return(cev->any.jobId);
		default: break;
	}
	switch (cev->type) {
		case Event::REGJOB:
		switch (attr) {
			case Event::PARENT: return(cev->regJob.parent);
			default: goto badattr;
		}
		case Event::DEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::DONE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::MATCH:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CHANGEACL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::ABORT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::ENQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CLEAR:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CHKPT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::USERTAG:
		switch (attr) {
			default: goto badattr;
		}
		case Event::HELPERCALL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CANCEL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::LISTENER:
		switch (attr) {
			default: goto badattr;
		}
		case Event::ACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::REFUSED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RESUBMISSION:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PENDING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::HELPERRETURN:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CURDESCR:
		switch (attr) {
			default: goto badattr;
		}
		case Event::TRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL, 
				  "attribute is not of jobid type"));
	}
badattr:
	STACK_ADD;
	throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return NULL; /* gcc, shut up! */
}

const 
edg::workload::common::jobid::JobId 
Event::getValJobId(Attr attr) const
{
	edg_wll_Event const *cev = (edg_wll_Event *) flesh->ptr;
	try {
		edg_wlc_JobId job_id = get_val_jobid(cev,attr);
		return(edg::workload::common::jobid::JobId(job_id));
	} 
	catch (Exception &e) {
		STACK_ADD;
		throw;
	}

}


static std::string const names[Event::TYPE_MAX] = {
  "undefined",
	"Transfer",
	"Accepted",
	"Refused",
	"EnQueued",
	"DeQueued",
	"HelperCall",
	"HelperReturn",
	"Running",
	"Resubmission",
	"Done",
	"Cancel",
	"Abort",
	"Clear",
	"Purge",
	"Match",
	"Pending",
	"RegJob",
	"Chkpt",
	"Listener",
	"CurDescr",
	"UserTag",
	"ChangeACL",
};

const std::string  & 
Event::name(void) const
{
  if (type<0 || type>TYPE_MAX) {
    STACK_ADD;
    throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid event type"));
  }
  return names[type];
}


static 
std::string const attr_names[Event::ATTR_MAX] = {
	"classad",
	"descr",
	"dest_host",
	"dest_id",
	"dest_instance",
	"dest_jobid",
	"destination",
	"exit_code",
	"from",
	"from_host",
	"from_instance",
	"helper_name",
	"helper_params",
	"host",
	"jdl",
	"job",
	"jobId",
	"jobtype",
	"level",
	"local_jobid",
	"name",
	"node",
	"ns",
	"nsubjobs",
	"operation",
	"parent",
	"permission",
	"permission_type",
	"priority",
	"queue",
	"reason",
	"result",
	"retval",
	"seed",
	"seqcode",
	"source",
	"src_instance",
	"src_role",
	"status_code",
	"svc_host",
	"svc_name",
	"svc_port",
	"tag",
	"timestamp",
	"user",
	"user_id",
	"user_id_type",
	"value",
};


const std::string & 
Event::getAttrName(Attr attr) const
{
  if (attr<0 || attr>=ATTR_MAX) {
    STACK_ADD;
    throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid attribute"));
  }
  return attr_names[attr];
}


typedef std::pair<Event::Attr,Event::AttrType> tpair;
static std::vector<tpair> attrs[Event::TYPE_MAX];

#define apush(etype,attr,atype) \
	attrs[etype].push_back(tpair(attr,atype))

static bool attrs_inited = false;

static void init_attrs(void)
{
	apush(Event::REGJOB,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::REGJOB,Event::PRIORITY,Event::INT_T);
	apush(Event::REGJOB,Event::LEVEL,Event::INT_T);
	apush(Event::REGJOB,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::REGJOB,Event::USER,Event::STRING_T);
	apush(Event::REGJOB,Event::SEQCODE,Event::STRING_T);
	apush(Event::REGJOB,Event::JOBID,Event::JOBID_T);
	apush(Event::REGJOB,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::REGJOB,Event::HOST,Event::STRING_T);
	apush(Event::REGJOB,Event::NS,Event::STRING_T);
	apush(Event::REGJOB,Event::PARENT,Event::JOBID_T);
	apush(Event::REGJOB,Event::NSUBJOBS,Event::INT_T);
	apush(Event::REGJOB,Event::JOBTYPE,Event::INT_T);
	apush(Event::REGJOB,Event::JDL,Event::STRING_T);
	apush(Event::REGJOB,Event::SEED,Event::STRING_T);
	apush(Event::DEQUEUED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::DEQUEUED,Event::PRIORITY,Event::INT_T);
	apush(Event::DEQUEUED,Event::LEVEL,Event::INT_T);
	apush(Event::DEQUEUED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::DEQUEUED,Event::USER,Event::STRING_T);
	apush(Event::DEQUEUED,Event::SEQCODE,Event::STRING_T);
	apush(Event::DEQUEUED,Event::JOBID,Event::JOBID_T);
	apush(Event::DEQUEUED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::DEQUEUED,Event::HOST,Event::STRING_T);
	apush(Event::DEQUEUED,Event::QUEUE,Event::STRING_T);
	apush(Event::DEQUEUED,Event::LOCAL_JOBID,Event::STRING_T);
	apush(Event::DONE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::DONE,Event::PRIORITY,Event::INT_T);
	apush(Event::DONE,Event::LEVEL,Event::INT_T);
	apush(Event::DONE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::DONE,Event::USER,Event::STRING_T);
	apush(Event::DONE,Event::SEQCODE,Event::STRING_T);
	apush(Event::DONE,Event::JOBID,Event::JOBID_T);
	apush(Event::DONE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::DONE,Event::HOST,Event::STRING_T);
	apush(Event::DONE,Event::EXIT_CODE,Event::INT_T);
	apush(Event::DONE,Event::STATUS_CODE,Event::INT_T);
	apush(Event::DONE,Event::REASON,Event::STRING_T);
	apush(Event::MATCH,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::MATCH,Event::PRIORITY,Event::INT_T);
	apush(Event::MATCH,Event::LEVEL,Event::INT_T);
	apush(Event::MATCH,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::MATCH,Event::USER,Event::STRING_T);
	apush(Event::MATCH,Event::SEQCODE,Event::STRING_T);
	apush(Event::MATCH,Event::JOBID,Event::JOBID_T);
	apush(Event::MATCH,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::MATCH,Event::HOST,Event::STRING_T);
	apush(Event::MATCH,Event::DEST_ID,Event::STRING_T);
	apush(Event::CHANGEACL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CHANGEACL,Event::PRIORITY,Event::INT_T);
	apush(Event::CHANGEACL,Event::LEVEL,Event::INT_T);
	apush(Event::CHANGEACL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CHANGEACL,Event::USER,Event::STRING_T);
	apush(Event::CHANGEACL,Event::SEQCODE,Event::STRING_T);
	apush(Event::CHANGEACL,Event::JOBID,Event::JOBID_T);
	apush(Event::CHANGEACL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CHANGEACL,Event::HOST,Event::STRING_T);
	apush(Event::CHANGEACL,Event::PERMISSION_TYPE,Event::INT_T);
	apush(Event::CHANGEACL,Event::PERMISSION,Event::INT_T);
	apush(Event::CHANGEACL,Event::OPERATION,Event::INT_T);
	apush(Event::CHANGEACL,Event::USER_ID_TYPE,Event::INT_T);
	apush(Event::CHANGEACL,Event::USER_ID,Event::STRING_T);
	apush(Event::ABORT,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::ABORT,Event::PRIORITY,Event::INT_T);
	apush(Event::ABORT,Event::LEVEL,Event::INT_T);
	apush(Event::ABORT,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::ABORT,Event::USER,Event::STRING_T);
	apush(Event::ABORT,Event::SEQCODE,Event::STRING_T);
	apush(Event::ABORT,Event::JOBID,Event::JOBID_T);
	apush(Event::ABORT,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::ABORT,Event::HOST,Event::STRING_T);
	apush(Event::ABORT,Event::REASON,Event::STRING_T);
	apush(Event::ENQUEUED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::ENQUEUED,Event::PRIORITY,Event::INT_T);
	apush(Event::ENQUEUED,Event::LEVEL,Event::INT_T);
	apush(Event::ENQUEUED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::ENQUEUED,Event::USER,Event::STRING_T);
	apush(Event::ENQUEUED,Event::SEQCODE,Event::STRING_T);
	apush(Event::ENQUEUED,Event::JOBID,Event::JOBID_T);
	apush(Event::ENQUEUED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::ENQUEUED,Event::HOST,Event::STRING_T);
	apush(Event::ENQUEUED,Event::REASON,Event::STRING_T);
	apush(Event::ENQUEUED,Event::QUEUE,Event::STRING_T);
	apush(Event::ENQUEUED,Event::RESULT,Event::INT_T);
	apush(Event::ENQUEUED,Event::JOB,Event::STRING_T);
	apush(Event::CLEAR,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CLEAR,Event::PRIORITY,Event::INT_T);
	apush(Event::CLEAR,Event::LEVEL,Event::INT_T);
	apush(Event::CLEAR,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CLEAR,Event::USER,Event::STRING_T);
	apush(Event::CLEAR,Event::SEQCODE,Event::STRING_T);
	apush(Event::CLEAR,Event::JOBID,Event::JOBID_T);
	apush(Event::CLEAR,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CLEAR,Event::HOST,Event::STRING_T);
	apush(Event::CLEAR,Event::REASON,Event::INT_T);
	apush(Event::CHKPT,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CHKPT,Event::PRIORITY,Event::INT_T);
	apush(Event::CHKPT,Event::LEVEL,Event::INT_T);
	apush(Event::CHKPT,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CHKPT,Event::USER,Event::STRING_T);
	apush(Event::CHKPT,Event::SEQCODE,Event::STRING_T);
	apush(Event::CHKPT,Event::JOBID,Event::JOBID_T);
	apush(Event::CHKPT,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CHKPT,Event::HOST,Event::STRING_T);
	apush(Event::CHKPT,Event::CLASSAD,Event::STRING_T);
	apush(Event::CHKPT,Event::TAG,Event::STRING_T);
	apush(Event::USERTAG,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::USERTAG,Event::PRIORITY,Event::INT_T);
	apush(Event::USERTAG,Event::LEVEL,Event::INT_T);
	apush(Event::USERTAG,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::USERTAG,Event::USER,Event::STRING_T);
	apush(Event::USERTAG,Event::SEQCODE,Event::STRING_T);
	apush(Event::USERTAG,Event::JOBID,Event::JOBID_T);
	apush(Event::USERTAG,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::USERTAG,Event::HOST,Event::STRING_T);
	apush(Event::USERTAG,Event::VALUE,Event::STRING_T);
	apush(Event::USERTAG,Event::NAME,Event::STRING_T);
	apush(Event::HELPERCALL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::HELPERCALL,Event::PRIORITY,Event::INT_T);
	apush(Event::HELPERCALL,Event::LEVEL,Event::INT_T);
	apush(Event::HELPERCALL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::HELPERCALL,Event::USER,Event::STRING_T);
	apush(Event::HELPERCALL,Event::SEQCODE,Event::STRING_T);
	apush(Event::HELPERCALL,Event::JOBID,Event::JOBID_T);
	apush(Event::HELPERCALL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::HELPERCALL,Event::HOST,Event::STRING_T);
	apush(Event::HELPERCALL,Event::SRC_ROLE,Event::INT_T);
	apush(Event::HELPERCALL,Event::HELPER_PARAMS,Event::STRING_T);
	apush(Event::HELPERCALL,Event::HELPER_NAME,Event::STRING_T);
	apush(Event::RUNNING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::RUNNING,Event::PRIORITY,Event::INT_T);
	apush(Event::RUNNING,Event::LEVEL,Event::INT_T);
	apush(Event::RUNNING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RUNNING,Event::USER,Event::STRING_T);
	apush(Event::RUNNING,Event::SEQCODE,Event::STRING_T);
	apush(Event::RUNNING,Event::JOBID,Event::JOBID_T);
	apush(Event::RUNNING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::RUNNING,Event::HOST,Event::STRING_T);
	apush(Event::RUNNING,Event::NODE,Event::STRING_T);
	apush(Event::CANCEL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CANCEL,Event::PRIORITY,Event::INT_T);
	apush(Event::CANCEL,Event::LEVEL,Event::INT_T);
	apush(Event::CANCEL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CANCEL,Event::USER,Event::STRING_T);
	apush(Event::CANCEL,Event::SEQCODE,Event::STRING_T);
	apush(Event::CANCEL,Event::JOBID,Event::JOBID_T);
	apush(Event::CANCEL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CANCEL,Event::HOST,Event::STRING_T);
	apush(Event::CANCEL,Event::STATUS_CODE,Event::INT_T);
	apush(Event::CANCEL,Event::REASON,Event::STRING_T);
	apush(Event::LISTENER,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::LISTENER,Event::PRIORITY,Event::INT_T);
	apush(Event::LISTENER,Event::LEVEL,Event::INT_T);
	apush(Event::LISTENER,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::LISTENER,Event::USER,Event::STRING_T);
	apush(Event::LISTENER,Event::SEQCODE,Event::STRING_T);
	apush(Event::LISTENER,Event::JOBID,Event::JOBID_T);
	apush(Event::LISTENER,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::LISTENER,Event::HOST,Event::STRING_T);
	apush(Event::LISTENER,Event::SVC_HOST,Event::STRING_T);
	apush(Event::LISTENER,Event::SVC_PORT,Event::PORT_T);
	apush(Event::LISTENER,Event::SVC_NAME,Event::STRING_T);
	apush(Event::ACCEPTED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::ACCEPTED,Event::PRIORITY,Event::INT_T);
	apush(Event::ACCEPTED,Event::LEVEL,Event::INT_T);
	apush(Event::ACCEPTED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::ACCEPTED,Event::USER,Event::STRING_T);
	apush(Event::ACCEPTED,Event::SEQCODE,Event::STRING_T);
	apush(Event::ACCEPTED,Event::JOBID,Event::JOBID_T);
	apush(Event::ACCEPTED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::ACCEPTED,Event::HOST,Event::STRING_T);
	apush(Event::ACCEPTED,Event::FROM,Event::LOGSRC_T);
	apush(Event::ACCEPTED,Event::FROM_HOST,Event::STRING_T);
	apush(Event::ACCEPTED,Event::LOCAL_JOBID,Event::STRING_T);
	apush(Event::ACCEPTED,Event::FROM_INSTANCE,Event::STRING_T);
	apush(Event::REFUSED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::REFUSED,Event::PRIORITY,Event::INT_T);
	apush(Event::REFUSED,Event::LEVEL,Event::INT_T);
	apush(Event::REFUSED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::REFUSED,Event::USER,Event::STRING_T);
	apush(Event::REFUSED,Event::SEQCODE,Event::STRING_T);
	apush(Event::REFUSED,Event::JOBID,Event::JOBID_T);
	apush(Event::REFUSED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::REFUSED,Event::HOST,Event::STRING_T);
	apush(Event::REFUSED,Event::FROM,Event::LOGSRC_T);
	apush(Event::REFUSED,Event::REASON,Event::STRING_T);
	apush(Event::REFUSED,Event::FROM_HOST,Event::STRING_T);
	apush(Event::REFUSED,Event::FROM_INSTANCE,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::RESUBMISSION,Event::PRIORITY,Event::INT_T);
	apush(Event::RESUBMISSION,Event::LEVEL,Event::INT_T);
	apush(Event::RESUBMISSION,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RESUBMISSION,Event::USER,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::SEQCODE,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::JOBID,Event::JOBID_T);
	apush(Event::RESUBMISSION,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::HOST,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::REASON,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::TAG,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::RESULT,Event::INT_T);
	apush(Event::PENDING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PENDING,Event::PRIORITY,Event::INT_T);
	apush(Event::PENDING,Event::LEVEL,Event::INT_T);
	apush(Event::PENDING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PENDING,Event::USER,Event::STRING_T);
	apush(Event::PENDING,Event::SEQCODE,Event::STRING_T);
	apush(Event::PENDING,Event::JOBID,Event::JOBID_T);
	apush(Event::PENDING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PENDING,Event::HOST,Event::STRING_T);
	apush(Event::PENDING,Event::REASON,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::HELPERRETURN,Event::PRIORITY,Event::INT_T);
	apush(Event::HELPERRETURN,Event::LEVEL,Event::INT_T);
	apush(Event::HELPERRETURN,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::HELPERRETURN,Event::USER,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::SEQCODE,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::JOBID,Event::JOBID_T);
	apush(Event::HELPERRETURN,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::HOST,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::SRC_ROLE,Event::INT_T);
	apush(Event::HELPERRETURN,Event::RETVAL,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::HELPER_NAME,Event::STRING_T);
	apush(Event::PURGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PURGE,Event::PRIORITY,Event::INT_T);
	apush(Event::PURGE,Event::LEVEL,Event::INT_T);
	apush(Event::PURGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PURGE,Event::USER,Event::STRING_T);
	apush(Event::PURGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::PURGE,Event::JOBID,Event::JOBID_T);
	apush(Event::PURGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PURGE,Event::HOST,Event::STRING_T);
	apush(Event::CURDESCR,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CURDESCR,Event::PRIORITY,Event::INT_T);
	apush(Event::CURDESCR,Event::LEVEL,Event::INT_T);
	apush(Event::CURDESCR,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CURDESCR,Event::USER,Event::STRING_T);
	apush(Event::CURDESCR,Event::SEQCODE,Event::STRING_T);
	apush(Event::CURDESCR,Event::JOBID,Event::JOBID_T);
	apush(Event::CURDESCR,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CURDESCR,Event::HOST,Event::STRING_T);
	apush(Event::CURDESCR,Event::DESCR,Event::STRING_T);
	apush(Event::TRANSFER,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::TRANSFER,Event::PRIORITY,Event::INT_T);
	apush(Event::TRANSFER,Event::LEVEL,Event::INT_T);
	apush(Event::TRANSFER,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::TRANSFER,Event::USER,Event::STRING_T);
	apush(Event::TRANSFER,Event::SEQCODE,Event::STRING_T);
	apush(Event::TRANSFER,Event::JOBID,Event::JOBID_T);
	apush(Event::TRANSFER,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::TRANSFER,Event::HOST,Event::STRING_T);
	apush(Event::TRANSFER,Event::DEST_HOST,Event::STRING_T);
	apush(Event::TRANSFER,Event::DEST_INSTANCE,Event::STRING_T);
	apush(Event::TRANSFER,Event::DESTINATION,Event::LOGSRC_T);
	apush(Event::TRANSFER,Event::DEST_JOBID,Event::STRING_T);
	apush(Event::TRANSFER,Event::REASON,Event::STRING_T);
	apush(Event::TRANSFER,Event::RESULT,Event::INT_T);
	apush(Event::TRANSFER,Event::JOB,Event::STRING_T);
}

std::vector<std::pair<Event::Attr,Event::AttrType> > const & Event::getAttrs(void) const
{
  if (type<0 || type>=TYPE_MAX) {
    STACK_ADD;
    throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid event type"));
  }
  
  /* FIXME: thread safety */
  if (!attrs_inited) {
    init_attrs();
    attrs_inited = true;
  }
  
  return attrs[type];
}


void 
Event::destroyFlesh(void *in) 
{
  edg_wll_FreeEvent((edg_wll_Event *) in);
  free(in);
}

EWL_END_NAMESPACE;
