#ident "$Header: /local/reps/lcgware/workload/logging/client/connection.c,v 1.21 2003/04/25 06:49:49 salvet Exp $"

#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>

#include "globus_config.h"
#include "sslutils.h"

#include "edg/workload/logging/client/consumer.h"
#include "edg/workload/logging/common/context.h"
#include "edg/workload/logging/common/dgssl.h"

int edg_wll_close(edg_wll_Context ctx)
{
	int sock; 


	edg_wll_ResetError(ctx);

	sock = SSL_get_fd(ctx->ssl);
	if (ctx->ssl) {
		edg_wll_ssl_close_timeout(ctx->ssl,&ctx->p_tmp_timeout);
		ctx->ssl = NULL;
		sock = -1;
	}
	if (ctx->gsiCred) {
		edg_wll_ssl_free(ctx->gsiCred);
		ctx->gsiCred = NULL;
	}
	if (sock >= 0 && close(sock)) edg_wll_SetError(ctx,(edg_wll_ErrorCode) errno,"edg_wll_close");

	return edg_wll_Error(ctx,NULL,NULL);
}


int edg_wll_open(edg_wll_Context ctx)
{
	if (ctx->ssl) 
		if (edg_wll_close(ctx)) return edg_wll_Error(ctx,NULL,NULL);;
	
	if (!(ctx->gsiCred = edg_wll_ssl_init(SSL_VERIFY_PEER,0,
						ctx->p_proxy_filename ? ctx->p_proxy_filename : ctx->p_cert_filename,
						ctx->p_proxy_filename ? ctx->p_proxy_filename : ctx->p_key_filename,
					       	0, 0)))
		return edg_wll_SetError(ctx,EDG_WLL_ERROR_SSL,ERR_error_string(ERR_get_error(), NULL));


	switch (edg_wll_ssl_connect(ctx->gsiCred,ctx->srvName, ctx->srvPort,&ctx->p_tmp_timeout,&ctx->ssl)) {
		case EDG_WLL_SSL_OK: return edg_wll_ResetError(ctx);
		case EDG_WLL_SSL_ERROR_ERRNO:
			edg_wll_SetError(ctx,errno,"edg_wll_ssl_connect()");
			break;
		case EDG_WLL_SSL_ERROR_SSL:
			edg_wll_SetError(ctx,EDG_WLL_ERROR_SSL,ERR_error_string(ERR_get_error(), NULL));
			break;
		case EDG_WLL_SSL_ERROR_HERRNO:
			edg_wll_SetError(ctx,EINVAL,hstrerror(errno));
			break;
		case EDG_WLL_SSL_ERROR_EOF:
			edg_wll_SetError(ctx,ECONNREFUSED,"edg_wll_ssl_connect():"
				       " server closed the connection, probably due to overload");
			break;
		case EDG_WLL_SSL_ERROR_TIMEOUT:
			edg_wll_SetError(ctx,ETIMEDOUT,"edg_wll_ssl_connect()");
			break;
	}

	edg_wll_ssl_free(ctx->gsiCred);
	ctx->gsiCred = NULL;
	
	return edg_wll_Error(ctx,NULL,NULL);
}
