#ident "$Header: /local/reps/lcgware/workload/logging/client/uiwrap.c.T,v 1.9 2004/10/07 16:08:04 dhsmith Exp $"
/*

  !! Automatically generated file
  !! Do not edit, your changes will be discarded upon build
  !! Change the corresponding template file uiwrap.c.T

*/

#include "edg/workload/common/jobid/jobid.h"
#include "edg/workload/logging/client/producer.h"


/*!
 * \fn int edg_wll_LogTransfer(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * result, const char * reason, const char * dest_jobid); 
 * \brief simple wrapper around edg_wll_LogEvent for event Transfer
 * \param context	context to work with,
 * \param destination	destination where the job is being transfered to
 * \param dest_host	destination hostname
 * \param dest_instance	destination instance
 * \param job	job description in receiver language
 * \param result	result of the attempt
 * \param reason	detailed description of transfer, especially reason of failure
 * \param dest_jobid	destination internal jobid
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogTransfer(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * result, const char * reason, const char * dest_jobid)
{
	int i;
	char *s_destination = edg_wll_SourceToString(destination);

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_TRANSFER,EDG_WLL_FORMAT_TRANSFER, s_destination, dest_host, dest_instance, job, result, reason, dest_jobid);
	free(s_destination);

	return(i);   
}


/*!
 * \fn int edg_wll_LogTransferSTART(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid); 
 * \brief simple wrapper around edg_wll_LogEvent for event Transfer, result START
 * \param context	context to work with,
 * \param destination	destination where the job is being transfered to
 * \param dest_host	destination hostname
 * \param dest_instance	destination instance
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \param dest_jobid	destination internal jobid
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogTransferSTART(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid)
{
	int i;
	char *s_destination = edg_wll_SourceToString(destination);

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_TRANSFER,EDG_WLL_FORMAT_TRANSFER, s_destination, dest_host, dest_instance, job, "START", reason, dest_jobid);
	free(s_destination);

	return(i);
}


/*!
 * \fn int edg_wll_LogTransferOK(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid); 
 * \brief simple wrapper around edg_wll_LogEvent for event Transfer, result OK
 * \param context	context to work with,
 * \param destination	destination where the job is being transfered to
 * \param dest_host	destination hostname
 * \param dest_instance	destination instance
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \param dest_jobid	destination internal jobid
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogTransferOK(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid)
{
	int i;
	char *s_destination = edg_wll_SourceToString(destination);

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_TRANSFER,EDG_WLL_FORMAT_TRANSFER, s_destination, dest_host, dest_instance, job, "OK", reason, dest_jobid);
	free(s_destination);

	return(i);
}


/*!
 * \fn int edg_wll_LogTransferREFUSED(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid); 
 * \brief simple wrapper around edg_wll_LogEvent for event Transfer, result REFUSED
 * \param context	context to work with,
 * \param destination	destination where the job is being transfered to
 * \param dest_host	destination hostname
 * \param dest_instance	destination instance
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \param dest_jobid	destination internal jobid
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogTransferREFUSED(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid)
{
	int i;
	char *s_destination = edg_wll_SourceToString(destination);

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_TRANSFER,EDG_WLL_FORMAT_TRANSFER, s_destination, dest_host, dest_instance, job, "REFUSED", reason, dest_jobid);
	free(s_destination);

	return(i);
}


/*!
 * \fn int edg_wll_LogTransferFAIL(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid); 
 * \brief simple wrapper around edg_wll_LogEvent for event Transfer, result FAIL
 * \param context	context to work with,
 * \param destination	destination where the job is being transfered to
 * \param dest_host	destination hostname
 * \param dest_instance	destination instance
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \param dest_jobid	destination internal jobid
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogTransferFAIL(edg_wll_Context context, const edg_wll_Source destination, const char * dest_host, const char * dest_instance, const char * job, const char * reason, const char * dest_jobid)
{
	int i;
	char *s_destination = edg_wll_SourceToString(destination);

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_TRANSFER,EDG_WLL_FORMAT_TRANSFER, s_destination, dest_host, dest_instance, job, "FAIL", reason, dest_jobid);
	free(s_destination);

	return(i);
}


/*!
 * \fn int edg_wll_LogAccepted(edg_wll_Context context, const edg_wll_Source from, const char * from_host, const char * from_instance, const char * local_jobid); 
 * \brief simple wrapper around edg_wll_LogEvent for event Accepted
 * \param context	context to work with,
 * \param from	where was the job received from
 * \param from_host	sending component hostname
 * \param from_instance	sending component instance
 * \param local_jobid	new jobId (Condor, Globus ...) assigned by the receiving component
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogAccepted(edg_wll_Context context, const edg_wll_Source from, const char * from_host, const char * from_instance, const char * local_jobid)
{
	int i;
	char *s_from = edg_wll_SourceToString(from);

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_ACCEPTED,EDG_WLL_FORMAT_ACCEPTED, s_from, from_host, from_instance, local_jobid);
	free(s_from);

	return(i);   
}


/*!
 * \fn int edg_wll_LogRefused(edg_wll_Context context, const edg_wll_Source from, const char * from_host, const char * from_instance, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Refused
 * \param context	context to work with,
 * \param from	where was the job received from
 * \param from_host	sending component hostname
 * \param from_instance	sending component instance
 * \param reason	reason of refusal
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogRefused(edg_wll_Context context, const edg_wll_Source from, const char * from_host, const char * from_instance, const char * reason)
{
	int i;
	char *s_from = edg_wll_SourceToString(from);

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_REFUSED,EDG_WLL_FORMAT_REFUSED, s_from, from_host, from_instance, reason);
	free(s_from);

	return(i);   
}


/*!
 * \fn int edg_wll_LogEnQueued(edg_wll_Context context, const char * queue, const char * job, const char * result, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event EnQueued
 * \param context	context to work with,
 * \param queue	destination queue
 * \param job	job description in receiver language
 * \param result	result of the attempt
 * \param reason	detailed description of transfer, especially reason of failure
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogEnQueued(edg_wll_Context context, const char * queue, const char * job, const char * result, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_ENQUEUED,EDG_WLL_FORMAT_ENQUEUED, queue, job, result, reason);

	return(i);   
}


/*!
 * \fn int edg_wll_LogEnQueuedSTART(edg_wll_Context context, const char * queue, const char * job, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event EnQueued, result START
 * \param context	context to work with,
 * \param queue	destination queue
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogEnQueuedSTART(edg_wll_Context context, const char * queue, const char * job, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_ENQUEUED,EDG_WLL_FORMAT_ENQUEUED, queue, job, "START", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogEnQueuedOK(edg_wll_Context context, const char * queue, const char * job, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event EnQueued, result OK
 * \param context	context to work with,
 * \param queue	destination queue
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogEnQueuedOK(edg_wll_Context context, const char * queue, const char * job, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_ENQUEUED,EDG_WLL_FORMAT_ENQUEUED, queue, job, "OK", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogEnQueuedREFUSED(edg_wll_Context context, const char * queue, const char * job, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event EnQueued, result REFUSED
 * \param context	context to work with,
 * \param queue	destination queue
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogEnQueuedREFUSED(edg_wll_Context context, const char * queue, const char * job, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_ENQUEUED,EDG_WLL_FORMAT_ENQUEUED, queue, job, "REFUSED", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogEnQueuedFAIL(edg_wll_Context context, const char * queue, const char * job, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event EnQueued, result FAIL
 * \param context	context to work with,
 * \param queue	destination queue
 * \param job	job description in receiver language
 * \param reason	detailed description of transfer, especially reason of failure
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogEnQueuedFAIL(edg_wll_Context context, const char * queue, const char * job, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_ENQUEUED,EDG_WLL_FORMAT_ENQUEUED, queue, job, "FAIL", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogDeQueued(edg_wll_Context context, const char * queue, const char * local_jobid); 
 * \brief simple wrapper around edg_wll_LogEvent for event DeQueued
 * \param context	context to work with,
 * \param queue	queue name
 * \param local_jobid	new jobId assigned by the receiving component
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogDeQueued(edg_wll_Context context, const char * queue, const char * local_jobid)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_DEQUEUED,EDG_WLL_FORMAT_DEQUEUED, queue, local_jobid);

	return(i);   
}


/*!
 * \fn int edg_wll_LogHelperCall(edg_wll_Context context, const char * helper_name, const char * helper_params, const char * src_role); 
 * \brief simple wrapper around edg_wll_LogEvent for event HelperCall
 * \param context	context to work with,
 * \param helper_name	name of the called component
 * \param helper_params	parameters of the call
 * \param src_role	whether the logging component is called or calling one
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogHelperCall(edg_wll_Context context, const char * helper_name, const char * helper_params, const char * src_role)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_HELPERCALL,EDG_WLL_FORMAT_HELPERCALL, helper_name, helper_params, src_role);

	return(i);   
}


/*!
 * \fn int edg_wll_LogHelperCallCALLING(edg_wll_Context context, const char * helper_name, const char * helper_params); 
 * \brief simple wrapper around edg_wll_LogEvent for event HelperCall, src_role CALLING
 * \param context	context to work with,
 * \param helper_name	name of the called component
 * \param helper_params	parameters of the call
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogHelperCallCALLING(edg_wll_Context context, const char * helper_name, const char * helper_params)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_HELPERCALL,EDG_WLL_FORMAT_HELPERCALL, helper_name, helper_params, "CALLING");

	return(i);
}


/*!
 * \fn int edg_wll_LogHelperCallCALLED(edg_wll_Context context, const char * helper_name, const char * helper_params); 
 * \brief simple wrapper around edg_wll_LogEvent for event HelperCall, src_role CALLED
 * \param context	context to work with,
 * \param helper_name	name of the called component
 * \param helper_params	parameters of the call
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogHelperCallCALLED(edg_wll_Context context, const char * helper_name, const char * helper_params)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_HELPERCALL,EDG_WLL_FORMAT_HELPERCALL, helper_name, helper_params, "CALLED");

	return(i);
}


/*!
 * \fn int edg_wll_LogHelperReturn(edg_wll_Context context, const char * helper_name, const char * retval, const char * src_role); 
 * \brief simple wrapper around edg_wll_LogEvent for event HelperReturn
 * \param context	context to work with,
 * \param helper_name	name of the called component
 * \param retval	returned data
 * \param src_role	whether the logging component is called or calling one
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogHelperReturn(edg_wll_Context context, const char * helper_name, const char * retval, const char * src_role)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_HELPERRETURN,EDG_WLL_FORMAT_HELPERRETURN, helper_name, retval, src_role);

	return(i);   
}


/*!
 * \fn int edg_wll_LogHelperReturnCALLING(edg_wll_Context context, const char * helper_name, const char * retval); 
 * \brief simple wrapper around edg_wll_LogEvent for event HelperReturn, src_role CALLING
 * \param context	context to work with,
 * \param helper_name	name of the called component
 * \param retval	returned data
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogHelperReturnCALLING(edg_wll_Context context, const char * helper_name, const char * retval)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_HELPERRETURN,EDG_WLL_FORMAT_HELPERRETURN, helper_name, retval, "CALLING");

	return(i);
}


/*!
 * \fn int edg_wll_LogHelperReturnCALLED(edg_wll_Context context, const char * helper_name, const char * retval); 
 * \brief simple wrapper around edg_wll_LogEvent for event HelperReturn, src_role CALLED
 * \param context	context to work with,
 * \param helper_name	name of the called component
 * \param retval	returned data
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogHelperReturnCALLED(edg_wll_Context context, const char * helper_name, const char * retval)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_HELPERRETURN,EDG_WLL_FORMAT_HELPERRETURN, helper_name, retval, "CALLED");

	return(i);
}


/*!
 * \fn int edg_wll_LogRunning(edg_wll_Context context, const char * node); 
 * \brief simple wrapper around edg_wll_LogEvent for event Running
 * \param context	context to work with,
 * \param node	worker node where the executable is run
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogRunning(edg_wll_Context context, const char * node)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_RUNNING,EDG_WLL_FORMAT_RUNNING, node);

	return(i);   
}


/*!
 * \fn int edg_wll_LogResubmission(edg_wll_Context context, const char * result, const char * reason, const char * tag); 
 * \brief simple wrapper around edg_wll_LogEvent for event Resubmission
 * \param context	context to work with,
 * \param result	result code
 * \param reason	reason for the decision
 * \param tag	value of the attribute on which the decision is based
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogResubmission(edg_wll_Context context, const char * result, const char * reason, const char * tag)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_RESUBMISSION,EDG_WLL_FORMAT_RESUBMISSION, result, reason, tag);

	return(i);   
}


/*!
 * \fn int edg_wll_LogResubmissionWILLRESUB(edg_wll_Context context, const char * reason, const char * tag); 
 * \brief simple wrapper around edg_wll_LogEvent for event Resubmission, result WILLRESUB
 * \param context	context to work with,
 * \param reason	reason for the decision
 * \param tag	value of the attribute on which the decision is based
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogResubmissionWILLRESUB(edg_wll_Context context, const char * reason, const char * tag)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_RESUBMISSION,EDG_WLL_FORMAT_RESUBMISSION, "WILLRESUB", reason, tag);

	return(i);
}


/*!
 * \fn int edg_wll_LogResubmissionWONTRESUB(edg_wll_Context context, const char * reason, const char * tag); 
 * \brief simple wrapper around edg_wll_LogEvent for event Resubmission, result WONTRESUB
 * \param context	context to work with,
 * \param reason	reason for the decision
 * \param tag	value of the attribute on which the decision is based
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogResubmissionWONTRESUB(edg_wll_Context context, const char * reason, const char * tag)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_RESUBMISSION,EDG_WLL_FORMAT_RESUBMISSION, "WONTRESUB", reason, tag);

	return(i);
}


/*!
 * \fn int edg_wll_LogDone(edg_wll_Context context, const char * status_code, const char * reason, const int exit_code); 
 * \brief simple wrapper around edg_wll_LogEvent for event Done
 * \param context	context to work with,
 * \param status_code	way of termination
 * \param reason	reason for the change
 * \param exit_code	process exit code
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogDone(edg_wll_Context context, const char * status_code, const char * reason, const int exit_code)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_DONE,EDG_WLL_FORMAT_DONE, status_code, reason, exit_code);

	return(i);   
}


/*!
 * \fn int edg_wll_LogDoneOK(edg_wll_Context context, const char * reason, const int exit_code); 
 * \brief simple wrapper around edg_wll_LogEvent for event Done, status_code OK
 * \param context	context to work with,
 * \param reason	reason for the change
 * \param exit_code	process exit code
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogDoneOK(edg_wll_Context context, const char * reason, const int exit_code)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_DONE,EDG_WLL_FORMAT_DONE, "OK", reason, exit_code);

	return(i);
}


/*!
 * \fn int edg_wll_LogDoneFAILED(edg_wll_Context context, const char * reason, const int exit_code); 
 * \brief simple wrapper around edg_wll_LogEvent for event Done, status_code FAILED
 * \param context	context to work with,
 * \param reason	reason for the change
 * \param exit_code	process exit code
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogDoneFAILED(edg_wll_Context context, const char * reason, const int exit_code)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_DONE,EDG_WLL_FORMAT_DONE, "FAILED", reason, exit_code);

	return(i);
}


/*!
 * \fn int edg_wll_LogDoneCANCELLED(edg_wll_Context context, const char * reason, const int exit_code); 
 * \brief simple wrapper around edg_wll_LogEvent for event Done, status_code CANCELLED
 * \param context	context to work with,
 * \param reason	reason for the change
 * \param exit_code	process exit code
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogDoneCANCELLED(edg_wll_Context context, const char * reason, const int exit_code)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_DONE,EDG_WLL_FORMAT_DONE, "CANCELLED", reason, exit_code);

	return(i);
}


/*!
 * \fn int edg_wll_LogCancel(edg_wll_Context context, const char * status_code, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Cancel
 * \param context	context to work with,
 * \param status_code	classification of the cancel
 * \param reason	detailed description
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogCancel(edg_wll_Context context, const char * status_code, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CANCEL,EDG_WLL_FORMAT_CANCEL, status_code, reason);

	return(i);   
}


/*!
 * \fn int edg_wll_LogCancelREQ(edg_wll_Context context, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Cancel, status_code REQ
 * \param context	context to work with,
 * \param reason	detailed description
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogCancelREQ(edg_wll_Context context, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CANCEL,EDG_WLL_FORMAT_CANCEL, "REQ", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogCancelREFUSE(edg_wll_Context context, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Cancel, status_code REFUSE
 * \param context	context to work with,
 * \param reason	detailed description
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogCancelREFUSE(edg_wll_Context context, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CANCEL,EDG_WLL_FORMAT_CANCEL, "REFUSE", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogCancelDONE(edg_wll_Context context, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Cancel, status_code DONE
 * \param context	context to work with,
 * \param reason	detailed description
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogCancelDONE(edg_wll_Context context, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CANCEL,EDG_WLL_FORMAT_CANCEL, "DONE", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogCancelABORT(edg_wll_Context context, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Cancel, status_code ABORT
 * \param context	context to work with,
 * \param reason	detailed description
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogCancelABORT(edg_wll_Context context, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CANCEL,EDG_WLL_FORMAT_CANCEL, "ABORT", reason);

	return(i);
}


/*!
 * \fn int edg_wll_LogAbort(edg_wll_Context context, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Abort
 * \param context	context to work with,
 * \param reason	reason of abort
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogAbort(edg_wll_Context context, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_ABORT,EDG_WLL_FORMAT_ABORT, reason);

	return(i);   
}


/*!
 * \fn int edg_wll_LogClear(edg_wll_Context context, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Clear
 * \param context	context to work with,
 * \param reason	why the job was cleared
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogClear(edg_wll_Context context, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CLEAR,EDG_WLL_FORMAT_CLEAR, reason);

	return(i);   
}


/*!
 * \fn int edg_wll_LogClearUSER(edg_wll_Context context); 
 * \brief simple wrapper around edg_wll_LogEvent for event Clear, reason USER
 * \param context	context to work with,
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogClearUSER(edg_wll_Context context)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CLEAR,EDG_WLL_FORMAT_CLEAR, "USER");

	return(i);
}


/*!
 * \fn int edg_wll_LogClearTIMEOUT(edg_wll_Context context); 
 * \brief simple wrapper around edg_wll_LogEvent for event Clear, reason TIMEOUT
 * \param context	context to work with,
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogClearTIMEOUT(edg_wll_Context context)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CLEAR,EDG_WLL_FORMAT_CLEAR, "TIMEOUT");

	return(i);
}


/*!
 * \fn int edg_wll_LogClearNOOUTPUT(edg_wll_Context context); 
 * \brief simple wrapper around edg_wll_LogEvent for event Clear, reason NOOUTPUT
 * \param context	context to work with,
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogClearNOOUTPUT(edg_wll_Context context)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CLEAR,EDG_WLL_FORMAT_CLEAR, "NOOUTPUT");

	return(i);
}


/*!
 * \fn int edg_wll_LogPurge(edg_wll_Context context); 
 * \brief simple wrapper around edg_wll_LogEvent for event Purge
 * \param context	context to work with,
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogPurge(edg_wll_Context context)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_PURGE,EDG_WLL_FORMAT_PURGE);

	return(i);   
}


/*!
 * \fn int edg_wll_LogMatch(edg_wll_Context context, const char * dest_id); 
 * \brief simple wrapper around edg_wll_LogEvent for event Match
 * \param context	context to work with,
 * \param dest_id	Id of the destination CE/queue
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogMatch(edg_wll_Context context, const char * dest_id)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_MATCH,EDG_WLL_FORMAT_MATCH, dest_id);

	return(i);   
}


/*!
 * \fn int edg_wll_LogPending(edg_wll_Context context, const char * reason); 
 * \brief simple wrapper around edg_wll_LogEvent for event Pending
 * \param context	context to work with,
 * \param reason	why matching CE cannot be found
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogPending(edg_wll_Context context, const char * reason)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_PENDING,EDG_WLL_FORMAT_PENDING, reason);

	return(i);   
}


/*!
 * \fn int edg_wll_LogRegJob(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const char * jobtype, const int nsubjobs, const char * seed); 
 * \brief simple wrapper around edg_wll_LogEvent for event RegJob
 * \param context	context to work with,
 * \param jdl	job description
 * \param ns	NetworkServer handling the job
 * \param parent	jobid of parent job
 * \param jobtype	job type
 * \param nsubjobs	number of subjobs
 * \param seed	seed for subjob id generation
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogRegJob(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const char * jobtype, const int nsubjobs, const char * seed)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_REGJOB,EDG_WLL_FORMAT_REGJOB, jdl, ns, parent, jobtype, nsubjobs, seed);

	return(i);   
}


/*!
 * \fn int edg_wll_LogRegJobSIMPLE(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed); 
 * \brief simple wrapper around edg_wll_LogEvent for event RegJob, jobtype SIMPLE
 * \param context	context to work with,
 * \param jdl	job description
 * \param ns	NetworkServer handling the job
 * \param parent	jobid of parent job
 * \param nsubjobs	number of subjobs
 * \param seed	seed for subjob id generation
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogRegJobSIMPLE(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_REGJOB,EDG_WLL_FORMAT_REGJOB, jdl, ns, parent, "SIMPLE", nsubjobs, seed);

	return(i);
}


/*!
 * \fn int edg_wll_LogRegJobDAG(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed); 
 * \brief simple wrapper around edg_wll_LogEvent for event RegJob, jobtype DAG
 * \param context	context to work with,
 * \param jdl	job description
 * \param ns	NetworkServer handling the job
 * \param parent	jobid of parent job
 * \param nsubjobs	number of subjobs
 * \param seed	seed for subjob id generation
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogRegJobDAG(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_REGJOB,EDG_WLL_FORMAT_REGJOB, jdl, ns, parent, "DAG", nsubjobs, seed);

	return(i);
}


/*!
 * \fn int edg_wll_LogRegJobPARTITIONABLE(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed); 
 * \brief simple wrapper around edg_wll_LogEvent for event RegJob, jobtype PARTITIONABLE
 * \param context	context to work with,
 * \param jdl	job description
 * \param ns	NetworkServer handling the job
 * \param parent	jobid of parent job
 * \param nsubjobs	number of subjobs
 * \param seed	seed for subjob id generation
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogRegJobPARTITIONABLE(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_REGJOB,EDG_WLL_FORMAT_REGJOB, jdl, ns, parent, "PARTITIONABLE", nsubjobs, seed);

	return(i);
}


/*!
 * \fn int edg_wll_LogRegJobPARTITIONED(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed); 
 * \brief simple wrapper around edg_wll_LogEvent for event RegJob, jobtype PARTITIONED
 * \param context	context to work with,
 * \param jdl	job description
 * \param ns	NetworkServer handling the job
 * \param parent	jobid of parent job
 * \param nsubjobs	number of subjobs
 * \param seed	seed for subjob id generation
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogRegJobPARTITIONED(edg_wll_Context context, const char * jdl, const char * ns, const edg_wlc_JobId parent, const int nsubjobs, const char * seed)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_REGJOB,EDG_WLL_FORMAT_REGJOB, jdl, ns, parent, "PARTITIONED", nsubjobs, seed);

	return(i);
}


/*!
 * \fn int edg_wll_LogChkpt(edg_wll_Context context, const char * tag, const char * classad); 
 * \brief simple wrapper around edg_wll_LogEvent for event Chkpt
 * \param context	context to work with,
 * \param tag	checkpoint tag
 * \param classad	checkpoint value
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogChkpt(edg_wll_Context context, const char * tag, const char * classad)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CHKPT,EDG_WLL_FORMAT_CHKPT, tag, classad);

	return(i);   
}


/*!
 * \fn int edg_wll_LogListener(edg_wll_Context context, const char * svc_name, const char * svc_host, const uint16_t svc_port); 
 * \brief simple wrapper around edg_wll_LogEvent for event Listener
 * \param context	context to work with,
 * \param svc_name	port instance name
 * \param svc_host	hostname
 * \param svc_port	port number
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogListener(edg_wll_Context context, const char * svc_name, const char * svc_host, const uint16_t svc_port)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_LISTENER,EDG_WLL_FORMAT_LISTENER, svc_name, svc_host, svc_port);

	return(i);   
}


/*!
 * \fn int edg_wll_LogCurDescr(edg_wll_Context context, const char * descr); 
 * \brief simple wrapper around edg_wll_LogEvent for event CurDescr
 * \param context	context to work with,
 * \param descr	description of current job transformation (output of helper)
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogCurDescr(edg_wll_Context context, const char * descr)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CURDESCR,EDG_WLL_FORMAT_CURDESCR, descr);

	return(i);   
}


/*!
 * \fn int edg_wll_LogUserTag(edg_wll_Context context, const char * name, const char * value); 
 * \brief simple wrapper around edg_wll_LogEvent for event UserTag
 * \param context	context to work with,
 * \param name	tag name
 * \param value	tag value
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogUserTag(edg_wll_Context context, const char * name, const char * value)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_USERTAG,EDG_WLL_FORMAT_USERTAG, name, value);

	return(i);   
}


/*!
 * \fn int edg_wll_LogChangeACL(edg_wll_Context context, const char * user_id, const int user_id_type, const int permission, const int permission_type, const int operation); 
 * \brief simple wrapper around edg_wll_LogEvent for event ChangeACL
 * \param context	context to work with,
 * \param user_id	DN or VOMS parameter (in format VO:group)
 * \param user_id_type	type of information given in user_id (DN or VOMS)
 * \param permission	ACL permission to change (currently only READ)
 * \param permission_type	type of permission requested ('allow', 'deny')
 * \param operation	operation requested to perform with ACL (add, remove)
 * \see edg_wll_LogEvent()
 */

int edg_wll_LogChangeACL(edg_wll_Context context, const char * user_id, const int user_id_type, const int permission, const int permission_type, const int operation)
{
	int i;

	i = edg_wll_LogEvent(context,EDG_WLL_EVENT_CHANGEACL,EDG_WLL_FORMAT_CHANGEACL, user_id, user_id_type, permission, permission_type, operation);

	return(i);   
}

