#ident "$Header: /local/reps/lcgware/workload/logging/common/events_parse.c.T,v 1.37 2003/10/14 12:41:34 michal Exp $"
/*

  !! Automatically generated file
  !! Do not edit, your changes will be discarded upon build
  !! Change the corresponding template file events_parse.c.T

*/

#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>

#include "edg/workload/logging/client/events.h"
#include "edg/workload/logging/client/producer.h"
#include "edg/workload/logging/common/events_parse.h"
#include "edg/workload/logging/common/ulm_parse.h"
#include "edg/workload/logging/common/context.h"
#include "edg/workload/logging/common/escape.h"
#include "edg/workload/common/jobid/jobid.h"

#include "edg/workload/thirdparty/trio/trio.h"

static const struct timeval null_timeval = {0,0};

/* -- Internal function prototype -- */
char *my_edg_wll_ULMGetValueAt( p_edg_wll_ULMFields, int );

/*!
 * edg_wll_ParseEvent - parse ULM message to internal structures
 * Calls: calloc, free, sprintf, strdup
 *        edg_wll_ULMNewParseTable, edg_wll_ULMFreeParseTable, edg_wll_ULMProcessParseTable,
 *        edg_wll_ULMGetNameAt, my_edg_wll_ULMGetValueAt, edg_wll_ULMDateToTimeval (edg_wll_ULMDateToDouble),
 *        edg_wll_StringToEvent, edg_wll_StringToKeyName, edg_wll_StringToLevel, edg_wlc_jobid_tParse,
 *        edg_wll_EventToString, edg_wll_KeyNameToString, edg_wll_SetError (or edg_wll_ResetError)
 * Algorithm: break ULM string into fields and then according the event type
 *            fill in the proper structures
 */

/* XXX: temporarily disable DUPLICITY if not working properly */
#define DUPLICITY { \
	char *k =  edg_wll_KeyNameToString(keycode); \
	sprintf(err_desc,"Key %s already exists.", k); \
	free(k); \
	ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_KEY_DUPLICITY,err_desc); \
	goto end; }
/* #define DUPLICITY	{} */

#define MISUSE { \
	char *e = edg_wll_EventToString(eventcode); \
	char *k =  edg_wll_KeyNameToString(keycode); \
	sprintf(err_desc,"Key %s schouldn't be used for event type %s.", k,e); \
	free(e); \
	free(k); \
	ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_KEY_MISUSE,err_desc); \
	goto end; }

edg_wll_ErrorCode edg_wll_ParseEvent(
        edg_wll_Context context,   /* context IN */
        edg_wll_LogLine logline,     /* logline IN: ULM string to parse */
        edg_wll_Event **event      /* event OUT: parsed event 
                           (may be NULL - syntax checking with no output */
)
{
int i;
int extra=0; 			/* number of extra unknown key=value pairs */
char err_desc[128]; 		/* error description for use in edg_wll_SetError */
char *value=NULL;
p_edg_wll_ULMFields table = edg_wll_ULMNewParseTable(logline);
edg_wll_KeyNameCode keycode=UNDEFINED;
edg_wll_EventCode eventcode=EDG_WLL_EVENT_UNDEF;
edg_wll_ErrorCode ret;
edg_wll_Event *this=NULL;

/* break ULM string into fields */
if ( edg_wll_ULMProcessParseTable(table) != 0 ) { 
	ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_BROKEN_ULM,"ULM parse error"); 
	goto end; 
}

/* determine the event type */
for (i=0; i<table->num; i++) {
   keycode=edg_wll_StringToKeyName(edg_wll_ULMGetNameAt(table,i));
   if ( keycode == EDG_WLL_EVNT ) { 
	value=my_edg_wll_ULMGetValueAt(table,i); 
	eventcode=edg_wll_StringToEvent(value); 
	free(value);
	value=NULL;
	break; 
   }
}
if ( eventcode == EDG_WLL_EVENT_UNDEF ) {
	ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_EVENT_UNDEF,"Unknown or missing event type"); 
	goto end; 
}
/* allocate memory for 'this' (edg_wll_Event) */
// XXX:  this = (edg_wll_Event *) calloc(1,sizeof(edg_wll_Event)); 
this = edg_wll_InitEvent(eventcode);
this->any.type = eventcode;

/* go through all fields and fill in the edg_wll_Event union
 * in each step check for key duplicity and key name misuse 
 */
for (i=0; i<table->num; i++) {
   keycode=edg_wll_StringToKeyName(edg_wll_ULMGetNameAt(table,i));
   value=my_edg_wll_ULMGetValueAt(table,i); 
   switch (keycode) {
   case EDG_WLL_EVNT : 
	if (this->any.type != edg_wll_StringToEvent(value)) DUPLICITY
      break;
   case ULM_DATE :
	if (!((this->any.timestamp).tv_sec == (null_timeval).tv_sec && (this->any.timestamp).tv_usec == (null_timeval).tv_usec)) DUPLICITY 
	edg_wll_ULMDateToTimeval(value,&this->any.timestamp);
      break;
   case ULM_HOST :
	if (!(((this->any.host) == NULL && (NULL) == NULL) || ((this->any.host)&&(NULL)&& !strcmp(this->any.host,NULL)))) DUPLICITY 
	this->any.host = strdup(value);
      break;
   case ULM_LVL :
	if (!((this->any.level == 0))) DUPLICITY 
	this->any.level = edg_wll_StringToLevel(value);
      break;
   case EDG_WLL_COMMON_PRIORITY :
	if (!((this->any.priority == -1))) DUPLICITY 
	this->any.priority = atoi(value);
      break;
   case EDG_WLL_COMMON_JOBID :
	if (!((this->any.jobId) == (NULL))) DUPLICITY 
	edg_wlc_JobIdParse(value,&this->any.jobId);
      break;
   case EDG_WLL_COMMON_SEQCODE :
	if (!(((this->any.seqcode) == NULL && (NULL) == NULL) || ((this->any.seqcode)&&(NULL)&& !strcmp(this->any.seqcode,NULL)))) DUPLICITY 
	this->any.seqcode = strdup(value);
      break;
   case EDG_WLL_COMMON_USER :
	if (!(((this->any.user) == NULL && (NULL) == NULL) || ((this->any.user)&&(NULL)&& !strcmp(this->any.user,NULL)))) DUPLICITY 
	this->any.user = strdup(value);
      break;
   case EDG_WLL_COMMON_SOURCE :
	if (!((this->any.source) == (EDG_WLL_SOURCE_NONE))) DUPLICITY 
	this->any.source = edg_wll_StringToSource(value);
      break;
   case EDG_WLL_COMMON_SRC_INSTANCE :
	if (!(((this->any.src_instance) == NULL && (NULL) == NULL) || ((this->any.src_instance)&&(NULL)&& !strcmp(this->any.src_instance,NULL)))) DUPLICITY 
	this->any.src_instance = strdup(value);
      break;
   case EDG_WLL_TRANSFER_DESTINATION :
	if (!((this->transfer.destination) == (EDG_WLL_SOURCE_NONE))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_TRANSFER ) MISUSE
	this->transfer.destination = edg_wll_StringToSource(value);
      break;
   case EDG_WLL_TRANSFER_DEST_HOST :
	if (!(((this->transfer.dest_host) == NULL && (NULL) == NULL) || ((this->transfer.dest_host)&&(NULL)&& !strcmp(this->transfer.dest_host,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_TRANSFER ) MISUSE
	this->transfer.dest_host = strdup(value);
      break;
   case EDG_WLL_TRANSFER_DEST_INSTANCE :
	if (!(((this->transfer.dest_instance) == NULL && (NULL) == NULL) || ((this->transfer.dest_instance)&&(NULL)&& !strcmp(this->transfer.dest_instance,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_TRANSFER ) MISUSE
	this->transfer.dest_instance = strdup(value);
      break;
   case EDG_WLL_TRANSFER_JOB :
	if (!(((this->transfer.job) == NULL && (NULL) == NULL) || ((this->transfer.job)&&(NULL)&& !strcmp(this->transfer.job,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_TRANSFER ) MISUSE
	this->transfer.job = strdup(value);
      break;
   case EDG_WLL_TRANSFER_RESULT :
	if (!((this->transfer.result == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_TRANSFER ) MISUSE
	this->transfer.result = edg_wll_StringToTransferResult(value);
      break;
   case EDG_WLL_TRANSFER_REASON :
	if (!(((this->transfer.reason) == NULL && (NULL) == NULL) || ((this->transfer.reason)&&(NULL)&& !strcmp(this->transfer.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_TRANSFER ) MISUSE
	this->transfer.reason = strdup(value);
      break;
   case EDG_WLL_TRANSFER_DEST_JOBID :
	if (!(((this->transfer.dest_jobid) == NULL && (NULL) == NULL) || ((this->transfer.dest_jobid)&&(NULL)&& !strcmp(this->transfer.dest_jobid,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_TRANSFER ) MISUSE
	this->transfer.dest_jobid = strdup(value);
      break;
   case EDG_WLL_ACCEPTED_FROM :
	if (!((this->accepted.from) == (EDG_WLL_SOURCE_NONE))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ACCEPTED ) MISUSE
	this->accepted.from = edg_wll_StringToSource(value);
      break;
   case EDG_WLL_ACCEPTED_FROM_HOST :
	if (!(((this->accepted.from_host) == NULL && (NULL) == NULL) || ((this->accepted.from_host)&&(NULL)&& !strcmp(this->accepted.from_host,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ACCEPTED ) MISUSE
	this->accepted.from_host = strdup(value);
      break;
   case EDG_WLL_ACCEPTED_FROM_INSTANCE :
	if (!(((this->accepted.from_instance) == NULL && (NULL) == NULL) || ((this->accepted.from_instance)&&(NULL)&& !strcmp(this->accepted.from_instance,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ACCEPTED ) MISUSE
	this->accepted.from_instance = strdup(value);
      break;
   case EDG_WLL_ACCEPTED_LOCAL_JOBID :
	if (!(((this->accepted.local_jobid) == NULL && (NULL) == NULL) || ((this->accepted.local_jobid)&&(NULL)&& !strcmp(this->accepted.local_jobid,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ACCEPTED ) MISUSE
	this->accepted.local_jobid = strdup(value);
      break;
   case EDG_WLL_REFUSED_FROM :
	if (!((this->refused.from) == (EDG_WLL_SOURCE_NONE))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REFUSED ) MISUSE
	this->refused.from = edg_wll_StringToSource(value);
      break;
   case EDG_WLL_REFUSED_FROM_HOST :
	if (!(((this->refused.from_host) == NULL && (NULL) == NULL) || ((this->refused.from_host)&&(NULL)&& !strcmp(this->refused.from_host,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REFUSED ) MISUSE
	this->refused.from_host = strdup(value);
      break;
   case EDG_WLL_REFUSED_FROM_INSTANCE :
	if (!(((this->refused.from_instance) == NULL && (NULL) == NULL) || ((this->refused.from_instance)&&(NULL)&& !strcmp(this->refused.from_instance,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REFUSED ) MISUSE
	this->refused.from_instance = strdup(value);
      break;
   case EDG_WLL_REFUSED_REASON :
	if (!(((this->refused.reason) == NULL && (NULL) == NULL) || ((this->refused.reason)&&(NULL)&& !strcmp(this->refused.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REFUSED ) MISUSE
	this->refused.reason = strdup(value);
      break;
   case EDG_WLL_ENQUEUED_QUEUE :
	if (!(((this->enQueued.queue) == NULL && (NULL) == NULL) || ((this->enQueued.queue)&&(NULL)&& !strcmp(this->enQueued.queue,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ENQUEUED ) MISUSE
	this->enQueued.queue = strdup(value);
      break;
   case EDG_WLL_ENQUEUED_JOB :
	if (!(((this->enQueued.job) == NULL && (NULL) == NULL) || ((this->enQueued.job)&&(NULL)&& !strcmp(this->enQueued.job,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ENQUEUED ) MISUSE
	this->enQueued.job = strdup(value);
      break;
   case EDG_WLL_ENQUEUED_RESULT :
	if (!((this->enQueued.result == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ENQUEUED ) MISUSE
	this->enQueued.result = edg_wll_StringToEnQueuedResult(value);
      break;
   case EDG_WLL_ENQUEUED_REASON :
	if (!(((this->enQueued.reason) == NULL && (NULL) == NULL) || ((this->enQueued.reason)&&(NULL)&& !strcmp(this->enQueued.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ENQUEUED ) MISUSE
	this->enQueued.reason = strdup(value);
      break;
   case EDG_WLL_DEQUEUED_QUEUE :
	if (!(((this->deQueued.queue) == NULL && (NULL) == NULL) || ((this->deQueued.queue)&&(NULL)&& !strcmp(this->deQueued.queue,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_DEQUEUED ) MISUSE
	this->deQueued.queue = strdup(value);
      break;
   case EDG_WLL_DEQUEUED_LOCAL_JOBID :
	if (!(((this->deQueued.local_jobid) == NULL && (NULL) == NULL) || ((this->deQueued.local_jobid)&&(NULL)&& !strcmp(this->deQueued.local_jobid,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_DEQUEUED ) MISUSE
	this->deQueued.local_jobid = strdup(value);
      break;
   case EDG_WLL_HELPERCALL_HELPER_NAME :
	if (!(((this->helperCall.helper_name) == NULL && (NULL) == NULL) || ((this->helperCall.helper_name)&&(NULL)&& !strcmp(this->helperCall.helper_name,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_HELPERCALL ) MISUSE
	this->helperCall.helper_name = strdup(value);
      break;
   case EDG_WLL_HELPERCALL_HELPER_PARAMS :
	if (!(((this->helperCall.helper_params) == NULL && (NULL) == NULL) || ((this->helperCall.helper_params)&&(NULL)&& !strcmp(this->helperCall.helper_params,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_HELPERCALL ) MISUSE
	this->helperCall.helper_params = strdup(value);
      break;
   case EDG_WLL_HELPERCALL_SRC_ROLE :
	if (!((this->helperCall.src_role == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_HELPERCALL ) MISUSE
	this->helperCall.src_role = edg_wll_StringToHelperCallSrc_role(value);
      break;
   case EDG_WLL_HELPERRETURN_HELPER_NAME :
	if (!(((this->helperReturn.helper_name) == NULL && (NULL) == NULL) || ((this->helperReturn.helper_name)&&(NULL)&& !strcmp(this->helperReturn.helper_name,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_HELPERRETURN ) MISUSE
	this->helperReturn.helper_name = strdup(value);
      break;
   case EDG_WLL_HELPERRETURN_RETVAL :
	if (!(((this->helperReturn.retval) == NULL && (NULL) == NULL) || ((this->helperReturn.retval)&&(NULL)&& !strcmp(this->helperReturn.retval,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_HELPERRETURN ) MISUSE
	this->helperReturn.retval = strdup(value);
      break;
   case EDG_WLL_HELPERRETURN_SRC_ROLE :
	if (!((this->helperReturn.src_role == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_HELPERRETURN ) MISUSE
	this->helperReturn.src_role = edg_wll_StringToHelperReturnSrc_role(value);
      break;
   case EDG_WLL_RUNNING_NODE :
	if (!(((this->running.node) == NULL && (NULL) == NULL) || ((this->running.node)&&(NULL)&& !strcmp(this->running.node,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_RUNNING ) MISUSE
	this->running.node = strdup(value);
      break;
   case EDG_WLL_RESUBMISSION_RESULT :
	if (!((this->resubmission.result == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_RESUBMISSION ) MISUSE
	this->resubmission.result = edg_wll_StringToResubmissionResult(value);
      break;
   case EDG_WLL_RESUBMISSION_REASON :
	if (!(((this->resubmission.reason) == NULL && (NULL) == NULL) || ((this->resubmission.reason)&&(NULL)&& !strcmp(this->resubmission.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_RESUBMISSION ) MISUSE
	this->resubmission.reason = strdup(value);
      break;
   case EDG_WLL_RESUBMISSION_TAG :
	if (!(((this->resubmission.tag) == NULL && (NULL) == NULL) || ((this->resubmission.tag)&&(NULL)&& !strcmp(this->resubmission.tag,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_RESUBMISSION ) MISUSE
	this->resubmission.tag = strdup(value);
      break;
   case EDG_WLL_DONE_STATUS_CODE :
	if (!((this->done.status_code == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_DONE ) MISUSE
	this->done.status_code = edg_wll_StringToDoneStatus_code(value);
      break;
   case EDG_WLL_DONE_REASON :
	if (!(((this->done.reason) == NULL && (NULL) == NULL) || ((this->done.reason)&&(NULL)&& !strcmp(this->done.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_DONE ) MISUSE
	this->done.reason = strdup(value);
      break;
   case EDG_WLL_DONE_EXIT_CODE :
	if (!((this->done.exit_code == -1))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_DONE ) MISUSE
	this->done.exit_code = atoi(value);
      break;
   case EDG_WLL_CANCEL_STATUS_CODE :
	if (!((this->cancel.status_code == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CANCEL ) MISUSE
	this->cancel.status_code = edg_wll_StringToCancelStatus_code(value);
      break;
   case EDG_WLL_CANCEL_REASON :
	if (!(((this->cancel.reason) == NULL && (NULL) == NULL) || ((this->cancel.reason)&&(NULL)&& !strcmp(this->cancel.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CANCEL ) MISUSE
	this->cancel.reason = strdup(value);
      break;
   case EDG_WLL_ABORT_REASON :
	if (!(((this->abort.reason) == NULL && (NULL) == NULL) || ((this->abort.reason)&&(NULL)&& !strcmp(this->abort.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_ABORT ) MISUSE
	this->abort.reason = strdup(value);
      break;
   case EDG_WLL_CLEAR_REASON :
	if (!((this->clear.reason == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CLEAR ) MISUSE
	this->clear.reason = edg_wll_StringToClearReason(value);
      break;
   case EDG_WLL_MATCH_DEST_ID :
	if (!(((this->match.dest_id) == NULL && (NULL) == NULL) || ((this->match.dest_id)&&(NULL)&& !strcmp(this->match.dest_id,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_MATCH ) MISUSE
	this->match.dest_id = strdup(value);
      break;
   case EDG_WLL_PENDING_REASON :
	if (!(((this->pending.reason) == NULL && (NULL) == NULL) || ((this->pending.reason)&&(NULL)&& !strcmp(this->pending.reason,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_PENDING ) MISUSE
	this->pending.reason = strdup(value);
      break;
   case EDG_WLL_REGJOB_JDL :
	if (!(((this->regJob.jdl) == NULL && (NULL) == NULL) || ((this->regJob.jdl)&&(NULL)&& !strcmp(this->regJob.jdl,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REGJOB ) MISUSE
	this->regJob.jdl = strdup(value);
      break;
   case EDG_WLL_REGJOB_NS :
	if (!(((this->regJob.ns) == NULL && (NULL) == NULL) || ((this->regJob.ns)&&(NULL)&& !strcmp(this->regJob.ns,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REGJOB ) MISUSE
	this->regJob.ns = strdup(value);
      break;
   case EDG_WLL_REGJOB_PARENT :
	if (!((this->regJob.parent) == (NULL))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REGJOB ) MISUSE
	edg_wlc_JobIdParse(value,&this->regJob.parent);
      break;
   case EDG_WLL_REGJOB_JOBTYPE :
	if (!((this->regJob.jobtype == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REGJOB ) MISUSE
	this->regJob.jobtype = edg_wll_StringToRegJobJobtype(value);
      break;
   case EDG_WLL_REGJOB_NSUBJOBS :
	if (!((this->regJob.nsubjobs == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REGJOB ) MISUSE
	this->regJob.nsubjobs = atoi(value);
      break;
   case EDG_WLL_REGJOB_SEED :
	if (!(((this->regJob.seed) == NULL && (NULL) == NULL) || ((this->regJob.seed)&&(NULL)&& !strcmp(this->regJob.seed,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_REGJOB ) MISUSE
	this->regJob.seed = strdup(value);
      break;
   case EDG_WLL_CHKPT_TAG :
	if (!(((this->chkpt.tag) == NULL && (NULL) == NULL) || ((this->chkpt.tag)&&(NULL)&& !strcmp(this->chkpt.tag,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CHKPT ) MISUSE
	this->chkpt.tag = strdup(value);
      break;
   case EDG_WLL_CHKPT_CLASSAD :
	if (!(((this->chkpt.classad) == NULL && (NULL) == NULL) || ((this->chkpt.classad)&&(NULL)&& !strcmp(this->chkpt.classad,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CHKPT ) MISUSE
	this->chkpt.classad = strdup(value);
      break;
   case EDG_WLL_LISTENER_SVC_NAME :
	if (!(((this->listener.svc_name) == NULL && (NULL) == NULL) || ((this->listener.svc_name)&&(NULL)&& !strcmp(this->listener.svc_name,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_LISTENER ) MISUSE
	this->listener.svc_name = strdup(value);
      break;
   case EDG_WLL_LISTENER_SVC_HOST :
	if (!(((this->listener.svc_host) == NULL && (NULL) == NULL) || ((this->listener.svc_host)&&(NULL)&& !strcmp(this->listener.svc_host,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_LISTENER ) MISUSE
	this->listener.svc_host = strdup(value);
      break;
   case EDG_WLL_LISTENER_SVC_PORT :
	if (!((this->listener.svc_port == 0))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_LISTENER ) MISUSE
	this->listener.svc_port = (uint16_t) atoi(value);
      break;
   case EDG_WLL_CURDESCR_DESCR :
	if (!(((this->curDescr.descr) == NULL && (NULL) == NULL) || ((this->curDescr.descr)&&(NULL)&& !strcmp(this->curDescr.descr,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CURDESCR ) MISUSE
	this->curDescr.descr = strdup(value);
      break;
   case EDG_WLL_USERTAG_NAME :
	if (!(((this->userTag.name) == NULL && (NULL) == NULL) || ((this->userTag.name)&&(NULL)&& !strcmp(this->userTag.name,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_USERTAG ) MISUSE
	this->userTag.name = strdup(value);
      break;
   case EDG_WLL_USERTAG_VALUE :
	if (!(((this->userTag.value) == NULL && (NULL) == NULL) || ((this->userTag.value)&&(NULL)&& !strcmp(this->userTag.value,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_USERTAG ) MISUSE
	this->userTag.value = strdup(value);
      break;
   case EDG_WLL_CHANGEACL_USER_ID :
	if (!(((this->changeACL.user_id) == NULL && (NULL) == NULL) || ((this->changeACL.user_id)&&(NULL)&& !strcmp(this->changeACL.user_id,NULL)))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CHANGEACL ) MISUSE
	this->changeACL.user_id = strdup(value);
      break;
   case EDG_WLL_CHANGEACL_USER_ID_TYPE :
	if (!((this->changeACL.user_id_type == -1))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CHANGEACL ) MISUSE
	this->changeACL.user_id_type = atoi(value);
      break;
   case EDG_WLL_CHANGEACL_PERMISSION :
	if (!((this->changeACL.permission == -1))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CHANGEACL ) MISUSE
	this->changeACL.permission = atoi(value);
      break;
   case EDG_WLL_CHANGEACL_PERMISSION_TYPE :
	if (!((this->changeACL.permission_type == -1))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CHANGEACL ) MISUSE
	this->changeACL.permission_type = atoi(value);
      break;
   case EDG_WLL_CHANGEACL_OPERATION :
	if (!((this->changeACL.operation == -1))) DUPLICITY
	if (eventcode != EDG_WLL_EVENT_CHANGEACL ) MISUSE
	this->changeACL.operation = atoi(value);
      break;

   case UNDEFINED :
      break;

   default : 
	extra++;
      break;
   }
   free(value);
   value=NULL;
}

/* now check if all required fields are present */
ret=edg_wll_CheckEvent(context,this);
if (ret) { goto end; }

/* parse is OK, only extra fields could occur */
if (extra) {
	sprintf(err_desc,"There are %d extra fields in the logline.",extra);
	ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_OK_WITH_EXTRA_FIELDS,err_desc); }
else {	ret=edg_wll_ResetError(context); }

end:
   /* finally (if wanted) "return" pointer to the filled edg_wll_Event union
      NOTE: a pointer (to half-filled structure) is returned even if an error occured ! */
   if (event != NULL) {
	*event = this; }
	/* This also means, that the memory must be freed by edg_wll_FreeEvent() somewhere else */
   else {
	edg_wll_FreeEvent(this);
	free(this);
   }

   edg_wll_ULMFreeParseTable(table);
   return ret;
}

#undef DUPLICITY
#undef MISUSE


/*!
 * edg_wll_UnparseEvent - unparse ULM message from internal structures
 * Calls: malloc, free, strlen, strcmp, asprintf, trio_asprintf
 *        edg_wll_ULMTimevalToDate,
 *        edg_wll_EventToString, edg_wll_KeyNameToString, edg_wll_LevelToString, 
 *        edg_wlc_jobid_tUnparse, 
 * Algorithm: format values from internal structures into a ULM string
 */
#define NOMEM { if (logline) free(logline); logline = NULL; edg_wll_SetError(context,ENOMEM,NULL); goto clean; }

edg_wll_LogLine edg_wll_UnparseEvent(       /* logline OUT */
          edg_wll_Context context,    /* context IN */
          edg_wll_Event *event        /* event IN */
)
{
edg_wll_LogLine logline;
edg_wll_EventCode eventcode=event->type;
char *date, *common, *user, *var, *e, *l, *j, *s;
edg_wll_Event	nonulls;

logline = date = common = user = var = NULL;
date=(char *) malloc(1+ULM_DATE_STRING_LENGTH*sizeof(char));

/* FIXME: after EDG_WLL_FORMAT_COMMON automatic generation automate this code as well */
/* format the common fields */
edg_wll_ULMTimevalToDate(event->any.timestamp.tv_sec, event->any.timestamp.tv_usec, date);

memcpy(&nonulls,event,sizeof nonulls);
if (!nonulls.any.host) nonulls.any.host = "";
if (!nonulls.any.seqcode) nonulls.any.seqcode = "";
if (!nonulls.any.user) nonulls.any.user = "";
if (!nonulls.any.src_instance) nonulls.any.src_instance = "";

e = edg_wll_EventToString(eventcode);
l = edg_wll_LevelToString(event->any.level);
j = edg_wlc_JobIdUnparse(event->any.jobId);
s = edg_wll_SourceToString(event->any.source);
if (trio_asprintf(&common,EDG_WLL_FORMAT_COMMON, \
	date, event->any.host, l, event->any.priority, s, nonulls.any.src_instance, \
	e, j, nonulls.any.seqcode) == -1) { free(e); NOMEM }
free(e);
free(l);
free(j);
free(s);

if (trio_asprintf(&user,EDG_WLL_FORMAT_USER, event->any.user) == -1) NOMEM

/* format the rest of the logline */
switch (eventcode) {
   case EDG_WLL_EVENT_TRANSFER :
	{	char *destination_str = edg_wll_SourceToString(event->transfer.destination);
	char *result_code = edg_wll_TransferResultToString(event->transfer.result);
		if (!nonulls.transfer.dest_host) nonulls.transfer.dest_host = "";
		if (!nonulls.transfer.dest_instance) nonulls.transfer.dest_instance = "";
		if (!nonulls.transfer.job) nonulls.transfer.job = "";
		if (!nonulls.transfer.reason) nonulls.transfer.reason = "";
		if (!nonulls.transfer.dest_jobid) nonulls.transfer.dest_jobid = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_TRANSFER,destination_str?destination_str:"",nonulls.transfer.dest_host,nonulls.transfer.dest_instance,nonulls.transfer.job,result_code,nonulls.transfer.reason,nonulls.transfer.dest_jobid) == -1 ) {
	   free(destination_str); free(result_code); NOMEM }
	free(destination_str); free(result_code); 
	}
      break;
   case EDG_WLL_EVENT_ACCEPTED :
	{	char *from_str = edg_wll_SourceToString(event->accepted.from);
		if (!nonulls.accepted.from_host) nonulls.accepted.from_host = "";
		if (!nonulls.accepted.from_instance) nonulls.accepted.from_instance = "";
		if (!nonulls.accepted.local_jobid) nonulls.accepted.local_jobid = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_ACCEPTED,from_str?from_str:"",nonulls.accepted.from_host,nonulls.accepted.from_instance,nonulls.accepted.local_jobid) == -1 ) {
	   free(from_str); NOMEM }
	free(from_str); 
	}
      break;
   case EDG_WLL_EVENT_REFUSED :
	{	char *from_str = edg_wll_SourceToString(event->refused.from);
		if (!nonulls.refused.from_host) nonulls.refused.from_host = "";
		if (!nonulls.refused.from_instance) nonulls.refused.from_instance = "";
		if (!nonulls.refused.reason) nonulls.refused.reason = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_REFUSED,from_str?from_str:"",nonulls.refused.from_host,nonulls.refused.from_instance,nonulls.refused.reason) == -1 ) {
	   free(from_str); NOMEM }
	free(from_str); 
	}
      break;
   case EDG_WLL_EVENT_ENQUEUED :
	{	char *result_code = edg_wll_EnQueuedResultToString(event->enQueued.result);
		if (!nonulls.enQueued.queue) nonulls.enQueued.queue = "";
		if (!nonulls.enQueued.job) nonulls.enQueued.job = "";
		if (!nonulls.enQueued.reason) nonulls.enQueued.reason = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_ENQUEUED,nonulls.enQueued.queue,nonulls.enQueued.job,result_code,nonulls.enQueued.reason) == -1 ) {
	   free(result_code); NOMEM }
	free(result_code); 
	}
      break;
   case EDG_WLL_EVENT_DEQUEUED :
	{		if (!nonulls.deQueued.queue) nonulls.deQueued.queue = "";
		if (!nonulls.deQueued.local_jobid) nonulls.deQueued.local_jobid = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_DEQUEUED,nonulls.deQueued.queue,nonulls.deQueued.local_jobid) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_HELPERCALL :
	{	char *src_role_code = edg_wll_HelperCallSrc_roleToString(event->helperCall.src_role);
		if (!nonulls.helperCall.helper_name) nonulls.helperCall.helper_name = "";
		if (!nonulls.helperCall.helper_params) nonulls.helperCall.helper_params = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_HELPERCALL,nonulls.helperCall.helper_name,nonulls.helperCall.helper_params,src_role_code) == -1 ) {
	   free(src_role_code); NOMEM }
	free(src_role_code); 
	}
      break;
   case EDG_WLL_EVENT_HELPERRETURN :
	{	char *src_role_code = edg_wll_HelperReturnSrc_roleToString(event->helperReturn.src_role);
		if (!nonulls.helperReturn.helper_name) nonulls.helperReturn.helper_name = "";
		if (!nonulls.helperReturn.retval) nonulls.helperReturn.retval = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_HELPERRETURN,nonulls.helperReturn.helper_name,nonulls.helperReturn.retval,src_role_code) == -1 ) {
	   free(src_role_code); NOMEM }
	free(src_role_code); 
	}
      break;
   case EDG_WLL_EVENT_RUNNING :
	{		if (!nonulls.running.node) nonulls.running.node = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_RUNNING,nonulls.running.node) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_RESUBMISSION :
	{	char *result_code = edg_wll_ResubmissionResultToString(event->resubmission.result);
		if (!nonulls.resubmission.reason) nonulls.resubmission.reason = "";
		if (!nonulls.resubmission.tag) nonulls.resubmission.tag = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_RESUBMISSION,result_code,nonulls.resubmission.reason,nonulls.resubmission.tag) == -1 ) {
	   free(result_code); NOMEM }
	free(result_code); 
	}
      break;
   case EDG_WLL_EVENT_DONE :
	{	char *status_code_code = edg_wll_DoneStatus_codeToString(event->done.status_code);
		if (!nonulls.done.reason) nonulls.done.reason = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_DONE,status_code_code,nonulls.done.reason,nonulls.done.exit_code) == -1 ) {
	   free(status_code_code); NOMEM }
	free(status_code_code); 
	}
      break;
   case EDG_WLL_EVENT_CANCEL :
	{	char *status_code_code = edg_wll_CancelStatus_codeToString(event->cancel.status_code);
		if (!nonulls.cancel.reason) nonulls.cancel.reason = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_CANCEL,status_code_code,nonulls.cancel.reason) == -1 ) {
	   free(status_code_code); NOMEM }
	free(status_code_code); 
	}
      break;
   case EDG_WLL_EVENT_ABORT :
	{		if (!nonulls.abort.reason) nonulls.abort.reason = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_ABORT,nonulls.abort.reason) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_CLEAR :
	{	char *reason_code = edg_wll_ClearReasonToString(event->clear.reason);
	if (trio_asprintf(&var,EDG_WLL_FORMAT_CLEAR,reason_code) == -1 ) {
	   free(reason_code); NOMEM }
	free(reason_code); 
	}
      break;
   case EDG_WLL_EVENT_PURGE :
	{	if (trio_asprintf(&var,EDG_WLL_FORMAT_PURGE) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_MATCH :
	{		if (!nonulls.match.dest_id) nonulls.match.dest_id = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_MATCH,nonulls.match.dest_id) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_PENDING :
	{		if (!nonulls.pending.reason) nonulls.pending.reason = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_PENDING,nonulls.pending.reason) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_REGJOB :
	{	char *parent_str = edg_wlc_JobIdUnparse(event->regJob.parent);
	char *jobtype_code = edg_wll_RegJobJobtypeToString(event->regJob.jobtype);
		if (!nonulls.regJob.jdl) nonulls.regJob.jdl = "";
		if (!nonulls.regJob.ns) nonulls.regJob.ns = "";
		if (!nonulls.regJob.seed) nonulls.regJob.seed = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_REGJOB,nonulls.regJob.jdl,nonulls.regJob.ns,parent_str?parent_str:"",jobtype_code,nonulls.regJob.nsubjobs,nonulls.regJob.seed) == -1 ) {
	   free(parent_str); free(jobtype_code); NOMEM }
	free(parent_str); free(jobtype_code); 
	}
      break;
   case EDG_WLL_EVENT_CHKPT :
	{		if (!nonulls.chkpt.tag) nonulls.chkpt.tag = "";
		if (!nonulls.chkpt.classad) nonulls.chkpt.classad = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_CHKPT,nonulls.chkpt.tag,nonulls.chkpt.classad) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_LISTENER :
	{		if (!nonulls.listener.svc_name) nonulls.listener.svc_name = "";
		if (!nonulls.listener.svc_host) nonulls.listener.svc_host = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_LISTENER,nonulls.listener.svc_name,nonulls.listener.svc_host,nonulls.listener.svc_port) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_CURDESCR :
	{		if (!nonulls.curDescr.descr) nonulls.curDescr.descr = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_CURDESCR,nonulls.curDescr.descr) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_USERTAG :
	{		if (!nonulls.userTag.name) nonulls.userTag.name = "";
		if (!nonulls.userTag.value) nonulls.userTag.value = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_USERTAG,nonulls.userTag.name,nonulls.userTag.value) == -1 ) {
	   NOMEM }
	}
      break;
   case EDG_WLL_EVENT_CHANGEACL :
	{		if (!nonulls.changeACL.user_id) nonulls.changeACL.user_id = "";
	if (trio_asprintf(&var,EDG_WLL_FORMAT_CHANGEACL,nonulls.changeACL.user_id,nonulls.changeACL.user_id_type,nonulls.changeACL.permission,nonulls.changeACL.permission_type,nonulls.changeACL.operation) == -1 ) {
	   NOMEM }
	}
      break;
  case EDG_WLL_EVENT_UNDEF :
  default :
     break;
}

/* put it all together (inc. the ending LF) */
if (asprintf(&logline,"%s%s%s\n",common,user,var) == -1) NOMEM

clean:
	if (date) free(date);
	if (common) free(common);
	if (user) free(user);
	if (var) free(var);
	return logline;
}
#undef NOMEM


/*!
 * edg_wll_CheckEvent - check internal structures if all required fields are present
 * Calls: free, sprintf, strcmp
 *        edg_wll_KeyNameToString, edg_wll_SetError (or edg_wll_ResetError)
 * Algorithm:
 */
#define MISSING(m_key) { \
	char *k =  edg_wll_KeyNameToString(m_key); \
        sprintf(err_desc,"Message incomplete, missing key %s.", k); \
	free(k); \
        ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_MSG_INCOMPLETE,err_desc); \
        goto end; }

edg_wll_ErrorCode edg_wll_CheckEvent(
	edg_wll_Context context,	/* context IN */
	edg_wll_Event *event	/* event IN */
)
{
char err_desc[128]; 		/* error description for use in edg_wll_SetError */
edg_wll_EventCode eventcode=EDG_WLL_EVENT_UNDEF;
edg_wll_ErrorCode ret;

eventcode=event->type;
if ( eventcode == EDG_WLL_EVENT_UNDEF ) {
	ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_EVENT_UNDEF,"Unknown or missing event type"); 
	goto end; 
}

/*
FIXME:
?	if (!event->any.user) MISSING(EDG_WLL_USER) - cannot use in edg_wll_LogEvent(), where is no DG.USER
*/

	if ((event->any.timestamp).tv_sec == (null_timeval).tv_sec && (event->any.timestamp).tv_usec == (null_timeval).tv_usec) MISSING(ULM_DATE)
	if (((event->any.host) == NULL && (NULL) == NULL) || ((event->any.host)&&(NULL)&& !strcmp(event->any.host,NULL))) MISSING(ULM_HOST)
	if ((event->any.priority == -1)) MISSING(EDG_WLL_COMMON_PRIORITY)
	if ((event->any.jobId) == (NULL)) MISSING(EDG_WLL_COMMON_JOBID)
	if (((event->any.seqcode) == NULL && (NULL) == NULL) || ((event->any.seqcode)&&(NULL)&& !strcmp(event->any.seqcode,NULL))) MISSING(EDG_WLL_COMMON_SEQCODE)
	if (((event->any.user) == NULL && (NULL) == NULL) || ((event->any.user)&&(NULL)&& !strcmp(event->any.user,NULL))) MISSING(EDG_WLL_COMMON_USER)
	if ((event->any.source) == (EDG_WLL_SOURCE_NONE)) MISSING(EDG_WLL_COMMON_SOURCE)

switch (eventcode) {
   case EDG_WLL_EVENT_TRANSFER :
	if ((event->transfer.destination) == (EDG_WLL_SOURCE_NONE)) MISSING(EDG_WLL_TRANSFER_DESTINATION)
	if (((event->transfer.dest_host) == NULL && (NULL) == NULL) || ((event->transfer.dest_host)&&(NULL)&& !strcmp(event->transfer.dest_host,NULL))) MISSING(EDG_WLL_TRANSFER_DEST_HOST)
	if (((event->transfer.job) == NULL && (NULL) == NULL) || ((event->transfer.job)&&(NULL)&& !strcmp(event->transfer.job,NULL))) MISSING(EDG_WLL_TRANSFER_JOB)
      break;
   case EDG_WLL_EVENT_ACCEPTED :
	if ((event->accepted.from) == (EDG_WLL_SOURCE_NONE)) MISSING(EDG_WLL_ACCEPTED_FROM)
	if (((event->accepted.from_host) == NULL && (NULL) == NULL) || ((event->accepted.from_host)&&(NULL)&& !strcmp(event->accepted.from_host,NULL))) MISSING(EDG_WLL_ACCEPTED_FROM_HOST)
	if (((event->accepted.local_jobid) == NULL && (NULL) == NULL) || ((event->accepted.local_jobid)&&(NULL)&& !strcmp(event->accepted.local_jobid,NULL))) MISSING(EDG_WLL_ACCEPTED_LOCAL_JOBID)
      break;
   case EDG_WLL_EVENT_REFUSED :
	if ((event->refused.from) == (EDG_WLL_SOURCE_NONE)) MISSING(EDG_WLL_REFUSED_FROM)
	if (((event->refused.from_host) == NULL && (NULL) == NULL) || ((event->refused.from_host)&&(NULL)&& !strcmp(event->refused.from_host,NULL))) MISSING(EDG_WLL_REFUSED_FROM_HOST)
	if (((event->refused.reason) == NULL && (NULL) == NULL) || ((event->refused.reason)&&(NULL)&& !strcmp(event->refused.reason,NULL))) MISSING(EDG_WLL_REFUSED_REASON)
      break;
   case EDG_WLL_EVENT_ENQUEUED :
	if (((event->enQueued.queue) == NULL && (NULL) == NULL) || ((event->enQueued.queue)&&(NULL)&& !strcmp(event->enQueued.queue,NULL))) MISSING(EDG_WLL_ENQUEUED_QUEUE)
	if (((event->enQueued.job) == NULL && (NULL) == NULL) || ((event->enQueued.job)&&(NULL)&& !strcmp(event->enQueued.job,NULL))) MISSING(EDG_WLL_ENQUEUED_JOB)
	if (((event->enQueued.reason) == NULL && (NULL) == NULL) || ((event->enQueued.reason)&&(NULL)&& !strcmp(event->enQueued.reason,NULL))) MISSING(EDG_WLL_ENQUEUED_REASON)
      break;
   case EDG_WLL_EVENT_DEQUEUED :
	if (((event->deQueued.queue) == NULL && (NULL) == NULL) || ((event->deQueued.queue)&&(NULL)&& !strcmp(event->deQueued.queue,NULL))) MISSING(EDG_WLL_DEQUEUED_QUEUE)
	if (((event->deQueued.local_jobid) == NULL && (NULL) == NULL) || ((event->deQueued.local_jobid)&&(NULL)&& !strcmp(event->deQueued.local_jobid,NULL))) MISSING(EDG_WLL_DEQUEUED_LOCAL_JOBID)
      break;
   case EDG_WLL_EVENT_HELPERCALL :
	if (((event->helperCall.helper_name) == NULL && (NULL) == NULL) || ((event->helperCall.helper_name)&&(NULL)&& !strcmp(event->helperCall.helper_name,NULL))) MISSING(EDG_WLL_HELPERCALL_HELPER_NAME)
	if (((event->helperCall.helper_params) == NULL && (NULL) == NULL) || ((event->helperCall.helper_params)&&(NULL)&& !strcmp(event->helperCall.helper_params,NULL))) MISSING(EDG_WLL_HELPERCALL_HELPER_PARAMS)
      break;
   case EDG_WLL_EVENT_HELPERRETURN :
	if (((event->helperReturn.helper_name) == NULL && (NULL) == NULL) || ((event->helperReturn.helper_name)&&(NULL)&& !strcmp(event->helperReturn.helper_name,NULL))) MISSING(EDG_WLL_HELPERRETURN_HELPER_NAME)
	if (((event->helperReturn.retval) == NULL && (NULL) == NULL) || ((event->helperReturn.retval)&&(NULL)&& !strcmp(event->helperReturn.retval,NULL))) MISSING(EDG_WLL_HELPERRETURN_RETVAL)
      break;
   case EDG_WLL_EVENT_RUNNING :
	if (((event->running.node) == NULL && (NULL) == NULL) || ((event->running.node)&&(NULL)&& !strcmp(event->running.node,NULL))) MISSING(EDG_WLL_RUNNING_NODE)
      break;
   case EDG_WLL_EVENT_RESUBMISSION :
	if (((event->resubmission.reason) == NULL && (NULL) == NULL) || ((event->resubmission.reason)&&(NULL)&& !strcmp(event->resubmission.reason,NULL))) MISSING(EDG_WLL_RESUBMISSION_REASON)
	if (((event->resubmission.tag) == NULL && (NULL) == NULL) || ((event->resubmission.tag)&&(NULL)&& !strcmp(event->resubmission.tag,NULL))) MISSING(EDG_WLL_RESUBMISSION_TAG)
      break;
   case EDG_WLL_EVENT_DONE :
	if (((event->done.reason) == NULL && (NULL) == NULL) || ((event->done.reason)&&(NULL)&& !strcmp(event->done.reason,NULL))) MISSING(EDG_WLL_DONE_REASON)
	if ((event->done.exit_code == -1)) MISSING(EDG_WLL_DONE_EXIT_CODE)
      break;
   case EDG_WLL_EVENT_CANCEL :
	if (((event->cancel.reason) == NULL && (NULL) == NULL) || ((event->cancel.reason)&&(NULL)&& !strcmp(event->cancel.reason,NULL))) MISSING(EDG_WLL_CANCEL_REASON)
      break;
   case EDG_WLL_EVENT_ABORT :
	if (((event->abort.reason) == NULL && (NULL) == NULL) || ((event->abort.reason)&&(NULL)&& !strcmp(event->abort.reason,NULL))) MISSING(EDG_WLL_ABORT_REASON)
      break;
   case EDG_WLL_EVENT_CLEAR :
      break;
   case EDG_WLL_EVENT_PURGE :
      break;
   case EDG_WLL_EVENT_MATCH :
	if (((event->match.dest_id) == NULL && (NULL) == NULL) || ((event->match.dest_id)&&(NULL)&& !strcmp(event->match.dest_id,NULL))) MISSING(EDG_WLL_MATCH_DEST_ID)
      break;
   case EDG_WLL_EVENT_PENDING :
	if (((event->pending.reason) == NULL && (NULL) == NULL) || ((event->pending.reason)&&(NULL)&& !strcmp(event->pending.reason,NULL))) MISSING(EDG_WLL_PENDING_REASON)
      break;
   case EDG_WLL_EVENT_REGJOB :
	if (((event->regJob.jdl) == NULL && (NULL) == NULL) || ((event->regJob.jdl)&&(NULL)&& !strcmp(event->regJob.jdl,NULL))) MISSING(EDG_WLL_REGJOB_JDL)
	if (((event->regJob.ns) == NULL && (NULL) == NULL) || ((event->regJob.ns)&&(NULL)&& !strcmp(event->regJob.ns,NULL))) MISSING(EDG_WLL_REGJOB_NS)
      break;
   case EDG_WLL_EVENT_CHKPT :
	if (((event->chkpt.tag) == NULL && (NULL) == NULL) || ((event->chkpt.tag)&&(NULL)&& !strcmp(event->chkpt.tag,NULL))) MISSING(EDG_WLL_CHKPT_TAG)
	if (((event->chkpt.classad) == NULL && (NULL) == NULL) || ((event->chkpt.classad)&&(NULL)&& !strcmp(event->chkpt.classad,NULL))) MISSING(EDG_WLL_CHKPT_CLASSAD)
      break;
   case EDG_WLL_EVENT_LISTENER :
	if (((event->listener.svc_name) == NULL && (NULL) == NULL) || ((event->listener.svc_name)&&(NULL)&& !strcmp(event->listener.svc_name,NULL))) MISSING(EDG_WLL_LISTENER_SVC_NAME)
	if (((event->listener.svc_host) == NULL && (NULL) == NULL) || ((event->listener.svc_host)&&(NULL)&& !strcmp(event->listener.svc_host,NULL))) MISSING(EDG_WLL_LISTENER_SVC_HOST)
	if ((event->listener.svc_port == 0)) MISSING(EDG_WLL_LISTENER_SVC_PORT)
      break;
   case EDG_WLL_EVENT_CURDESCR :
	if (((event->curDescr.descr) == NULL && (NULL) == NULL) || ((event->curDescr.descr)&&(NULL)&& !strcmp(event->curDescr.descr,NULL))) MISSING(EDG_WLL_CURDESCR_DESCR)
      break;
   case EDG_WLL_EVENT_USERTAG :
	if (((event->userTag.name) == NULL && (NULL) == NULL) || ((event->userTag.name)&&(NULL)&& !strcmp(event->userTag.name,NULL))) MISSING(EDG_WLL_USERTAG_NAME)
	if (((event->userTag.value) == NULL && (NULL) == NULL) || ((event->userTag.value)&&(NULL)&& !strcmp(event->userTag.value,NULL))) MISSING(EDG_WLL_USERTAG_VALUE)
      break;
   case EDG_WLL_EVENT_CHANGEACL :
	if (((event->changeACL.user_id) == NULL && (NULL) == NULL) || ((event->changeACL.user_id)&&(NULL)&& !strcmp(event->changeACL.user_id,NULL))) MISSING(EDG_WLL_CHANGEACL_USER_ID)
	if ((event->changeACL.user_id_type == -1)) MISSING(EDG_WLL_CHANGEACL_USER_ID_TYPE)
	if ((event->changeACL.permission == -1)) MISSING(EDG_WLL_CHANGEACL_PERMISSION)
	if ((event->changeACL.permission_type == -1)) MISSING(EDG_WLL_CHANGEACL_PERMISSION_TYPE)
	if ((event->changeACL.operation == -1)) MISSING(EDG_WLL_CHANGEACL_OPERATION)
      break;

   case EDG_WLL_EVENT_UNDEF :
   default:
	ret=edg_wll_SetError(context,EDG_WLL_ERROR_PARSE_EVENT_UNDEF,"Unknown or missing event type"); 
        goto end;
      break;
};
ret=edg_wll_ResetError(context);

end:
	return ret;
}

#undef MISSING


/*!
 * my_edg_wll_ULMGetValueAt - get value at index, but also
 *                - remove surrounding quotes if any
 *                - and unescape the string
 *                - the new string will be allocated (by edg_wll_LogUnescape)
 * Calls: edg_wll_ULMGetValueAt, edg_wll_LogUnescape, calloc and strncpy or strdup
 */
char *my_edg_wll_ULMGetValueAt( p_edg_wll_ULMFields table, int index )
{
char *str = edg_wll_ULMGetValueAt( table, index);
size_t len = strlen(str);
char *ret,*first,*last,*tmp;

first = last = str;
last += len - 1;

/* remove surrounding quotes */
if ((*first == ULM_QM) && (*last == ULM_QM)) {
	/* be careful with doppel_ULM_QM */
	if (len > 2) {
		tmp = (char *) calloc (1,(len-1)*sizeof(char));
		strncpy(tmp,first+1,len-2);
		tmp[len-2] = '\0';
	}
	else {
		tmp = strdup("");
	}
}
else tmp = strdup(str);

if (len > 2) {
	ret = edg_wll_LogUnescape(tmp);
	if (tmp) free(tmp);
}
else ret = tmp;

return ret;
}


/*!
 * edg_wll_GetJobId - parse jobId from ULM message
 * Returns: edg_wlc_jobid_t string or NULL
 * Calls: edg_wll_ULMNewParseTable, edg_wll_ULMFreeParseTable, edg_wll_ULMProcessParseTable,
 *        edg_wll_ULMGetNameAt, my_edg_wll_ULMGetValueAt, edg_wlc_jobid_tParse, strdup
 * Algorithm: break ULM string into fields and then look for jobId
 */
char *edg_wll_GetJobId(edg_wll_LogLine logline)
{
p_edg_wll_ULMFields table = edg_wll_ULMNewParseTable(logline);
int i;
char *ret=NULL,*fullid=NULL;
edg_wll_KeyNameCode keycode=UNDEFINED;
edg_wlc_JobId jobId = NULL;

/* break ULM string into fields */
if ( edg_wll_ULMProcessParseTable(table) != 0 ) goto clean;

/* look for jobId */
for (i=0; i<table->num; i++) {
	keycode=edg_wll_StringToKeyName(edg_wll_ULMGetNameAt(table,i));
	if ( keycode == EDG_WLL_COMMON_JOBID ) { fullid=my_edg_wll_ULMGetValueAt(table,i); break; }
}
if ( fullid == NULL ) goto clean;

if (edg_wlc_JobIdParse(fullid, &jobId)) goto clean;

ret = strdup(fullid);

clean:
   if (fullid) free(fullid);
   if (jobId) edg_wlc_JobIdFree(jobId);
   edg_wll_ULMFreeParseTable(table);
   return ret;
}
