#ident "$Header: /local/reps/lcgware/workload/logging/common/status.c.T,v 1.11 2003/11/19 13:48:28 salvet Exp $"

#include <stdlib.h>
#include <string.h>

#include "edg/workload/logging/client/consumer.h"

static const struct timeval null_timeval = {0,0};


void edg_wll_FreeStatus(edg_wll_JobStat *stat)
{ 
  if (stat) {
	int 	i;
    
	edg_wlc_JobIdFree(stat->jobId);
	if (stat->owner != NULL )    	free(stat->owner);
	edg_wlc_JobIdFree(stat->parent_job);
	if (stat->seed != NULL )    	free(stat->seed);
	if (stat->children != NULL ) {
		for (i=0; stat->children[i]; i++)
			free(stat->children[i]);
		free(stat->children);
	}
	if (stat->children_hist != NULL )    	free(stat->children_hist);
	if (stat->children_states != NULL ) {
		for (i=0; stat->children_states[i].state; i++)
			edg_wll_FreeStatus(&stat->children_states[i]);
		free(stat->children_states);
	}
	if (stat->condorId != NULL )    	free(stat->condorId);
	if (stat->globusId != NULL )    	free(stat->globusId);
	if (stat->localId != NULL )    	free(stat->localId);
	if (stat->jdl != NULL )    	free(stat->jdl);
	if (stat->matched_jdl != NULL )    	free(stat->matched_jdl);
	if (stat->destination != NULL )    	free(stat->destination);
	if (stat->condor_jdl != NULL )    	free(stat->condor_jdl);
	if (stat->rsl != NULL )    	free(stat->rsl);
	if (stat->reason != NULL )    	free(stat->reason);
	if (stat->location != NULL )    	free(stat->location);
	if (stat->ce_node != NULL )    	free(stat->ce_node);
	if (stat->network_server != NULL )    	free(stat->network_server);
	if (stat->cancelReason != NULL )    	free(stat->cancelReason);
	if (stat->user_tags != NULL ) {
		for (i=0; stat->user_tags[i].tag; i++) {
			free(stat->user_tags[i].tag);
			free(stat->user_tags[i].value);
		}
		free(stat->user_tags);
	}
	if (stat->stateEnterTimes != NULL )    	free(stat->stateEnterTimes);
	if (stat->expectFrom != NULL )    	free(stat->expectFrom);
	if (stat->acl != NULL )    	free(stat->acl);
    
  }
}

edg_wll_JobStat *edg_wll_CpyStatus(edg_wll_JobStat *src, edg_wll_JobStat *dest)
{
	int 	i;


	if ( !src || !dest )
		return NULL;

	edg_wll_InitStatus(dest);
    	dest->state = src->state;
	if ( edg_wlc_JobIdDup(src->jobId, &(dest->jobId)) ) goto err;
	if ( src->owner != NULL )
		if ( !(dest->owner = strdup(src->owner)) ) goto err;
	dest->jobtype = src->jobtype;
	if ( edg_wlc_JobIdDup(src->parent_job, &(dest->parent_job)) ) goto err;
	if ( src->seed != NULL )
		if ( !(dest->seed = strdup(src->seed)) ) goto err;
	dest->children_num = src->children_num;
	if ( src->children != NULL )
	{
		for ( i = 0; src->children[i]; i++ ) ;
		if ( !(dest->children = malloc(sizeof(*src->children)*(i+1))) ) goto err;
		for ( i = 0; src->children[i]; i++ )
			if ( !(dest->children[i] = strdup(src->children[i])) ) goto err;
		dest->children[i] = NULL;
	}
	if ( src->children_hist != NULL )
	{
		i = 1 + src->children_hist[0];
		if ( !(dest->children_hist = malloc(sizeof(*src->children_hist)*i)) ) goto err;
		memcpy(dest->children_hist,src->children_hist,sizeof(*src->children_hist)*i);
	}
	if ( src->children_states != NULL )
	{
		for ( i = 0; src->children_states[i].state; i++ ) ;
		if ( !(dest->children_states = malloc(sizeof(*src->children_states)*(i+1))) ) goto err;
		for ( i = 0; src->children_states[i].state; i++ )
			if ( !edg_wll_CpyStatus(&src->children_states[i], &dest->children_states[i]) ) goto err;
		dest->children_states[i].state = EDG_WLL_JOB_UNDEF;
	}
	if ( src->condorId != NULL )
		if ( !(dest->condorId = strdup(src->condorId)) ) goto err;
	if ( src->globusId != NULL )
		if ( !(dest->globusId = strdup(src->globusId)) ) goto err;
	if ( src->localId != NULL )
		if ( !(dest->localId = strdup(src->localId)) ) goto err;
	if ( src->jdl != NULL )
		if ( !(dest->jdl = strdup(src->jdl)) ) goto err;
	if ( src->matched_jdl != NULL )
		if ( !(dest->matched_jdl = strdup(src->matched_jdl)) ) goto err;
	if ( src->destination != NULL )
		if ( !(dest->destination = strdup(src->destination)) ) goto err;
	if ( src->condor_jdl != NULL )
		if ( !(dest->condor_jdl = strdup(src->condor_jdl)) ) goto err;
	if ( src->rsl != NULL )
		if ( !(dest->rsl = strdup(src->rsl)) ) goto err;
	if ( src->reason != NULL )
		if ( !(dest->reason = strdup(src->reason)) ) goto err;
	if ( src->location != NULL )
		if ( !(dest->location = strdup(src->location)) ) goto err;
	if ( src->ce_node != NULL )
		if ( !(dest->ce_node = strdup(src->ce_node)) ) goto err;
	if ( src->network_server != NULL )
		if ( !(dest->network_server = strdup(src->network_server)) ) goto err;
	dest->subjob_failed = src->subjob_failed;
	dest->done_code = src->done_code;
	dest->exit_code = src->exit_code;
	dest->resubmitted = src->resubmitted;
	dest->cancelling = src->cancelling;
	if ( src->cancelReason != NULL )
		if ( !(dest->cancelReason = strdup(src->cancelReason)) ) goto err;
	dest->cpuTime = src->cpuTime;
	dest->stateEnterTime = src->stateEnterTime;
	dest->lastUpdateTime = src->lastUpdateTime;
	if ( src->stateEnterTimes != NULL )
	{
		i = 1 + src->stateEnterTimes[0];
		if ( !(dest->stateEnterTimes = malloc(sizeof(*src->stateEnterTimes)*i)) ) goto err;
		memcpy(dest->stateEnterTimes,src->stateEnterTimes,sizeof(*src->stateEnterTimes)*i);
	}
	dest->expectUpdate = src->expectUpdate;
	if ( src->expectFrom != NULL )
		if ( !(dest->expectFrom = strdup(src->expectFrom)) ) goto err;
	if ( src->acl != NULL )
		if ( !(dest->acl = strdup(src->acl)) ) goto err;
    
  return dest;

err:
  edg_wll_FreeStatus(dest);
  return NULL;
}


int edg_wll_InitStatus(edg_wll_JobStat *stat)
{
	if (!stat) return -1;
	
	stat->state = EDG_WLL_JOB_UNDEF;

	stat->jobId = NULL;
	stat->owner = NULL;
	stat->jobtype = -1;
	stat->parent_job = NULL;
	stat->seed = NULL;
	stat->children_num = 0;
	stat->children = NULL;
	stat->children_hist = NULL;
	stat->children_states = NULL;
	stat->condorId = NULL;
	stat->globusId = NULL;
	stat->localId = NULL;
	stat->jdl = NULL;
	stat->matched_jdl = NULL;
	stat->destination = NULL;
	stat->condor_jdl = NULL;
	stat->rsl = NULL;
	stat->reason = NULL;
	stat->location = NULL;
	stat->ce_node = NULL;
	stat->network_server = NULL;
	stat->subjob_failed = 0;
	stat->done_code = -1;
	stat->exit_code = 0;
	stat->resubmitted = 0;
	stat->cancelling = 0;
	stat->cancelReason = NULL;
	stat->cpuTime = -1;
	stat->user_tags = NULL;
	stat->stateEnterTime = null_timeval;
	stat->lastUpdateTime = null_timeval;
	stat->stateEnterTimes = NULL;
	stat->expectUpdate = 0;
	stat->expectFrom = NULL;
	stat->acl = NULL;

	return 0;
}

static const char * const statNames[] = {
	"Undefined",
	"Submitted",
	"Waiting",
	"Ready",
	"Scheduled",
	"Running",
	"Done",
	"Cleared",
	"Aborted",
	"Cancelled",
	"Unknown",
	"Purged",
};

edg_wll_JobStatCode edg_wll_StringToStat(const char *name)

{
        unsigned int     i;

        for (i=0; i<sizeof(statNames)/sizeof(statNames[0]); i++)
                if (strcasecmp(statNames[i],name) == 0) return (edg_wll_JobStatCode) i;
        return (edg_wll_JobStatCode) -1; 
}

char *edg_wll_StatToString(edg_wll_JobStatCode statCode)
{
        if ((int)statCode < 0 || statCode >= sizeof(statNames)/sizeof(statNames[0])) return (char *) NULL; 
        return strdup(statNames[statCode]);
}
