#ident "$Header: /local/reps/lcgware/workload/logging/lbserver/db_store.c,v 1.17 2003/09/19 12:19:16 ljocha Exp $"

#include <string.h>
#include <errno.h>
#include <stdlib.h>

#include "edg/workload/logging/client/consumer.h"
#include "edg/workload/logging/common/context.h"
#include "edg/workload/logging/common/events_parse.h"
#include "edg/workload/logging/lbserver/store.h"
#include "edg/workload/logging/lbserver/lbs_db.h"
#include "edg/workload/logging/lbserver/lock.h"

extern int debug;

/* XXX */
#define use_db	1

int
db_store(edg_wll_Context ctx,char *ucs, char *event)
{
  edg_wll_Event *ev;
  int	seq;
  int   err;

  ev = NULL;

  edg_wll_ResetError(ctx);

  if(edg_wll_ParseEvent(ctx, event, &ev))
    goto err;
  
  if(ev->any.user == NULL)
    ev->any.user = strdup(ucs);

  if(use_db) {
    if (ctx->strict_locking && edg_wll_LockJob(ctx,ev->any.jobId)) goto err;
    if(edg_wll_StoreEvent(ctx, ev,&seq))
      goto err;
  }

  if (debug) { fputs(event,stderr); fputc('\n',stderr); }

  if (!ctx->strict_locking && edg_wll_LockJob(ctx,ev->any.jobId)) goto err;

  if ( ev->any.type == EDG_WLL_EVENT_CHANGEACL )
    err = edg_wll_UpdateACL(ctx, ev->any.jobId,
			ev->changeACL.user_id, ev->changeACL.user_id_type,
			ev->changeACL.permission, ev->changeACL.permission_type,
			ev->changeACL.operation);
  else
    err = edg_wll_StepIntState(ctx,ev->any.jobId, ev, seq);

  if (edg_wll_UnlockJob(ctx,ev->any.jobId)) goto err;
  if (err) goto err;

  edg_wll_FreeEvent(ev);
  free(ev);

  return(0);

 err:
  if(ev) {
    edg_wll_FreeEvent(ev);
    free(ev);
  }
  
  return edg_wll_Error(ctx,NULL,NULL);
}

