#ident "$Header: /local/reps/lcgware/workload/logging/lbserver/get_events.c.T,v 1.11 2003/01/31 12:00:37 ljocha Exp $"

/*

  !! Automatically generated file
  !! Do not edit, your changes will be discarded upon build
  !! Change the corresponding template file get_events.c.T

*/

/* Helper functions for getting events from the LB database *
 * XXX: lots of stuff still hadcoded:
 * 		there's mapping db.columns <-> union event fields
 */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <syslog.h>

#include "edg/workload/logging/lbserver/get_events.h"
#include "edg/workload/logging/common/context.h"
#include "edg/workload/thirdparty/trio/trio.h"
#include "edg/workload/logging/common/events_parse.h"

static void edg_wll_set_event_field(edg_wll_Event *,char *,char *);
static void edg_wll_set_event_field_warn(edg_wll_Event *,char *,char *);

int edg_wll_get_event_flesh(edg_wll_Context ctx,int n,edg_wll_Event *e)
{
	char	*jobid = edg_wlc_JobIdGetUnique(e->any.jobId),
		*q = NULL,*nameval[2];
	edg_wll_Stmt	sh;
	int	ret,t;
	const char	*tables[] = { "short_fields","long_fields" };

	edg_wll_ResetError(ctx);

	for (t=0; t<=1; t++) {
		trio_asprintf(&q,"select name,value from %s "
				"where jobid = '%|Ss' and event = %d ",
				tables[t],jobid,n);

		if ((ret=edg_wll_ExecStmt(ctx,q,&sh)) < 0) goto cleanup;

		while ((ret=edg_wll_FetchRow(sh,nameval)) > 0) {
			edg_wll_set_event_field(e,nameval[0],nameval[1]);
			free(nameval[0]);
			/* XXX: nameval[1] freed in edg_wll_set_event_field
			 * if necessary
			 */
		}

		if (ret<0) goto cleanup;
		edg_wll_FreeStmt(&sh);
		free(q); q=NULL;
	}

	ret=edg_wll_CheckEvent(ctx,e);

cleanup:
	if (sh) edg_wll_FreeStmt(&sh);
	free(jobid);
	free(q);

	if (ret) { edg_wll_FreeEvent(e); memset(e,0,sizeof *e); }
	return ret;
}


/* print/log  warning for database inconsistency */

static void edg_wll_set_event_field_warn(
		edg_wll_Event	*event,
		char		*name,
		char		*value)
{
	char *e = edg_wll_EventToString(event->any.type);

	fprintf(stderr, "edg_wll_set_event_field: bad field:"
		"code=\"%s\" name=\"%s\" value=\"%s\"\n",
		e, name, value);
	free(e);
	/* XXX edg_wll_Log */
}

/* set event structure field */

static void edg_wll_set_event_field(
		edg_wll_Event	*event,
		char		*name,
		char		*value)
{
/* XXX: where's the best place to hande it? */
	if (!strcasecmp(name,"SRC_INSTANCE")) {
		event->any.src_instance = value;
		return;
	}

/* XXX: handled separately, should go to event_head one day */
	if (!strcasecmp(name,"SEQCODE")) {
		event->any.seqcode = value;
		return;
	}

	if (!strcasecmp(name,"destination")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_TRANSFER: event->transfer.destination = edg_wll_StringToSource(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"dest_host")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_TRANSFER: event->transfer.dest_host = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"dest_instance")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_TRANSFER: event->transfer.dest_instance = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"dest_jobid")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_TRANSFER: event->transfer.dest_jobid = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"from")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_ACCEPTED: event->accepted.from = edg_wll_StringToSource(value); break;
			case EDG_WLL_EVENT_REFUSED: event->refused.from = edg_wll_StringToSource(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"from_host")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_ACCEPTED: event->accepted.from_host = strdup(value); break;
			case EDG_WLL_EVENT_REFUSED: event->refused.from_host = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"from_instance")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_ACCEPTED: event->accepted.from_instance = strdup(value); break;
			case EDG_WLL_EVENT_REFUSED: event->refused.from_instance = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"job")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_ENQUEUED: event->enQueued.job = strdup(value); break;
			case EDG_WLL_EVENT_TRANSFER: event->transfer.job = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"result")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_ENQUEUED: event->enQueued.result = edg_wll_StringToEnQueuedResult(value); break;
			case EDG_WLL_EVENT_RESUBMISSION: event->resubmission.result = edg_wll_StringToResubmissionResult(value); break;
			case EDG_WLL_EVENT_TRANSFER: event->transfer.result = edg_wll_StringToTransferResult(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"queue")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_DEQUEUED: event->deQueued.queue = strdup(value); break;
			case EDG_WLL_EVENT_ENQUEUED: event->enQueued.queue = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"local_jobid")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_DEQUEUED: event->deQueued.local_jobid = strdup(value); break;
			case EDG_WLL_EVENT_ACCEPTED: event->accepted.local_jobid = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"helper_name")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_HELPERCALL: event->helperCall.helper_name = strdup(value); break;
			case EDG_WLL_EVENT_HELPERRETURN: event->helperReturn.helper_name = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"helper_params")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_HELPERCALL: event->helperCall.helper_params = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"src_role")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_HELPERCALL: event->helperCall.src_role = edg_wll_StringToHelperCallSrc_role(value); break;
			case EDG_WLL_EVENT_HELPERRETURN: event->helperReturn.src_role = edg_wll_StringToHelperReturnSrc_role(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"retval")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_HELPERRETURN: event->helperReturn.retval = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"node")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_RUNNING: event->running.node = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"status_code")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_DONE: event->done.status_code = edg_wll_StringToDoneStatus_code(value); break;
			case EDG_WLL_EVENT_CANCEL: event->cancel.status_code = edg_wll_StringToCancelStatus_code(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"reason")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_DONE: event->done.reason = strdup(value); break;
			case EDG_WLL_EVENT_ABORT: event->abort.reason = strdup(value); break;
			case EDG_WLL_EVENT_ENQUEUED: event->enQueued.reason = strdup(value); break;
			case EDG_WLL_EVENT_CLEAR: event->clear.reason = edg_wll_StringToClearReason(value); break;
			case EDG_WLL_EVENT_CANCEL: event->cancel.reason = strdup(value); break;
			case EDG_WLL_EVENT_REFUSED: event->refused.reason = strdup(value); break;
			case EDG_WLL_EVENT_RESUBMISSION: event->resubmission.reason = strdup(value); break;
			case EDG_WLL_EVENT_PENDING: event->pending.reason = strdup(value); break;
			case EDG_WLL_EVENT_TRANSFER: event->transfer.reason = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"exit_code")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_DONE: event->done.exit_code = atoi(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"dest_id")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_MATCH: event->match.dest_id = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"jdl")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_REGJOB: event->regJob.jdl = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"ns")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_REGJOB: event->regJob.ns = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"parent")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_REGJOB: edg_wlc_JobIdParse(value,&event->regJob.parent); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"jobtype")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_REGJOB: event->regJob.jobtype = edg_wll_StringToRegJobJobtype(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"nsubjobs")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_REGJOB: event->regJob.nsubjobs = atoi(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"seed")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_REGJOB: event->regJob.seed = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"tag")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CHKPT: event->chkpt.tag = strdup(value); break;
			case EDG_WLL_EVENT_RESUBMISSION: event->resubmission.tag = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"classad")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CHKPT: event->chkpt.classad = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"svc_name")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_LISTENER: event->listener.svc_name = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"svc_host")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_LISTENER: event->listener.svc_host = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"svc_port")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_LISTENER: event->listener.svc_port = (uint16_t) atoi(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"descr")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CURDESCR: event->curDescr.descr = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"name")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_USERTAG: event->userTag.name = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"value")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_USERTAG: event->userTag.value = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"user_id")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CHANGEACL: event->changeACL.user_id = strdup(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"user_id_type")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CHANGEACL: event->changeACL.user_id_type = atoi(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"permission")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CHANGEACL: event->changeACL.permission = atoi(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"permission_type")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CHANGEACL: event->changeACL.permission_type = atoi(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}
	if (!strcasecmp(name,"operation")) {
		switch (event->any.type) {
			case EDG_WLL_EVENT_CHANGEACL: event->changeACL.operation = atoi(value); break;
			default: edg_wll_set_event_field_warn(event,name,value); break;
		} /* switch */
		free(value);
		return;
	}

	edg_wll_set_event_field_warn(event,name,value);
	free(value);
	return;
}
		

int compare_events_by_tv(const void *a, const void *b)
{
	const edg_wll_Event *e = (edg_wll_Event *)a;
	const edg_wll_Event *f = (edg_wll_Event *)b;

	if (e->any.timestamp.tv_sec < f->any.timestamp.tv_sec) return -1;
	if (e->any.timestamp.tv_sec > f->any.timestamp.tv_sec) return 1;
	if (e->any.timestamp.tv_usec < f->any.timestamp.tv_usec) return -1;
	if (e->any.timestamp.tv_usec > f->any.timestamp.tv_usec) return 1;
	return 0;
}
