#ident "$Header: /local/reps/lcgware/workload/logging/lbserver/lb_http.c,v 1.19 2002/11/07 16:21:53 mulac Exp $"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include "edg/workload/logging/lbserver/lb_http.h"
#include "edg/workload/logging/lbserver/lb_proto.h"

#include "edg/workload/logging/client/consumer.h"
#include "edg/workload/logging/common/mini_http.h"
#include "edg/workload/logging/common/context.h"

#define dprintf(x) printf x


int edg_wll_ServerHTTP(edg_wll_Context ctx)
{
	char	**hdr = NULL,*req = NULL,*body = NULL,
		**hdrOut = NULL, *resp = NULL, *bodyOut = NULL,
		*err_desc = NULL;
	edg_wll_ErrorCode	err = 0;


	err = edg_wll_http_recv(ctx,&req,&hdr,&body);

	dprintf(("[%d] %s\n",getpid(),req));
	if (body) dprintf(("\n%s\n\n",body));

	if (!err) {
		if ((err = edg_wll_Proto(ctx,req,hdr,body,&resp,&hdrOut,&bodyOut))) 
			edg_wll_Error(ctx,NULL,&err_desc);

		if (resp) edg_wll_http_send(ctx,resp,(char const * const *)hdrOut,bodyOut);
	}

	free(req);
	free(resp);
	if (hdr) {
		char 	**h;
		for (h = hdr; *h; h++) free(*h);
		free(hdr);
	}
	// hdrOut are static
	free(body);
	free(bodyOut);

	if (err != edg_wll_Error(ctx,NULL,NULL)) edg_wll_SetError(ctx,err,err_desc);
	free(err_desc);
	return err;
}
