#include <unistd.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <errno.h>

#include "edg/workload/common/jobid/jobid.h"
#include "edg/workload/logging/common/context.h"
#include "edg/workload/logging/lbserver/lock.h"


int edg_wll_LockUnlockJob(const edg_wll_Context ctx,const edg_wlc_JobId job,int lock)
{
	struct sembuf	s;
	char	*un = edg_wlc_JobIdGetUnique(job);
	int	n,i;
	static const char b64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";
	
	if (!un) return edg_wll_SetError(ctx,EINVAL,"jobid");

	for (n=0; n<sizeof b64 && b64[n] != un[0]; n++);
	for (i=0; i<sizeof b64 && b64[i] != un[1]; i++);
	n += i<<6;

	fprintf(stderr,"[%d] semop(%d,%d) \n",getpid(),n % ctx->semaphores,lock);

	s.sem_num = n % ctx->semaphores;
	s.sem_op = lock;
	s.sem_flg = SEM_UNDO;

	if (semop(ctx->semset,&s,1)) return edg_wll_SetError(ctx,errno,"edg_wll_LockUnlockJob()");
	return edg_wll_ResetError(ctx);
}
