#ident "$Header: /local/reps/lcgware/workload/logging/lbserver/store.c.T,v 1.30 2003/09/19 12:19:16 ljocha Exp $"

/*


  !! Automatically generated file
  !! Do not edit, your changes will be discarded upon build
  !! Change the corresponding template file store.c.T


 * XXX: still lots of hardcoded stuff
 *	there's mapping db.column <-> event struct field
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <errno.h>
#include <syslog.h>

#include "globus_config.h"
#include "sslutils.h"

#include "edg/workload/logging/lbserver/store.h"
#include "edg/workload/logging/lbserver/get_events.h"
#include "edg/workload/logging/lbserver/lbs_db.h"
#include "edg/workload/logging/lbserver/lock.h"
#include "edg/workload/logging/lbserver/lb_authz.h"
#include "edg/workload/logging/common/events_parse.h"

#include "edg/workload/logging/client/context.h"
#include "edg/workload/logging/client/producer.h"
#include "edg/workload/logging/common/context.h"
#include "edg/workload/logging/common/log_proto.h"	/* for EDG_WLL_LOG_USER_DEFAULT */
#include "edg/workload/common/jobid/strmd5.h"

#include "edg/workload/thirdparty/trio/trio.h"

static int store_user(edg_wll_Context,const char *,const char *); 
static int store_job(edg_wll_Context,const edg_wlc_JobId,const char *);
static int store_flesh(edg_wll_Context,edg_wll_Event *,char *,int);
static int store_seq(edg_wll_Context,edg_wll_Event *,int);
static int check_dup(edg_wll_Context,edg_wll_Event *);
static int check_auth(edg_wll_Context,edg_wll_Event *e); 
static int register_subjobs(edg_wll_Context,const edg_wll_RegJobEvent *);

void edg_wll_StoreAnonymous(edg_wll_Context ctx,int anon) {
	ctx->allowAnonymous = anon;
}

int edg_wll_StoreEvent(edg_wll_Context ctx,edg_wll_Event *e,int *seq)
{
	edg_wll_ErrorCode	err = 0;
	char		*userid = NULL,*jobid,*stmt;
	char		*select_max,*ssrc;
	edg_wll_Stmt	sh = NULL;
	int		next = 0xDEAD;
	char		*now_s = NULL;

	ssrc = jobid = stmt = select_max = NULL;

	now_s = strdup(edg_wll_TimeToDB(time(NULL)));
	edg_wll_ResetError(ctx);
	switch (err = check_auth(ctx,e)) {
		case 0: break;
		case ENOENT: goto clean;
		case EPERM:
			if (!ctx->noAuth) goto clean;
			edg_wll_ResetError(ctx);
			break;
		default: goto clean;
	}
	if ((err = check_dup(ctx,e))) goto clean;

	userid = strdup(strmd5(e->any.user,NULL));

/* make sure user record is there */
	if ((err = store_user(ctx,userid,e->any.user))) goto clean;

	jobid = edg_wlc_JobIdGetUnique(e->any.jobId);

/* only REGJOB events determine job owner now */
	if (e->type == EDG_WLL_EVENT_REGJOB && 
		(err = store_job(ctx,e->any.jobId,userid))) goto clean;


/* obtain next event sequence number */
	trio_asprintf(&select_max,
		"select max(event) from events "
		"where jobid = '%|Ss'",jobid);

	ssrc = edg_wll_SourceToString(e->any.source);

/* try to insert (someone else may be doing the same) */
	while (1) {
		char	*max;

		if (edg_wll_ExecStmt(ctx,select_max,&sh) < 0 ||
		    edg_wll_FetchRow(sh,&max) < 0)
		{
			err = edg_wll_Error(ctx,NULL,NULL);
			goto clean;
		}
		edg_wll_FreeStmt(&sh); 
		
		next = max && *max ? atoi(max)+1 : 0;
		
	/* store an UNDEF event first in order to prevent race condition
	 * with readers */
		trio_asprintf(&stmt,
			"insert into events(jobid,event,code,prog,host,time_stamp,usec,arrived,level,userid) "
			"values ('%|Ss',%d,%d,'%|Ss','%|Ss',%s,%d,'%|Ss',%d,'%|Ss')",
			jobid,next,EDG_WLL_EVENT_UNDEF,ssrc,e->any.host,
			edg_wll_TimeToDB(e->any.timestamp.tv_sec),e->any.timestamp.tv_usec,
			now_s, e->any.level,userid);

		if (edg_wll_ExecStmt(ctx,stmt,NULL) < 0) {
			if ((err = edg_wll_Error(ctx,NULL,NULL)) != EEXIST)
				goto clean;
		} else break; /* successful insert */

	/* we were late -- try once again */
		free(stmt);
	}

	free(stmt);
	if ((err = store_seq(ctx,e,next)) ||
		(err = store_flesh(ctx,e,jobid,next))) {
	/* attempt to cleanup, ignore new errors */
		char		*desc;
		edg_wll_ErrorCode	oerr = edg_wll_Error(ctx,NULL,&desc);

		edg_wll_delete_event(ctx,jobid,next);
		edg_wll_SetError(ctx,oerr,desc);
		free(desc);
	}
	else {
	/* emulate commit, i.e. swith to a real event type to make
	 * the record valid */
		trio_asprintf(&stmt,
			"update events set code=%d "
			"where jobid='%|Ss' and event=%d",
			(int) e->any.type,jobid,next);
		switch (edg_wll_ExecStmt(ctx,stmt,NULL)) {
			case 0: if (ctx->strict_locking)
					err = edg_wll_SetError(ctx,ENOENT,"event disappeared on store while strict locking");
			/* purge in progres: drop the garbage, ignore errors */
				else {
					edg_wll_delete_event(ctx,jobid,next);
					err = edg_wll_SetError(ctx,ENOENT,"job being purged");
				}
				break;
			case 1: if (ctx->strict_locking) err = 0;
				else {
			/* check whether the job is still there to prevent garbage
			 * left while there is a concurrent purge 
			 */
					free(stmt);
					trio_asprintf(&stmt,
						"select 'x' from jobs where jobid='%|Ss'",
						jobid);
					switch (edg_wll_ExecStmt(ctx,stmt,NULL)) {
						case 1: break;
						case 0: /* purge in progres */
							edg_wll_delete_event(ctx,jobid,next);
							err = edg_wll_SetError(ctx,ENOENT,"job being purged");
							break;
						default: err = edg_wll_SetError(ctx,EDG_WLL_ERROR_DB_CALL,
								"more job records, what is that?");
							break;
					}
				}
				break;
			case -1: err = edg_wll_Error(ctx,NULL,NULL);
				break;

			default: err = edg_wll_SetError(ctx,EDG_WLL_ERROR_DB_CALL,
				"more event records, what is that?");
				break;
		}
	}

	if (err == 0 && 
		e->any.type == EDG_WLL_EVENT_REGJOB &&
		(e->regJob.jobtype == EDG_WLL_REGJOB_DAG ||
		 e->regJob.jobtype == EDG_WLL_REGJOB_PARTITIONED) &&
		e->regJob.nsubjobs > 0) err = register_subjobs(ctx,&e->regJob);


clean:
	free(now_s);
	free(userid);
	free(jobid);
	free(stmt);
	free(ssrc);
	free(select_max);
	if (sh) edg_wll_FreeStmt(&sh);
	if (!err) *seq = next;
	return err;
}

static int store_user(edg_wll_Context ctx,const char *userid,const char *subj)
{
	char	*stmt;

	trio_asprintf(&stmt,"insert into users(userid,cert_subj) "
		"values ('%|Ss','%|Ss')",userid,subj);

	if (edg_wll_ExecStmt(ctx,stmt,NULL) < 0) {
		if (edg_wll_Error(ctx,NULL,NULL) == EEXIST)
			edg_wll_ResetError(ctx);
	}

	free(stmt);
	return edg_wll_Error(ctx,NULL,NULL);
}

static int store_job(edg_wll_Context ctx,const edg_wlc_JobId job,const char *userid)
{
	char *jobstr = edg_wlc_JobIdUnparse(job);
	char *jobid = edg_wlc_JobIdGetUnique(job);
	char *stmt;

/* debug Duplicate key on index: Duplicate entry '(nil)' for key 1
 */
	if (jobid == NULL || jobstr == NULL) 
		return edg_wll_SetError(ctx,EINVAL,"store_job()");

	edg_wll_ResetError(ctx);
	trio_asprintf(&stmt,"insert into jobs(jobid,dg_jobid,userid) "
		"values ('%|Ss','%|Ss','%|Ss')",jobid,jobstr,userid);

	if (edg_wll_ExecStmt(ctx,stmt,NULL) < 0) {
		if (edg_wll_Error(ctx,NULL,NULL) == EEXIST) 
			edg_wll_ResetError(ctx);
	}
	free(stmt);
	free(jobstr);
	free(jobid);
	return edg_wll_Error(ctx,NULL,NULL);
}

/*
 * XXX: store it in SHORT_FIELDS for now despite it should go to dedicated
 * 	column in EVENTS.
 *
 * 	don't want to change the database structure now, will be done anyway
 * 	soon
 */
static int store_seq(edg_wll_Context ctx,edg_wll_Event *e,int no)
{
	int	ret;
	char	*stmt;
	char	*jobid = edg_wlc_JobIdGetUnique(e->any.jobId);

	edg_wll_ResetError(ctx);
	trio_asprintf(&stmt,"insert into short_fields(jobid,event,name,value) "
			"values ('%|Ss',%d,'SEQCODE','%|Ss')",
			jobid,no,e->any.seqcode);

	ret = edg_wll_ExecStmt(ctx,stmt,NULL);
	free(stmt);
	free(jobid);

	return ret>=0 ? 0 : edg_wll_Error(ctx,NULL,NULL);
}

#define SHORT_LEN	255	/* short_fiels.value db column lenght */

static int store_flesh(edg_wll_Context ctx,edg_wll_Event *e,char *jobid,int no)
{
	struct {
		char	*key;
		char	*val;
	} f[20];

	char	*stmt;
	unsigned int	i;
	int	err = 0;

	edg_wll_ResetError(ctx);
	memset(f,0,sizeof(f)); assert(f[0].key == NULL);

	switch (e->type) {
		case EDG_WLL_EVENT_TRANSFER:
			f[0].key = "DESTINATION";
			f[0].val = edg_wll_SourceToString(e->transfer.destination);
			f[1].key = "DEST_HOST";
			f[1].val = e->transfer.dest_host?strdup(e->transfer.dest_host):NULL;
			f[2].key = "DEST_INSTANCE";
			f[2].val = e->transfer.dest_instance?strdup(e->transfer.dest_instance):NULL;
			f[3].key = "JOB";
			f[3].val = e->transfer.job?strdup(e->transfer.job):NULL;
			f[4].key = "RESULT";
			f[4].val = edg_wll_TransferResultToString(e->transfer.result);
			f[5].key = "REASON";
			f[5].val = e->transfer.reason?strdup(e->transfer.reason):NULL;
			f[6].key = "DEST_JOBID";
			f[6].val = e->transfer.dest_jobid?strdup(e->transfer.dest_jobid):NULL;
			assert(7<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_ACCEPTED:
			f[0].key = "FROM";
			f[0].val = edg_wll_SourceToString(e->accepted.from);
			f[1].key = "FROM_HOST";
			f[1].val = e->accepted.from_host?strdup(e->accepted.from_host):NULL;
			f[2].key = "FROM_INSTANCE";
			f[2].val = e->accepted.from_instance?strdup(e->accepted.from_instance):NULL;
			f[3].key = "LOCAL_JOBID";
			f[3].val = e->accepted.local_jobid?strdup(e->accepted.local_jobid):NULL;
			assert(4<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_REFUSED:
			f[0].key = "FROM";
			f[0].val = edg_wll_SourceToString(e->refused.from);
			f[1].key = "FROM_HOST";
			f[1].val = e->refused.from_host?strdup(e->refused.from_host):NULL;
			f[2].key = "FROM_INSTANCE";
			f[2].val = e->refused.from_instance?strdup(e->refused.from_instance):NULL;
			f[3].key = "REASON";
			f[3].val = e->refused.reason?strdup(e->refused.reason):NULL;
			assert(4<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_ENQUEUED:
			f[0].key = "QUEUE";
			f[0].val = e->enQueued.queue?strdup(e->enQueued.queue):NULL;
			f[1].key = "JOB";
			f[1].val = e->enQueued.job?strdup(e->enQueued.job):NULL;
			f[2].key = "RESULT";
			f[2].val = edg_wll_EnQueuedResultToString(e->enQueued.result);
			f[3].key = "REASON";
			f[3].val = e->enQueued.reason?strdup(e->enQueued.reason):NULL;
			assert(4<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_DEQUEUED:
			f[0].key = "QUEUE";
			f[0].val = e->deQueued.queue?strdup(e->deQueued.queue):NULL;
			f[1].key = "LOCAL_JOBID";
			f[1].val = e->deQueued.local_jobid?strdup(e->deQueued.local_jobid):NULL;
			assert(2<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_HELPERCALL:
			f[0].key = "HELPER_NAME";
			f[0].val = e->helperCall.helper_name?strdup(e->helperCall.helper_name):NULL;
			f[1].key = "HELPER_PARAMS";
			f[1].val = e->helperCall.helper_params?strdup(e->helperCall.helper_params):NULL;
			f[2].key = "SRC_ROLE";
			f[2].val = edg_wll_HelperCallSrc_roleToString(e->helperCall.src_role);
			assert(3<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_HELPERRETURN:
			f[0].key = "HELPER_NAME";
			f[0].val = e->helperReturn.helper_name?strdup(e->helperReturn.helper_name):NULL;
			f[1].key = "RETVAL";
			f[1].val = e->helperReturn.retval?strdup(e->helperReturn.retval):NULL;
			f[2].key = "SRC_ROLE";
			f[2].val = edg_wll_HelperReturnSrc_roleToString(e->helperReturn.src_role);
			assert(3<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_RUNNING:
			f[0].key = "NODE";
			f[0].val = e->running.node?strdup(e->running.node):NULL;
			assert(1<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_RESUBMISSION:
			f[0].key = "RESULT";
			f[0].val = edg_wll_ResubmissionResultToString(e->resubmission.result);
			f[1].key = "REASON";
			f[1].val = e->resubmission.reason?strdup(e->resubmission.reason):NULL;
			f[2].key = "TAG";
			f[2].val = e->resubmission.tag?strdup(e->resubmission.tag):NULL;
			assert(3<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_DONE:
			f[0].key = "STATUS_CODE";
			f[0].val = edg_wll_DoneStatus_codeToString(e->done.status_code);
			f[1].key = "REASON";
			f[1].val = e->done.reason?strdup(e->done.reason):NULL;
			f[2].key = "EXIT_CODE";
			asprintf(&f[2].val,"%d",e->done.exit_code);
			assert(3<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_CANCEL:
			f[0].key = "STATUS_CODE";
			f[0].val = edg_wll_CancelStatus_codeToString(e->cancel.status_code);
			f[1].key = "REASON";
			f[1].val = e->cancel.reason?strdup(e->cancel.reason):NULL;
			assert(2<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_ABORT:
			f[0].key = "REASON";
			f[0].val = e->abort.reason?strdup(e->abort.reason):NULL;
			assert(1<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_CLEAR:
			f[0].key = "REASON";
			f[0].val = edg_wll_ClearReasonToString(e->clear.reason);
			assert(1<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_PURGE:
			assert(0<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_MATCH:
			f[0].key = "DEST_ID";
			f[0].val = e->match.dest_id?strdup(e->match.dest_id):NULL;
			assert(1<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_PENDING:
			f[0].key = "REASON";
			f[0].val = e->pending.reason?strdup(e->pending.reason):NULL;
			assert(1<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_REGJOB:
			f[0].key = "JDL";
			f[0].val = e->regJob.jdl?strdup(e->regJob.jdl):NULL;
			f[1].key = "NS";
			f[1].val = e->regJob.ns?strdup(e->regJob.ns):NULL;
			f[2].key = "PARENT";
			f[2].val = edg_wlc_JobIdUnparse(e->regJob.parent);
			f[3].key = "JOBTYPE";
			f[3].val = edg_wll_RegJobJobtypeToString(e->regJob.jobtype);
			f[4].key = "NSUBJOBS";
			asprintf(&f[4].val,"%d",e->regJob.nsubjobs);
			f[5].key = "SEED";
			f[5].val = e->regJob.seed?strdup(e->regJob.seed):NULL;
			assert(6<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_CHKPT:
			f[0].key = "TAG";
			f[0].val = e->chkpt.tag?strdup(e->chkpt.tag):NULL;
			f[1].key = "CLASSAD";
			f[1].val = e->chkpt.classad?strdup(e->chkpt.classad):NULL;
			assert(2<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_LISTENER:
			f[0].key = "SVC_NAME";
			f[0].val = e->listener.svc_name?strdup(e->listener.svc_name):NULL;
			f[1].key = "SVC_HOST";
			f[1].val = e->listener.svc_host?strdup(e->listener.svc_host):NULL;
			f[2].key = "SVC_PORT";
			asprintf(&f[2].val,"%d",(int) e->listener.svc_port);
			assert(3<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_CURDESCR:
			f[0].key = "DESCR";
			f[0].val = e->curDescr.descr?strdup(e->curDescr.descr):NULL;
			assert(1<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_USERTAG:
			f[0].key = "NAME";
			f[0].val = e->userTag.name?strdup(e->userTag.name):NULL;
			f[1].key = "VALUE";
			f[1].val = e->userTag.value?strdup(e->userTag.value):NULL;
			assert(2<sizeof f/sizeof f[0]);
			break;
		case EDG_WLL_EVENT_CHANGEACL:
			f[0].key = "USER_ID";
			f[0].val = e->changeACL.user_id?strdup(e->changeACL.user_id):NULL;
			f[1].key = "USER_ID_TYPE";
			asprintf(&f[1].val,"%d",e->changeACL.user_id_type);
			f[2].key = "PERMISSION";
			asprintf(&f[2].val,"%d",e->changeACL.permission);
			f[3].key = "PERMISSION_TYPE";
			asprintf(&f[3].val,"%d",e->changeACL.permission_type);
			f[4].key = "OPERATION";
			asprintf(&f[4].val,"%d",e->changeACL.operation);
			assert(5<sizeof f/sizeof f[0]);
			break;
		default:
			break;
	}

	for (i=0; i<sizeof(f)/sizeof(f[0]) && !err; i++) if (f[i].key && f[i].val) {
		trio_asprintf(&stmt,"insert into %s(jobid,event,name,value) "
			"values ('%|Ss',%d,'%|Ss','%|Ss')",
			strlen(f[i].val) <= SHORT_LEN ? "short_fields" : "long_fields",
			jobid,no,f[i].key,f[i].val);

		if (edg_wll_ExecStmt(ctx,stmt,NULL) < 0) err = edg_wll_Error(ctx,NULL,NULL);
		free(stmt);
	}
	for (i=0; i<sizeof(f)/sizeof(f[0]); i++) free(f[i].val);

/* XXX: hardcoded, no other suitable place to store it */
	trio_asprintf(&stmt,"insert into short_fields(jobid,event,name,value) "
		"values ('%|Ss',%d,'SRC_INSTANCE','%|Ss')",
		jobid,no,e->any.src_instance);
	if (edg_wll_ExecStmt(ctx,stmt,NULL) < 0) err = edg_wll_Error(ctx,NULL,NULL);
	free(stmt);

	return err;
}

static int check_dup(edg_wll_Context ctx,edg_wll_Event *e)
{
	int		i,dup_detected = 0;
	int		err;
	char		*es,*es2;
	edg_wll_QueryRec	jc[2],ec[2];
	edg_wll_QueryRec        **jca, **eca;
	edg_wll_Event	*e2;

	edg_wll_ResetError(ctx);

	jc[0].attr = EDG_WLL_QUERY_ATTR_JOBID;
	jc[0].value.j = e->any.jobId;
	jc[0].op = EDG_WLL_QUERY_OP_EQUAL;
	jc[1].attr = EDG_WLL_QUERY_ATTR_UNDEF;

	ec[0].attr = EDG_WLL_QUERY_ATTR_TIME;
	memcpy(&ec[0].value.t,&e->any.timestamp,sizeof(struct timeval));
	ec[0].op = EDG_WLL_QUERY_OP_EQUAL;
	ec[1].attr = EDG_WLL_QUERY_ATTR_UNDEF;

        jca = (edg_wll_QueryRec **) malloc (2 * sizeof(edg_wll_QueryRec **));
        eca = (edg_wll_QueryRec **) malloc (2 * sizeof(edg_wll_QueryRec **));
        jca[0] = jc;
        jca[1] = NULL;
        eca[0] = ec;
        eca[1] = NULL;

	err = edg_wll_QueryEventsServer(ctx,1,(const edg_wll_QueryRec **)jca, 
					(const edg_wll_QueryRec **)eca,&e2);
	switch (err) {
		case 0: /* continue normally */
			break;
		case ENOENT:
			free(jca);
			free(eca);
			return edg_wll_ResetError(ctx);
			break;
		default:
			free(jca);
			free(eca);
			return edg_wll_Error(ctx,NULL,NULL);
			break;
	}

	es = edg_wll_UnparseEvent(ctx,e);
	assert(es);

	for (i=0;e2[i].type && !dup_detected;i++) {
		/* Ignore priority */
		e2[i].any.priority = e->any.priority;
		es2 = edg_wll_UnparseEvent(ctx,e2+i);
		assert(es2);
		if (!strcmp(es,es2)) {
			dup_detected = 1;
			edg_wll_SetError(ctx,EEXIST,"duplicate event");
		}
		free(es2);
	}

	free(jca);
	free(eca);
	free(es);
	for (i=0; e2[i].type; i++) edg_wll_FreeEvent(e2+i);
	free(e2);
	return edg_wll_Error(ctx,NULL,NULL);
}

static int check_auth(edg_wll_Context ctx,edg_wll_Event *e)
{
	char	*jobid = edg_wlc_JobIdGetUnique(e->any.jobId);
	char	*q = NULL,*owner = NULL;
	edg_wll_Stmt	stmt = NULL;
	char	*user;

	edg_wll_ResetError(ctx);

	if (e->type == EDG_WLL_EVENT_REGJOB) 
		return strcmp(e->any.user,EDG_WLL_LOG_USER_DEFAULT) ?
			0 : edg_wll_SetError(ctx,EPERM,"can't register jobs anonymously");

	trio_asprintf(&q,"select userid from jobs where jobid='%|Ss'",jobid);

	if (edg_wll_ExecStmt(ctx,q,&stmt) < 0
		|| edg_wll_FetchRow(stmt,&owner) < 0
	) goto clean;

	if (!owner) {
		edg_wll_SetError(ctx,ENOENT,"job not registered");
		goto clean;
	}

	switch (e->any.source) {
		case EDG_WLL_SOURCE_USER_INTERFACE:
		case EDG_WLL_SOURCE_LRMS:
		case EDG_WLL_SOURCE_APPLICATION:
			user = strmd5(e->any.user,NULL);
			if (strcmp(owner,user)) edg_wll_SetError(ctx,EPERM,"check_auth()");
			break;
		default:
			/* XXX: just don't allow anonymous */
			if (!strcmp(e->any.user,EDG_WLL_LOG_USER_DEFAULT))
				edg_wll_SetError(ctx,EPERM,"check_auth()");
			break;
	}


clean:
	if (stmt) edg_wll_FreeStmt(&stmt);
	free(q);
	free(owner);
	return edg_wll_Error(ctx,NULL,NULL);
}

static int register_subjobs(edg_wll_Context ctx,const edg_wll_RegJobEvent *e)
{
	int	i,err;
	edg_wlc_JobId	*subjobs;
	struct timeval	now;

	edg_wll_ResetError(ctx);
	if (e->nsubjobs == 0) return 0;
	if (e->nsubjobs < 0) return edg_wll_SetError(ctx,EINVAL,"negative number of subjobs");

	if ((err = edg_wll_GenerateSubjobIds(ctx,e->jobId,e->nsubjobs,e->seed,&subjobs)))
		return err;

	gettimeofday(&now,NULL);

	for (i=0; i<e->nsubjobs; i++) {
		edg_wll_Event	e2;
		int		seq;
		char		*et,*ed,*job_s;

		memset(&e2,0,sizeof e2);
		e2.type = EDG_WLL_EVENT_REGJOB;
		e2.any.jobId = subjobs[i]; subjobs[i] = NULL;
		memcpy(&e2.regJob.timestamp,&now,sizeof now);
		e2.any.host = strdup(ctx->srvName);
		e2.any.level = e->level;
		e2.any.priority = e->priority;
		e2.any.seqcode = NULL;		/* XXX: I'm not sure :-( */
		e2.any.user = strdup(e->user);
		e2.any.source = e->source;
		e2.regJob.ns = strdup(e->ns);
		edg_wlc_JobIdDup(e->jobId,&e2.regJob.parent);
		e2.regJob.jobtype = EDG_WLL_REGJOB_SIMPLE;
		e2.regJob.jdl = strdup("");

		switch (edg_wll_StoreEvent(ctx,&e2,&seq)) {

			case 0: break;
			/* maybe some non-ignorable errors should be handled here */

			default: 
				edg_wll_Error(ctx,&et,&ed);
				job_s = edg_wlc_JobIdUnparse(e2.any.jobId);
				fprintf(stderr,"register subjob %s: %s (%s)\n",job_s,et,ed);
				syslog(LOG_ERR,"register subjob %s: %s (%s)",job_s,et,ed);
				free(job_s); free(et); free(ed);
				edg_wll_FreeEvent(&e2);
				edg_wll_ResetError(ctx);
				continue;
		}

		if (edg_wll_LockJob(ctx,e2.any.jobId)) {
			job_s = edg_wlc_JobIdUnparse(e2.any.jobId);
			fprintf(stderr,"lock job %s: %s (%s)\n",job_s,et,ed);
			syslog(LOG_ERR,"lock job %s: %s (%s)",job_s,et,ed);
			free(job_s); free(et); free(ed);
			edg_wll_FreeEvent(&e2);
			edg_wll_ResetError(ctx);
			continue;
		}

		if ((err = edg_wll_StepIntState(ctx,e2.any.jobId,&e2,seq)))
			edg_wll_Error(ctx,&et,&ed);

		edg_wll_UnlockJob(ctx,e2.any.jobId);
		edg_wll_ResetError(ctx);

		if (err) {
			job_s = edg_wlc_JobIdUnparse(e2.any.jobId);
			fprintf(stderr,"%s: %s (%s)\n",job_s,et,ed);
			syslog(LOG_ERR,"%s: %s (%s)",job_s,et,ed);
			free(job_s); free(et); free(ed);
			edg_wll_ResetError(ctx);
		}

		edg_wll_FreeEvent(&e2);
	}

	return edg_wll_Error(ctx,NULL,NULL);
}

int edg_wll_delete_event(edg_wll_Context ctx,const char *jobid,int event)
{
	char	*stmt;

/* The order of tables is important to prevent another process calling
 * StoreEvent() to get our event number and mess up the fields together.
 *
 * XXX: best effort: more or less ignore errors
 *
 */

	trio_asprintf(&stmt,
		"delete from short_fields where jobid='%|Ss' and event=%d",
		jobid,event);
	edg_wll_ExecStmt(ctx,stmt,NULL);
	free(stmt);

	trio_asprintf(&stmt,
		"delete from long_fields where jobid='%|Ss' and event=%d",
		jobid,event);
	edg_wll_ExecStmt(ctx,stmt,NULL);
	free(stmt);

	trio_asprintf(&stmt,
		"delete from events where jobid='%|Ss' and event=%d",
		jobid,event);
	edg_wll_ExecStmt(ctx,stmt,NULL);
	free (stmt);

	return edg_wll_Error(ctx,NULL,NULL);
}
