#ident "$Header: /local/reps/lcgware/workload/logging/lbserver/userjobs.c,v 1.14 2002/10/24 16:05:42 ljocha Exp $"

#include "edg/workload/logging/lbserver/lbs_db.h"
#include "edg/workload/logging/common/context.h"

#include "edg/workload/common/jobid/jobid.h"
#include "edg/workload/common/jobid/strmd5.h"
#include "edg/workload/thirdparty/trio/trio.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

int edg_wll_UserJobs(
	edg_wll_Context ctx,
	edg_wlc_JobId	**jobs,
	edg_wll_JobStat	**states)
{
	char	*userid = strmd5(ctx->peerName,NULL),*stmt = NULL,
		*res = NULL;
	int	njobs = 0,ret,i;
	edg_wlc_JobId	*out = NULL;
	edg_wll_Stmt	sth = NULL;
	edg_wll_ErrorCode	err = 0;

	edg_wll_ResetError(ctx);

	trio_asprintf(&stmt,"select cert_subj from users where userid = '%|Ss'",userid);

	switch (edg_wll_ExecStmt(ctx,stmt,&sth)) {
		case 0: edg_wll_SetError(ctx,ENOENT,ctx->peerName);
		case -1: goto err;
		default:
			if (edg_wll_FetchRow(sth,&res) < 0) goto err;
			if (strcmp(ctx->peerName,res)) {
				edg_wll_SetError(ctx,EDG_WLL_ERROR_MD5_CLASH,ctx->peerName);
				goto err;
			}
	}

	edg_wll_FreeStmt(&sth);
	free(stmt); stmt = NULL;
	free(res); res = NULL;

	trio_asprintf(&stmt,"select dg_jobid from jobs where userid = '%|Ss'",userid);
	switch (njobs = edg_wll_ExecStmt(ctx,stmt,&sth)) {
		case 0: edg_wll_SetError(ctx,ENOENT,ctx->peerName);
		case -1: goto err;
	}

	out = malloc(sizeof(*out)*(njobs+1));
	memset(out,0,sizeof(*out)*(njobs+1));
	
	for (i=0; (ret = edg_wll_FetchRow(sth,&res)); i++) {
		if (ret < 0) goto err;
		if ((ret = edg_wlc_JobIdParse(res,out+i))) {
			edg_wll_SetError(ctx,errno,res);
			goto err;
		}
		free(res); res = NULL;
	}

err:
	free(res);
	free(stmt);
	edg_wll_FreeStmt(&sth);
	if ((err = edg_wll_Error(ctx,NULL,NULL))) {
		if (out) {
		    for (i=0; i<njobs; i++)
			edg_wlc_JobIdFree(out[i]);
		    free(out);
		}
	} else *jobs = out;

	return err;
}
