#include "edg/workload/networkserver/commands/Command.h"
#include "edg/workload/networkserver/commands/fsm/Jump.h"

namespace edg {
namespace workload {
namespace networkserver {
namespace commands {
namespace fsm {

Jump::Jump(const std::string& s) : stepsName(s)
{  
  steps = -1;
} 

Jump::Jump(const int i)
{  
  steps = i;
}

bool Jump::execute(commands::Command* cmd)
{
  if (steps == -1) {
    if (!cmd->getParam(stepsName, steps)) return false;
  }
  
  for (int i = 0; i < steps; i++) {
    if( cmd -> fsm -> empty() ) { return false; }
    cmd -> fsm -> pop();
  }

  return true;
}

} // namespace fsm
} // namespace comamnds
} // namespace networkserver
} // namespace workload
} // namespace edg


