/*
 * File: NetworkServer.cpp
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

#include "edg/workload/networkserver/daemon/NetworkServer.h"
#include "edg/workload/networkserver/daemon/NetworkServerImpl.h"
#include "edg/workload/networkserver/daemon/NetworkServerReal.h"

namespace edg {
namespace workload {
namespace networkserver {
namespace daemon {

namespace configuration = workload::common::configuration;
 
static NetworkServerImpl* create_ns_impl();

NetworkServer::NetworkServer() : 
  m_impl(create_ns_impl())
{
}
 
NetworkServer::~NetworkServer()
{
 delete m_impl;
}
 
void NetworkServer::run()
{
 m_impl -> run();
}

void NetworkServer::init()
{
 m_impl -> init();
}

void NetworkServer::shutdown()
{
 m_impl -> shutdown();
}

void NetworkServer::drop_privileges()
{
 m_impl -> drop_privileges();
}

const configuration::NSConfiguration& NetworkServer::configuration() 
{
 return m_impl -> configuration();
}

NetworkServerImpl* create_ns_impl()
{
 return new NetworkServerReal;
}


} // namespace daemon
} // namespace networkserver
} // namespace workload
} // namespace edg
