// File: RBMinimizeAccessCostImpl.cpp
// Author: Salvatore Monforte <Salvatore.Monforte@ct.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: RBMinimizeAccessCostImpl.cpp,v 1.15 2006/02/27 17:38:29 dhsmith Exp $ 

#include <algorithm>
#include <functional>
#include <numeric>
#include <vector> 

#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/tuple/tuple.hpp>
#include <classad_distribution.h>
#include "edg/workload/common/requestad/ManipulationExceptions.h"
#include "edg/workload/common/requestad/JobAdManipulation.h"

#include "edg/workload/planning/broker/matchmaking/matchmakerGlueImpl.h"
#include "edg/workload/planning/broker/matchmaking/glue_attributes.h"
#include "edg/workload/planning/broker/matchmaking/jdl_attributes.h"
#include "edg/workload/planning/broker/RBMinimizeAccessCostImpl.h"
#include "edg/workload/planning/broker/utility.h"
#include "edg/workload/planning/broker/rls/ReplicaServiceReal.h"
#include "edg/workload/common/logger/edglog.h"
#include "edg/workload/common/logger/manipulators.h"

#define edglog(level) logger::threadsafe::edglog << logger::setlevel(logger::level)
#define edglog_fn(name) logger::StatePusher    pusher(logger::threadsafe::edglog, #name);

using namespace std;

namespace edg {
namespace workload {
	
namespace logger        = common::logger;
namespace requestad = common::requestad;
	
namespace planning {
namespace broker {

using namespace matchmaking;
using namespace brokerinfo;
using namespace rls;

RBMinimizeAccessCostImpl::RBMinimizeAccessCostImpl(matchmaking::brokerinfo::BrokerInfo<matchmaking::brokerinfo::brokerinfoGlueImpl> *bi)
{
	BI = bi;
}
 
RBMinimizeAccessCostImpl::~RBMinimizeAccessCostImpl()
{
}

match_table_t* RBMinimizeAccessCostImpl::findSuitableCEs(const classad::ClassAd* requestAd)
{
  edglog_fn(RBMinimizeAccessCostImpl::findSuitableCEs);

  if (!requestAd) return 0;

  edglog( info ) << "AccessCost not implemented in LCG, returning no matches" << endl << flush;
  throw (std::string("AccessCost not implemented in LCG, returning no matches"));
  return 0;
}

} // namespace broker
} // namespace planning
} // namespace workload
} // namespace edg

