// File: JCCancellingPolicy.cpp
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: JCCancellingPolicy.cpp,v 1.3 2003/09/09 06:46:33 giaco Exp $

#include "edg/workload/planning/manager/JCCancellingPolicy.h"
#include "edg/workload/planning/manager/lb_utils.h"
#include "edg/workload/planning/common/logger_utils.h"
#include "edg/workload/common/jobid/JobId.h"
#include "edg/workload/jobcontrol/controller/JobController.h"

namespace jobid = edg::workload::common::jobid;

namespace edg {
namespace workload {
namespace planning {
namespace manager {

JCCancellingPolicy::~JCCancellingPolicy()
{
}

void JCCancellingPolicy::Cancel(common::jobid::JobId const& id)
{
  Debug("cancelling job " << id);

  ContextPtr context_ptr = get_context(id);
  assert(context_ptr);
  assert(unregister_context(id));
  edg_wll_Context context = *context_ptr;
  jobcontrol::controller::JobController(&context).cancel(id);
}

}}}} // edg::workload::planning::manager

