// File: JCDeliveryPolicy.cpp
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: JCDeliveryPolicy.cpp,v 1.5 2003/09/09 06:46:33 giaco Exp $

#include "edg/workload/planning/manager/JCDeliveryPolicy.h"
#include <string>
#include <classad_distribution.h>
#include "edg/workload/planning/manager/dispatching_utils.h"
#include "edg/workload/planning/manager/lb_utils.h"
#include "edg/workload/planning/common/logger_utils.h"
#include "edg/workload/jobcontrol/controller/JobController.h"
#include "edg/workload/common/jobid/JobId.h"
#include "edg/workload/common/requestad/JobAdManipulation.h"

namespace edg {
namespace workload {
namespace planning {
namespace manager {

JCDeliveryPolicy::~JCDeliveryPolicy()
{
}

void
JCDeliveryPolicy::Deliver(classad::ClassAd const& ad)
{
  common::jobid::JobId id(common::requestad::get_edg_jobid(ad));

  boost::mutex::scoped_lock l(submit_cancel_mutex());
  ContextPtr context_ptr = get_context(id);
  if (unregister_context(id)) {
    Debug("delivering job " << id);
    edg_wll_Context context = *context_ptr;
    jobcontrol::controller::JobController(&context).submit(&ad);
  }
}

}}}} // edg::workload::planning::manager

