// File: signal_handling.c
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: signal_handling.cpp,v 1.1 2003/04/14 13:27:20 giaco Exp $

#include "edg/workload/planning/manager/signal_handling.h"
#include <csignal>

static std::sig_atomic_t f_received_quit_signal;

extern "C" {
  void signal_handler(int)
  {
    f_received_quit_signal = 1;
  }
}

namespace edg {
namespace workload {
namespace planning {
namespace manager {

void signal_handling_init()
{
  std::signal(SIGPIPE, SIG_IGN);
  std::signal(SIGINT, signal_handler);
  std::signal(SIGTERM, signal_handler);
  std::signal(SIGQUIT, signal_handler);
}

bool received_quit_signal()
{
  return f_received_quit_signal != 0;
}

}}}} // edg::workload::planning::manager
