/*
 * File: edg-classad-plugin-loader.cpp
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

// $Id: edg-classad-plugin-loader.cpp,v 1.5 2005/11/11 16:03:01 dhsmith Exp $

#define ENABLE_SHARED_LIBRARY_FUNCTIONS

#include <edg-classad-plugin-loader.h>
#include <classad_distribution.h>
#include <fnCall.h>

namespace edg {
namespace workload {
namespace planning {
namespace plugin {

boost::mutex	classad_plugin_loader::mtx;
int 		classad_plugin_loader::count=0;
bool            classad_plugin_loader::loaded=false;

classad_plugin_loader::classad_plugin_loader()	
{
  boost::mutex::scoped_lock lk(mtx);
  if (count++ && !loaded) {

	  classad::ClassAdParser parser;
          loaded = classad::FunctionCall::RegisterSharedLibraryFunctions("libedg_wl_classad_plugin.so");
  }
}

classad_plugin_loader::~classad_plugin_loader()
{
  boost::mutex::scoped_lock lk(mtx);
  if (count>0 && --count==0 && loaded) {
  
	  // the classad library does not provide any function to
	  // unregister previous registered functions..
          // loaded = false;
  }
}

} // namespace plugin
} // namespace planning
} // namespace workload
} // namespace edg
