/*
 * File: edg-classad-plugin.cpp
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

// $Id: edg-classad-plugin.cpp,v 1.2 2003/07/29 10:16:35 monforte Exp $

#include <classad_distribution.h>
#include <fnCall.h>

using namespace std;
#ifdef WANT_NAMESPACES
using namespace classad;
#endif

namespace edg {
namespace workload {
namespace planning {
namespace plugin {
	
extern bool doMatch         	 (const char *, const ArgumentList&, EvalState&, Value&);
extern bool listAttrRegEx  	 (const char *, const ArgumentList&, EvalState&, Value&);
extern bool retrieveCloseSEsInfo (const char *, const ArgumentList&, EvalState&, Value&);

static ClassAdFunctionMapping functions[] = 
  {
    { "anyMatch",      		(void*) doMatch,       		0  },
    { "allMatch",      		(void*) doMatch,       		0  },
    { "whichMatch",    		(void*) doMatch,       		0  },
    { "listAttrRegEx", 		(void*) listAttrRegEx, 		0  },
    { "retrieveCloseSEsInfo",	(void*) retrieveCloseSEsInfo,	0  },	
    { "", NULL, 0 }
};

} // namespace plugin
} // namespace planning
} // namespace workload
} // namespace edg

namespace plugin = edg::workload::planning::plugin;

extern "C" 
{ 
  ClassAdFunctionMapping *Init(void) 
  {
    return plugin::functions; 
  }
}
