#include "grid_console.h"
/*
Bypass
Copyright (C) 1999-2001 Douglas Thain
http://www.cs.wisc.edu/condor/bypass
This program is released under the GNU General Public License.
See the file COPYING for details.
*/


extern "C" {

#include <stdarg.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>

#include <sys/types.h>  //getpid

#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/poll.h>
#include <sys/wait.h>
#include <signal.h>

#ifdef USE_PTHREADS
	#include <pthread.h>
#endif

}

#include <fstream>  //logfile



int global_bypass_fd = 0;

extern "C" int isatty( int fd );
extern "C" void _exit( int status );
extern "C" ssize_t write( int fd, const void* data, size_t length );
extern "C" ssize_t read( int fd, void* data, size_t length );
extern "C" off_t lseek( int fd, off_t offset, int whence );
extern "C" int close( int fd );
extern "C" int open( const char* path, int flags, ... );
extern "C" int poll( struct pollfd* ufds, unsigned long nfds, int timeout );
static int bypass_shadow_action_isatty( int fd )
{
	return isatty( fd );

}

static void bypass_shadow_action__exit( int status )
{
_exit( status );

}

static ssize_t bypass_shadow_action_write( int fd, void* data, size_t length )
{
	return write( fd, (void*)data, length );

}

static ssize_t bypass_shadow_action_read( int fd, void* data, size_t length )
{
	return read( fd, data, length );

}

static off_t bypass_shadow_action_lseek( int fd, off_t offset, int whence )
{
	return lseek( fd, offset, whence );

}

static int bypass_shadow_action_close( int fd )
{
	return close( fd );

}

static int bypass_shadow_action_open( char* path, int flags, ... )
{
	va_list bypass_arglist;
	va_start(bypass_arglist,flags);
	int	mode;
	mode = va_arg(bypass_arglist,int);
	va_end(bypass_arglist);
	return open( (char*)path, flags, mode );

}

static int bypass_shadow_action_poll( struct pollfd* ufds, unsigned long nfds, int timeout )
{
	return poll( ufds, nfds, timeout );

}

/*
Bypass
Copyright (C) 1999-2001 Douglas Thain
http://www.cs.wisc.edu/condor/bypass
This program is released under the GNU General Public License.
See the file COPYING for details.
*/

#include "network.h"
#include "packet.h"
#include "external.h"
#include "external_unix.h"
#include "pattern.h"
#include "auth.h"

#define TRY(x) if(!(x)) goto fail;

extern "C" int bypass_receive_call( int bypass_fd )
{
	int	bypass_errno = 0;
	int 	bypass_number = 0;

	struct packet *bypass_packet, *bypass_response;

	bypass_packet = packet_get(bypass_fd);
	if(!bypass_packet) return -1;

	bypass_response = packet_create(0);
	if(!bypass_response) {
		packet_delete(bypass_packet);
		return -1;
	}

	if(!external(bypass_packet,EXTERNAL_IN,&bypass_number)) goto fail;

	switch(bypass_number) {




		case BYPASS_CALL_isatty:
		{
		int result;
		int fd=0;
		TRY(external(bypass_packet,EXTERNAL_IN,&fd));
		errno = 0;
		result =bypass_shadow_action_isatty( fd );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		TRY(external(bypass_response,EXTERNAL_OUT,&result));
		}
		break;

		case BYPASS_CALL__exit:
		{
		int status=0;
		TRY(external(bypass_packet,EXTERNAL_IN,&status));
		errno = 0;
		bypass_shadow_action__exit( status );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		}
		break;

		case BYPASS_CALL_write:
		{
		ssize_t result;
		int fd=0;
		void* data=0;
		size_t length=0;
		TRY(external(bypass_packet,EXTERNAL_IN,&fd));
		TRY(external_opaque(bypass_packet,EXTERNAL_IN,(char**)&data,length));
		TRY(external(bypass_packet,EXTERNAL_IN,&length));
		errno = 0;
		result =bypass_shadow_action_write( fd, data, length );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		TRY(external(bypass_response,EXTERNAL_OUT,&result));
		}
		break;

		case BYPASS_CALL_read:
		{
		ssize_t result;
		int fd=0;
		void* data=0;
		size_t length=0;
		TRY(external(bypass_packet,EXTERNAL_IN,&fd));
		TRY(external(bypass_packet,EXTERNAL_IN,&length));
		TRY(data = (void*) packet_alloc(bypass_response,length));
		errno = 0;
		result =bypass_shadow_action_read( fd, data, length );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		TRY(external(bypass_response,EXTERNAL_OUT,&result));
		TRY(external_opaque(bypass_response,EXTERNAL_OUT,(char**)&data,length));
		}
		break;

		case BYPASS_CALL_lseek:
		{
		off_t result;
		int fd=0;
		off_t offset=0;
		int whence=0;
		TRY(external(bypass_packet,EXTERNAL_IN,&fd));
		TRY(external(bypass_packet,EXTERNAL_IN,&offset));
		TRY(external(bypass_packet,EXTERNAL_IN,&whence));
		errno = 0;
		result =bypass_shadow_action_lseek( fd, offset, whence );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		TRY(external(bypass_response,EXTERNAL_OUT,&result));
		}
		break;

		case BYPASS_CALL_close:
		{
		int result;
		int fd=0;
		TRY(external(bypass_packet,EXTERNAL_IN,&fd));
		errno = 0;
		result =bypass_shadow_action_close( fd );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		TRY(external(bypass_response,EXTERNAL_OUT,&result));
		}
		break;

		case BYPASS_CALL_open:
		{
		int result;
		char* path=0;
		int flags=0;
		int mode=0;
		TRY(external_string(bypass_packet,EXTERNAL_IN,&path,0));
		TRY(external_open_map(bypass_packet,EXTERNAL_IN,&flags));
		TRY(external(bypass_packet,EXTERNAL_IN,&mode));
		errno = 0;
		result =bypass_shadow_action_open( path, flags, mode );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		TRY(external(bypass_response,EXTERNAL_OUT,&result));
		}
		break;

		case BYPASS_CALL_poll:
		{
		int result;
		struct pollfd* ufds=0;
		unsigned long nfds=0;
		int timeout=0;
		TRY(external_array(bypass_packet,EXTERNAL_IN,&ufds,nfds));
		TRY(external(bypass_packet,EXTERNAL_IN,&nfds));
		TRY(external(bypass_packet,EXTERNAL_IN,&timeout));
		errno = 0;
		result =bypass_shadow_action_poll( ufds, nfds, timeout );
		bypass_errno = errno;
		TRY(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno));
		TRY(external(bypass_response,EXTERNAL_OUT,&result));
		TRY(external_array(bypass_response,EXTERNAL_OUT,&ufds,nfds));
		}
		break;

/*
Bypass
Copyright (C) 1999-2001 Douglas Thain
http://www.cs.wisc.edu/condor/bypass
This program is released under the GNU General Public License.
See the file COPYING for details.
*/

		default:
			packet_delete(bypass_packet);
			bypass_packet = 0;
			goto fail;
	}

	if(packet_put( bypass_fd, bypass_response )) {
		packet_delete(bypass_response);
		bypass_response = 0;
	}

	fail:

	if(bypass_packet) {
		packet_delete(bypass_packet);
		bypass_packet = 0;
	}

	if(bypass_response) {
		packet_delete(bypass_response);
		bypass_response = 0;

		bypass_response = packet_create(0);
		bypass_errno = EINVAL;
		if(external_errno_map(bypass_response,EXTERNAL_OUT,&bypass_errno)) {
			if(!packet_put(bypass_fd,bypass_response)) {
				packet_delete(bypass_response);
				bypass_response = 0;
			}
		}
	}

	if(bypass_response) {
		packet_delete(bypass_response);
		return -1;
	} else {
		return bypass_number;
	}
}

static int debug=0;
static char *authfile=0;
static char *logFile=0;
static int enable_globus_auth=0;
static int enable_trivial_auth=0;

char *bypass_call_string( int call );

static void handle_one_client( int client )
{
	char addrstr[256];
	char *subject;
	int addr, port;
	int callnum;

	network_address_remote( client, &addr, &port );
	network_address_to_string( addr, addrstr );
	network_tune( client, NETWORK_TUNE_INTERACTIVE );

	if(debug) {
		fprintf(stderr,"%s connected\n",addrstr);
	}

	if(!auth_accept(client,&subject,debug)) {
		fprintf(stderr,"%s couldn't authenticate user\n",addrstr);
		network_close(client);
		return;
	}

	if(authfile) {
		if(auth_lookup(subject,authfile)) {
			if(debug) {
				fprintf(stderr,"%s '%s' is authorized\n",addrstr,subject);
			}
		} else {
			fprintf(stderr,"%s '%s' is *not* authorized\n",addrstr,subject);
			network_close(client);
			return;
		}
	} else {
		if(debug) {
			fprintf(stderr,"%s no authfile, so '%s' is authorized by default\n",addrstr,subject);
		}
	}

	while(1) {
		global_bypass_fd = client;
		callnum = bypass_receive_call(client);
		if( callnum==-1 ) {
			if(debug) {
				fprintf(stderr,"%s disconnected\n",addrstr);
			}
			break;
		} else {
			if( debug ) {
				fprintf(stderr,"%s called %s\n",addrstr,bypass_call_string(callnum));
			}
		}
	}

	network_close( client );
}

/* We don't really care when or how children exit, but we must wait() to reap the dead process */

static void child_handler( int sig )
{
	int result=1;
	while(result>0) {
		result = waitpid(-1,0,WNOHANG);
	}
	signal(SIGCHLD,child_handler);
}

#include <fstream>

int main(int argc, char *argv[])
{
	enum { ONESHOT, MULTIPROCESS, MULTITHREAD } mode=MULTIPROCESS;
	int server, client;
	char server_str[256];
	network_address server_address;
	int server_port=0,i;
	pid_t child_pid;

	#ifdef USE_PTHREADS
		pthread_t child_tid;
	#endif

	#ifdef USE_GLOBUS_GSS
		enable_globus_auth = 1;
		enable_trivial_auth = 0;
	#else
		enable_globus_auth = 0;
		enable_trivial_auth = 1;
	#endif


	for( i=1; i<argc; i++ ) {
		if(!strcmp(argv[i],"-oneshot")) {
			mode = ONESHOT;
		} else if(!strcmp(argv[i],"-multiprocess")) {
			mode = MULTIPROCESS;
		} else if(!strcmp(argv[i],"-multithread")) {
			#ifdef USE_PTHREADS
				mode = MULTITHREAD;
			#else
				fprintf(stderr,"%s not supported.  Try re-building with -DUSE_PTHREADS\n",argv[i]);
			#endif
		} else if(!strcmp(argv[i],"-port")) {
			i++;
			if(i>=argc) {
				fprintf(stderr,"-port requires an argument.\n");
				return -1;
			}
			server_port = atoi(argv[i]);
		} else if(!strcmp(argv[i],"-authfile")) {
			i++;
			if(i>=argc) {
				fprintf(stderr,"-authfile requires an argument.\n");
				return -1;
			}
			authfile = argv[i];
		} else if(!strcmp(argv[i],"-enable-globus-auth")) {
			#ifdef USE_GLOBUS_GSS
				enable_globus_auth=1;
			#else
				fprintf(stderr,"%s not supported.  Try rebuilding with -DUSE_GLOBUS_GSS.\n",argv[i]);
			#endif
		} else if(!strcmp(argv[i],"-disable-globus-auth")) {
			enable_globus_auth=0;
		} else if(!strcmp(argv[i],"-enable-trivial-auth")) {
			enable_trivial_auth=1;
		} else if(!strcmp(argv[i],"-disable-trivial-auth")) {
			enable_trivial_auth=0;
		}
// #IFDEF EDG
		else if(!strcmp(argv[i],"-log-to-file")) {
			i++;
			if(i>=argc) {
				fprintf(stderr,"-log-to-file requires an argument.\n");
				return -1;
			}
			logFile = argv[i];
		}
// #ENDIF
		else if(!strcmp(argv[i],"-debug")) {
			debug=1;
		} else {
			fprintf(stderr,"Use: %s [options]\n",argv[0]);
			fprintf(stderr,"Options are:\n");
			fprintf(stderr,"    -multiprocess            Start a new process for every client\n");
			fprintf(stderr,"    -multithread             Start a new thread for every client\n");
			fprintf(stderr,"    -oneshot                 Accept one client and exit when done\n");
			fprintf(stderr,"    -port <number>           Listen for connections on this port\n");
			fprintf(stderr,"    -enable-globus-auth      Allow authentication using Globus GSS\n");
			fprintf(stderr,"    -disable-globus-auth     Do not allow the same\n");
			fprintf(stderr,"    -enable-trivial-auth     Allow authentication using the 'trivial' scheme\n");
			fprintf(stderr,"    -disable-trivial-auth    Do not allow the same\n");
			fprintf(stderr,"    -authfile <file>         File listing authorized users\n");
// #IFDEF EDG
			fprintf(stderr,"    -log-to-file <file>      Log Information into the specified file\n");
// #ENDIF			
			fprintf(stderr,"    -debug                   Show debugging output\n");
			return -1;
		}
	}

	if(enable_trivial_auth) {
		auth_trivial_register();
	}

	#ifdef USE_GLOBUS_GSS
		if(enable_globus_auth) {
			auth_globus_register();
		}
	#endif

	signal(SIGCHLD,child_handler);

	server = network_serve(server_port);
	if(server==-1) {
// #IFDEF EDG
		if(logFile) {
			// create the info pipeline:
                        int errno_appo = 0;
                        errno_appo = errno;
			struct stat buf ;
			stat( logFile , &buf);
			if (!S_ISFIFO( buf.st_mode )  )
                           mkfifo(logFile , 0600);
	                std::ofstream fout(logFile);
        	        fout <<"[\nSHADOW_ERROR=" << errno_appo ;
              	        fout << "\n]\n" ;
               	        fout.close();
		}else fprintf(stderr,"Unable to use port %d! (%s)\n",server_port,strerror(errno));

// #ENDIF
		return -1;
	}
	network_address_local( server, &server_address, &server_port );
	network_address_to_string( server_address, server_str );
	if(!logFile) {
		fprintf(stdout,"setenv BYPASS_SHADOW_HOST %s\n",server_str);
		fprintf(stdout,"setenv BYPASS_SHADOW_PORT %d\n",server_port);
		fprintf(stdout,"************************************************************");
		fprintf(stdout,"\n****************  Interactive Session Start ****************");
		fprintf(stdout,"\n************************************************************\n\n\n");
	}
// #IFDEF EDG
	if(logFile) {
		// create the pipelines:
		struct stat buf ;
		char in [128] , out[128] ;
		// Creating the input pipe line
		sprintf(in  , "%s%s" , logFile , ".in" );
		stat( in , &buf);
		if (!S_ISFIFO( buf.st_mode )  )
			mkfifo( in , 0666);
		// Creating the output pipe line
		sprintf(out , "%s%s" , logFile , ".out");
		stat( out , &buf);
		if (!S_ISFIFO( buf.st_mode )  )
			mkfifo( out , 0666);
		// Creating the info pipeline
		stat( logFile , &buf);
		if (!S_ISFIFO( buf.st_mode )  )
         		mkfifo(logFile , 0600);
         	std::ofstream fout(logFile);
         	fout <<"[\nPORT=" << server_port ;
         	fout <<";\nPID="<< getpid() ;
	 	fout << "\n]" ;
         	fout.close();
	 	}
// #ENDIF
	while(1) {
		client = network_accept(server);
		if(client<0) continue;

		switch(mode) {
			case MULTIPROCESS:
				child_pid = fork();
				if( child_pid>0 ) {
					network_close(client);
				} else if( child_pid==0 ) {
					handle_one_client(client);
					exit(0);
				} else {
					fprintf(stderr,"Unable to fork! (%s)\n",strerror(errno));
				}
				break;

			#ifdef USE_PTHREADS
				case MULTITHREAD:
					pthread_create( &child_tid, 0, (void * (*)(void *)) handle_one_client, (void*)client );
					pthread_detach( child_tid );
					break;
			#endif

			default:
				handle_one_client(client);
				exit(0);
				break;

		}
	}
}
/*
Bypass
Copyright (C) 1999-2001 Douglas Thain
http://www.cs.wisc.edu/condor/bypass
This program is released under the GNU General Public License.
See the file COPYING for details.
*/

static char * bypass_call_name_table[] = {

"isatty",
"_exit",
"write",
"read",
"lseek",
"close",
"open",
"poll",
};

char *bypass_call_string( int call_number )
{
	return bypass_call_name_table[call_number];
}
