/* **************************************************************************
*  filename  : AdWrapper.cpp
*  author    : Alessandro Maraschini <alessandro.maraschini@datamat.it>
*  copyright : (C) 2002 by DATAMAT
***************************************************************************/
#include "edg/workload/userinterface/common/AdWrapper.h"
#include "edg/workload/common/utilities/Exceptions.h"
#include <stdlib.h>
using namespace edg::workload::common::utilities ;
using namespace std ;
#ifdef WANT_NAMESPACES
using namespace classad;
#endif

#define EDG_WL_UI_COMMON_TRY_ERRROR try{ error_code = false ;
#define EDG_WL_UI_COMMON_CATCH_ERRROR \
} catch (Exception &exc){  error_code= true; error = exc.what(); \
} catch (exception &exc){  error_code= true; error = exc.what(); \
} catch (...){  error_code= true; error = "Fatal Error: Unpredictalbe exception thrown by swig wrapper"; }

// Constructor
AdWrapper::AdWrapper( int level ){
   if (level==0)  jad = new edg::workload::common::requestad::JobAd();
   else  jad = new edg::workload::common::requestad::Ad();

} ;
// Destructor
AdWrapper::~AdWrapper() {
  delete jad ;
}



int AdWrapper::get_error (string& err){
   err= error ;
   error ="";
   if (error_code)
     return 1;
   return 0;
};

bool AdWrapper::fromFile(const string  &jdl_file ){
   EDG_WL_UI_COMMON_TRY_ERRROR
     jad->fromFile(jdl_file ) ;
     return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
};
void  AdWrapper::printChar( const std::string &ch ) {  cout << ch << flush ;  };

bool AdWrapper::fromString(const string  &jdl ){
   EDG_WL_UI_COMMON_TRY_ERRROR
     jad->fromString( jdl ) ;
     return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
} ;


bool  AdWrapper::checkMulti( const std::vector <std::string>&  multi ){
   EDG_WL_UI_COMMON_TRY_ERRROR
      (    (edg::workload::common::requestad::JobAd*)  jad)->checkMultiAttribute( multi );
      return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
}


bool  AdWrapper::check(){   //DEPRECATED
   EDG_WL_UI_COMMON_TRY_ERRROR
      (    (edg::workload::common::requestad::JobAd*)  jad)->check();
      return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
}

string AdWrapper::toLines(){
   EDG_WL_UI_COMMON_TRY_ERRROR
      return jad->toLines() ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return "" ;
};

string AdWrapper::toString(){
   EDG_WL_UI_COMMON_TRY_ERRROR
      //jad->check() ;
      return ((edg::workload::common::requestad::JobAd*)jad)->toSubmissionString() ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return "" ;
};

bool  AdWrapper::removeAttribute (const string& attr_name){
   EDG_WL_UI_COMMON_TRY_ERRROR
       jad->delAttribute(attr_name ) ;
       return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
}
bool  AdWrapper::addAttributeStr (const string& attr_name, const string& attr_value) {
   EDG_WL_UI_COMMON_TRY_ERRROR
       jad->addAttribute(attr_name , attr_value) ;
       return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
};

bool  AdWrapper::setAttributeStr (const string& attr_name, const string& attr_value) {
   EDG_WL_UI_COMMON_TRY_ERRROR
       jad->setAttribute(attr_name , attr_value) ;
       return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
};
bool  AdWrapper::setAttributeInt (const string& attr_name, int attr_value) {
   EDG_WL_UI_COMMON_TRY_ERRROR
       jad->setAttribute(attr_name , attr_value) ;
       return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
};
bool  AdWrapper::setAttributeReal (const string& attr_name, double attr_value){
   EDG_WL_UI_COMMON_TRY_ERRROR
       jad->setAttribute(attr_name , attr_value) ;
       return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
} ;
bool  AdWrapper::setAttributeBool (const string& attr_name, bool attr_value){
   EDG_WL_UI_COMMON_TRY_ERRROR
      jad->setAttribute(attr_name , attr_value) ;
      return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true ;
} ;
bool AdWrapper::setAttributeExpr (const std::string& attr_name , const std::string& attr_value ){
   EDG_WL_UI_COMMON_TRY_ERRROR
        jad->setAttributeExpr (attr_name , attr_value ) ;
        return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return true;
};
bool AdWrapper::hasKey (const string& attr_name) {
   EDG_WL_UI_COMMON_TRY_ERRROR
        return jad->hasAttribute (attr_name) ;
        return false ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return false ;
};


std::vector <std::string> AdWrapper::attributes ( )  {    return jad->attributes() ;  };

std::string AdWrapper::getValueExpr (const std::string& attr_name){
   EDG_WL_UI_COMMON_TRY_ERRROR
      return jad->getAttributeExpr(attr_name) ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return "" ;
}  ;
std::vector <std::string> AdWrapper::getStringValue (const string& attr_name)  {
   EDG_WL_UI_COMMON_TRY_ERRROR
      return jad->getStringValue(attr_name) ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   vector<string> result ;
   return  result ;
};



std::vector <  std::string>  AdWrapper::getStringList (const std::string& attr_name) {
	vector< string>result ;
	EDG_WL_UI_COMMON_TRY_ERRROR
	vector< vector<string> > vect = jad->getStringList(attr_name) ;
	for (unsigned int i = 0 ; i< vect.size() ;  i++ ){
		for (unsigned int j = 0 ;  j< vect[i].size() ;  j++ ){
			result.push_back( vect[i][j] ) ;
		}
		result.push_back("") ;
	}
	EDG_WL_UI_COMMON_CATCH_ERRROR
	return  result ;
} ;


vector <int> AdWrapper::getIntValue (const string& attr_name){
   EDG_WL_UI_COMMON_TRY_ERRROR
     return jad->getIntValue(attr_name) ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   vector<int> result ;
   return  result ;
}  ;
vector <bool> AdWrapper::getBoolValue(const string& attr_name){
   EDG_WL_UI_COMMON_TRY_ERRROR
     return jad->getBoolValue(attr_name) ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   vector<bool> result ;
   return  result ;
}  ;
vector<double> AdWrapper::getDoubleValue (const string& attr_name){
   EDG_WL_UI_COMMON_TRY_ERRROR
       return jad->getDoubleValue(attr_name) ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   vector<double> result ;
   return  result ;
}  ;

string AdWrapper::getAd( const string& name  ) {
   EDG_WL_UI_COMMON_TRY_ERRROR
   return (    (edg::workload::common::requestad::JobAd*)  jad)->getAd(  name  ) ;
   EDG_WL_UI_COMMON_CATCH_ERRROR
   return "" ;
}

