/*
 * edg-wl-job-submit.cpp
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 */

#include "edg/workload/common/utilities/Exceptions.h"
#include "edg/workload/common/requestad/JobAd.h"
#include "edg/workload/userinterface/client/Job.h"
using namespace std ;
using namespace edg::workload::common::utilities ;

int main(int argc,char *argv[]){
try{
   if (argc < 4 ||  strcmp(argv[1],"--help") == 0)  {
		cout << "Usage : " << argv[0] << "  <JDL file>  <ns host> <ns port> " << endl;
		return 1;
   }
   edg::workload::common::requestad::JobAd jab;
   jab.fromFile ( argv[1] ) ;
   edg::workload::userinterface::Job   job(jab);
   cout << "Performing a list Job Match, please wait..." << endl <<  flush;
   vector< pair <string , double> >   resources = job.listMatchingCE ( argv[2] , atoi(argv[3]) ) ;
   if ( resources.size() >0 )
      cout << "Resources found: " << endl ;
   else
      cout << "No matching Resources found: " << endl ;
   for (unsigned int i = 0 ; i< resources.size() ; i++)
      cout <<  "Ce id= " << resources[i].first << "       Rank =    " << resources[i].second << endl ;
   return 0;
}catch  (Exception &exc){
         cout << "\nOperation not performed\n" ;
         cout <<  exc.printStackTrace();
}
return 1 ;
};
