#include "edg/workload/common/jobid/JobId.h"
#include "edg/workload/userinterface/client/JobExceptions.h"
#include "edg/workload/userinterface/client/Job.h"
#include <iostream>
using namespace std ;
using namespace edg::workload::common::utilities ;
int main(int argc,char *argv[]){
try{
   if (argc < 3 ||  strcmp(argv[1],"--help") == 0)  {
        cout << "Usage : " << argv[0] << "  <job id > <output direcotory>" << endl;
        return 1;
   }
   edg::workload::common::jobid::JobId jid ( argv[1] );
   edg::workload::userinterface::Job   job(jid);
   cout << "Retrieving output files, please wait..." << endl <<  flush;
   string logName ;
   char* ln_env  = getenv ("LOGNAME") ;
   if (ln_env != NULL)
       logName = string( ln_env );
   else
       // Prefix with "JobOutput" if cannot get LOGNAME
       logName = "jobOutput";
   string outputDir = string (  argv[2]  )  + "/" + logName + jid.getUnique()  ;
   if (mkdir (  outputDir.c_str() ,  S_IRWXU )  )
        throw edg::workload::userinterface::JobOperationException     ( __FILE__ , __LINE__ , argv[0] , ENOENT ,"Unable to create Directory") ;
   job.getOutput(  outputDir ) ;
   cout << "Succeed. Output Directory:\n " << outputDir << endl << flush ;
   return 0 ;
}catch  (Exception &exc){
         cout << "Operation not performed\n" ;
         cout <<  exc.printStackTrace();
}
return 1 ;
}
