/*
 * edg-wl-job-submit.cpp
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 */

#include "edg/workload/common/utilities/Exceptions.h"
#include "edg/workload/common/requestad/JobAd.h"
#include "edg/workload/userinterface/client/Job.h"
using namespace std ;
using namespace edg::workload::common::utilities ;

int main(int argc,char *argv[]){
try{
   if (argc < 6 ||  strcmp(argv[1],"--help") == 0)  {
		cout << "Usage : " << argv[0] << "  <JDL file>  <ns host> <ns port> <lbHost> <lbPort> [<ce_id>]" << endl;
		return 1;
   }
   edg::workload::common::requestad::JobAd jab;
   jab.fromFile ( argv[1] ) ;
   edg::workload::userinterface::Job   job(jab);
   job.setLoggerLevel (6) ;
   cout << "Performing a submission to " << argv[2] << ":" <<  argv[3]  << endl << flush ;
   cout << "LB address: "<< argv[4] << ":" <<  argv[5]  << endl << flush ;
   cout << "please wait..." << endl <<  flush;
   if (argc ==6)
      job.submit ( argv[2] , atoi(argv[3]) , argv[4] , atoi( argv[5] ) ,  "") ;
   else
      job.submit ( argv[2] , atoi(argv[3]) , argv[4] , atoi( argv[5] ) , argv[6] ) ;
   cout << "Succeed:\n "  << job.getJobId()->toString()  << endl << flush ;
   return 0;
}catch  (Exception &exc){
         cout << "\nOperation not performed\n" ;
         cout <<  exc.printStackTrace();
}
return 1 ;
};
