#ifndef  EDG_WORKLOAD_COMMON_REQUESTAD_JOBADSCHEMA_H
#define EDG_WORKLOAD_COMMON_REQUESTAD_JOBADSCHEMA_H
/*
* JobAdSchema.h
*
* Copyright (c) 2001 The European DataGrid Project - IST programme, all rights reserved.
*
* Contributors are mentioned in the code there appropriate.
*
*/
#include  "edg/workload/common/requestad/requestad_namespace.h"
#include <string>
#include <vector>
COMMON_REQUESTAD_NAMESPACE_BEGIN



/**
 * Provides a Schema used to check the attribute in the JobAd
 * The default utilised schema is GLUE. To instanciate a schema you
 * will need to provide an array of Strings, one per attribute
 * Known used schema so far: EDG , GLUE (Default used schema)
 * @version 0.1
 * @author Alessandro Maraschini <alessandro.maraschini@datamat.it>
*/
class JobAdSchema {
	public:
	// int SCHEMA_MAX_ATTR
	/******************Public methods********************/
	enum attribute {
		/** other.DataAccessCost attribute */
		SCHEMA_DAC ,
		/** other.GlueHostApplicationSoftwareRunTimeEnvironment attribute.
		* Appended for MPI jobs in Requirements expression */
		SCHEMA_RTE     ,
		/** other.GlueCEInfoTotalCPUs attribute.
		* Appended for MPI jobs in Requirements expression */
		SCHEMA_TCPU  ,
		/**  other.GlueCEStateFreeCPUs attribute
		* Set for MPI jobs as a default rank (if not given) */
		SCHEMA_FCPU  ,
		/** other.GlueHostNetworkAdapterOutboundIP
		* Added for  Interactive Jobs in requirements expression*/
		SCHEMA_OIP  ,
		/*** Max index array dimension for Schema Attributes */
		SCHEMA_ARRAY
	};
	/** CUSTOM schema constructor
	* @param values an array of string of #SCHEMA_ARRAY dimension  */
	JobAdSchema ( std::vector<std::string> values  )  ;
	/** GLUE schema static constructor  (JobAd default utilised schema)*/
	static JobAdSchema*  glueSchema() ;
	/** EDG schema static constructor */
	static JobAdSchema edgSchema( ) ;
	std::string get ( attribute attrName ) ;
	JobAdSchema* Copy( ) ;

	private :
	/******************Private memebrs********************/
	std::vector<std::string> values ;
	JobAdSchema() ;
};

}   // requestad namespace
COMMON_NAMESPACE_END } //Closing  UserInterFace NameSpace
#endif
