#ifndef IL_ERROR_H
#define IL_ERROR_H

#ident "$Header: /local/reps/lcgware/workload/logging/locallogger/il_error.h,v 1.3 2003/07/25 07:27:14 michal Exp $"

#ifdef HAVE_CONFIG_H
#include "edg/workload/config.h"
#endif

#include <syslog.h>

enum err_code_maj { /* minor =                   */
  IL_OK,            /*     0                     */
  IL_SYS,           /*     errno                 */
  IL_NOMEM,         /*     ENOMEM                */
  IL_AUTH,          /*     0 (SSL error)         */
  IL_PROTO,         /*     LB_*                  */
  IL_LBAPI,         /*     dgLBErrCode           */
  IL_DGSSL,         /*     EDG_WLL_SSL_*         */
  IL_HOST           /*     h_errno               */
};

struct error_inf {
  int  code_maj;
  long code_min;
  char *msg;
};

int init_errors(int);
int set_error(int, long, char *);
int clear_error();
int error_get_maj();
long error_get_min();
char *error_get_msg();

int il_log(int, char *, ...);

#endif
