/*
 * CommandFactoryClientImpl.h
 * 
 * Copyright (c) 2001, 2002 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */
 
#ifndef _CommandFactoryClientImpl_h_
#define _CommandFactoryClientImpl_h_

#include "edg/workload/networkserver/commands/CommandFactoryImpl.h"

namespace edg {
namespace workload {
namespace networkserver {
namespace commands {
 
class Command;

/**
 * The Client implementation of the command-factory definition.
 *
 * @version
 * @date September 16 2002
 * @author Salvatore Monforte
 */
class CommandFactoryClientImpl : public CommandFactoryImpl
{
public:
  /**
   * Creates a new command of the specified type, using Client view.
   * @return a pointer to a new server-side command.
   */
   Command* create(const std::string& name);
};

} // namespace commands
} // namespace networkserver
} // namespace workload
} // namespace edg 
 
#endif
