/*
 * CommandFactoryImpl.h
 * 
 * Copyright (c) 2001, 2002 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */
 
#ifndef _CommandFactoryImpl_h_
#define _CommandFactoryImpl_h_

namespace edg {
namespace workload {
namespace networkserver {
namespace commands {
 
class Command;

/**
 * The command-factory definition.
 *
 * @version
 * @date September 16 2002
 * @author Salvatore Monforte
 */
class CommandFactoryImpl
{
public:
  /**
   * Creates a new command of the specified type.
   * @return a pointer to a new command.
   */
  virtual Command* create(const std::string& name) = 0;
  /**
   * Destructor.
   */
  virtual ~CommandFactoryImpl() {}
};

} // namespace commands
} // namespace networkserver
} // namespace workload
} // namespace edg
 
#endif
