#ifndef _ForwardRequest_h_
#define _ForwardRequest_h_

#include "edg/workload/networkserver/commands/fsm/CommandState.h"

namespace edg {
namespace workload {
namespace networkserver {
namespace commands {
namespace fsm {
 
class Command;

/**
 * This State sends a string attribute of the command over a connection. 
 * @author Marco Pappalardo marco.pappalardo@ct.infn.it
 * @author Salvatore Monforte salvatore.monforte@ct.infn.it
 */
class ForwardRequest : public CommandState 
{
 public:
  /**
   * Constructor
   * @param s the name of the attribute whose value is to be sent.
   */
  ForwardRequest();
  
  /**
   * Describes the action this state must perform.
   * @param cmd the command the state belongs to.
   * @return whether an error code indicating whether error occurred or not.
   * @throws Broker::Client::JDLParsingException if parsing error occurs.
   */
  bool execute (commands::Command* cmd);

  /**
   * Overrides the superclass method to forward request.
   * @return true so the request is forwarded to WM.
   */
  bool forwardRequest() const;
};

} // namespace fsm
} // namespace comamnds
} // namespace networkserver
} // namespace workload
} // namespace edg

#endif 







