#ifndef _Jump_h_
#define _Jump_h_

#include "edg/workload/networkserver/commands/fsm/CommandState.h"

namespace edg {
namespace workload {
namespace networkserver {
namespace commands {
namespace fsm {
 
class Command;

/**
 * This State represents a Jump in the FSM. 
 * @author Marco Pappalardo marco.pappalardo@ct.infn.it
 */
class Jump : public CommandState 
{
 public:
  /**
   * Constructor
   * @param s the attribute representing number of steps to be skipped.
   */
  Jump(const std::string& s);
  /**
   * Constructor
   * @param steps number of steps to be skipped.
   */
  Jump(const int steps);

  /**
   * Describes the action this state must perform.
   * @param cmd the command the state belongs to.
   * @return whether an error code indicating whether error occurred or not.
   */
  bool execute (commands::Command* cmd);

 private:
  std::string stepsName;
  int steps;
};

} // namespace fsm
} // namespace comamnds
} // namespace networkserver
} // namespace workload
} // namespace edg

#endif 







