/**
 * File: JobId.h
 *
 * author: Marco Pappalardo@ct.infn.it
 * Copyright (c) 2002 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

// $Id: JobId.h,v 1.2 2003/11/14 18:22:58 pappalar Exp $

#ifndef _EDG_WORKLOAD_NETWORKSERVER_COMMON_JOBID_H_
#define _EDG_WORKLOAD_NETWORKSERVER_COMMON_JOBID_H_

#include "edg/workload/common/jobid/JobId.h"
#include "edg/workload/common/jobid/manipulation.h"

namespace common = edg::workload::common;

namespace edg {
namespace workload {
namespace networkserver {    
namespace jobid {

  inline std::string to_filename(common::jobid::JobId j, 
				 int level = 0,
				 bool extended_path = true) {
    std::string path( get_reduced_part(j, level) );
    if ( extended_path ) path.append(std::string("/") + common::jobid::to_filename(j));
    return path;
  }
		     
}
}
}
}
#endif
