/*
 * File: NetworkServer.h
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */
 
#ifndef _NetworkServer_h_
#define _NetworkServer_h_

#include <boost/utility.hpp>
#include <boost/pool/detail/singleton.hpp>
#include "edg/workload/common/configuration/NSConfiguration.h"
 
using namespace boost::details::pool;

namespace edg {
namespace workload {
namespace common {
namespace configuration {
class NSConfiguration;
}
}

namespace networkserver {
namespace daemon {

class NetworkServerImpl;

class NetworkServer : boost::noncopyable
{ 
 public:
  NetworkServer();
  ~NetworkServer();
  
  void run();
  void init();
  void shutdown();
  void drop_privileges();
  const common::configuration::NSConfiguration& configuration();
 
 private:
  NetworkServerImpl *m_impl;
};

}; // daemon
}; // networkserver
}; // workload
}; // edg

#endif
