/*
 * File: NetworkServerImpl.h
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */
 
#ifndef _NetworkServerImpl_h_
#define _NetworkServerImpl_h_

#include <boost/utility.hpp>
 
namespace edg {
namespace workload {
namespace common {
namespace configuration {
class NSConfiguration;
}
}
namespace networkserver {
namespace daemon {

class NetworkServerImpl : boost::noncopyable 
{
public:
  NetworkServerImpl();
  virtual ~NetworkServerImpl();

  virtual void run()                                                    = 0;
  virtual void init()                                                   = 0;
  virtual void shutdown()                                               = 0;
  virtual const common::configuration::NSConfiguration& configuration() = 0;
  virtual void drop_privileges()                                       = 0;
};
} // namespace daemon
} // namespace networkserver
} // namesapce workload
} // namespace edg

#endif
