#ifndef _DaemonExceptions_h_
#define _DaemonExceptions_h_

#include <exception>
#include <string> 

#include "edg/workload/common/utilities/Exceptions.h"

#define _CANNOT_START_ERR_ 1000

namespace utilities = edg::workload::common::utilities;

namespace edg {
namespace workload {
namespace networkserver {  
namespace daemon {
 
  class Exception : public utilities::Exception
  {
   protected:	
    Exception() {} 
    Exception(const std::string& s, const std::string& m, int c, const std::string& n) :
      utilities::Exception(s, m, c, n) {} 
    };
 
  class CannotStartException : public daemon::Exception
  {
   public: 
    CannotStartException( const std::string& message ) :
      daemon::Exception( std::string(""), std::string(""), _CANNOT_START_ERR_, "CannotStartException" )
    {
      this -> error_message = message;
    }
  };

} // namespace daemon
} // namespace networkserver 
} // namespace workload
} // namespace edg

#endif
