// File: RBMaximizeFilesImpl.h
// Author: Salvatore Monforte <Salvatore.Monforte@ct.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: RBMaximizeFilesImpl.h,v 1.3 2004/05/12 11:55:31 dhsmith Exp $

#ifndef _EDG_WORKLOAD_PLANNING_BROKER_RBMAXIMIZEFILESIMPL_H_
#define _EDG_WORKLOAD_PLANNING_BROKER_RBMAXIMIZEFILESIMPL_H_

#include "edg/workload/planning/broker/ResourceBroker.h"
#include "edg/workload/planning/broker/matchmaking/brokerinfo.h"
#include "edg/workload/planning/broker/matchmaking/brokerinfoGlueImpl.h"

namespace edg {
namespace workload {
namespace planning {
namespace broker {	

class RBMaximizeFilesImpl : public ResourceBrokerImpl
{
public:
   RBMaximizeFilesImpl(matchmaking::brokerinfo::BrokerInfo<matchmaking::brokerinfo::brokerinfoGlueImpl> *, bool do_prefetch=false);
  ~RBMaximizeFilesImpl();
  matchmaking::match_table_t* findSuitableCEs(const classad::ClassAd* requestAd);
private:
  matchmaking::brokerinfo::BrokerInfo<matchmaking::brokerinfo::brokerinfoGlueImpl>* BI;
  bool m_prefetch;
};

} // namespace broker
} // namespace planning
} // namespace workload
} // namespace edg

#endif
