/*
 * File: RBSelectionSchema.h
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

// $Id: RBSelectionSchema.h,v 1.2 2003/03/31 10:38:22 smonforte Exp $

# ifndef _EDG_WORKLOAD_PLANNING_BROKER_RBSELECTIONSCHEMA_H_
# define _EDG_WORKLOAD_PLANNING_BROKER_RBSELECTIONSCHEMA_H_
# include <boost/utility.hpp>
# include <boost/thread/mutex.hpp>
# include <map>
# include "edg/workload/planning/broker/matchmaking/matchmaker.h"
# include<vector>
namespace edg {
namespace workload {
namespace planning {
namespace broker {

class RBSelectionSchema 
{
 public:
   RBSelectionSchema() {}
   virtual ~RBSelectionSchema() {}
   virtual matchmaking::match_const_iterator selectBestCE(const matchmaking::match_table_t& match_table) = 0;
};

	
class RBSelectionSchemaMap : boost::noncopyable
{
 public:
  RBSelectionSchemaMap();
  ~RBSelectionSchemaMap();
  static RBSelectionSchema*       getSchema       (const std::string& name);
  static bool                     registerSchema  (const std::string& name, RBSelectionSchema* schema);
  static RBSelectionSchema*       unregisterSchema(const std::string& name); 

 private:
  static boost::mutex m_map_access_mutex;
  static std::map<std::string, RBSelectionSchema*>* m_selection_schema_map;
};

namespace {
  static RBSelectionSchemaMap f_SelectionSchemaMapInit;
}

}; // namespace broker
}; // namespace planning
}; // workload
}; // edg

#endif
