// File: matchmakerGlueImpl.h
// Author: Salvatore Monforte <Salvatore.Monforte@ct.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: matchmakerGlueImpl.h,v 1.7 2004/05/12 11:55:31 dhsmith Exp $

#ifndef _EDG_WORKLOAD_PLANNING_BROKER_MATCHMAKING_MATCHMAKERGLUEIMPL_H
#define _EDG_WORKLOAD_PLANNING_BROKER_MATCHMAKING_MATCHMAKERGLUEIMPL_H

#include "edg/workload/planning/broker/matchmaking/matchmaker.h"
#include "edg/workload/common/ldif2classad/LDIFObject.h"

namespace edg {
namespace workload {
namespace planning {
namespace broker {
namespace matchmaking { 

class matchmakerGlueImpl : public MatchMakerImpl
{
 public:
  matchmakerGlueImpl();
  ~matchmakerGlueImpl();
  void prefetchCEInfo  (const classad::ClassAd* requestAd, match_table_t& suitableCEs);
  void checkRequirement(const classad::ClassAd* requestAd, match_table_t& suitableCEs, bool use_prefetched_ces=false);
  void checkRank       (const classad::ClassAd* requestAd, match_table_t& suitableCEs, bool use_prefetched_ces=false);
 private:
#ifdef ENABLE_SHARED_LIBRARY_FUNCTIONS
    static boost::scoped_ptr< classad::ClassAd > gang_match_storageAd;
#endif
    std::vector<edg::workload::common::ldif2classad::LDIFObject> m_CE_info_cache;
    bool m_CE_info_prefetched;
};

} // namespace matchmaking
} // namespace broker
} // namespace planning
} // namespace workload
} // namespace edg

#endif
