/*
 * File: utility.h
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

// $Id: utility.h,v 1.4 2003/05/09 14:18:09 smonforte Exp $

#ifndef _EDG_WORKLOAD_PLANNING_BROKER_MATCHMAKING_UTILITY_H_
#define _EDG_WORKLOAD_PLANNING_BROKER_MATCHMAKING_UTILITY_H_

#include <vector>
#include <numeric>
#include <algorithm>
#include "edg/workload/planning/broker/matchmaking/matchmaker.h"

using namespace std;

namespace edg {
namespace workload {
namespace planning {
namespace broker {
namespace matchmaking {

typedef std::vector< std::pair<match_table_t::key_type,match_table_t::mapped_type> > match_vector_t;
	
struct rank_less_than_comparator :
    public binary_function< match_table_t::value_type&, match_table_t::value_type&, bool>
{ 
	 bool operator()(const match_table_t::value_type& a, const match_table_t::value_type& b)
	 {
	    return a.second.getRank() < b.second.getRank();
	 }
};

struct rank_greater_than_comparator :
    public binary_function< match_table_t::value_type&, match_table_t::value_type&, bool>
{
         bool operator()(const match_table_t::value_type& a, const match_table_t::value_type& b)
         {
             return a.second.getRank() > b.second.getRank();
         }
};

}; // namespace matchmaking
}; // namespace broker
}; // namespace planning
}; // workload
}; // edg

#endif



