/*
 * File: stochasticRankSelector.h
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

// $Id: stochasticRankSelector.h,v 1.3 2003/04/17 15:13:50 smonforte Exp $

#ifndef _EDG_WORKLOAD_PLANNING_BROKER_STOCHASTICRANKSELECTOR_H_
#define _EDG_WORKLOAD_PLANNING_BROKER_STOCHASTICRANKSELECTOR_H_

#include "edg/workload/planning/broker/RBSelectionSchema.h"

#include <boost/scoped_ptr.hpp>
#include <boost/random/linear_congruential.hpp>
#include <boost/random/uniform_01.hpp>

namespace edg {
namespace workload {
namespace planning {
namespace broker {

class stochasticRankSelector : public RBSelectionSchema
{
 public:
  stochasticRankSelector::stochasticRankSelector();
  stochasticRankSelector::~stochasticRankSelector();	
  matchmaking::match_const_iterator selectBestCE(const matchmaking::match_table_t& match_table);
 private:
  boost::scoped_ptr< boost::uniform_01<boost::minstd_rand> > m_unirand01;
};	

}; // namespace broker
}; // namespace planning
}; // workload
}; // edg

#endif
