// File: Helper.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: Helper.h,v 1.4 2003/09/02 14:32:17 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_HELPER_HELPER_H
#define EDG_WORKLOAD_PLANNING_HELPER_HELPER_H

#ifndef EDG_WORKLOAD_X_STRING
#define EDG_WORKLOAD_X_STRING
#include <string>
#endif
#ifndef EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#define EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {
namespace planning {
namespace helper {

class HelperImpl;

class Helper: boost::noncopyable
{
  HelperImpl* m_impl;

public:
  Helper(std::string const& id);
  ~Helper();

  std::string id() const;

  std::string resolve(std::string const& input_file) const;
  classad::ClassAd* resolve(classad::ClassAd const* input_ad) const;
};
 
}}}} // edg::workload::planning::helper

#endif // EDG_WORKLOAD_PLANNING_HELPER_HELPER_H
