// File: HelperImpl.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: HelperImpl.h,v 1.5 2003/09/02 14:32:18 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_HELPER_HELPERIMPL_H
#define EDG_WORKLOAD_PLANNING_HELPER_HELPERIMPL_H

#ifndef EDG_WORKLOAD_X_STRING
#define EDG_WORKLOAD_X_STRING
#include <string>
#endif
#ifndef EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#define EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {
namespace planning {
namespace helper {

class HelperImpl: boost::noncopyable
{
public:
  HelperImpl();
  virtual ~HelperImpl();

  std::string resolve(std::string const& input_file) const;

  virtual std::string id() const = 0;
  virtual std::string output_file_suffix() const = 0;
  virtual classad::ClassAd* resolve(const classad::ClassAd* input_ad) const = 0;
};

}}}} // edg::workload::planning::helper

#endif
