// File: Request.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2001 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: Request.h,v 1.3 2002/12/18 12:17:33 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_HELPER_REQUEST_H
#define EDG_WORKLOAD_PLANNING_HELPER_REQUEST_H

#ifndef EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#define EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {
namespace planning {
namespace helper {

class Request: boost::noncopyable
{
  class Impl;

  Impl* m_impl;

public:
  Request(classad::ClassAd const* ad);
  ~Request();
  void resolve();
  bool is_resolved() const;
  classad::ClassAd const* original_ad() const;
  classad::ClassAd const* current_ad() const;
};

inline
classad::ClassAd const*
resolved_ad(Request const& request)
{
  return request.is_resolved() ? request.current_ad() : 0;
}

} // namespace helper
} // namespace planning
} // namespace workload
} // namespace edg

#endif // EDG_WORKLOAD_PLANNING_HELPER_REQUEST_H

