/***************************************************************************
 *  filename  : JobAdapter.h
 *  authors   : Elisabetta Ronchieri <elisabetta.ronchieri@cnaf.infn.it>
 *  Copyright (c) 2002 CERN and INFN on behalf of the EU DataGrid.
 *  For license conditions see LICENSE file or
 *  http://www.edg.org/license.html
 ***************************************************************************/

// $Id: JobAdapter.h,v 1.7 2003/02/03 15:53:02 joda Exp $

#ifndef EDG_WORKLOAD_PLANNING_JOBADAPTER_JOBADAPTER_H
#define EDG_WORKLOAD_PLANNING_JOBADAPTER_JOBADAPTER_H

#ifndef EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#define EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {
namespace planning {
namespace jobadapter {

class JobAdapter: boost::noncopyable
{
public:
  /**
   * Constructor.
   */
  JobAdapter(const classad::ClassAd* ad);
  /**
   * Destructor.
   */
  ~JobAdapter();

public:
  /**
   * Create a new ClassAd using a selection of input ClassAd's ones.
   */
  classad::ClassAd* resolve(void);
  
private: 
  const classad::ClassAd* m_ad;
};

} // namespace jobadapter
} // namespace planning
} // namespace workload
} // namespace edg

#endif // EDG_WORKLOAD_PLANNING_JOBADAPTER_JOBADAPTER_H
