/***************************************************************************
 *  filename  : MpiLsfJobWrapper.h
 *  authors   : Alessio Gianelle <alessio.gianelle@pd.infn.it>
 *              Francesco Giacomini <francesco.giacomini@cnaf.infn.it>
 *              Rosario Peluso <rosario.peluso@pd.infn.it>
 *              Elisabetta Ronchieri <elisabetta.ronchieri@cnaf.infn.it>
 *  Copyright (c) 2002 CERN and INFN on behalf of the EU DataGrid.
 *  For license conditions see LICENSE file or
 *  http://www.edg.org/license.html
 ***************************************************************************/

#ifndef EDG_WORKLOAD_PLANNING_JOBADAPTER_MPI_LSF_JOB_WRAPPER_H
#define EDG_WORKLOAD_PLANNING_JOBADAPTER_MPI_LSF_JOB_WRAPPER_H

#ifndef EDG_WORKLOAD_X_STRING
#define EDG_WORKLOAD_X_STRING
#include <string>
#endif

#ifndef EDG_WORKLOAD_X_VECTOR
#define EDG_WORKLOAD_X_VECTOR
#include <vector>
#endif

#ifndef EDG_WORKLOAD_X_IOSTREAM
#define EDG_WORKLOAD_X_IOSTREAM
#include <iostream>
#endif

#ifndef EDG_WORKLOAD_X_UTILITY
#define EDG_WORKLOAD_X_UTILITY
#include <utility>
#endif

#ifndef EDG_WORKLOAD_PLANNING_COMMON_URL_H
#include "edg/workload/planning/common/URL.h"
#endif

#ifndef EDG_WORKLOAD_PLANNING_JOBADAPTER_JOB_WRAPPER_H
#include "edg/workload/planning/jobadapter/JobWrapper.h"
#endif

namespace edg {
namespace workload {
namespace planning {
namespace jobadapter {

class MpiLsfJobWrapper : public JobWrapper
{

public:

  /**
   *  Default constructor.
   *  Initializes the object passing the parameters to the job wrapper.
   *  \param job
   *  \ingroup jobadapter
   */
  MpiLsfJobWrapper(const std::string& job);

  /**
   *  Default destructor.
   *  \ingroup jobadapter
   */
  virtual ~MpiLsfJobWrapper(void);

protected:
  virtual std::ostream& set_subdir(std::ostream&      os,
                                   const std::string& dir) const;

  virtual std::ostream& execute_job(std::ostream&      os,
		                    const std::string& arguments,
                                    const std::string& job,
                                    const std::string& stdi,
                                    const std::string& stdo,
                                    const std::string& stde,
				    int                node) const;
};

} // namespace jobadapter
} // namespace planning
} // namespace workload
} // namespace edg

#endif // EDG_WORKLOAD_PLANNING_JOBADAPTER_MPI_LSF_JOB_WRAPPER_H
