// File: exceptions.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2003 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: exceptions.h,v 1.1 2003/09/02 14:35:42 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_JOBADAPTER_EXCEPTIONS_H
#define EDG_WORKLOAD_PLANNING_JOBADAPTER_EXCEPTIONS_H

#include "edg/workload/planning/helper/exceptions.h"
#include <string>
#include <boost/shared_ptr.hpp>

namespace edg {
namespace workload {
namespace planning {
namespace jobadapter {

class CannotCreateJobWrapper: public helper::HelperError
{
  class Impl;
  boost::shared_ptr<Impl> m_impl;

public:
  CannotCreateJobWrapper(std::string const& path);
  ~CannotCreateJobWrapper() throw();
  std::string path() const;
  char const* what() const throw();
};

}}}} // edg::workload::planning::jobadapter

#endif

// Local Variables:
// mode: c++
// End:
