// File: Dispatcher.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2001 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: Dispatcher.h,v 1.4 2003/02/28 10:14:15 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_MANAGER_DISPATCHER_H
#define EDG_WORKLOAD_PLANNING_MANAGER_DISPATCHER_H

#ifndef BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif
#ifndef BOOST_SCOPED_PTR_HPP
#include <boost/scoped_ptr.hpp>
#endif
#ifndef EDG_WORKLOAD_PLANNING_MANAGER_PIPEDEFS_H
#include "edg/workload/planning/manager/pipedefs.h"
#endif
#ifndef EDG_WORKLOAD_COMMON_TASK_TASK_H
#include "edg/workload/common/task/Task.h"
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {
namespace planning {
namespace manager {

class DispatcherImpl;

class Dispatcher:
    public common::task::PipeWriter<pipe_value_type>,
    boost::noncopyable
{
  boost::scoped_ptr<DispatcherImpl> m_impl;

public:
  Dispatcher();
  virtual ~Dispatcher();

  virtual void run();
};


} // namespace manager
} // namespace planning
} // namespace workload
} // namespace edg

#endif // EDG_WORKLOAD_PLANNING_MANAGER_DISPATCHER_H
