// File: DispatcherFromFileList.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: DispatcherFromFileList.h,v 1.1 2003/03/27 14:27:29 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_MANAGER_DISPATCHERFROMFILELIST_H
#define EDG_WORKLOAD_PLANNING_MANAGER_DISPATCHERFROMFILELIST_H

#ifndef EDG_WORKLOAD_X_STRING
#define EDG_WORKLOAD_X_STRING
#include <string>
#endif
#ifndef BOOST_SHARED_PTR_HPP
#include <boost/shared_ptr.hpp>
#endif
#ifndef EDG_WORKLOAD_PLANNING_MANAGER_DISPATCHERIMPL_H
#include "edg/workload/planning/manager/DispatcherImpl.h"
#endif
#ifndef EDG_WORKLOAD_COMMON_UTILITIES_FLEXTRACTOR_H
#include "edg/workload/common/utilities/FLExtractor.h"
#endif

namespace edg {
namespace workload {
namespace planning {
namespace manager {

class DispatcherFromFileList: public DispatcherImpl
{
public:
  typedef edg::workload::common::utilities::FLExtractor<std::string> extractor_type;

private:
  boost::shared_ptr<extractor_type> m_extractor;

public:
  DispatcherFromFileList(boost::shared_ptr<extractor_type> extractor);

  void run(common::task::PipeWriteEnd<pipe_value_type>& write_end);
};

}}}} // edg::workload::planning::manager

#endif

// Local Variables:
// mode: c++
// End:
