// File: RequestHandler.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2001 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: RequestHandler.h,v 1.3 2002/12/04 16:00:08 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_MANAGER_REQUESTHANDLER_H
#define EDG_WORKLOAD_PLANNING_MANAGER_REQUESTHANDLER_H

#ifndef BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif
#ifndef BOOST_SHARED_PTR_HPP
#include <boost/shared_ptr.hpp>
#endif
#ifndef BOOST_SHARED_PTR_HPP
#include <boost/scoped_ptr.hpp>
#endif
#ifndef EDG_WORKLOAD_COMMON_TASK_TASK_H
#include "edg/workload/common/task/Task.h"
#endif
#ifndef EDG_WORKLOAD_PLANNING_MANAGER_PIPEDEFS_H
#include "edg/workload/planning/manager/pipedefs.h"
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {
namespace planning {
namespace manager {

class RequestHandler:
    public common::task::PipeReader<pipe_value_type>,
    boost::noncopyable
{
  class Impl;
  Impl* m_impl;

public:
  RequestHandler();
  virtual ~RequestHandler();

  virtual void run();
};


} // namespace manager
} // namespace planning
} // namespace workload
} // namespace edg

#endif // EDG_WORKLOAD_PLANNING_MANAGER_REQUESTHANDLER_H
