// File: RequestPlanningPolicy.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: RequestPlanningPolicy.h,v 1.8 2003/11/11 14:19:42 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_MANAGER_REQUESTPLANNINGPOLICY_H
#define EDG_WORKLOAD_PLANNING_MANAGER_REQUESTPLANNINGPOLICY_H

#include <classad_distribution.h>
#include "edg/workload/planning/helper/Request.h"

namespace edg {
namespace workload {
namespace planning {
namespace manager {

class RequestPlanningPolicy
{
protected:
  ~RequestPlanningPolicy() {}

public:
  static classad::ClassAd* Plan(classad::ClassAd const& ad)
  {
    helper::Request request(&ad);

    while (!request.is_resolved()) {
      request.resolve();
    }

    classad::ClassAd const* res_ad = resolved_ad(request);
    return res_ad->Copy();
  }
};

typedef RequestPlanningPolicy PlanningPolicy;

}}}} // edg::workload::planning::manager

#endif // EDG_WORKLOAD_PLANNING_MANAGER_REQUESTPLANNINGPOLICY_H
