// File: WMFactory.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: WMFactory.h,v 1.5 2003/03/27 14:13:14 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_MANAGER_WMFACTORY_H
#define EDG_WORKLOAD_PLANNING_MANAGER_WMFACTORY_H

#ifndef EDG_WORKLOAD_X_STRING
#define EDG_WORKLOAD_X_STRING
#include <string>
#endif
#ifndef BOOST_SCOPED_PTR_HPP
#include <boost/scoped_ptr.hpp>
#endif
#ifndef BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif

namespace edg {
namespace workload {
namespace planning {
namespace manager {

class WMImpl;

class WMFactory: boost::noncopyable
{
  class Impl;

  boost::scoped_ptr<Impl> m_impl;

  static WMFactory* s_instance;

  WMFactory();

  typedef WMImpl product_type;
  typedef product_type* (*product_creator_type)();

public:
  static WMFactory* instance();
  ~WMFactory();

public:

  typedef std::string wm_type;

  bool register_wm(wm_type const& id, product_creator_type creator);
  bool unregister_wm(wm_type const& id);
  product_type* create_wm(wm_type const& id);
};

}}}} // edg::workload::planning::manager


#endif // EDG_WORKLOAD_PLANNING_MANAGER_WMFACTORY_H
