// File: WMImpl.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2001 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: WMImpl.h,v 1.7 2003/03/27 14:13:14 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_MANAGER_WMIMPL_H
#define EDG_WORKLOAD_PLANNING_MANAGER_WMIMPL_H

#ifndef EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#define EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {

namespace common {
namespace jobid {
class JobId;
}}

namespace planning {
namespace manager {

class WMImpl: boost::noncopyable
{
public:
  WMImpl();
  virtual ~WMImpl();

  virtual void submit(classad::ClassAd const* request_ad) = 0;
  virtual void resubmit(common::jobid::JobId const& request_id) = 0;
  virtual void cancel(common::jobid::JobId const& request_id) = 0;
};

} // namespace manager
} // namespace planning
} // namespace workload
} // namespace edg

#endif // EDG_WORKLOAD_PLANNING_MANAGER_WMIMPL_H

