// File: pipedefs.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.
// For license conditions see http://www.eu-datagrid.org/license.html

// $Id: pipedefs.h,v 1.1 2002/12/04 15:59:12 giaco Exp $

#ifndef EDG_WORKLOAD_PLANNING_MANAGER_PIPEDEFS_H
#define EDG_WORKLOAD_PLANNING_MANAGER_PIPEDEFS_H

#ifndef EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#define EDG_WORKLOAD_X_BOOST_UTILITY_HPP
#include <boost/utility.hpp>
#endif
#ifndef EDG_WORKLOAD_X_BOOST_SHAREDPTR_HPP
#define EDG_WORKLOAD_X_BOOST_SHAREDPTR_HPP
#include <boost/shared_ptr.hpp>
#endif
#ifndef EDG_WORKLOAD_X_BOOST_FUNCTION_HPP
#define EDG_WORKLOAD_X_BOOST_FUNCTION_HPP
#include <boost/function.hpp>
#endif
#ifndef EDG_WORKLOAD_COMMON_TASK_TASK_H
#include "edg/workload/common/task/Task.h"
#endif

namespace classad {
class ClassAd;
}

namespace edg {
namespace workload {
namespace planning {
namespace manager {

typedef boost::function0<void> PostProcessFunction;
typedef boost::shared_ptr<classad::ClassAd> ClassAdPtr;
typedef std::pair<PostProcessFunction, ClassAdPtr> pipe_value_type;
typedef edg::workload::common::task::Pipe<pipe_value_type> pipe_type;

}}}} // edg::workload::planning::manager

#endif

// Local Variables:
// mode: c++
// End:
