/*
 * File: edg-classad-plugin-loader.cpp
 * Author: Monforte Salvatore <Salvatore.Monforte@ct.infn.it>
 * Copyright (c) 2001 EU DataGrid.
 * For license conditions see http://www.eu-datagrid.org/license.html
 */

// $Id: edg-classad-plugin-loader.h,v 1.5 2005/11/11 16:03:01 dhsmith Exp $

#include <boost/utility.hpp>
#include <boost/thread/mutex.hpp>

#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/thread/tss.hpp>

#include "edg/workload/planning/broker/matchmaking/brokerinfo.h"
#include "edg/workload/planning/broker/matchmaking/brokerinfoGlueImpl.h"

namespace edg {
namespace workload {
namespace planning {
namespace plugin {

class classad_plugin_loader : boost::noncopyable
{
  public:
    classad_plugin_loader();
    ~classad_plugin_loader();

  private:
    static boost::mutex mtx;
    static int count;
    static bool loaded;
};
	
static classad_plugin_loader init;

} // namespace plugin
} // namespace planning
} // namespace workload
} // namespace edg
