#ifndef  EDG_WORKLOAD_USERINTERFACE_COMMON_ADWRAPPER_H
#define EDG_WORKLOAD_USERINTERFACE_COMMON_ADWRAPPER_H
/*
 * AdWrapper.h
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 *
 */

#include "edg/workload/common/requestad/JobAd.h"
# include <list>
#include <string>

/**
  * Provides a wrapping class implementation of the Userinterface JobAd library distribution
 *
 * @brief Provides a wrapping class implementation of the condor classad library distribution
  * @version 0.1
 * @date 15 April 2002
 * @author Alessandro Maraschini <alessandro.maraschini@datamat.it>
*/

class AdWrapper {
   public:
      // Constructor
      AdWrapper( int level=0);
      ~AdWrapper();
      void printChar( const std::string &ch ) ;
      bool fromString(const std::string &jdl) ;
      bool fromFile(const std::string &jdl) ;
      bool check();
      // Print the classAd as a string
      std::string toString();
      std::string toLines();
      // Check Multi attribute

      bool checkMulti ( const std::vector<std::string>& multi );
      bool removeAttribute ( const std::string& attr_name ) ;
      // set a string Attribute
      bool  setAttributeStr (const std::string& attr_name, const std::string& attr_value) ;
      bool  addAttributeStr (const std::string& attr_name, const std::string& attr_value) ;
      // set an int Attribute
      bool  setAttributeInt (const std::string& attr_name, int attr_value) ;
      // set a double Attribute/
      bool  setAttributeReal (const std::string& attr_name, double attr_value) ;
      // set a boolean Attribute
      bool  setAttributeBool (const std::string& attr_name, bool attr_value) ;
      // set an Expr attribute
      bool  setAttributeExpr (const std::string& attr_name, const std::string& attr_value) ;
      // Chek if a specified key is inside the classAd
      bool hasKey (const std::string& attr_name) ;
      int get_error ( std::string& err);
      // Retrieve the list of all inserted attributes
      std::vector <std::string> attributes ( )  ;
      // Get the value of a string attribute:
      std::vector <std::string> getStringValue (const std::string& attr_name)  ;


      // Get the value of a vector of strings
      std::vector < std::string>  getStringList (const std::string& attr_name)  ;


      // Get the value of an int attribute:
      std::vector <int> getIntValue (const std::string& attr_name)  ;
      // Get the value of a boolean attribute:
      std::vector <bool> getBoolValue (const std::string& attr_name)  ;
      // Get the value of a Real attribute:
      std::vector <double> getDoubleValue (const std::string& attr_name)  ;
      // Get any kind of attribute
      std::string getValueExpr (const std::string& attr_name)  ;
      std::string getAd( const std::string& name  ) ;

   private:
      // private classAd instance
      // edg::workload::common::requestad::JobAd jad ;
      edg::workload::common::requestad::Ad* jad ;
      std::string error ;
      bool error_code ;
      // friend class DagWrapper;
      //   ClassAd* clAd ;  //Deprecated
      // ClassAdParser par ;  //Deprecated

 };
 #endif
