#ifndef  EDG_WORKLOAD_USERINTERFACE_COMMON_LBWRAPPER_H
#define EDG_WORKLOAD_USERINTERFACE_COMMON_LBWRAPPER_H
/*
 * LbWrapper.h
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 *
 */
#include "edg/workload/logging/client/JobStatus.h"
#include "edg/workload/logging/client/Event.h"
#include "edg/workload/logging/client/Job.h"
#include <list>

/** Job Status class information */
class Status {
  public:
     Status () ;
     ~Status () ;
     int size () ;
     int size (int status_number) ;
     int getStatus (const std::string& jobid, int level = 0) ;
     int getStates (const std::string& host , int port , int level = 0) ;
     std::string getVal (int field, std::string& attrValue, int status_number = 0);
     int get_error (std::string& err) ;
     std::vector< std::string  > loadStatus( int status_number= 0) ;
     int queryStates (const std::string& host , int port ,
     	const std::vector<std::string>& tagNames,const std::vector<std::string>& tagValues,
     	const std::vector<int>& excludes,const std::vector<int>& includes,
     	std::string issuer,int from , int to ,int ad );
     std::vector<edg::workload::logging::client::JobStatus>   getAllStates (const std::string& host , int port , int level= 0) ;
  private:
     std::list<edg::workload::logging::client::JobStatus> states ;
     std::string error ;
     bool error_code ;
     void log_error ( const std::string& err) ;
};
/**  Job logging info class information*/
class Eve{
  public:
     Eve () ;
     ~Eve();
     int size () ;     
     int size (int status_number) ;
     int getEvents ( const std::string& jobid) ;
     std::string getVal (int field , std::string& attrValue , int event_number);
     int get_error (std::string& err) ;
     int Eve::queryEvents (const std::string& host , int port ,const std::vector<std::string>& tagNames,const std::vector<std::string>& tagValues,std::string issuer,int from , int to , int ad);
  private:
     std::list<edg::workload::logging::client::Event> events ;
     std::string error;
     bool error_code ;
     void log_error ( const std::string& err) ;
};

#endif
