#ifndef  EDG_WORKLOAD_USERINTERFACE_COMMON_LOGWRAPPER_H
#define EDG_WORKLOAD_USERINTERFACE_COMMON_LOGWRAPPER_H
/*
 * LogWrapper.h
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 */
#include <vector>
#include <list>
#include <string>
#include "edg/workload/logging/client/producer.h"
#define EDG_WL_LOG_DESTINATION "EDG_WL_LOG_DESTINATION"
/**  LOG methods */
class LOG {
   public:
       /**  C LOG Methods:  */
       LOG() ;
       ~LOG() ;
       void init ( const std::string& lb ) ;
       void regist( const std::string& jobid , const std::string& jdl , const std::string& ns ) ;
       void logSync (const  std::string& state ) ;
       void log_start (const std::string& host  , int port , const std::string& jdl ) ;
       void log_tag (const std::string& attrName  , const std::string& attrValue ) ;
       void log_jobid(const std::string& jobid ) ;
       void free () ;
       std::string getSequence();
       void log_listener( const std::string& jobid ,const std::string& host , int port  ) ;
       void log_tr_ok  ( const std::string& jdl , const std::string&  host , int port ) ;
       void log_tr_fail ( const std::string& jdl , const std::string&  host , int port , const char* exc) ;
       std::string retrieveState ( const std::string& jobid , int step = 0) ;
       int get_error (std::string& err) ;
       std::vector<std::string>  regist_dag ( const std::vector<std::string>& jdls, const std::string& jobid ,const std::string& jdl , int length , const std::string& ns );
   private:
       // void log_error ( const std::string& err ,  edg_wll_Context *ctx=NULL ) ;
       void log_error ( const std::string& err ) ;
       edg_wll_Context ctx ;
       std::string error ;
       int error_code ;

};
#endif
