#ifndef  EDG_WORKLOAD_USERINTERFACE_COMMON_NSWRAPPER_H
#define EDG_WORKLOAD_USERINTERFACE_COMMON_NSWRAPPER_H
/*
 * NsWrapper.h
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 *
 */

#include "edg/workload/networkserver/client/NSClient.h"
#include "edg/workload/common/utilities/Exceptions.h"
#include "edg/workload/common/logger/common.h"
#include "edg/workload/logging/client/JobStatus.h"
#include <vector>


/*********************
* VOMS includes:
*********************/
#include "voms_api.h"
#include "sslutils.h"

class NS {
public:
	NS();
	~NS();
	void ns_init (const std::string& nsAddress , int nsPort, int logLevel=0 )  ;
	// const std::string& ns_contact()  ;  //Deprecated
	void ns_submit (const std::string& jdl )  ;
	//  void ns_output (const std::string& jobid , const std::string& dir)  ;  //DEPRECATED ! ! !
	int ns_cancel (const std::string& jobid )  ;
	std::string ns_get_root(const std::string& jobid)  ;
	std::string ns_purge(const std::string& jobid)  ;
	std::string toDir( const std::string& url) ;
	std::vector <std::string> ns_multi()  ;
	std::vector <std::string> ns_output_sandbox(const std::string& jobid)  ;
	std::vector <std::string> ns_match (const std::string& jdl)  ;
	void ns_free () ;
	int get_error (std::string&  err) ;
	std::string create_job_id(const std::string& lbAddress , int lbPort) ; private :
	edg::workload::networkserver::client::NSClient * ns ;
	//edg::workload::logging::client::JobStatus* pippo ;
	// std::vector <edg::workload::logging::client::JobStatus> statesP ;
	void log_error ( const std::string& ) ;
	std::string error ;
	bool error_code ;
} ;


class  UserCredential {
	public:
		/** Constructor */
		UserCredential ( const std::string& proxy_file) ;
		~UserCredential();
		/** Retrieve the default Virtual Organisation name*/
		std::string  getDefaultVoName ();
		/** Retrieve the Certificate Issuer*/
		std::string  getIssuer() ;
		/** Retrieve the last allowed date*/
		int getExpiration() ;
		/** Retrieve the vector of all  the Virtual Organisation names */
		std::vector <std::string> getVoNames ();
		/***Retrieve all groups belonging to the specified VirtualOrganisation
		* @param voName the name of the Virtual Organisation where to retrieve groups */
		std::vector <std::string> getGroups ( const std::string& voName ) ;
		/** Returns the groups belonging to the default VirtualOrganisation*/
		std::vector <std::string > getDefaultGroups () ;
		/** Check wheater the specifie Virtual Organisation is contained in the Vo certificate extension*/
		bool containsVo ( const std::string& voName )  ;
		std::string get_error () ;
	private:
		int vo_data_error , timeleft ;
		std::string   proxy_file ; 
		int load_voms ( vomsdata& d ) ;
};

#endif

